#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

using namespace std;
#define int long long

int binpow(int a, int n){
    if (n == 0) return 1;
    if (n%2 == 0){
        int b = binpow(a, n/2);
        return b*b;
    }
    return a*binpow(a, n-1);
}

int gcd(int a, int b){
    if (b == 0) return a;
    return gcd(b, a%b);
}

tuple<int, int, int> gcdex(int a, int b){
    if (b == 0) return {a, 1, 0};
    int x, y, g;
    tie(g, x, y) = gcdex(b, a%b);
    return {g, y, x-(a/b)*y};
}

int32_t main(){
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--){
        int a, b;
        cin >> a >> b;
        cout << a*b << '\n';
    }
    return 0;
}