#include <bits/stdc++.h>

using namespace std;

#define se second
#define fi first

typedef long long ll;
typedef long double ld;

long long T(long long n){ return n * (n + 1) >> 1; }
long long MOD(long long a, long long mod){ return (a % mod + mod) % mod; }
long long gcd(long long a, long long b) { return (b == 0 ? a : gcd(b, a % b)); }

long long fpow(long long a, long long b, long long mod){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1, mod) * a % mod;

    long long res = fpow(a, b >> 1, mod);
    return res * res % mod;
}

long long fpow(long long a, long long b){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1) * a;

    long long res = fpow(a, b >> 1);
    return res * res;
}

const int INF32 = 2e9;
const long long INF64 = 4e18;
const int SZ = 2e5 + 11;
const int mod = 1e9 + 7;

#define int ll

bool check(vector<int> v, int m, int r){
    for(int &i : v){
        if(i >= m)
            return 0;
    }

    for(int i = 1; i < v.size(); i++)
        if(v[i] != (v[i - 1] + r) % m)
            return 0;

    return 1;
}

bool check(vector<int> v, int r){
    for(int i = 1; i < v.size(); i++)
        if(v[i] != v[i - 1] + r)
            return 0;

    return 1;
}

void Solve(){
    int n;
    cin >> n;

    vector<int> v(n);

    for(int &i : v)
        cin >> i;

    if(n == 1 || n == 2){
        cout << 0 << '\n';
        return;
    }

    bool ny = 1;

    for(int i = 1; i < n; i++)
        ny &= (v[i] < v[i - 1]);

    if(ny){
        int r = v[1] - v[0];
        if(check(v, r)) cout << 0 << '\n';
        else cout << -1 << '\n';
    }else{
        int r = 0;
        int m = 0;

        for(int i = 1; i < n; i++){
            if(v[i] >= v[i - 1]){
                r = v[i] - v[i - 1];
                break;
            }
        }

        for(int i = 1; i < n; i++){
            if(v[i] < v[i - 1]){
                m = v[i - 1] + r - v[i];
                break;
            }
        }

        if(m == 0){
            if(check(v, r)) cout << 0 << '\n';
            else cout << -1 << '\n';
            return;
        }

        if(check(v, m, r)) cout << m << ' ' << r << '\n';
        else cout << -1 << '\n';
    }
}

signed main(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    srand(time(NULL));
    cout << fixed << setprecision(10);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "r", stdout);

    int test = 1;
    cin >> test;

    for(int i = 1; i <= test; i++){
        Solve();
    }
}