#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

mt19937 rnd(time(0));

#define all(x) (x).begin(),(x).end()
#define ld long double
#define int long long

struct SparceTable {
    int n;
    vector<int> pows;
    vector<vector<int>> ST;
    SparceTable(vector<int> a1) {
        n = a1.size();
        pows.resize(n + 1, 0);
        for (int i = 2; i <= n; ++i) pows[i] = pows[i / 2] + 1;
        ST.resize(pows[n] + 1, vector<int> (n));
        for (int i = 0; i < n; ++i) ST[0][i] = a1[i];
        for (int p = 1; p <= pows[n]; ++p) {
            for (int i = 0; i < n; ++i) {
                ST[p][i] = min(ST[p - 1][i], ST[p - 1][min(i + (1 << (p - 1)), n - 1)]);
            }
        }
    }
    int getMin(int l, int r) {
        int len = r - l + 1;
        int p = pows[len];
        return min(ST[p][l], ST[p][r - (1 << p) + 1]);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a) cin >> i;
    bool ans0 = true;
    for (int i = 2; i < n; ++i) {
        if (a[i] - a[i - 1] != a[i - 1] - a[i - 2]) {
            ans0 = false;
        }
        if (a[i] < a[i - 1] || a[i - 1] < a[i - 2]) {
            ans0 = false;
        }
    }
    if (ans0) {
        cout << 0 << endl;
        return;
    }
    int c = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= a[i - 1]) {
            c = a[i] - a[i - 1];
            break;
        }
    }
    if (c == -1) {
        for (int i = 2; i < n; ++i) {
            if (a[i - 2] - a[i - 1] != a[i - 1] - a[i]) {
                cout << -1 << endl;
                return;
            }
        }
        cout << 0 << endl;
        return;
    }
    int m = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= a[i - 1]) {
            if (a[i] - a[i - 1] == c) continue;
            else {
                cout << -1 << endl;
                return;
            }
        } else {
            if (c == 0) {
                cout << -1 << endl;
                return;
            }
            m = a[i - 1] + c - a[i];
            break;
        }
    }
    if (a[0] >= m) {
        cout << -1 << endl;
        return;
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] >= m || (a[i - 1] + c) % m != a[i]) {
            cout << -1 << endl;
            return;
        }
    }
    cout << m << ' ' << c << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}