#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define pii pair < int, int >
#define ll long long
#define F first
#define S second
#define TIME 1.0 * clock() / CLOCKS_PER_SEC
#define pb push_back
#define endl '\n'
#define Endl '\n'

const int mod = 1e9 + 7;
const ll inf = 1e18;

mt19937 gen(time(0));

const int SX[4] = {1, -1, 0, 0};
const int SY[4] = {0, 0, -1, 1};

void solve(){
    int n;
    cin >> n;
    vector < int > a(n);
    bool ok = 1;
    ll c = 1e10;
    for (int i = 0;i < n; ++i){
        cin >> a[i];
        if (i){
            if (a[i] >= a[i - 1] && ok){
                if (i == 1)c = a[i] - a[i - 1];
                else{
                    if (c != a[i] - a[i - 1]){
                        ok = 0;
                    }
                }
            }else{
                ok = 0;
            }
        }
    }


    if (ok){
        cout << 0 << endl;
        return;
    }

    bool fl = 1;
    for (int i = 1;i < n; ++i){
        if (a[i] <= a[i - 1] && fl){
            if (i == 1)c = a[i - 1] - a[i];
            else{
                if (c != a[i - 1] - a[i]){
                    fl = 0;
                }
            }
        }else{
            fl = 0;
        }
    }

    if (fl){
        cout << 0 << endl;
        return;
    }

    for (int i = 1;i < n; ++i){
        if (a[i] > a[i - 1]){
            c = a[i] - a[i - 1];
            break;
        }
    }

    int m = -1;
    for (int i = 1;i < n; ++i){
        if (a[i] - a[i - 1] == c)continue;
        m = (a[i - 1] + c) - a[i];
        break;
    }
    //cerr << m << endl;
    fl = 1;
    for (int i = 1;i < n; ++i){
        if (a[i] != (a[i - 1] + c) % m){
            fl = 0;
            break;
        }
    }
    if (!fl || m <= a[0] || c >= m)cout << -1 << endl;
    else cout << m <<  " " << c << endl;
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t --> 0)solve();
    return 0;
}
