#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

template <class T> bool ckmin(T &a,T b){ return a > b ? a=b, true : false;}
template <class T> bool ckmax(T &a,T b){ return a < b ? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define mp make_pair
#define mt make_tuple

const int N = 2e5 + 500;
const int mod = 1e9 + 7;//988244353
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;
const ld eps = 1e-9;

void solve(){
    int n; cin>>n;
    if(n == 1){
        cout<<"0\n"; return;
    }
    vector<int> v(n); for(auto &e:v) cin>>e;
    int c = -1, k = INF;
    for(int i=1;i<n;i++){
        if(v[i] >= v[i-1]){
            if(c == -1){
                c = v[i] - v[i-1];
            }else if(c != v[i] - v[i-1]){
                cout<<"-1\n"; return;
            }
        }else{
            ckmin(k,v[i] - v[i-1]);
        }
    }
    bool zer = false;
    int m = c - k;
    if(k == INF) m = INF, zer = true;
    else if(c == -1) zer = true, m = INF, c = k + m;

    if(v[0] >= m){ cout<<"-1\n"; return;}
    for(int i=1;i<n;i++){
        if(v[i] != (v[i-1] + c) % m){
            cout<<"-1\n"; return;
        }
    }
    if(zer) {cout<<"0\n"; return;}
    cout<<m<<' '<<c<<'\n';
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0);
    // freopen("in.txt", "r", stdin); freopen("out.txt","w", stdout);
    cout<<fixed<<setprecision(20);
    int t = 1; cin>>t;
    while(t--) solve();
    return 0;
}
