﻿#include <unordered_map>
#include <unordered_set>
#include <type_traits>
#include <functional>
#include <algorithm>
#include <iterator>
#include <iostream>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <sstream>
#include <fstream>
#include <utility>
#include <vector>
#include <string>
#include <bitset>
#include <cstdio>
#include <math.h>
#include <stack>
#include <ctime>
#include <queue>
#include <cmath>
#include <list>
#include <set>
#include <map>

using namespace std;

#define SZ(v)			ll((v).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   numeric_limits<type>::max()
#define TYPEMIN(type)   numeric_limits<type>::min()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef vector<ll> vl;
typedef vector<vl> vvl;
typedef vector<char> vc;
typedef vector<vc> vvc;

const ll INF = 1000000007LL;
const ll MAXN = 150000LL;
const double EPS = 1e-9;

typedef bool (*fn) (ll);

bool equals(const double a, const double b) { return fabs(a - b) < EPS; }

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0); cerr.tie(0);
	ll t; cin >> t;
	while (t--)
	{
		ll n; cin >> n;
		vl arr(n);
		set<ll> s;
		for (ll& x : arr) { cin >> x; s.insert(x); }
		//сначала проверим случай 0
		if ((ll)s.size() == 1LL)
		{
			cout << 0LL << endl;
			continue;
		}
		if (arr[0LL] < arr[1LL])
		{
			ll prev = arr[1LL] - arr[0LL];
			bool win = true;
			for (ll i = 2LL; i < n; i++)
			{
				if (arr[i] - arr[i - 1LL] != prev)
				{
					win = false;
					break;
				}
			}
			if (win)
			{
				cout << 0LL << endl;
				continue;
			}
		}
		ll c = -INF, cWithoutM = INF;
		bool win = true;
		for (ll i = 1LL; i < n; i++)
		{
			if (arr[i] - arr[i - 1LL] > 0LL)
			{
				if (c == -INF) { c = arr[i] - arr[i - 1LL]; }
				else if (c != arr[i] - arr[i - 1LL])
				{
					win = false;
					break;
				}
			}
			else
			{
				if (cWithoutM == INF) { cWithoutM = arr[i] - arr[i - 1LL]; }
				else if (cWithoutM != arr[i] - arr[i - 1LL])
				{
					win = false;
					break;
				}
			}
		}
		if (!win)
		{
			cout << -1LL << endl;
			continue;
		}
		if (c == -INF)
		{
			cout << 0LL << endl;
			continue;
		}
		ll m = -cWithoutM + c;
		if (m <= c)
		{
			cout << -1LL << endl;
			continue;
		}
		for (ll x : arr)
		{
			if (x >= m)
			{
				win = false;
				break;
			}
		}
		if (!win)
		{
			cout << -1LL << endl;
			continue;
		}
		cout << m << " " << c << endl;
	}
	return 0;
}
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////