#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    bool ooo = true;
    for (int i = 0; i < n; i++) {
        if (a[i] < 0) {
            ooo = false;
            break;
        }
    }
    if (!ooo) {
        cout << "-1\n";
        return;
    }

    if (n == 1) {
        cout << "0\n";
        return;
    }
    int m = 0;
    int c = a[1] - a[0];
    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1] + c) {
            continue;
        }

        m = abs(a[i - 1] + c - a[i]);

        bool ok = a[0] < m;

        for (int j = 1; j < n; j++) {
            if (!ok) {
                break;
            }
            if (a[j] != (((a[j - 1] + c) % m) + m) % m) {
                ok = false;
            }
        }

        if (!ok) {
            m = -1;
        }
        break;
    }

    if (m == 0 || m == -1) {
        cout << m << endl;
    } else {
        cout << m << " " << ((c % m) + m) % m << endl;
    }
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("./in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t T_;
    cin >> T_;
    for (int32_t T_i = 0; T_i < T_; T_i++) {
#endif
        solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}
