#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
using namespace std;
typedef long long ll;

void Solve()
{
	int n;
	cin >> n;
	vector<int> vec(n);
	unordered_set<int> st;
	for (auto& el : vec)
	{
		cin >> el;
		st.insert(el);
	}
	if (st.size() == 1)
	{
		cout << "0\n";
		return;
	}
	int m = INT_MAX, c = -1;
	for (int i = 1; i < n; ++i)
	{
		if (vec[i - 1] <= vec[i])
		{
			if (c == -1)
				c = max(c, vec[i] - vec[i - 1]);
		}
	}
	if (c == -1)
	{
		int d = vec[0] - vec[1];
		bool f = 1;
		for (int i = 2; i < n; ++i)
		{
			if (vec[i - 1] - vec[i] != d)
			{
				f = 0;
				break;
			}
		}
		if (f)
		{
			cout << "0\n";
			return;
		}
	}
	for (int i = 1; i < n; ++i)
	{
		if (vec[i - 1] > vec[i])
		{
			if (c == -1)
			{
				m = 2 * vec[i - 1];
				c = vec[i - 1] + vec[i];
			}
			else
			{
				if (vec[i - 1] + c - vec[i] <= vec[i])
				{
					cout << "-1\n";
					return;
				}
				m = min(m, vec[i - 1] + c - vec[i]);
			}
		}
	}
	int s = vec[0];
	vector<int> tp(n);
	tp[0] = s % m;
	for (int i = 1; i < n; ++i)
		tp[i] = (tp[i - 1] + c) % m;
	if (tp == vec)
	{
		if (m == INT_MAX)
			cout << 0 << endl;
		else
			cout << m << ' ' << c << endl;
	}
	else
		cout << -1 << endl;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
		Solve();
}