#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <functional>
#include <random>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int INF = 1e9 + 7;
const ll LINF = 2e18;
const int MOD = INF;
const int N = 1e5;

void Solve() {
	int n;
	cin >> n;
	vector <int> v(n);
	for (auto& i : v) cin >> i;
	set <int> dif;
	for (int i = 0; i < n - 1; i++) {
		if (v[i] > v[i + 1]) dif.insert(v[i] - v[i+1]);
	}
	if (dif.size() == 0) {
		set <int> s;
		for (int i = 0; i < n - 1; i++) {
			s.insert(v[i] - v[i + 1]);
		}
		if (s.size() <= 1) cout << "0\n";
		else cout << "-1\n";
	}
	else if (dif.size() == 1) {
		int d = *dif.begin();
		set <int> s;
		for (int i = 0; i < n - 1; i++) {
			if (v[i] - d == v[i + 1]) continue;
			s.insert(v[i + 1]- v[i]);
		}
		if (s.size() == 0) {
			cout << "0\n";
		}
		else if (s.size() == 1) {
			int md = d + *s.begin();
			if (*max_element(v.begin(), v.end()) >= md) cout << "-1\n";
			else cout << d + *s.begin() << " " << *s.begin() << '\n';
		}
		else {
			cout << "-1\n";
		}
	}
	else {
		cout << "-1\n";
	}
}

int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
	Solve();
}