#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <string>

using namespace std;

using ll = long long;
const int INF = 2 * (int)1e9;
const ll INFL = 2 * (ll)1e18;
const ll MOD = 1e9;

mt19937 rnd(1337);

void solve() {
	int n;
	cin >> n;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	
	if (n == 1) {
		cout << "0\n";
		return;
	}

	ll c = v[1] - v[0];
	int idx = 0;
	ll mx = v[0];
	for (int i = 1; i < n; ++i) {
		mx = max(mx, v[i]);
		if (v[i] - v[i - 1] != c) {
			idx = i;
			break;
		}
	}
	if (idx == 0) {
		cout << "0\n";
		return;
	}
	ll m = v[idx - 1] + c - v[idx];
	if (m <= 0)
		m = -m;
	if (c < 0)
		c += m;
	for (int i = 0; i < n - 1; ++i) {
		mx = max(mx, v[i]);
		if (mx >= m || (v[i] + c) % m != v[i + 1]) {
			cout << "-1\n";
			return;
		}
	}
	cout << m << ' ' << c << '\n';
}

int main() {
//#ifdef _LOCAL
//	FILE* Stream;
//	freopen_s(&Stream, "input.txt", "r", stdin);
//	//freopen_s(&Stream, "output.txt", "w", stdout);
//#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}