#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <bitset>
#include <cmath>
#include <ctime>
#include <deque>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <stack>
#include <string>
#include <tuple>

#define int long long
#define double long double

#define start cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false)

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &elem : v) {
        is >> elem;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &elem : v) {
        os << elem << ' ';
    }
    return os;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int diff = a[1] - a[0];
    bool flag = true;
    for (int i = 2; i < n; ++i) {
        if (a[i] - a[i - 1] != diff) {
            flag = false;
        }
    }
    if (flag) {
        cout << 0 << '\n';
        return;
    }
    int m = -1, c;
    if (diff >= 0) {
        c = diff;
        flag = true;
        for (int i = 2; i < n; ++i) {
            if (a[i] == a[i - 1]) {
                flag = false;
            }
            if (a[i] < a[i - 1]) {
                if (m == -1) {
                    m = a[i - 1] - a[i] + c;
                }
            }
            if (m != -1) {
                if ((a[i - 1] + c) % m != a[i]) {
                    flag = false;
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            if (m != -1) {
                if ((a[i - 1] + c) % m != a[i]) {
                    flag = false;
                }
            }
        }
        if (a[0] >= m) {
            flag = false;
        }
        if (m == -1) {
            flag = false;
        }
        if (!flag) {
            cout << -1 << '\n';
            return;
        } else {
            cout << m << ' ' << c << '\n';
        }
    } else {
        flag = true;
        for (int i = 2; i < n; ++i) {
            if (a[i] == a[i - 1]) {
                flag = false;
            }
            if (a[i] > a[i - 1]) {
                c = a[i] - a[i - 1];
                break;
            }
        }
        for (int i = 1; i < n; ++i) {
            if (m == -1 && a[i] < a[i - 1]) {
                m = a[i - 1] - a[i] + c;
            }
            if (m != -1) {
                if ((a[i - 1] + c) % m != a[i]) {
                    flag = false;
                }
            }
        }
        if (m == -1) {
            flag = false;
        }
        if (a[0] >= m || c >= m) {
            flag = false;
        }
        if (!flag) {
            cout << -1 << '\n';
        } else {
            cout << m << ' ' << c << '\n';
        }
    }
}

int32_t main() {
//    start;

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}