#include <bits/stdc++.h>

#define X first
#define Y second
#define endl '\n'

#define int long long

using namespace std;

const int INF = 2e9 + 1;

int gcd(int a, int b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

int sign(int x){
    if (x > 0)
        return 1;
    if (x < 0)
        return -1;
    return 0;
}

bool check(vector<int> & arr, int m, int k){
    if (arr[0] >= m)
        return false;

    for (int i = 1; i < arr.size(); ++i)
        if ((arr[i - 1] + k) % m != arr[i])
            return false;
    return true;
}


bool check2(vector<int> & arr, int k){
    for (int i = 1; i < arr.size(); ++i)
        if (arr[i - 1] + k != arr[i])
            return false;
    return true;
}


bool are_same(vector<int> & arr){
    for (int i = 1; i < arr.size(); ++i)
        if (arr[i] != arr[i - 1])
        return false;
    return true;
}


void solve(){
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int & i : arr)
        cin >> i;

    if (n <= 2 || are_same(arr)){
        cout << 0 << endl;
        return;
    }

    int maxx = -INF;
    for (int i = 1; i < n; ++i)
        maxx = max(maxx, arr[i] - arr[i - 1]);

    if (check2(arr, maxx)){
        cout << 0 << endl;
        return;
    }

    int k = 0;
    for (int i = 1; i < n; ++i){
        int d = arr[i - 1] - (arr[i] - maxx);
        if (d != 0)
            k = gcd(d, k);
    }

    if (k != 0 && check(arr, k, maxx))
        cout << k << " " << maxx << endl;
    else
        cout << -1 << endl;
}

signed main(){
#ifdef MY
freopen("in.txt", "r", stdin);
#endif // MY
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--)
        solve();
}
