#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(x) int32_t(x.size())
#define pii pair < int, int >
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define se second
#define fi first
#define int ll

using namespace __gnu_pbds;
using namespace std;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 15;

int dx[] = { 1, -1, 0, 0 };
int dy[] = { 0, 0, -1, 1 };

int32_t main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int q = 1;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;
        int a[n + 1];
        for(int i = 1; i <= n; i++) {
            cin >> a[i];
        }

        if(n == 1) {
            cout << 0 << '\n';
            continue;
        }

        int c = -1;
        int ans = true, u = false;
        for(int i = 2; i <= n; i++) {
            if(a[i] >= a[i - 1]) {
                if(c == -1) {
                    c = a[i] - a[i - 1];
                }
                else {
                    if(c != a[i] - a[i - 1]) {
                        ans = false;
                    }
                }
            }
            else {
                u = true;
            }
        }

        if(!u || !ans) {
            cout << ans - 1 << endl;
            continue;
        }

        if(c != -1) {
            int md;
            for(int i = 2; i <= n; i++) {
                if(a[i] < a[i - 1]) {
                    md = a[i - 1] - a[i] + c;
                    break;
                }
            }
            bool ok = true;
            if(md < a[1] + 1) ok = false;
            for(int i = 2; i <= n; i++) {
                if(a[i] != (a[i - 1] + c) % md) {
                    ok = false;
                }
            }
            if(ok) {
                cout << md _ c << endl;
            }
            else {
                cout << -1 << endl;
            }
        }
        else {
            int ok = 1;
            int k = a[1] - a[2];
            for(int i = 2; i <= n; i++) {
                if(k != a[i - 1] - a[i]) ok = 0;
            }
            cout << ok - 1 << endl;
        }
    }
    return 0;
}
