#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<utility>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<climits>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<random>
using namespace std;
#define int long long
mt19937 azino(777);
struct fenwick {
	vector<int> f;
	int n;
	void add(int i, int val) {
		for (; i < n; i |= (i + 1)) f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i) {
			ans += f[i];
		}
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
	fenwick(vector<int> a) {
		n = a.size();
		f.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			add(i, a[i]);
		}
	}
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
};
void solve() {
	int n, c = 0, cl = 0, m = 0;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];
	for (int i = 1; i < n; ++i) {
		if (a[i] > a[i - 1]) c = a[i] - a[i - 1];
		if (a[i] < a[i - 1]) cl = a[i - 1] - a[i];
	}
	if (cl != 0 && c != 0) m = cl + c;
	else m = 1e18;
	if (c == 0 && cl != 0) c = m - cl;
	int cur = a[0];
	if (cur >= m) {
		cout << -1 << '\n';
		return;
	}
	for (int i = 1; i < n; ++i) {
		cur = (cur + c) % m;
		if (cur != a[i]) {
			cout << -1 << '\n';
			return;
		}
	}
	if (m == 1e18) cout << 0 << '\n';
	else cout << m << ' ' << c << '\n';
	return;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}