#include <bits/extc++.h>

using namespace std;

#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) int((a).size())
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd(2342309423);

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio();
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}

void Solve() {
    int n;
    cin >> n;
    vi a(n);
    for (auto& i : a)
        cin >> i;
    if (n == 1) {
        cout << 0 << nl;
        return;
    }
    int c = a[1] - a[0];
    int m = 1;
    bool isM = false;
    for (int i = 2; i < n; i++) {
        if (isM) {
            int t = (a[i - 1] + c) % m;
            if (t != a[i]) {
                cout << -1 << nl;
                return;
            }
        }
        else {
            int t = a[i - 1] + c;
            if (t == a[i])
                continue;
            m = abs(t - a[i]);
            isM = true;
            c = (c % m + m) % m;
        }
    }
    if (!isM) {
        cout << 0 << nl;
        return;
    }
    bool isAns = a[0] < m;
    for (int i = 1; i < n; i++) {
        isAns &= a[i] == (a[i - 1] + c) % m;
    }
    if (isAns) {
        cout << m << ' ' << c << nl;
    }
    else {
        cout << -1 << nl;
    }
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; i++) {
        Solve();
    }
    return 0;
}
