#include<bits/stdc++.h>

using namespace std;

string tostr(string s) {
    string res = "";
    res.push_back('"');
    res += s;
    res.push_back('"');
    return res;
}

string tostr(char c) {
    string res = "";
    res += "'";
    res.push_back(c);
    res += "'";
    return res;
}

string tostr(long long x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + (x % 10));
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

string tostr(int x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + x % 10);
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

template<typename A, typename B>
string tostr(pair<A, B> a) {
    return "{" + tostr(a.first) + ", " + tostr(a.second) + "}";
}

template<typename A>
string tostr(vector<A> a) {
    string res = "{";
    bool f = false;
    for (auto x : a) {
        if (!f) {
            f = true;
        }
        else {
            res += ", ";
        }
        res += tostr(x);
    }
    res += "}";
    return res;
}

#define debug(x) cout << #x << " = " << tostr(x) << endl
#define int long long
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (n == 1) {
        cout << 0 << '\n';
        return;
    }
    for (int i = 1; i < n; i++) {
        if (a[i] >= a[i - 1]) {
            int mx = *max_element(all(a));
            int c = a[i] - a[i - 1];
            int m = -1;
            for (int j = 1; j < n; j++) {
                if (a[j - 1] <= a[j]) {
                    int z = a[j] - a[j - 1];
                    if (z != c) {
                        cout << -1 << '\n';
                        return;
                    }
                }
                else {
                    int res = a[j - 1] + c - a[j];
                    if (res <= c || res <= mx) {
                        cout << -1 << '\n';
                        return;
                    }
                    if (m == -1) {
                        m = res;
                    }
                    else if (m != res) {
                        cout << -1 << '\n';
                        return;
                    }
                }
            }
            if (m == -1) {
                cout << 0 << '\n';
            }
            else {
                cout << m << " " << c << '\n';
            }
            return;
        }
    }
    int c = a[0] - a[1];
    for (int j = 1; j < n; j++) {
        int res = a[j - 1] - a[j];
        if (res != c) {
            cout << -1 << '\n';
            return;
        }
    }
    cout << 0 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
