#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define int ll

inline void solve() {
    int n;
    cin >> n;
    vec<int> a(n);
    for (auto &x : a)
        cin >> x;

    bool zero = true;
    for (int i = 1; i < n; i++) {
        zero &= a[i] - a[i - 1] == a[1] - a[0];
        zero &= a[i] - a[i - 1] >= 0;
    }
    if (zero) {
        cout << "0\n";
        return;
    }

    for (int i = 1; i < n; i++)
        if (a[i] >= a[i - 1]) {
            int c = a[i] - a[i - 1];
            for (int j = 1; j < n; j++)
                if (a[j] >= a[j - 1] && a[j] - a[j - 1] != c) {
                    cout << "-1\n";
                    return;
                }

            int m = -1;
            for (int j = 1; j < n; j++)
                if (a[j] < a[j - 1]) {
                    int cur_m = a[j - 1] + c - a[j];
                    if (m == -1)
                        m = cur_m;
                    if (cur_m != m) {
                        cout << "-1\n";
                        return;
                    }
                }

            assert(m != -1);
            if (m <= a[0] || c < 0 || c >= m) {
                cout << "-1\n";
                return;
            }
            int cur = a[0];
            for (int i = 1; i < n; i++) {
                cur += c;
                cur %= m;
                if (cur != a[i]) {
                    cout << "-1\n";
                    return;
                }
            }
            cout << m << ' ' << c << '\n';
            return;
        }

    for (int i = 1; i < n; i++)
        if (a[i - 1] - a[i] != a[0] - a[1]) {
            cout << "-1\n";
            return;
        }

    // int delta = a[0] - a[1];
    cout << "0\n";
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
