#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
typedef long double ld;

using namespace std;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;
const int md = 1e9 + 7;


void solve() {
    int n; cin >> n;
    vector<int> a(n);
    range(i, n) cin >> a[i];
    set<int> can;
    range(i, n - 1) {
        can.insert(a[i + 1] - a[i]);
    }
    if (n == 1) {
        cout << "0\n";
        return;
    }
    if (can.size() == 1) {
        int x = *can.begin();
        if (x > 0) {
            cout << "0\n";
            return;
        }
        cout << "0\n";
        return;
    }
    if (can.size() > 2) {
        cout << "-1\n";
        return;
    }
    int x = *can.rbegin();
    int y = *can.begin();
    if (y > 0 || x < 0) {
        cout << "-1\n";
        return;
    }
    // y = c - m
    // x = c
    int m = x - y;
    int d = *max_element(all(a));
    if (d >= m) {
        cout << "-1\n";
        return;
    }
    int c = x;
    if (c >= m) {
        cout << "-1\n";
        return;
    }
    for(int i = 1; i < n; ++i) {
        int w = (a[i - 1] + c) % m;
        if (w != a[i]) {
            cout << "-1\n";
            return;
        }
    }
    cout << m << ' ' << c << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}