#include <iostream>
#include <string>
#include <vector>
#include <climits>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;

const ll INF = 88005553535;
const ld PI = 3.141592653589793;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t --> 0) {
		ll n;
		cin >> n;
		vector <ll> arr(n);
		for (ll i = 0; i < n; ++i) {
			cin >> arr[i];
		}
		if (n == 1) {
			cout << 0 << '\n';
			continue;
		}
		bool flag_0 = true;
		ll prev = arr[1] - arr[0];
		//vector <ll> plus_interval, minus_interval;
		set <ll> st_p, st_m;
		ll first_pair = -1;
		for (ll i = 1; i < n; ++i) {
			if (arr[i] - arr[i - 1] != prev) {
				flag_0 = false;
			}
			if (arr[i] > arr[i - 1]) {
				//plus_interval.push_back(arr[i] - arr[i - 1]);
				st_p.insert(arr[i] - arr[i - 1]);
			}
			else {
				//minus_interval.push_back(arr[i] - arr[i - 1]);
				st_m.insert(arr[i] - arr[i - 1]);
				if (first_pair == -1) {
					first_pair = i;
				}
			}
		}
		if (flag_0) {
			cout << 0 << '\n';
			continue;
		}
		if (st_p.size() != 1 || st_m.size() != 1) {
			cout << -1 << '\n';
			continue;
		}
		ll prob_c = *st_p.begin();
		ll prob_mod = arr[first_pair - 1] + prob_c - arr[first_pair];
		bool flag_1 = true;
		for (ll i = 0; i < n - 1; ++i) {
			if ((arr[i] + prob_c) % prob_mod != arr[i + 1]) {
				flag_1 = false;
			}
			if (arr[i] > prob_mod) {
				flag_1 = false;
			}
		}
		if (flag_1) {
			cout << prob_mod << ' ' << prob_c << '\n';
		}
		else {
			cout << -1 << '\n';
		}
	}
	return 0;
}

/*

*/