//package start;

import java.io.*;
import java.util.*;
import java.lang.*;

public class Main extends IO {

    public static void main(String[] args) throws IOException {
        int quantity = readInt();
        mainCycle:
        for (int x = 0; x < quantity; x++){
            int size = readInt();
            int[] data = readArrayInt(" ");
            int bDelta = 0;
            int mDelta = 0;
            boolean equals = false;
            for (int i = 0; i < data.length - 1; i++){
                if (data[i + 1] > data[i]){
                    if (equals){
                        writeInt(-1, "\n");
                        continue mainCycle;
                    }
                    if (bDelta == 0){
                        bDelta = data[i + 1] - data[i];
                    }else if (bDelta != (data[i + 1] - data[i])){
                        writeInt(-1, "\n");
                        continue mainCycle;
                    }
                }
                else if (data[i + 1] < data[i]){
                    if (equals){
                        writeInt(-1, "\n");
                        continue mainCycle;
                    }
                    if (mDelta == 0){
                        mDelta = data[i] - data[i + 1];
                    }else if (mDelta != (data[i] - data[i + 1])){
                        writeInt(-1, "\n");
                        continue mainCycle;
                    }
                }
                else{
                    if (!equals && i > 0){
                        writeInt(-1, "\n");
                        continue mainCycle;
                    }
                    equals = true;
                }

            }
            int m = mDelta + bDelta;
            if (mDelta == 0 || bDelta == 0){
                writeString("0", "\n");
                continue mainCycle;
            }
            if (data[0] >= m){
                writeInt(-1, "\n");
                continue mainCycle;
            }
            for (int i = 1; i < data.length; i++){
                if (data[i] != ((data[i - 1] + bDelta) % m)){
                    writeInt(-1, "\n");
                    continue mainCycle;
                }
            }
            writeInt(bDelta + mDelta, " ");
            writeInt(bDelta, "\n");
        }
        print();
    }
}


class Pair<T, U>{
    T first;
    U second;

    Pair(T first, U second){
        this.first = first;
        this.second = second;
    }

    @Override
    public int hashCode() {
        return 31 * first.hashCode() * second.hashCode() - (first.hashCode() ^ second.hashCode());
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Pair)){
            return false;
        }
        Pair p = (Pair) obj;
        return this.first == p.first && this.second == p.second;
    }
}

class IO{

    private static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));

    static int readInt() throws IOException {
        return Integer.parseInt(reader.readLine());
    }

    static long readLong() throws IOException {
        return Long.parseLong(reader.readLine());
    }

    static int[] readArrayInt(String split) throws IOException {
        return Arrays.stream(reader.readLine().split(split)).mapToInt(Integer::parseInt).toArray();
    }

    static void writeInt(int value, String end) throws IOException {
        writer.write(Integer.toString(value));
        writer.write(end);
    }

    static void writeLong(long value, String end) throws IOException {
        writer.write(Long.toString(value));
        writer.write(end);
    }

    static void writeString(String value, String end) throws IOException {
        writer.write(value);
        writer.write(end);
    }

    static void writeArray(int[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++){
            builder.append(array[i]);
            if (i + 1 < array.length){
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void writeArray(long[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++){
            builder.append(array[i]);
            if (i + 1 < array.length){
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void writeArray(String[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++){
            builder.append(array[i]);
            if (i + 1 < array.length){
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void print(boolean exit) throws IOException {
        writer.flush();
        if (exit){
            reader.close();
            writer.close();
        }
    }

    static void print() throws IOException {
        print(false);
    }


}