#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <iostream>
#include <algorithm>

#define ll long long
#define f first
#define s second
#define pii pair <int, int>
#define pb push_back

using namespace std;

const int N = 1e6 * 2 + 100;
const int INF = 1e9 + 100;

int a[N], b[N];

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int q;
	cin >> q;

	while (q--) {
		int n, ans = 1;
		cin >> n;

		for (int i = 0; i < n; i++)
			cin >> a[i];

		if (n == 1) {
			cout << 0 << "\n";
			continue;
		}

		int c = -1, m = -1;
		n--;

		for (int i = 0; i < n; i++) {
			if (a[i + 1] >= a[i])
				c = a[i + 1] - a[i];
		}

		if (c == -1) {
			//cout << 1;
			c = a[0] - a[1];
			for (int i = 0; i < n; i++) {
				if (a[i] - a[i + 1] != c)
					ans = 0;
			}
			if (ans)
				cout << 0;
			else
				cout << -1;
			cout << "\n";
			continue;
		}

		for (int i = 0; i < n; i++) {
			if (a[i + 1] >= a[i] && a[i + 1] - a[i] != c) {
				ans = 0;
			}
		}

		if (ans == 0) {
			cout << -1 << "\n";
			continue;
		}


		for (int i = 0; i < n; i++) {
			if (a[i + 1] < a[i])
				m = a[i] + c - a[i + 1];
		}

		if (m == -1 && ans) {
			cout << 0 << "\n";
			continue;
		}

		//cout << m << "\n";
		for (int i = 0; i < n; i++) {
			if (a[i + 1] < a[i] && (a[i] + c) % m != a[i + 1] || (m <= a[i] && m != -1))
				ans = 0;
		}

		if (ans == 0) {
			cout << -1 << "\n";
			continue;
		}

		b[0] = a[0];

		//cout << ans << "\n";

		for (int i = 1; i < n + 1; i++)
			b[i] = (b[i - 1] + c) % m;


		for (int i = 1; i < n + 1; i++)
			if (a[i] != b[i])
				ans = 0;

		if (ans == 0)
		{
			cout << -1 << "\n";
			continue;
		}

		cout << m << " " << c << "\n";
	}

}