#include <algorithm>
#include <iomanip>
#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <queue>

#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int gcd(int a, int b) {
  while (b) {
    a %= b;
    swap(a, b);
  }
  return a;
}

void solve() {
  int n;
  cin >> n;
  vector<int> v(n);
  for (int i = 0; i < n; ++i) {
    cin >> v[i];
  }
  int a = -1, b = -1;
  for (int i = 0; i + 1 < n; ++i) {
    if (v[i] <= v[i + 1]) {
      if (a == -1) {
	a = v[i + 1] - v[i];
      } else {
	if (v[i + 1] - v[i] != a) {
	  cout << -1 << endl;
	  return;
	}
      }
    } else {
      if (b == -1) {
	b = v[i] - v[i + 1];
      } else {
	if (v[i] - v[i + 1] != b) {
	  cout << -1 << endl;
	  return;
	}
      }
    }
  }
  if (a == -1 || b == -1) {
    cout << 0 << endl;
    return;
  }
  for (int i = 0; i < n; ++i) {
    if (v[i] >= a + b) {
      cout << -1 << endl;
      return;
    }
  }
  cout << a + b << " " << a << endl;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
  int t;
  cin >> t;
  for (int i = 0 ; i < t; ++i) {
    solve();
  }
  return 0;
}
