#include <algorithm>
#include <iostream>
#include <math.h>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define int ll

//#define x first
//#define y second

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define vs vector<string>
#define pipii pair<int, pii>
#define piipi pair<pii, int>

const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;
const int N = 1e5;
const ll M = 1e9 + 7; //92359417

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

void solve() {
    int n; cin >> n;
    if (n == 1) {
        cout << "0\n";
        return;
    }
    vi a(n);
    int mins = INF, maxs = -INF;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i) {
            mins = min(mins, a[i] - a[i - 1]);
            maxs = max(maxs, a[i] - a[i - 1]);
        }
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] - a[i - 1] != mins && a[i] - a[i - 1] != maxs) {
            cout << "-1\n";
            return;
        }
    }
    if (mins == maxs) {
        cout << "0\n";
        return;
    }
    int m = maxs - mins, c;
    if (a[1] > a[0])c = a[1] - a[0];
    else c = (a[1] + m - a[0]);
    bool ok = 1;
    for (int i = 0; i < n; ++i) {
        if ((i && a[i] != (a[i - 1] + c) % m) || a[i] >= m) {
            cout << "-1\n";
            return;
        }
    }
    cout << m << ' ' << c << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}