#include <bits/stdc++.h>

#define long long long
#define all(x) (x).begin(), (x).end()
#define help ios_base::sync_with_stdio(false);
#define me cin.tie(0)
#define yes "YES\n"
#define no "NO\n"

using namespace std;

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    if (n < 3) {
        cout << 0 << '\n';
        return;
    }

    long posdif = -1, negdif = 1;
    for (int i = 1; i < n; i++) {
        if (a[i] >= a[i - 1]) {
            if (posdif == -1) {
                posdif = a[i] - a[i - 1];
            } else if (posdif != a[i] - a[i - 1]) {
                cout << -1 << '\n';
                return;
            }
        }
        if (a[i] <= a[i - 1]) {
            if (negdif == 1) {
                negdif = a[i] - a[i - 1];
            } else if (negdif != a[i] - a[i - 1]) {
                cout << -1 << '\n';
                return;
            }
        }
    }
    if (posdif == -1 || negdif == 1) {
        cout << 0 << '\n';
        return;
    }
    long m = posdif - negdif, c = posdif;
    if (m == 0) {
        cout << 0 << '\n';
        return;
    }
    vector<int> b(n);
    b[0] = a[0] % m;
    for (int i = 1; i < n; i++) {
        b[i] = (b[i - 1] + c) % m;
    }
    if (a != b) {
        cout << -1 << '\n';
    } else {
        cout << m << ' ' << c << '\n';
    }
}

signed main() {
    help me;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}