#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
using namespace std;
#define int long long
#define ii pair <int, int> 
#define ll long long
#define vi vector <int>
#define debug(x) cerr << #x << ": " << x << endl;
#define mp make_pair
void ckmin(int &a, int b) { a = min(a, b); }
void ckmax(int &a, int b) { a = max(a, b); }

int gcd(int a, int b) {
    while (b) {
        int t = a%b;
        a = b;
        b = t;
    }
    return a;
}

signed main() {
    #ifdef LOCAL
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #define endl '\n'
    #endif

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vi a(n);
        int mx = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            ckmax(mx, a[i]);
        }

        if (n == 1) {
            cout << 0 << endl;
            continue;
        }

        int d = a[1] - a[0];
        for (int i = 0; i < n; ++i) {
            a[i] -= i * d;
        }

        int g = 0;
        for (int i = 0; i + 1 < n; ++i) {
            g = gcd(g, abs(a[i + 1] - a[i]));
        }
        if (g == 0) {
            cout << 0 << endl;
        }
        else if (g <= mx) {
            cout << -1 << endl;
        }
        else {
            cout << g << ' ' << (d % g + g) % g << endl;
        }
    }

}