#include <bits/stdc++.h>

/// #pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>


void solve() {
    ll n;
    cin >> n;
    vector<ll> a;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }

    bool has_less = false;
    bool has_eq = false;
    bool has_more = false;
    for(ll i = 1; i < n; i++) {
        if(a[i] < a[i - 1]) {
            has_less = true;
        }
        if(a[i] > a[i - 1]) {
            has_more = true;
        }

        if(a[i] == a[i - 1]) has_eq = true;
    }
    if(has_eq && (has_less || has_more)) {
        cout << "-1\n";
        return;
    }
    if(!has_less) {
        if(n > 1) {
            ll dif = a[1] - a[0];
            for(ll i = 2; i < n; i++) {
                if(a[i] - a[i - 1] != dif) {
                    cout << "-1\n";
                    return;
                }
            }
        }
        cout << "0\n";
        return;
    }
    if(!has_more) {
        if(n > 1) {
            ll dif = a[1] - a[0];
            for(ll i = 2; i < n; i++) {
                if(a[i] - a[i - 1] != dif) {
                    cout << "-1\n";
                    return;
                }
            }
        }
        cout << "0\n";
        return;
    }

    ll c = 0;
    for(ll i = 1; i < n; i++) {
        if(a[i] > a[i - 1]) {
            c = a[i] - a[i - 1];
            break;
        }
    }

    ll m = -1;

    for(ll i = 1; i < n; i++) {
        if(a[i] < a[i - 1]) {
            m = a[i - 1] + c - a[i];
            break;
        }
    }

    bool ok = true;
    if(a[0] >= m) {
        ok = false;
    }
    for(ll i = 1; i < n; i++) {
        if((a[i - 1] + c) % m != a[i]) {
            ok = false;
        }
    }

    if(!ok) {
        cout << "-1\n";
    } else cout << m << " " << c << "\n";
}

int main()
{
    //freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q;
    cin >> q;
    for(ll i = 0; i < q; i++)
    solve();

    return 0;
}
