#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <stack>

#define int long long
#define vi vector<int>
#define vpii vector<pair<int, int>>

using namespace std;


void solve() {
	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (n == 1) {
		cout << "0\n";
		return;
	}

	int val = a[1] - a[0];
	for (int i = 1; i < n; i++) {
		if (a[i] - a[i - 1] != val)break;
		if (i == n - 1) {
			cout << "0\n";
			return;
		}
	}
	int c = -1;
	for (int i = 0; i < n - 1; i++) {
		if (a[i + 1] >= a[i])c = a[i + 1] - a[i];
	}
	for (int i = 0; i < n - 1; i++) {
		if (a[i + 1] >= a[i] && c != a[i + 1] - a[i]) {
			cout << "-1\n";
			return;
		}
	}

	//km + a2 = a1 + c;
	//km = a1 + c - a2;
	int m = -1e18;
	for (int i = 0; i < n - 1; i++) {
		if (a[i] > a[i + 1]) {
			if (m == -1e18) {
				m = a[i] + c - a[i + 1];
				if (m <= 0) {
					cout << "-1\n";
					return;
				}
			}
			else {
				if (m != a[i] + c - a[i + 1]) {
					cout << "-1\n";
					return;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (m <= a[i]) {
			cout << "-1\n";
			return;
		}
	}
	cout << m << ' ' << c << "\n";
}

// a1
// a1 + c
// a1 + 2c
// a1 + 3c
// a1 + 4c

// 0 - возрастающая арифм. прогрессия


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}