#include <bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define eb emplace_back

using namespace std;

template <typename T>
bool chmin(T& a, const T& b){
  if (a > b){
    a = b;
    return true;
  }
  return false;
}

template <typename T>
bool chmax(T& a, const T& b){
  if (a < b){
    a = b;
    return true;
  }
  return false;
}

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

#ifdef ONPC
mt19937 rnd(54);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 54LL;
const ld PI = acos(-1);

#ifdef ONPC
const int MAXN = 154;
#else
const int MAXN = 300100;
#endif

//#define int long long
const int INF = 1e9;

void solve(){
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++){
    cin >> a[i];
  }

  int c = -1;
  int mc = -1;
  for (int i = 0; i < n - 1; i++){
    if (a[i + 1] >= a[i]){
      if (c == -1) c = a[i+1] - a[i];
      else {
        if (c != a[i+1] - a[i]){
          cout << -1 << '\n';
          return;
        }
      }
    } else {
      if (mc == -1) mc = a[i] - a[i + 1];
      else {
        if (mc != a[i] - a[i+1]){
          cout << "-1\n";
          return;
        }
      }
    }
  }

  if (c == -1 || mc == -1){
    cout << "0\n";
    return;
  }

  int md = c + mc;
  for (int i = 0; i < n; i++){
    if (a[i] >= md){
      cout << "-1\n";
      return;
    }
  }

  if (c >= md){
    cout << "-1\n";
    return;
  }

  cout << c + mc << ' ' << c << '\n';
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  int Q;
  cin >> Q;
  while (Q--)
    solve();
}