#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>

#define inf 1e18

using namespace std;

typedef long long ll;

void solve();

int main()
{
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	int t = 1; cin >> t;
	while (t--)
		solve();
}

void solve() {
	int n, mx = 0; cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(mx, a[i]);
	}
	if (n == 1) {
		cout << 0 << '\n';
		return;
	}
	
	bool asc = false;
	int c = -1;

	for (int i = 1; i < n; i++) {
		if (a[i] >= a[i - 1]) {
			asc = true;
			if (c != -1 && c != a[i] - a[i - 1]) {
				cout << -1 << '\n';
				return;
			}
			c = a[i] - a[i - 1];
		}
	}

	if (c > 0) {
		int m = -1;
		for (int i = 1; i < n; i++) {
			if (a[i] < a[i - 1]) {
				if (m != -1 && m != a[i - 1] + c - a[i]) {
					cout << -1 << '\n';
					return;
				}
				m = a[i - 1] + c - a[i];
			}
		}
		if (m == -1)
			cout << 0 << '\n';
		else if (m <= mx)
			cout << -1 << '\n';
		else
			cout << m << ' ' << c << '\n';
	}
	else {
		int diff = 1e9;
		for (int i = 1; i < n; i++) {
			if (diff != 1e9 && a[i] - a[i - 1] != diff) {
				cout << -1 << '\n';
				return;
			}
			diff = a[i] - a[i - 1];
		}
		cout << 0 << '\n';
	}
}