#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int long long

typedef tree <
int,
null_type,
less<int>, 
rb_tree_tag,
tree_order_statistics_node_update> orset;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	
	int t;
	cin >> t;
	while(t--) {
		int n;
		cin >> n;
		
		vector<int> a(n);
		for(int i = 0; i < n; i++) {
			cin >> a[i];
		}
		
		if(n == 1) {
			cout << 0 << "\n";
			continue;
		}
		
		vector<int> diff(n-1);
		for(int i = 0; i < n-1; i++) {
			diff[i] = a[i+1] - a[i];
		}
		
		
		set<int> s;
		for(int i = 0; i < diff.size(); i++) s.insert(diff[i]);
		if(s.size() > 2) {
			cout << -1 << "\n";
			continue;
		}
		
		if(s.size() == 1) {
			cout << 0 << "\n";
			continue;
		}
		
		int A = *s.begin(), B = *(++s.begin());
		int MOD = abs(A) + abs(B);
		
		if(a[0] >= MOD) {
			cout << -1 << "\n";
			continue;
		}
		
		int c;
		if(A > 0) c = A;
		else c = B;
		
		if(A > 0 && B > 0) {
			cout << -1 << "\n";
			continue;
		}
		
		if(A < 0 && B < 0) {
			cout << -1 << "\n";
			continue;
		}
		
		bool flag = true;
		for(int i = 1; i < n; i++) {
			int dist;
			if(a[i] > a[i-1]) dist = a[i] - a[i-1];
			else dist = MOD - a[i-1] + a[i];
			
			if((c != -1 && dist != c)) {
				cout << -1 << "\n";
				flag = false;
				break;
			}
			c = dist;
		}
		
		for(int i = 1; i < n; i++) {
			if((a[i-1]+c)%MOD != a[i]) {
				cout << -1 << "\n";
				flag = false;
				break;
			}
		}
		
	
		if(flag) cout << MOD << " " << c << endl;
	}
}



