#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define sz(x) (int)(x).size()
#define S second
#define F first
#define all(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

void setIO(string name = "") {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	if (sz(name)) {
		freopen((name + ".in").c_str(), "r", stdin);
		freopen((name + ".out").c_str(), "w", stdout);
	}
}

const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;
const int MAXN = 1e6 + 5;

int n;
ll a[MAXN];

bool inc() {
	for (int i = 1; i < n; i++) {
		if (a[i] >= a[i + 1]) return 0;
	}
	return 1;
}

bool dec() {
	for (int i = 1; i < n; i++) {
		if (a[i] <= a[i + 1]) return 0;
	}
	return 1;
}

void solve() {
	cin >> n;

	set<ll> s;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		s.insert(a[i]);
	}

	if (sz(s) == 1) {
		cout << "0\n";
		return;
	}

	if (inc()) {
		ll dif = -1;
		for (int i = 1; i < n; i++) {
			if (dif == -1) dif = a[i + 1] - a[i];
			else {
				if (dif != a[i + 1] - a[i]) {
					cout << "-1\n";
					return;
				}
			}
		}
		
		cout << "0\n";
		return;
	}

	if (dec()) {
		ll dif = -1;
		for (int i = 1; i < n; i++) {
			if (dif == -1) dif = a[i] - a[i + 1];
			else {
				if (dif != a[i] - a[i + 1]) {
					cout << "-1\n";
					return;
				}
			}
		}

		cout << "0\n";
		return;
	}

	ll c = -1;
	for (int i = 1; i < n; i++) {
		if (a[i] == a[i + 1]) {
			cout << "-1\n";
			return;
		}
		
		if (a[i] < a[i + 1]) {
			if (c == -1) c = a[i + 1] - a[i];
			else {
				if (c != a[i + 1] - a[i]) {
					cout << "-1\n";
					return;
				}
			}
		}
	}

	ll m = -1;
	for (int i = 1; i < n; i++) {
		if (a[i] > a[i + 1]) {
			if (m == -1) m = a[i] + c - a[i + 1];
			else {
				if (m != a[i] + c - a[i + 1]) {
					cout << "-1\n";
					return;
				}
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		if (a[i] >= m || c >= m) {
			cout << "-1\n";
			return;
		}
	}

	cout << m << ' ' << c << '\n';
}


main() {
	setIO();
	
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
	}
	
	return 0;
}
