/*
 ''''' '  ' '''' '''' '''' '''' '''' ''''
   '   '  ' '       '    ' '  ' '       '
   '   '  ' '''' '''' '''' '''' '''' ''''
   '   '  ' '    '    '    '  ' '  ' '  '
   '   '''' '''' '''' '''' '''' '''' ''''
*/

#ifdef lolipop
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <cstddef>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <cassert>
#include <bitset>
#include <deque>
#include <utility>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forn(i, x, n) for (int i = x; i < n; i++)
#define ld double

using namespace std;

inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define endl '\n'

void solve() {
    int n;
    cin >> n;
    vector <int> a;
    forn (i, 0, n) {
        int x;
        cin >> x;
        a.push_back(x);
    }
    int c = -1, m = -1, ob = -1;
    forn (i, 1, n) {
        if (a[i] >= a[i-1]) {
            if (c == -1) c = a[i]-a[i-1]; else {
                if (c != a[i]-a[i-1]) {
                    cout << "-1\n";
                    return;
                }
            }
        } else {
            if (c > -1) {
                if (m > -1) {
                    if ((a[i-1]+c)%m != a[i]) {
                        cout << "-1\n";
                        return;
                    }
                } else {
                    if (c <= a[i]) {
                        cout << "-1\n";
                        return;
                    } else {
                        m = a[i-1]+c-a[i];
                    }
                }
            } else {
                if (ob > -1) {
                    if (a[i-1]-a[i] != ob) {
                        cout << "-1\n";
                        return;
                    }
                } else ob = a[i-1]-a[i];
            }
        }
    }

    if (c == -1) cout << "0\n"; else {
        m = -1;
        forn (i, 1, n) {
            if (a[i] >= a[i-1]) {
                if (m != -1 && a[i] >= m) {
                    cout << "-1\n";
                    return;
                }
                if (c != a[i]-a[i-1]) {
                    cout << "-1\n";
                    return;
                }
            } else {
                if (m > -1) {
                    if ((a[i-1]+c)%m != a[i]) {
                        cout << "-1\n";
                        return;
                    }
                } else {
                    if (c <= a[i]) {
                        cout << "-1\n";
                        return;
                    } else {
                        m = a[i-1]+c-a[i];
                    }
                }
            }
        }
        if (m == -1) cout << "0\n"; else cout << m << " " << c << "\n";
    }
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}