#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <random>
#include <ctime>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
using namespace std;
using vi = vector<int>;
using vc = vector<char>;
using pii = pair<int, int>;
using vvi = vector<vector<int>>;


inline void solve()
{
    int n;
    cin >> n;

    vi a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    int d1 = -1, d2 = -1;
    bool d0 = 0;
    for (int i = 1; i < n; i++)
    {
        int d = a[i] - a[i-1];

        if (d == 0)
            d0 = 1;
        else if (d0)
        {
            cout << "-1\n";
            return;
        }

        if (d > 0)
        {
            if (d1 == -1)
                d1 = d;
            else if (d1 != d)
            {
                cout << "-1\n";
                return;
            }
        }
        else
        {
            if (d2 == -1)
                d2 = -d;
            else if (d2 != -d)
            {
                cout << "-1\n";
                return;
            }
        }
    }

    if (d2 == -1 || d1 == -1)
    {
        cout << "0\n";
        return;
    }

    int c = d1, m = d1+d2;

    for (int i = 0; i < n; i++)
        if (a[i] >= m)
        {
            cout << "-1\n";
            return;
        }

    for (int i = 1; i < n; i++)
    {
        if (a[i] != (a[i-1] + c)%m)
        {
            cout << "-1\n";
            return;
        }
    }

    cout << m << ' ' << c << '\n';
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;
    while (T--)
        solve();

    return 0;
}
