#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

mt19937 rnd(time(0));

#define all(x) (x).begin(),(x).end()
#define ld long double
#define int long long

struct SparceTable {
    int n;
    vector<int> pows;
    vector<vector<int>> ST;
    SparceTable(vector<int> a1) {
        n = a1.size();
        pows.resize(n + 1, 0);
        for (int i = 2; i <= n; ++i) pows[i] = pows[i / 2] + 1;
        ST.resize(pows[n] + 1, vector<int> (n));
        for (int i = 0; i < n; ++i) ST[0][i] = a1[i];
        for (int p = 1; p <= pows[n]; ++p) {
            for (int i = 0; i < n; ++i) {
                ST[p][i] = min(ST[p - 1][i], ST[p - 1][min(i + (1 << (p - 1)), n - 1)]);
            }
        }
    }
    int getMin(int l, int r) {
        int len = r - l + 1;
        int p = pows[len];
        return min(ST[p][l], ST[p][r - (1 << p) + 1]);
    }
};

bool cmp(pair<int, vector<int>> &a, pair<int, vector<int>> &b) {
    return a.second.size() < b.second.size();
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, vector<int>>> a(m);
    vector<int> b(m, -1), cnt(n);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        a[i].first = i;
        while (k--) {
            int x;
            cin >> x;
            a[i].second.push_back(x - 1);
        }
    }
    sort(all(a), cmp);
    for (auto& i : a) {
        int bestID = 0, miVal = 1e9;
        for (auto& j : i.second) {
            if (cnt[j] < miVal) {
                bestID = j;
                miVal = cnt[j];
            }
        }
        ++cnt[bestID];
        b[i.first] = bestID;
    }
    bool ans = true;
    for (auto& i : cnt) {
        if (i > (m + 1) / 2) ans = false;
    }
    if (ans) {
        cout << "YES\n";
        for (auto& i : b) cout << i + 1 << ' ';
        cout << endl;
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}