#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define pii pair < int, int >
#define ll long long
#define F first
#define S second
#define TIME 1.0 * clock() / CLOCKS_PER_SEC
#define pb push_back
#define endl '\n'
#define Endl '\n'

const int mod = 1e9 + 7;
const ll inf = 1e18;

mt19937 gen(time(0));

const int SX[4] = {1, -1, 0, 0};
const int SY[4] = {0, 0, -1, 1};

void solve(){
    int n, m;
    cin >> n >> m;
    vector < int > cnt(n, 0);
    vector < vector < int > > all(m);

    vector < pair < int, int > > sz;

    for (int i = 0;i < m; ++i){
        int k;
        cin >> k;
        all[i].resize(k);
        for (auto &to : all[i])cin >> to, cnt[to - 1]++;

        sz.pb({k, i});

    }
    vector < pii > mem;
    for (int i = 0;i < n; ++i){
        mem.pb({cnt[i], i});
    }
    sort(mem.begin(), mem.end());

    vector < int > pos(n, 0);
    for (int i = 0;i < n; ++i){
        if (!i)pos[mem[i].S] = 0;
        else{
            if (mem[i].F == mem[i - 1].F)pos[mem[i].S] = pos[mem[i - 1].S];
            else pos[mem[i].S] = pos[mem[i - 1].S] + 1;
        }
    }

    vector < int > kol(n, 0);
    vector < int > ans(m);
    bool ok = 1;
    sort(sz.begin(), sz.end());
    for (int j = 0;j < m; ++j){
        int i = sz[j].S;
        set < pair < int, int > > st;
        for (auto to : all[i]){
            st.insert({pos[to - 1], to - 1});
        }
        bool fl = 0;
        for (auto to : st){
            if (cnt[to.S] <= m / 2 + (m % 2) && kol[to.S] + 1 <= m / 2 + (m % 2)){
                kol[to.S]++;
                ans[i] = to.S + 1;
                fl = 1;
                break;
            }
        }
        if (fl)continue;
        for (auto to : st){
            if (kol[to.S] + 1 <= m / 2 + (m % 2)){
                kol[to.S]++;
                ans[i] = to.S + 1;
                fl = 1;
                break;
            }
        }
        if (!fl){
            ok = 0;
            break;
        }
    }
    if (ok){
        cout << "YES" << endl;
        for (auto to : ans)cout << to << " ";
        cout << endl;
        return;
    }


    ok = 1;
    fill(kol.begin(), kol.end(), 0);
    ans.clear();
    ans.resize(m);
    for (auto to : sz){
        set < pair < int, int > > st;
        for (auto tt : all[to.S]){
            st.insert({kol[tt - 1], tt - 1});
        }
        bool fl = 0;
        for (auto tt : st){
            if (cnt[tt.S] <= m / 2 + (m % 2) && kol[tt.S] + 1 <= m / 2 + (m % 2)){
                kol[tt.S]++;
                ans[to.S] = tt.S + 1;
                fl = 1;
                break;
            }
        }
        if (fl)continue;

        for (auto tt : st){
            if (kol[tt.S] + 1 <= m / 2 + (m % 2)){
                kol[tt.S]++;
                ans[to.S] = tt.S + 1;
                fl = 1;
                break;
            }
        }
        if (!fl){
            ok = 0;
            break;
        }
    }
    if (ok){
        cout << "YES" << endl;
        for (auto to : ans)cout << to << " ";
        cout << endl;
        return;
    }
    cout << "NO" << endl;
    return;
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t --> 0)solve();
    return 0;
}
