#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <utility>
#include <cassert>
#include <random>
#include <chrono>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <list>
#include <array>

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> cnt(n);
	vector<vector<int>> a(m);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			--a[i][j];
			++cnt[a[i][j]];
		}
	}
	int need = (m + 1) >> 1;
	int max_ind = max_element(cnt.begin(), cnt.end()) - cnt.begin();
	int max_cnt = cnt[max_ind];
	if (max_cnt <= need) {
		cout << "YES\n";
		for (int i = 0; i < m; ++i) {
			cout << a[i][0] + 1 << ' ';
		}
		cout << '\n';
		return;
	}
	vector<char> v(m);
	for (int i = 0; i < m; ++i) {
		if (a[i].size() == 1) {
			if (a[i][0] == max_ind) {
				v[i] = 0;
			} else {
				v[i] = 2;
			}
		} else {
			if (find(a[i].begin(), a[i].end(), max_ind) == a[i].end()) {
				v[i] = 2;
			} else {
				v[i] = 1;
			}
		}
	}
	int c = count(v.begin(), v.end(), 0);
	if (c > need) {
		cout << "NO\n";
	} else {
		vector<int> ans(m, -1);
		for (int i = 0; i < m; ++i) {
			if (v[i] == 0) {
				ans[i] = max_ind;
			}
		}
		int ost = need - c;
		for (int i = 0; i < m && ost; ++i) {
			if (v[i] == 1) {
				ans[i] = max_ind;
				--ost;
			}
		}
		for (int i = 0; i < m; ++i) {
			if (v[i] == 1) {
				a[i].erase(find(a[i].begin(), a[i].end(), max_ind));
			}
		}
		for (int i = 0; i < m; ++i) {
			if (ans[i] == -1) {
				ans[i] = a[i][0];
			}
		}
		cout << "YES\n";
		for (int i = 0; i < m; ++i) {
			cout << ans[i] + 1 << ' ';
		}
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		solve();
	}

	return 0;
}