#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;



void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> in(n);
    vector <vector <int>> host(m);

    for (int i = 0; i < m; i++) {
        int cn;
        cin >> cn;

        while (cn--) {
            int x;
            cin >> x;
            x--;
            in[x].push_back(i);
            host[i].push_back(x);
        }
    }

    int mx = 0;
    for (int i = 0; i < n; i++) {
        if (in[i].size() > in[mx].size()) {
            mx = i;
        }
    }

    vector <int> ans(m, -1);
    int cn = (m + 1) / 2;

    for (int i : in[mx]) {
        if (host[i].size() == 1) {
            ans[i] = mx;
            cn--;
        }
    }

    if (cn < 0) {
        cout << "NO\n";
        return;
    }

    for (int i : in[mx]) {
        if (ans[i] == -1 && cn) {
            ans[i] = mx;
            cn--;
        }
    }

    for (int i = 0; i < m; i++) {
        if (ans[i] != -1)
            continue;

        if (host[i][0] == mx)
            ans[i] = host[i][1];
        else
            ans[i] = host[i][0];
    }
    cout << "YES\n";
    for (int i : ans)
        cout << i + 1 << " ";
    cout << "\n";
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--)
        solve();
    return 0;
}
