#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <iomanip>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

void solve() {

	int n, m;
	cin >> n >> m;
	vvi a(m);
	vi ans(m);
	vvi b(n);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			--x;
			a[i].pb(x);
		}
		ans[i] = a[i][0];
		b[a[i][0]].pb(i);
	}
	for (int i = 0; i < n; ++i) {
		if (b[i].size() <= (m + 1) / 2)
			continue;
		int x = b[i].size() - (m + 1) / 2;
		for (int j : b[i]) {
			if (a[j].size() == 1)
				continue;
			ans[j] = a[j][1];
			--x;
			if (x == 0)
				break;
		}
		if (x) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (int i = 0; i < m; ++i)
		cout << ans[i] + 1 << ' ';
	cout << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();

	return 0;
}