#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
using namespace std;
typedef long long ll;

bool comp(pair<vector<int>, int> a, pair<vector<int>, int> b)
{
	return a.first.size() < b.first.size();
}

void Solve()
{
	int n, m;
	cin >> n >> m;
	vector<pair<vector<int>, int>> vec(m);
	vector<int> res(m);
	vector<int> cnt(n);
	for (int i = 0; i < m; ++i)
	{
		int k;
		cin >> k;
		vec[i].first.resize(k);
		for (auto& el : vec[i].first)
			cin >> el;
		vec[i].second = i;
	}
	sort(vec.begin(), vec.end(), comp);
	for (int i = 0; i < m; ++i)
	{	
		int mn = -1;
		for (int j = 0; j < vec[i].first.size(); ++j)
		{
			int x = vec[i].first[j];
			--x;
			if (mn == -1 || cnt[mn] > cnt[x])
				mn = x;
		}
		++cnt[mn];
		res[vec[i].second] = mn + 1;
	}
	bool f = 1;
	for (auto& el : cnt)
	{
		if (el > (m + 1) / 2)
		{
			f = 0;
			break;
		}
	}
	if (f)
	{
		cout << "YES\n";
		for (auto& el : res)
			cout << el << ' ';
		cout << endl;
	}
	else
		cout << "NO\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--)
		Solve();
}