#include <algorithm>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <map>
#include <set>

using namespace std;

void solve(){
	 int n, m, k;
	 cin >> n >> m;
	 vector <vector <int>> a(m);
	 for (int i = 0; i < m; i++){
		 cin >> k;
		 a[i].resize(k);
		 for (int j = 0; j < k; j++) cin >> a[i][j];
	 }
	 /*for (int i = 0; i < m; i++){
		 cout << i + 1 << '\n';
		 for (size_t j = 0; j < a[i].size(); j++){
			 cout << a[i][j] << ' ';
		 }
		 cout << '\n';
	 }*/
	 int mx = m / 2 + m % 2;
	 vector <int> play(m), played(n + 1, 0);
	 for (int i = 0; i < m; i++){
		 if ((int)a[i].size() == 1){
			 played[a[i][0]]++;
			 play[i] = a[i][0];
		 }
	 }
	 int mn;
	 for (int i = 0; i < m; i++){
		 if ((int)a[i].size() > 1){
			 mn = 0;
			 for (size_t j = 1; j < a[i].size(); j++){
				 if (played[a[i][j]] < played[a[i][mn]]) mn = j;
			 }
			 played[a[i][mn]]++;
			 play[i] = a[i][mn];
		 }
	 }
	 for (int i = 0; i <= n; i++){
		 if (played[i] > mx){
			 cout << "NO\n";
			 return;
		 }
	 }
	 cout << "YES\n";
	 for (int i = 0; i < m; i++) cout << play[i] << ' ';
	 cout << '\n';
}

int main(){
	ios_base::sync_with_stdio(0);
	int T = 1;
	cin >> T;
	while (T--){
		solve();
	}
	return 0;
}