#include <bits/stdc++.h>

#define ll long long
#define fi first
#define se second
#define vec vector
#define all(x) x.begin(), x.end()

using namespace std;

//#define int long long
//#define endl "\n"

struct ST{
    int sz;
    vec<int> tree, ad;
    ST (vec<int>& v) {
        sz = 1;
        while (v.size() > sz) sz *= 2;
        tree.resize(sz * 2, INT_MAX);
        ad.resize(sz * 2, 0);
        for (int i = 0; i < v.size(); ++i) {
            tree[i + sz] = v[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    int get_val(int id) {
        return tree[id] + ad[id];
    }
    void push(int id) {
        tree[id] += ad[id];
        ad[id * 2] += ad[id];
        ad[id * 2 + 1] += ad[id];
        ad[id] = 0;
    }
    int get_ans(int id, int l, int r, int lq, int rq) {
        if (rq <= l || r <= lq) return INT_MAX;
        if (lq <= l && r <= rq) return get_val(id);

        push(id);
        int la = get_ans(id * 2, l, (l + r) / 2, lq, rq);
        int ra = get_ans(id * 2 + 1, (l + r) / 2, r, lq, rq);
        return min(la, ra);
    }
    void add_val(int id, int l, int r, int lq, int rq, int val) {
        if (rq <= l || r <= lq) return;
        if (lq <= l && r <= rq) {ad[id] += val; return;}

        push(id);
        add_val(id * 2, l, (l + r) / 2, lq, rq, val);
        add_val(id * 2 + 1, (l + r) / 2, r, lq, rq, val);
        tree[id] = min(get_val(id * 2), get_val(id * 2 + 1));
    }
    void pr() {
        int x = 0, y = 1;
        for (int i = 1; i < tree.size(); ++i) {
            cout << "{ " << tree[i] << ' ' << ad[i] << " } ";
            x++;
            if (x == y) {
                x = 0;
                y *= 2;
                cout << endl;
            }
        }
    }
};



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    for (int q = 0; q < t; ++q) {
        int n, m; cin >> n >> m;
        vec<vec<int>> v(m);
        vec<int> cou(n + 1, 0), cou2(n + 1, 0);
        for (int i = 0; i < m; ++i) {
            int x; cin >> x;
            for (int j = 0; j < x; ++j) {
                int y; cin >> y;
                cou2[y]++;
                v[i].push_back(y);
            }
            if (x == 1) {
                cou[v[i][0]]++;
            }
        }
        bool f = false;
        int c = m / 2 + m % 2;
        for (int i = 0; i <= n; ++i) {
            if (cou[i] > c) {
                f = true;
                break;
            }
        }
        if (f) cout << "NO" << endl;
        else {
            cout << "YES" << endl;
            int num = -1;
            for (int i = 0; i <= n; ++i) {
                if (cou2[i] > c) num = i;
            }
            if (num == -1) {
                for (int i = 0; i < m; ++i) {
                    cout << v[i][0] << ' ';
                }
                cout << endl;
            } else {
                vec<int> ch(m + 1, 0);
                int kol = 0;
                for (int i = 0; i < m; ++i) {
                    if (kol == c) break;
                    if (v[i].size() == 1 && v[i][0] == num) {
                        ch[i] = 1;
                        kol++;
                    }
                }
                for (int i = 0; i < m; ++i) {
                    if (kol == c) break;
                    if (ch[i]) continue;
                    for (int j = 0; j < v[i].size(); ++j) {
                        if (v[i][j] == num) {
                            f = true;
                            ch[i] = 1;
                            kol++;
                            break;
                        }
                    }
                }
                for (int i = 0; i < m; ++i) {
                    if (ch[i]) cout << num << ' ';
                    else {
                        for (int j = 0; j < v[i].size(); ++j) {
                            if (v[i][j] != num) {
                                cout << v[i][j] << ' ';
                                break;
                            }
                        }
                    }
                }
                cout << endl;
            }
        }
    }
}
/*
8
2 3 9 0 8 5 1 3
*/







