#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <functional>
#include <random>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int INF = 1e9 + 7;
const ll LINF = 2e18;
const int MOD = INF;
const int N = 1e5;

void Solve() {
	int n, m;
	cin >> n >> m;
	int lim = (m + 1) / 2;
	vector <vector <int>> v(m);
	vector <vector <int>> canPlay(n);
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> v[i][j];
			canPlay[v[i][j] - 1].push_back(i);
		}
	}
	int problem = -1;
	for (int i = 0; i < n; i++) {
		if (canPlay[i].size() > lim) {
			problem = i;
		}
	}
	if (problem == -1) {
		cout << "YES\n";
		for (int i = 0; i < m; i++) {
			cout << v[i][0] << " ";
		}
		cout << '\n';
	}
	else {
		vector <int> ans(m, -1);
		for (int i : canPlay[problem]) {
			if (v[i].size() == 1) {
				if (lim) {
					ans[i] = problem + 1;
					lim--;
				}
				else {
					cout << "NO\n";
					return;
				}
			}
		}
		for (int i : canPlay[problem]) {
			if (lim) {
				if (ans[i] != problem + 1) {
					ans[i] = problem + 1;
					lim--;
				}
			}
			else {
				break;
			}
		}
		for (int i = 0; i < m; i++) {
			if (ans[i] != -1) continue;
			if (v[i][0] == problem + 1) {
				ans[i] = v[i][1];
			}
			else {
				ans[i] = v[i][0];
			}
		}
		cout << "YES\n";
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] << " ";
		}
		cout << "\n";
	}
}

int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
	Solve();
}