#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <iomanip>

#define endl '\n'

using namespace std;

const int Base = 1e5 + 55;

int t, n, m;
vector<int> freeFriends[Base];
int friendBadDays[Base];


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n >> m;
		for (int i = 0; i < n + 2; i++)
		{
			friendBadDays[i] = 0;
		}
		int maxBad = 0;
		for (int i = 0; i < m; i++)
		{
			int k;
			cin >> k;
			freeFriends[i].clear();
			for (int j = 0; j < k; j++)
			{
				int x;
				cin >> x;
				freeFriends[i].push_back(x);
			}
			if (freeFriends[i].size() == 1)
			{
				friendBadDays[freeFriends[i][0]]++;
				maxBad = max(maxBad, friendBadDays[freeFriends[i][0]]);
			}
		}
		if (maxBad > (m + 1) / 2)
		{
			cout << "NO" << endl;
		}
		else
		{
			cout << "YES" << endl;
			for (int i = 0; i < m; i++)
			{
				if (freeFriends[i].size() == 1)
				{
					cout << freeFriends[i][0] << ' ';
				}
				else
				{
					if (friendBadDays[freeFriends[i][0]] == (m + 1) / 2)
					{
						cout << freeFriends[i][1] << ' ';
						friendBadDays[freeFriends[i][1]]++;
					}
					else
					{
						cout << freeFriends[i][0] << ' ';
						friendBadDays[freeFriends[i][0]]++;
					}
				}
			}
			cout << endl;
		}
	}
}