﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

typedef long long ll;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}


bool cmp(const vector<int>& a, const vector<int>& b) {
    return a[0] < b[0];
}

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int q = 0; q != t; ++q) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> f;
        for (int i = 0; i != m; ++i) {
            int k;
            cin >> k;
            vector<int> free(k+2);
            free[0] = k;
            free[1] = i;
            for (int j = 2; j != k + 2; ++j)
                cin >> free[j];
            f.push_back(free);
        }
        sort(f.begin(), f.end(), cmp);
        vector<int> ans(m);
        vector<int> cnt(n + 1);
        for (int i = 0; i != m; ++i) {
            int min_v = (int)1e8;
            int min_f = -1;
            for (int j = 2; j != f[i][0] + 2; ++j) {
                if (min_v > cnt[f[i][j]]) {
                    min_v = cnt[f[i][j]];
                    min_f = f[i][j];
                }
            }
            ++cnt[min_f];
            ans[f[i][1]] = min_f;
        }
        bool good = true;
        for (int i = 1; i != n + 1; ++i )
            if (cnt[i] > (m + 1) / 2)
            {
                good = false;
                break;
            }
        if (good) {
            cout << "YES" << endl;
            for (int i : ans)
                cout << i << ' ';
            cout << endl;
        }
        else {
            cout << "NO" << endl;
        }
    }
}