#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <bitset>
#include <cmath>
#include <ctime>
#include <deque>
#include <map>
#include <numeric>
#include <queue>
#include <random>
#include <stack>
#include <string>
#include <tuple>

#define int long long
#define double long double

#define start cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false)

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &elem : v) {
        is >> elem;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (T &elem : v) {
        os << elem << ' ';
    }
    return os;
}

bool cmp(pair<int, vector<int>>& fi, pair<int, vector<int>>& se) {
    return fi.second.size() < se.second.size();
}

void solve() {
    int n, m, k;
    cin >> n >> m;
    vector<pair<int, vector<int>>> a(m, pair<int, vector<int>>());
    for (int i = 0; i < m; ++i) {
        cin >> k;
        a[i].second.resize(k);
        cin >> a[i].second;
        for (int j = 0; j < k; ++j) {
            a[i].second[j] -= 1;
        }
        a[i].first = i;
    }
    sort(a.begin(), a.end(), cmp);
    vector<int> b(n);
    bool flag = true;
    vector<int> ans(m);
    for (int i = 0; i < m; ++i) {
        if (a[i].second.size() == 1) {
            b[a[i].second[0]] += 1;
            ans[a[i].first] = a[i].second[0] + 1;
            if (b[a[i].second[0]] > (m + 2 - 1) / 2) {
                cout << "NO" << '\n';
                return;
            }
        } else {
            if (b[a[i].second[0]] == (m + 2 - 1) / 2) {
                b[a[i].second[1]] += 1;
                ans[a[i].first] = a[i].second[1] + 1;
            } else {
                b[a[i].second[0]] += 1;
                ans[a[i].first] = a[i].second[0] + 1;
            }
        }
    }
    cout << "YES" << '\n';
    cout << ans << '\n';
}

int32_t main() {
    start;

    int t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}