#include <bits/stdc++.h>

using namespace std;

#define endl "\n"


void setup() {
#ifdef LOCAL
    freopen("input", "r", stdin);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
}


int main() {
    setup();
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> daysLeft(n), daysSeen(n);
        vector<pair<vector<int>, int>> days(m);
        for (int i = 0; i < m; i++) {
            int k;
            cin >> k;
            for (int j = 0; j < k; j++) {
                int x;
                cin >> x;
                days[i].first.push_back(x);
                daysLeft[x - 1]++;
            }
            days[i].second = i;
        }
        sort(days.begin(), days.end(), [&](pair<vector<int>, int>& a1, pair<vector<int>, int>& a2) {
                    return a1.first.size() < a2.first.size();
                });
        int maxDays = (m + 1) / 2;
        vector<int> answer(m);
        for (int i = 0; i < m; i++) {
            int best = -1;
            for (int f : days[i].first) {
                if (daysSeen[f - 1] < maxDays) {
                    if (best == -1 || daysLeft[best - 1] > daysLeft[f - 1]) {
                        best = f;
                    }
                }
                daysLeft[f - 1]--;
            }
            answer[days[i].second] = best;
            if (best != -1)
                daysSeen[best - 1]++;
            else
                break;
        }
        bool no = false;
        for (int it : answer) {
            no |= it == -1;
        }
        if (no) {
            cout << "NO" << endl;
        } else {
            cout << "YES" << endl;
            for (int it : answer) {
                cout << it << " ";
            }
            cout << endl;
        }
    }
}

