#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <bitset>
#include <random>
#include <queue>
#include <ctime>
#include <deque>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()
#define an cerr <<"--->"; cerr.flush();

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;

const ll inf = (ll)1e18 + 228;
const ll cst = 3e5 + 5;
const ll mod = 1e9 + 7;

void operator delete(void*);

vector<ll> days[cst];

set<pair<ll, ll>> fr[cst];

ll answ[cst];

void solve() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i <= m; i++) {
		days[i].clear();
		answ[i] = -1;
	}
	for (ll i = 0; i <= n; i++) fr[i].clear();
	for (ll i = 1; i <= m; i++) {
		ll k;
		cin >> k;
		days[i].resize(k);
		for (ll j = 0; j < k; j++) {
			cin >> days[i][j];
			fr[days[i][j]].insert({ k, i });
		}
	}
	ll bigg = 0;
	for (ll i = 1; i <= n; i++) {
		if (fr[i].size() > fr[bigg].size()) bigg = i;
	}
	if (fr[bigg].size() <= (m + 1) / 2) {
		cout << "YES\n";
		for (ll i = 1; i <= m; i++) cout << days[i][0] << " ";
		return;
	}
	ll cnt = (m + 1) / 2;
	for (auto i : fr[bigg]) {
		if (i.first == 1 && cnt <= 0) {
			cout << "NO";
			return;
		}
		else if(cnt > 0) {
			answ[i.second] = bigg;
			cnt--;
		}
	}
	cout << "YES\n";
	for (ll i = 1; i <= m; i++) {
		if (answ[i] == -1) {
			for (ll j = 0; j < days[i].size(); j++) {
				if (days[i][j] != bigg) {
					answ[i] = days[i][j];
					break;
				}
			}
		}
		cout << answ[i] << " ";
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
#ifdef _DEBUG
		cout << endl;
#else
		cout << "\n";
#endif
	}
	return 0;
}
