#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <queue>
#include <numeric>
#include <random>
/*
#pragma GCC optimise("Ofast,O2,O3")
*/
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<set<int>> L(n), R(m);
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int v;
                cin >> v;
                --v;
                L[v].insert(i);
                R[i].insert(v);
            }
        }
        //
        set<pair<int, int>> S;
        for (int i = 0; i < n; ++i) {
            S.emplace(L[i].size(), i);
        }
        vector<int> res(m, -1);
        while (!S.empty() && S.begin()->first <= (m + 1) / 2) {
            int v = S.begin()->second;
            S.erase(S.begin());
            for (int u : L[v]) {
                res[u] = v;
                for (int w : R[u]) {
                    if (w == v) {
                        continue;
                    }
                    S.erase(make_pair(L[w].size(), w));
                    L[w].erase(u);
                    S.emplace(L[w].size(), w);
                }
            }
        }
        //
        if (S.size() == 1) {
            cout << "NO\n";
            continue;
        }
        //
        vector<int> cnt(n, 0);
        for (int i = 0; i < m; ++i) {
            if (res[i] != -1) {
                continue;
            }
            if (R[i].size() == 1) {
                res[i] = *R[i].begin();
                ++cnt[*R[i].begin()];
            }
        }
        //
        for (int i = 0; i < m; ++i) {
            if (res[i] != -1) {
                continue;
            }
            auto it = R[i].begin();
            int a = *it;
            ++it;
            int b = *it;
            if (cnt[a] > cnt[b]) {
                swap(a, b);
            }
            res[i] = a;
            ++cnt[a];
        }
        //
        cout << "YES\n";
        for (int i = 0; i < m; ++i) {
            cout << res[i] + 1 << " ";
        }
        cout << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}
