#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)

const ll INF = 2e9;
const ll inf = 2e18;
const ll MAXN = 2e5;

istream& operator >>(istream &in, pii x) {
    in >> x.first >> x.second;
    return in;
}

template <class T>
istream& operator >>(istream &in, vector<T> &a) {
    for (T &i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> a) {
    for (T i : a) {
        out << i << " ";
    }
    out << "\n";
    return out;
}

void solve() {
    int n, m; cin >> n >> m;
    vvi graph(m);
    vi cnt(n);
    vi used(m);
    vi ans(m);
    for (int i = 0; i < m; ++i) {
        int k; cin >> k;
        if (k == 1) {
            int x; cin >> x;
            --x;
            cnt[x]++;
            used[i] = 1;
            ans[i] = x;
        } else {
            for (int j = 0; j < k; ++j) {
                int u; cin >> u; --u;
                graph[i].push_back(u);
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (used[i]) continue;
        int vb = graph[i][0];
        for (int u : graph[i]) {
            if (cnt[u] < cnt[vb]) vb = u;
        }
        cnt[vb]++;
        used[i] = 1;
        ans[i] = vb;
    }
    for (int i = 0; i < n; ++i) {
        if (cnt[i] > (m + 1) / 2) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (int i : ans) cout << i + 1 << " ";
    cout << "\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif

    ll t; cin >> t;
    while (t--)
    solve();

    return 0;
}