#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define int long long
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> friends(m);
    vector<int> cnt(n);
    vector<int> ans(m, -1);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        friends[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> friends[i][j];
            friends[i][j]--;
        }
        if (k == 1) {
            cnt[friends[i][0]]++;
            ans[i] = friends[i][0];
        }
    }
    for (int i = 0; i < m; i++) {
        if (sz(friends[i]) == 1) continue;
        for (auto v : friends[i]) {
            if (cnt[v] + 1 <= (m + 1) / 2) {
                cnt[v] += 1;
                ans[i] = v;
                break;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (cnt[i] > (m + 1) / 2) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (int i = 0; i < m; i++) {
        assert(ans[i] != -1);
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
#endif
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
