#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
using namespace std;

int t, n, m, k, f;
vector<vector<int>> who;
vector<int> day, used;
vector<pair<int, int>> eq;

int main()
{
    cin >> t;
    while (--t + 1)
    {
        who.clear();
        day.clear();
        used.clear();
        eq.clear();
        cin >> n >> m;
        who.resize(m);
        day.resize(m, 0);
        used.resize(n + 1, 0);
        eq.resize(m);
        for (int i = 0; i < m; ++i)
        {
            cin >> k;
            who[i].resize(k);
            for (int j = 0; j < k; ++j)
                cin >> who[i][j];
        }
        for (int i = 0; i < m; ++i)
            eq[i] = {who[i].size(), i};
        sort(eq.begin(), eq.end());
        for (int i = 0; i < m; ++i)
        {
            k = eq[i].second;
            f = who[k][0];
            for (int j = 1; j < who[k].size(); ++j)
                if (used[who[k][j]] < used[f])
                    f = who[k][j];
            ++used[f];
            day[k] = f;
        }
        f = 0;
        for (int i = 1; i <= n; ++i)
            if (used[i] > (m + 1) / 2)
            {
                f = 1;
                break;
            }
        if (f)
            cout << "NO\n";
        else
        {
            cout << "YES\n";
            for (int i = 0; i < m; ++i)
                cout << day[i] << " ";
            cout << "\n";
        }
    }
}