#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")

#define int long long
#define len(a) (int)a.size()

const int INF = 2e18;


bool cmp(const pair<int, vector<int>> &a, const pair<int, vector<int>> &b) {
    return len(a.second) < len(b.second);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, vector<int>>> days(m);
    vector<int> friend_frequency(n);
    for (int i = 0; i < m; ++i) {
        int t;
        cin >> t;
        days[i].first = i;
        for (int j = 0; j < t; ++j) {
            int v;
            cin >> v;
            days[i].second.push_back(--v);
        }
    }
    sort(days.begin(), days.end(), &cmp);
    vector<int> ans(m);
    for (int i = 0; i < m; ++i) {
        int least_popular_friend = 0;
        for (int j = 0; j < len(days[i].second); ++j) {
            if (friend_frequency[days[i].second[j]] < friend_frequency[days[i].second[least_popular_friend]]) {
                least_popular_friend = j;
            }
        }
        ++friend_frequency[days[i].second[least_popular_friend]];
        if (friend_frequency[days[i].second[least_popular_friend]] > (m + 1) / 2) {
            cout << "NO" << "\n";
            return;
        }
        ans[days[i].first] = days[i].second[least_popular_friend] + 1;
    }
    cout << "YES" << "\n";
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}
