#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const long long INF = 1e16;

void solve()
{
    int n, m;
    cin >> n >> m;
    
    vector<vector<int>> a(m);
    vector<set<pair<int, int>>> b(n);

    for (int i = 0; i < m; i++)
    {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++)
            cin >> a[i][j];
    }

    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < a[i].size(); j++)
        {
            b[a[i][j] - 1].insert({ a[i].size(), i });
        }
    }

    vector<int> ans(m, -1);

    for (int i = 0; i < n; i++)
    {
        int t = 0;
        for (auto it = b[i].begin(); it != b[i].end(); it++)
        {
            if (t == (m + 1) / 2) break;
            if (ans[(*it).second] == -1)
            {
                ans[(*it).second] = i + 1;
                t++;
            }
        }
    }

    for (int i = 0; i < m; i++)
        if (ans[i] == -1)
        {
            cout << "NO\n";
            return;
        }

    cout << "YES\n";
    for (auto& x : ans)
        cout << x << " ";
    cout << '\n';

    return;
}

int main()
{
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}