#include<bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define pb push_back
#define ld long double
#define ll __int128

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> setik;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int>> good(m);
    vector<vector<int>> can(m);
    vector<int> last(n);
    vector<vector<int>> fr(n);
    for (int i = 0; i < n; i++)
    {
        last[i] = (m + 1) / 2;
    }
    for (int i = 0; i < m; i++)
    {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++){
            int a;
            cin >> a;
            a--;
            fr[a].pb(i);
        }
    }
    for (int i = 0; i < n; i++){
        if (fr[i].size() <= (m + 1) / 2){
            for (auto to : fr[i]){
                good[to].pb(i);
            }
        }
        else{
            for (auto to : fr[i]){
                can[to].pb(i);
            }
        }
    }
    vector<int> ans(m, -1);
    for (int i = 0; i < m; i++)
    {
        if (good[i].size() > 0)
        {
            ans[i] = good[i][0];
        }
        else
        {
            if (can[i].size() == 0)
            {
                cout << "NO\n";
                return;
            }
            else if (can[i].size() == 1){
                if (last[can[i][0]] == 0){
                    cout << "NO\n";
                    return;
                }
                last[can[i][0]]--;
                ans[i] = can[i][0];
            }
        }
    }
    for (int i = 0; i < m; i++){
        if (good[i].size() == 0 && can[i].size() > 1){
            for (auto to : can[i]){
                if (last[to] > 0){
                    last[to]--;
                    ans[i] = to;
                    break;
                }
            }
        }
    }
    cout << "YES\n";
    for (auto to : ans){
        cout << to + 1 << " ";
    }
    cout << endl;
}

int32_t main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--)
    {
        solve();
    }
    return 0;
}
