#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
typedef long double ld;

using namespace std;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;
const int md = 1e9 + 7;


void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> to(m);
    vector<int> ans(m);
    vector<int> cnt(n);
    range(i, m) {
        int k; cin >> k;
        to[i].resize(k);
        range(j, k) {
            cin >> to[i][j];
            to[i][j]--;
        }
        if (k == 1) {
            ans[i] = to[i][0];
            cnt[to[i][0]]++;
        }
    }
    range(i, m) {
        if (to[i].size() == 1) continue;
        int x = to[i][0];
        int y = to[i][1];
        if (cnt[x] > cnt[y]) {
            ans[i] = y;
            cnt[y]++;
        } else {
            ans[i] = x;
            cnt[x]++;
        }
    }
    int mx = *max_element(all(cnt));
    int t = (m + 1) / 2;
    if (mx > t) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    for(auto &x : ans) cout << x + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}