#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;

template <class T = int>
T next() { T x; cin >> x; return x; }

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t = next();
    while (t--)
    { 
        int n = next(), m = next();
        vector<int> games(n, 0);
        vector<vector<int>> days(m);
        vector<int> ans;

        for (auto& day : days)
        {
            int k = next();
            day.resize(k);

            for (int& x : day)
                x = next() - 1;
            
            if (day.size() == 1)
                games[day.front()]++;
        }

        for (auto& day : days)
        {
            if (day.size() == 1)
            {
                ans.push_back(day.front() + 1);
                continue;
            }

            int com = day.front();
            for (int x : day)
                if (games[x] < games[com])
                    com = x;

            ans.push_back(com + 1);
            games[com]++;
        }

        for (int i = 0; i < n; i++)
            if ((m + 1) / 2 < games[i])
            {
                cout << "NO\n";
                goto NXT;
            }

        cout << "YES\n";
        for (int v : ans)
            cout << v << ' ';
        cout << '\n';
            
    NXT:
        ;
    }

    return 0;
}