#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <time.h>
#include <math.h>
#include <fstream>
#define all(x) x.begin(), x.end()
#define make_pair mp
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7, N = 3e5 + 6;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }


ll n, m, k, t;


bool cmp(pair<vector<int>, int> &a, pair<vector<int>, int> &b) {
	if (a.first.size() < b.first.size() || a.first.size() == b.first.size() && a.second < b.second) {
		return true;
	}
	return false;
}


void solve()
{
	cin >> k >> n;

	vector<int> cnt(k);
	vector<pair<vector<int>, int>> tmp(n);


	for (int i = 0; i < n; i++) {
		cin >> m;

		tmp[i].second = i;

		for (int j = 0; j < m; j++) {
			int x;
			cin >> x;
			tmp[i].first.push_back(x);
		}
	}

	sort(all(tmp), cmp);

	vector<int> ans(n);

	for (int i = 0; i < n; i++) {
		int mini = INF, ind = -1;

		for (int j : tmp[i].first) {
			if (cnt[j - 1] < mini) {
				mini = cnt[j - 1];
				ind = j - 1;
			}
		}

		cnt[ind]++;
		ans[tmp[i].second] = ind + 1;
	}

	bool flag = true;

	for (int x : cnt) {
		if (x > ((n + 1) / 2)) {
			flag = false;
		}
	}


	if (flag) {
		cout << "YES\n";

		for (int x : ans) {
			cout << x << " ";
		}
		cout << '\n';
	}
	else {
		cout << "NO\n";
	}

}




signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL), cout.tie(NULL);
	

	cin >> t;
	while (t--) {
		solve();
	}


}

