#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);



int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> f(m);
        int k;
        for (int i = 0; i < m; i++)
        {
            cin >> k;
            f[i].resize(k);
            for (int j = 0; j < k; j++)
            {
                cin >> f[i][j];
            }
        }

        int mx = (m + 1) / 2;
        vector<int> cnt(n + 1, 0);
        bool good = 1;
        for (int i = 0; i < m; i++)
        {
            if (f[i].size() == 1)
            {
                cnt[f[i][0]]++;
                if (cnt[f[i][0]] > mx)
                {
                    good = 0;
                }
            }
        }

        if (!good)
        {
            cout << "NO" << endl;
            continue;
        }
        cout << "YES" << endl;

        for (int i = 0; i < m; i++)
        {
            if (f[i].size() == 1)
            {
                cout << f[i][0] << " ";
            }
            else
            {
                for (int x : f[i])
                {
                    if (cnt[x] < mx)
                    {
                        cnt[x]++;
                        cout << x << " ";
                        break;
                    }
                }
            }
        }
        cout << endl;
    }

    return 0;
}