
#include <bits/stdc++.h>

using namespace std;

#define int long long


vector<int> tree;

int get(int v, int l, int r, int tl, int tr)
{
    if (l >= tr)
    {
        return 0;
    }
    if (tl >= r)
    {
        return 0;
    }
    if (r <= l)
    {
        return 0;
    }
    if (l == tl && tr == r)
    {
        return tree[v];
    }
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, l, min(r, tm), tl, tm) + get(2 * v + 2, max(l, tm), r, tm, tr);
}

void upd(int v, int tl, int tr, int pos, int val)
{
    if (tl == tr - 1)
    {
        tree[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (tm > pos)
    {
        upd(2 * v + 1, tl, tm, pos, val);
    }
    else
    {
        upd(2 * v + 2, tm, tr, pos, val);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("output.txt", "w", stdout);
    //freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector<int> used(n);
        vector<vector<int> > days(m);
        for (int i = 0; i < m; ++i)
        {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j)
            {
                int x;
                cin >> x;
                x--;
                days[i].push_back(x);
            }
            if (k == 1)
            {
                used[days[i][0]]++;
            }
        }
        bool f = true;
        for (int i = 0; i < n; ++i)
        {
            if (used[i] > (m + 1) / 2)
            {
                cout << "NO" << "\n";
                f = false;
                break;
            }
        }
        if (f)
        {
            cout << "YES" << "\n";
        for (int i = 0; i < m; ++i)
        {
            if (days[i].size() == 1)
            {
                cout << days[i][0] + 1 << ' ';
            }
            else
            {
                for (int j = 0; j < days[i].size(); ++j)
                {
                    if (used[days[i][j]] < (m + 1) / 2)
                    {
                        cout << days[i][j] + 1 << ' ';
                        used[days[i][j]]++;
                        break;
                    }
                }
            }
        }
        cout << "\n";
        }
    }
}

//tyanocku hocheca
