#include <iostream>
#include <set>
#include <vector>

using namespace std;

int t, n, m, k, temp;
int deg[100001];
vector<int> adj[100001];
int answer[100001];

int main() {
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i <= m; i++) adj[i].clear();
        for (int i = 0; i <= m; i++) answer[i] = 0;
        for (int i = 0; i <= n; i++) deg[i] = 0;
        
        int max_amount = m / 2 + m % 2;
        bool ok = true;
        for (int i = 1; i <= m; i++) {
            cin >> k;
            if (k == 1) {
                cin >> temp;
                answer[i] = temp;
                deg[temp]++;
                if (deg[temp] > max_amount and ok) {
                    cout << "NO" << endl;
                    ok = false;
                }
            } else {
                for (int j = 0; j < k; j++) {
                    cin >> temp;
                    adj[i].push_back(temp);
                }
            }
        }
        if (!ok) continue;
        for (int i = 1; i <= m; i++) {
            if (answer[i] == 0) {
                if (deg[adj[i][0]] < max_amount) {
                    answer[i] = adj[i][0];
                    deg[adj[i][0]]++;
                } else {
                    if (deg[adj[i][1]] < max_amount) {
                        answer[i] = adj[i][1];
                        deg[adj[i][1]]++;
                    } else {
                        cout << "NO" << endl;
                        return 0;
                    }
                }
            }
        }
        cout << "YES" << endl;
        for (int i = 1; i <= m; i++) cout << answer[i] << " ";
        cout << endl;
    }
}
