/*
  _           _                 _                 ___  _
 | |         | |               | |               / _ \(_)
 | |__   __ _| | __ _ _ __   __| | __ _         | | | |_  __ _
 | '_ \ / _` | |/ _` | '_ \ / _` |/ _` |        | | | | |/ _` |
 | |_) | (_| | | (_| | | | | (_| | (_| |        | |_| | | (_| |
 |_.__/ \__,_|_|\__,_|_| |_|\__,_|\__,_|         \___/|_|\__, |
                                         ______             | |
                                        |______|            |_|
  __ _  __ _   _ __ ___   __ ___   _________  ___
 / _` |/ _` | | '_ ` _ \ / _` \ \ / /_  / _ \/ __|
| (_| | (_| | | | | | | | (_| |\ V / / /  __/\__ \
 \__, |\__, | |_| |_| |_|\__,_| \_/ /___\___||___/
    | |   | |
    |_|   |_|
govetz, goni sotku!!
 * */
#include <bits/stdc++.h>

using namespace std;
#define int long long

#ifdef DEBUG
inline string to_string(string s) {
    return s;
}
#define dbg(format, ...) fprintf(stderr, to_string(format).c_str() __VA_OPT__(,) __VA_ARGS__); cerr << endl
#else
#define dbg(...) 42
#define endl '\n'
#endif

bool cmp(const vector<int> &a, const vector<int> &b){
    return a.size() < b.size();
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t --> 0){
        int n, m;
        cin >> n >> m;
        vector<vector<int> > f(n), d(m);
        vector<int> ans(m, -1);
        vector<int> cnt(n, 0);
        vector<int> used(n, 0);
        for(int i = 0; i < m; i++){
            int k;
            cin >> k;
            if(k == 1) {
                int x;
                cin >> x;
                x--;
                cnt[x]++;
                ans[i] = x;
                used[x]++;
                continue;
            }
            for(int j = 0; j < k; j++){
                int x;
                cin >> x;
                x--;
                cnt[x]++;
                d[i].push_back(x);
                f[x].push_back(i);
            }
        }
//        for(auto to: ans) cout << to + 1 << ' ';
//        cout << endl;
        int mag = (m + 1) / 2;
        bool ok = true;
        for(int i = 0; i < n; i++){
            if(used[i] > mag){
                ok = false;
            }
            if(cnt[i] >= mag){
                int j = 0;
                while(used[i] < mag){
//                    cout << j << ' ' << cnt[i] << ' ' << f[i].size() << endl;
                    ans[f[i][j]] = i;
                    used[i]++;
                    j++;
                }
                break;
            }
        }
        if(!ok){
            cout << "NO" << endl;
            continue;
        }
        for(int i = 0; i < m; i++){
            if(ans[i] == -1){
                for(int j = 0; j < d[i].size(); j++){
                    if(used[d[i][j]] < mag){
                        ans[i] = d[i][j];
                        used[d[i][j]]++;
                    }
                }
            }
        }
        for(int i = 0; i < m; i++) {
            if(ans[i] == -1) {
                ok = false;
            }
        }
        if(!ok){
            cout << "NO" << endl;
            continue;
        }
        cout << "YES\n";
        for(auto to: ans) cout << to + 1 << ' ';
        cout << endl;
//        for(auto to: used) cout << to << ' ';
//        cout << endl;
    }
}
