#include <iostream>
#include<vector>
#include<set>
#include<map>
#include<string>
#include<algorithm>
#include<cmath>

using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> f(m);
        vector<int> cnt(n + 1);
        for (int i = 0; i < m; ++i) {
            int l;
            cin >> l;
            f[i].resize(l);
            for (int j = 0; j < l; ++j) {
                cin >> f[i][j];
            }
            if (l == 1) {
                cnt[f[i][0]]++;
            }
        }
        int fail = 0;
        for (int i = 0; i < n; ++i) {
            if (cnt[i + 1] > (m + 1) / 2)
                fail = 1;
        }
        if (fail) {
            cout << "NO\n";
            continue;
        }
        vector<int> ret;
        for (int i = 0; i < m; ++i) {
            for (int e : f[i]) {
                if (f[i].size() == 1) {
                    ret.push_back(e);
                    break;
                }
                if (cnt[e] + 1 <= (m + 1) / 2) {
                    cnt[e]++;
                    ret.push_back(e);
                    break;
                }
            }
        }
        cout << "YES\n";
        for (int e : ret) {
            cout << e << " ";
        }
        cout << "\n";
    }
}
