#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

void solve(){
	int n, m;
	cin >> n >> m;
	vector<int> cnt(n + 1), day(m + 1);
	vector<vector<int>> a(m + 1);
	for(int i = 1; i <= m;++i){
		int k;
		cin >> k;
		for(int j = 0, x; j < k; ++j)
			cin >> x, a[i].push_back(x), cnt[x]++;
	}
	for(int i = 1; i <= n; ++i)
		cnt[i] = min(cnt[i], (m + 1) / 2);
	vector<int> ans;
	map<int, int> mp;
	for(int i = 1; i <= m; ++i){
		ans.push_back(a[i][0]);
		mp[a[i][0]]++;
	}
	int u = -1;
	for(auto t : mp){
		if(t.second > (m + 1) / 2)u = t.first;
	}
	if(u == -1){
		cout << "YES\n";
		for(auto t : ans){
			cout << t << " ";
		}
		cout << "\n";
		return;
	}
	int x = mp[u] - (m + 1) / 2;
	ans.clear();
	for(int i = 1; i <= m; ++i){
		if(a[i].size() == 1){
			ans.push_back(a[i][0]);
			continue;
		}
		if(a[i][0] == u && x != 0){
			--x;
			ans.push_back(a[i][1]);
		}else
			ans.push_back(a[i][0]);
	}
	if(x == 0){
		cout << "YES\n";
		for(auto t : ans)
			cout << t << " ";
		cout << "\n";
	}else
		cout << "NO\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int q;
	cin >> q;
	while(q--)solve();

	return 0;
}