#include <iostream>
#include <bitset>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <string>
#include <vector>
#include <iomanip>
#include <algorithm>

#define vc vector
#ifdef kOk
#else
#include <bits/extc++.h>
#endif

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vc<ll> vll;
typedef vc<pll> vpll;
typedef vc<vll> vvll;
typedef vc<vpll> vvpll;

template<typename T>
void sort(T &a) {
    sort(a.begin(), a.end());
}

template<typename T>
void reverse(T &a) {
    reverse(a.begin(), a.end());
}

template<typename T>
void unique(T &a) {
    a.resize(unique(a.begin(), a.end()) - a.begin());
}

int main() {
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vvll a(n);
        vll cnt(m);
        for (ll _ = 0; _ < m; ++_) {
            ll k;
            cin >> k;
            while (k--) {
                ll x;
                cin >> x;
                a[x - 1].push_back(_);
                cnt[_]++;
            }
        }

        bool fl = true;
        vll ans(m, -1);
        for (ll i = 0; i < n; ++i) {
            set<pll> x;
            for (auto &j : a[i]) {
                x.insert({cnt[j], j});
            }
            ll cc = 0;
            while (!x.empty() && cc + 1 <= (m + 1) / 2) {
                ++cc;
                ans[x.begin()->second] = i;
                cnt[x.begin()->second] = LLONG_MAX;
                x.erase(x.begin());
            }
            while (!x.empty()) {
                cnt[x.begin()->second]--;
                x.erase(x.begin());
            }
        }
        for (auto &i : ans) {
            if (i == -1) {
                fl = false;
            }
        }
        if (!fl) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
            for (auto &i : ans) {
                cout << i + 1 << ' ';
            }
            cout << '\n';
        }
    }
}