#include <iostream>
#include <set>
#include <vector>
#include <map>

using namespace std;
typedef long long ll;

int n;
int m;
vector <int> a[100010];
int ans[100010];
map <int, int> cnt;

inline void solve()
{
	cin >> n >> m;
	cnt.clear();
	int bad = -1;

	for (int i = 1; i <= m; ++i)
	{
		a[i].clear();
		int k;
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; ++j) cin >> a[i][j];
		ans[i] = a[i][0];
		++cnt[a[i][0]];
		if (cnt[ans[i]] > (m + 1) / 2)
		{
			bad = ans[i];
		}
	}

	if (bad != -1)
	{
		int count = cnt[bad];

		for (int i = 1; i <= m; ++i)
		{
			if (ans[i] == bad)
			{
				if (a[i].size() >= 2)
				{
					if (a[i][0] != bad)
					{
						--count;
						ans[i] = a[i][0];
					}
					else
					{
						--count;
						ans[i] = a[i][1];
					}
					if (count <= (m + 1) / 2)
					{
						break;
					}
				}
			}
		}

		if (count > (m + 1) / 2)
		{
			cout << "NO\n";
			return;
		}
	}

	cout << "YES\n";

	for (int i = 1; i <= m; ++i) cout << ans[i] << ' ';
	cout << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}