    #include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>


using namespace std;
typedef long long ll;

const int INF = (int) 1e9 + 1;
#define all(a) (a).begin(), (a).end()

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T & i : v) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T & i : v) {
        out << i << " ";
    }
    return out;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t, n, m, k;
    cin >> t;
    vector<vector<int>> friends;
    while(t--) {
        cin >> n >> m;

        vector<pair<int, int>> ks(m);
        friends.resize(m);
        for (int i = 0; i < m; ++i) {
            cin >> k;
            ks[i] = {k, i};
            friends[i].resize(k);
            cin >> friends[i];
        }
        //for (int i = 0; i < m; ++i) {
        //    cout << friends[i] << "\n";
        //}
        sort(all(ks));
        vector<int> f(n+1, 0), ans(m);
        for (int i = 0; i < m; ++i) {
            int ind = ks[i].second;
            int min = INF;
            for (int j = 0; j < ks[i].first; ++j) {
                if(f[friends[ind][j]] < min) {
                    ans[ind] = friends[ind][j];
                    min = f[friends[ind][j]];
                }
            }
            f[ans[ind]]++;
        }
        for (int i = 0; i <= n; ++i) {
            //cout << f[i] << " ";
            if(f[i] > (m+1) / 2) {
                m = -1;
                break;
            }
        }
        if(m == -1) {
            cout << "NO\n";// << ans << "\n";
        } else {
            cout << "YES\n" << ans << "\n";
        }
    }


    return 0;
}