#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
#include <stack>

#define int long long
#define vi vector<int>
#define vpii vector<pair<int, int>>

using namespace std;


void solve() {
	int n, m;
	cin >> n >> m;
	vi deg1(n), deg2(n);
	vector<set<int>> s(m);
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int v;
			cin >> v;
			v--;
			s[i].insert(v);
			deg1[v]++;
			if (k == 1)deg2[v]++;
		}
	}
	int pos = 0;
	for (int i = 0; i < n; i++) {
		if (deg2[i] > (m + 1) / 2) {
			cout << "NO\n";
			return;
		}
	}
	vi ans(m, -1);
	int cnt = (m + 1) / 2;
	for (int i = 0; i < n; i++) {
		if (deg1[i] > deg1[pos])pos = i;
	}

	for (int i = 0; i < m; i++) {
		if (s[i].size() == 1) {
			ans[i] = *s[i].begin();
			if (*s[i].begin() == pos)cnt--;
		}
	}

	for (int i = 0; i < m; i++) {
		if (cnt > 0 && s[i].count(pos) && ans[i] == -1) {
			cnt--;
			ans[i] = pos;
		}
	}

	for (int i = 0; i < m; i++) {
		s[i].erase(pos);
	}

	for (int i = 0; i < m; i++) {
		if (ans[i] == -1) {
			ans[i] = *s[i].begin();
		}
	}
	cout << "YES\n";
	for (auto u : ans) {
		cout << u + 1 << ' ';
	}
	cout << "\n";
}



signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}