#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define sz(a) (int) (a).size()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";

//template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
//template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
//template<class t> using vc = vector<t>;
//template<class t> using vvc = vector<vector<t>>;

//using pi = pair<int, int>;
//using vi = vc<int>;
//using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 1e5 + 10;

int ans[maxn];
vector<int> g[maxn];
int deg[maxn];

bool cmp(const int &u, const int &v) {return deg[u] < deg[v];}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
            ans[i]= -1;
        int k;
        cin >> k;
        deg[i] = k;
        for (int j = 0; j < k; j++) {
            int v;
            cin >> v;
            v--;
            g[v].push_back(i);
        }
    }
    int mx = 0;
    for (int i = 0; i < n; i++) {
        if (sz(g[i]) > sz(g[mx])) mx = i;
    }
    sort(all(g[mx]), cmp);
    for (int i = 0; i < min(sz(g[mx]), (m + 1) / 2); i++) {
        ans[g[mx][i]] = mx;
    }
    for (int i = 0; i < n; i++) {
        if (i == mx) continue;
        for (int j = 0; j < sz(g[i]); j++) {
                int v = g[i][j];
            if (ans[v] != -1) continue;
            ans[v] = i;
        }
    }
    bool ok = true;
    for (int i = 0; i < m; i++) {
        if (ans[i] == -1) ok = false;
    }
    if (!ok) {
        cout << "NO\n";
        for (int i = 0; i < n; i++) {
        g[i].clear();
    }
        return;
    }
    cout << "YES\n";
    for (int i = 0; i < m; i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';
    for (int i = 0; i < n; i++) {
        g[i].clear();
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
