#include <bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define eb emplace_back

using namespace std;

template <typename T>
bool chmin(T& a, const T& b){
  if (a > b){
    a = b;
    return true;
  }
  return false;
}

template <typename T>
bool chmax(T& a, const T& b){
  if (a < b){
    a = b;
    return true;
  }
  return false;
}

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

#ifdef ONPC
mt19937 rnd(54);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 54LL;
const ld PI = acos(-1);

#ifdef ONPC
const int MAXN = 154;
#else
const int MAXN = 300100;
#endif

//#define int long long
const int INF = 1e9;

void solve(){
  int n, m;
  cin >> n >> m;
  //vector<vector<int>> a(n);
  vector<int> k(m);
  vector<vector<int>> wh(m);
  for (int i = 0; i < m; i++){
    cin >> k[i];
    for (int j = 0; j < k[i]; j++){
      int f;
      cin >> f;
      f--;
      wh[i].eb(f);
      //a[i].eb(f);
    }
    //cerr << "GO\n";
  }

  vector<int> c(m);
  vector<int> cnt(n);
  vector<int> d(m);
  iota(begin(d), end(d), 0);
  sort(begin(d), end(d), [&](int i, int j){
    return wh[i].size() < wh[j].size();
  });

  if (wh[d[0]].empty()){
    cout << "NO\n";
    return;
  }

  for (int i = 0; i < m; i++){
    int k = d[i];
    int cm = INF;
    int ind = -1;
    for (int j : wh[k]){
      if (chmin(cm, cnt[j])){
        ind = j;
      }
    }
    //cerr << ind << '\n';
    cnt[ind]++;
    c[k] = ind + 1;
  }

  for (int i = 0; i < n; i++){
    if (cnt[i] > (m + 1) / 2){
      cout << "NO\n";
      return;
    }
  }

  cout << "YES\n";
  for (int i = 0; i < m; i++){
    cout << c[i] << ' ';
  }
  cout << '\n';
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  int Q;
  cin >> Q;
  while (Q--)
    solve();
}