#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>
//#pragma GCC optimize("O3")
#define int long long
using namespace std;

int readi() {
    int x = 0;
    char c = getchar();
    bool f = false;
    if (c == '-') {
        f = true;
    } else {
        x = c - '0';
    }
    while ((c = getchar()) >= '0' && c <= '9') {
        x = (x * 10) + (c - '0');
    }
    if (f) return -x;
    return x;
}

void outpi(int x) {
    if (x == 0) {
        putchar('0');
        return;
    }
    if (x < 0){
        x = -x;
        putchar('-');
    }
    char buf[20];
    int ln = 0;
    while (x) {
        buf[ln++] = x % 10 + '0';
        x /= 10;
    }
    for (int i = ln - 1; i >= 0; i--) {
        putchar(buf[i]);
    }
}

signed main() {
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        vector<vector<pair<int, int>>> ind(n);
        vector<vector<int>> mas(m);
        for (int i = 0; i < m; i++) {
            int k;
            cin >> k;
            mas[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> mas[i][j];
                mas[i][j]--;
            }
            sort(mas[i].begin(), mas[i].end());
            for (int j = 0; j < k; j++) {
                ind[mas[i][j]].push_back({j, i});
            }
        }
        vector<int> otv(m, -1);
        for (int i = 0; i < n; i++) {
            int cnt = (m + 1) / 2;
            sort(ind[i].begin(), ind[i].end());
            for (int j = 0; j < ind[i].size(); j++) {
                if (cnt == 0) break;
                if (otv[ind[i][j].second] != -1) continue;
                if (ind[i][j].first == mas[ind[i][j].second].size() - 1) {
                    otv[ind[i][j].second] = i + 1;
                    cnt--;
                    if (cnt == 0) break;
                }
            }
            for (int j = 0; j < ind[i].size(); j++) {
                if (cnt == 0) break;
                if (otv[ind[i][j].second] != -1) continue;
                otv[ind[i][j].second] = i + 1;
                cnt--;
                if (cnt == 0) break;
            }
        }
        bool f = true;
        for (int i = 0; i < m; i++) {
            if (otv[i] == -1) f = false;
        }
        if (!f) {
            cout << "NO\n";
            continue;
        } else {
            cout << "YES\n";
            for (int i : otv) {
                cout << i << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}