#include <bits/stdc++.h>

using namespace std;

typedef vector<vector<int>> graph;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define F first
#define S second
#define pii pair<int, int>

const int INF = 1e18;

bool cmp(pair<int, vector<int>>& a, pair<int, vector<int>>& b) {
    return (a.S.size() < b.S.size());
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, vector<int>>> a(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        a[i].S.resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i].S[j];
            a[i].S[j]--;
        }
        a[i].F = i;
    }
    sort(all(a), cmp);
    vector<int> cnt(n), ans(m, -1);
    int c = m;
    for (int i = 0; i < m; i++) {
//        cout << a[i].F << endl;
        for (auto to : a[i].S) {
            if (cnt[to] < (m + 1) / 2) {
                cnt[to]++;
                ans[a[i].F] = to;
                c--;
                break;
            }
        }
    }
    if (c != 0) {
        cout << "NO";
        return;
    }
    cout << "YES" << endl;
    for (auto to : ans) {
        cout << to + 1<< ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(10);
    int q = 1;
    cin >> q;
    while(q--) {
        solve();
        cout << endl;
    }
    return 0;
}
