﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <iterator>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define FOR(i, n) for (ll (i) = 0; (i) < (n); (i)++)
#define FOR_(i, start, finish) for (ll (i) = (start); (i) <= (finish); (i)++)
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair

ll run()
{
	ll n, m;
	cin >> n >> m;
	vector <set <ll> > friends;
	vector <ll> ost, ans(m);
	vector <bool> day_used(m, false);
	ost.assign(n, (m + 1) / 2);
	friends.resize(m);
	//first - кол-во ост друзей. second - номер дня
	set <pair <ll, ll> > days;
	for (ll i = 0; i < m; i++)
	{
		ll k, x;
		cin >> k;
		for (ll j = 0; j < k; j++)
		{
			cin >> x;
			friends[i].insert(x - 1);
		}
	}
	for (ll i = 0; i < m; i++) days.insert({ friends[i].size(), i });
	while (!days.empty())
	{
		pair <ll, ll> x = *days.begin();
		days.erase(days.begin());
		ans[x.second] = *friends[x.second].begin();
		ost[*friends[x.second].begin()]--;
		day_used[x.second] = true;
		if (ost[*friends[x.second].begin()] == 0)
		{
			ll v = *friends[x.second].begin();
			days.clear();
			for (ll i = 0; i < m; i++) friends[i].erase(v);
			for (ll i = 0; i < m; i++) if (!day_used[i])
			{
				if (friends[i].size() == 0)
				{
					cout << "NO\n";
					return 0;
				}
				days.insert({ friends[i].size(), i });
			}
		}
	}
	cout << "YES\n";
	for (ll u : ans) cout << u + 1 << ' ';
	cout << endl;
	return 0;
}

int main()
{
	ll t;
	cin >> t;
	for (ll i = 0; i < t; i++) run();
	return 0;
}