#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <utility>
#include <numeric>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <bitset>
#include <cstdlib>
#include <cassert>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

bool canfind(vector<int> &a, int b) {
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] == b) {
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> var(m);
        vector<int> cnt(n);
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            var[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> var[i][j];
                cnt[--var[i][j]]++;
            }
        }
        int banboy = -1;
        for (int i = 0; i < n; ++i) {
            if (cnt[i] >= (m + 1) / 2) {
                banboy = i;
                break;
            }
        }
        if (banboy == -1) {
            cout << "YES\n";
            for (int i = 0; i < m; ++i) {
                cout << var[i][0] + 1 << " ";
            }
            cout << "\n";
        }
        else {
            vector<int> ans(m, -1);
            int bancnt = (m + 1) / 2;
            for (int i = 0; i < m; ++i) {
                if (var[i].size() == 1 && var[i][0] == banboy) {
                    ans[i] = banboy;
                    --bancnt;
                }
            }
            if (bancnt < 0) {
                cout << "NO\n";
            }
            else {
                for (int i = 0; i < m && bancnt > 0; ++i) {
                    if (ans[i] == -1 && canfind(var[i], banboy)) {
                        ans[i] = banboy;
                        --bancnt;
                    }
                }
                for (int i = 0; i < m; ++i) {
                    if (ans[i] == -1) {
                        if (var[i].back() == banboy) {
                            var[i].pop_back();
                        }
                        ans[i] = var[i].back();
                    }
                }
                cout << "YES\n";
                for (int i = 0; i < m; ++i) {
                    cout << ans[i] + 1 << " ";
                }
                cout << "\n";
            }
        }
    }

    return 0;
}