#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> cnt(n, 0);
    vector<int> days[m];
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            x--;
            cnt[x]++;
            days[i].push_back(x);
        }
    }
    int threshold = (m + 1) / 2;
    vector<int> best_friends;
    vector<bool> is_best(n, false);

    map<int, int> bf_num;

    for (int i = 0; i < n; ++i) {
        if (cnt[i] > threshold) {
            bf_num[i] = best_friends.size();
            best_friends.push_back(i);
            is_best[i] = true;
        }
    }
    int c = best_friends.size();
    vector<int> best_cnt(c, 0);

    vector<int> res(m, -1);

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < days[i].size(); ++j) {
            if (!is_best[days[i][j]]) {
                res[i] = days[i][j];
                break;
            }
        }
        if (res[i] == -1 && days[i].size() == 1) {
            res[i] = days[i][0];
            best_cnt[bf_num[days[i][0]]]++;
        }
    }

    for (int i = 0; i < m; ++i) {
        if (res[i] == -1) {
            int best_pos = 0;
            for (int j = 0; j < days[i].size(); ++j) {
                if (best_cnt[bf_num[days[i][best_pos]]] > best_cnt[bf_num[days[i][j]]]) {
                    best_pos = j;
                }
            }

            res[i] = days[i][best_pos];
            best_cnt[bf_num[days[i][best_pos]]]++;
        }
    }

    vector<int> res_cnt(n, 0);
    int res_mx = 0;
    for (int i = 0; i < m; ++i) {
        res_cnt[res[i]]++;
        res_mx = max(res_mx, res_cnt[res[i]]);
    }
    if (res_mx > threshold) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        for (auto e : res) {
            cout << e + 1 << ' ';
        }
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        solve();
    }
}
