#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
#define pb push_back
#define pii pair<int,int>
#define f first
#define s second
#define pld pair<ld,ld>
#define emp nullptr
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int MAX_N = 2e5 + 7;
vector<int> g[MAX_N];
bool used[MAX_N];
int t[MAX_N], d[MAX_N];

void find(int l, int r, int v, int vl, int vr) {
    if (vr < l || r < vl)return;
    if (l <= vl && vr <= r)return;
    int mid = (l + r) / 2;
    find(l, r, v * 2, vl, mid);
    find(l, r, v * 2 + 1, mid + 1, vr);
}

void change(int l, int r, int v, int vl, int vr, int val) {
    if (vr < l || r < vl)return;
    if (l <= vl && vr <= r) {
        t[v] = val;
        d[v] = val;
        return;
    }
    // push(v)
    int mid = (l + r) / 2;
    change(l, r, v * 2, vl, mid, val);
    change(l, r, v * 2 + 1, mid + 1, vr, val);
    //upd(v)
}

void dfs(int v) {
    used[v] = true;
    for (int to : g[v]) {
        if (!used[to])dfs(to);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        vector<int> a[m];
        int cnt[n];
        vector<int> alone[n];
        vector<int> days[n];
        fill(cnt, cnt + n, 0);
        for (int i = 0; i < m; ++i) {
            int sz;
            cin >> sz;
            for (int j = 0; j < sz; ++j) {
                int x;
                cin >> x;
                x--;
                cnt[x]++;
                a[i].pb(x);
                days[x].pb(i);
            }
            if (sz == 1) {
                alone[a[i][0]].pb(i);
            }
        }
        bool flag = true;
        for (int i = 0; i < n; ++i) {
            if ((int) alone[i].size() > m / 2 + m % 2) {
                cout << "NO" << endl;
                flag = false;
                break;
            }
        }
        if (!flag)continue;
        int ma = 0;
        for (int i = 0; i < n; ++i) {
            if (cnt[ma] < cnt[i])ma = i;
        }
        int done = 0;
        int ans[m];
        fill(ans, ans + m, -1);
        for (int x : alone[ma]) {
            ans[x] = ma + 1;
        }
        done += alone[ma].size();
        for (int i = 0; i < days[ma].size() && done < m / 2 + m % 2; ++i) {
            int cur = days[ma][i];
            if (ans[cur] == -1) {
                ans[cur] = ma + 1;
                done++;
            }
        }
        for (int i = 0; i < m; ++i) {
            if (ans[i] == -1) {
                for (int x : a[i]) {
                    if (x == ma)continue;
                    ans[i] = x + 1;
                    break;
                }
            }
        }
        cout << "YES" << endl;
        for (int i = 0; i < m; ++i) {
            cout << ans[i] << " ";
        }
        cout << endl;
    }
}