#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(m);
    vector<int> cnt(n);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int f;
            cin >> f;
            --f;
            a[i].push_back(f);
        }
        if (k == 1) {
            cnt[a[i].back()] += 1;
        }
    }
    vector<int> ans;
    for (int i = 0; i < m; ++i) {
        if (a[i].size() > 1) {
            int ind = 0;
            for (int j = 0; j < a[i].size(); ++j) {
                if (cnt[a[i][j]] < cnt[a[i][ind]]) {
                    ind = j;
                }
            }
            cnt[a[i][ind]] += 1;
            ans.push_back(a[i][ind] + 1);
        } else {
            ans.push_back(a[i].back() + 1);
        }
    }
    if (*max_element(cnt.begin(), cnt.end()) > (m + 1) / 2){
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    for (auto i : ans) {
        cout << i << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}