#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<string>
#include<numeric>
#include<fstream>
#include<iomanip>
typedef long long ll;
using namespace std;

struct stru {
	int nom;
	set<int> a;
};
bool comp1(const stru& v1, const stru& v2) {
	return v1.a.size() < v2.a.size();
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> a(m);
		vector<stru> b(n);
		for (int i = 0; i < n; ++i)
			b[i].nom = i;
		vector<int> ans(m, -1), used(n);
		for (int i = 0; i < m; ++i) {
			int k;
			cin >> k;
			if (k == 1) {
				cin >> k;
				ans[i] = k - 1;
				++used[k - 1];
			}
			else {
				a[i].resize(k);
				for (int j = 0; j < k; ++j) {
					cin >> a[i][j];
					--a[i][j];
					b[a[i][j]].a.insert(i);
				}
			}
		}
		sort(b.rbegin(), b.rend(), comp1);

		for (int i = 0; i < n; ++i) {
			for (auto d : b[i].a)
				if (used[b[i].nom] == (m + 1) / 2)
					break;
				else if(ans[d] == -1) {
					ans[d] = b[i].nom;
					++used[b[i].nom];
				}
		}
		bool f = true;
		for (int i = 0; i < m; ++i)
			if (ans[i] == -1) {
				f = false;
				break;
			}
		for (int i = 0; i < n; ++i)
			if (used[i] > (m + 1) / 2) {
				f = false;
				break;
			}
		if (f) {
			cout << "YES\n";
			for (auto& x : ans)
				cout << x + 1 << ' ';
			cout << '\n';
		}
		else
			cout << "NO\n";
	}

	return 0;
}