﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	vector < vector < int > > cantake(m);
	vector < vector < int > > a(n);
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int f;
			cin >> f;
			f--;
			cantake[i].push_back(f);
			a[f].push_back(i);
		}
	}
	vector < int > take(m, -1);
	for (int i = 0; i < m; i++) {
		if (cantake[i].size() == 1) {
			take[i] = cantake[i][0];
		}
	}
	vector < int > cnt(n, 0);
	for (auto e : take) {
		if (e == -1)
			continue;
		cnt[e]++;
	}
	for (auto e : cnt) {
		if (e > (m + 1) / 2) {
			cout << "NO\n";
			return;
		}
	}
	for (int i = 0; i < m; i++) {
		if (take[i] > -1)
			continue;
		for (int j = 0; j < cantake[i].size(); j++) {
			int p = cantake[i][j];
			if (cnt[p] < (m + 1) / 2) {
				take[i] = p;
				cnt[p]++;
				break;
			}
		}
	}
	for (auto e : take) {
		if (e == -1) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (auto e : take)
		cout << e + 1 << " ";
	cout << "\n";
}

int main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
		solve();
}