#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

void sol() {
    int n, m;
    cin >> n >> m;
    int r = (m + 1) / 2;
    vector<vector<int>> ds(m), fs(n);
    vector<int> clc(n);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int el;
            cin >> el;
            ds[i].push_back(el - 1);
            fs[el - 1].push_back(i);
            clc[el - 1]++;
        }
    }
    set<pair<int, int>> rofl;
    vector<vector<int>> res(n);
    vector<int> used(m);
    for (int i = 0; i < n; i++) {
        rofl.insert({clc[i], i});
    }
    while (!rofl.empty()) {
        auto now = *rofl.begin();
        int val = now.first, f = now.second;
        if (val <= r) {
            rofl.erase(rofl.begin());
            for (int d : fs[f]) {
                if (!used[d]) {
                    used[d] = 1;
                    for (int ff : ds[d]) {
                        clc[ff]--;
                    }
                    res[f].push_back(d);
                }
            }
        } else {
            break;
        }
    }
    for (int d = 0; d < m; d++) {
        if (!used[d] && (int) ds[d].size() == 1) {
            res[ds[d][0]].push_back(d);
            used[d] = 1;
        }
    }
    for (int d = 0; d < m; d++) {
        if (used[d]) {
            continue;
        }
        pair<int, int> now = {(int) 1e7, 0};
        for (int f : ds[d]) {
            now = min(now, make_pair((int) res[f].size(), f));
        }
        used[d] = 1;
        res[now.second].push_back(d);
    }
    bool flag = true;
    vector<int> ans(m);
    for (int f = 0; f < n; f++) {
        if ((int) res[f].size() > r) {
            flag = false;
        }
        for (int d : res[f]) {
            ans[d] = f + 1;
        }
    }
    if (flag) {
        cout << "YES\n";
        for (int el : ans) {
            cout << el << ' ';
        }
        cout << '\n';
    } else {
        cout << "NO\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        sol();
    }
}