#include <bits/stdc++.h>
#define ll long long
#define ld long double
using namespace std;

bool comp(pair<vector<ll>, ll> a, pair<vector<ll>, ll> b) {
    return a.first.size() < b.first.size();
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> used(n, 0), ans(m);
    vector<pair<vector<ll>, ll>> v(m);
    for (int i=0; i < m; ++i) {
        ll r;
        cin >> r;
        for (int j=0; j < r; ++j) {
            ll x;
            cin >> x;
            v[i].first.push_back(x);
        }
        v[i].second = i;
    }
    sort(v.begin(), v.end(), comp);
    for (auto i : v) {
        ll res, kol = 1e9;
        for (auto j : i.first) {
            if (used[j - 1] < kol) {
                res = j;
                kol = used[j - 1];
            }
        }
        used[res - 1]++;
        ans[i.second] = res;
    }
    for (auto i : used) {
        if (i > (m + 1) / 2) {
            cout << "NO";
            return;
        }
    }
    cout << "YES" << '\n';
    for (auto i : ans) {
        cout << i << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}
