#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ceildiv(x, y) (x / y + (x % y ? 1 : 0))

using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int SIZE = 1e5;

int n, m, ans[SIZE];

void solve() {
    cin >> n >> m;

    vector<vector<int>> f(m);
    vector<int> cnt(n + 1, 0);

    for(auto &i : f) {
        int k;
        cin >> k;
        i.resize(k);
        for(auto &j : i) {
            cin >> j;
        }
    }



    for(int k = 0; k < m; k++) {
        if(f[k].size() == 1) {
            ans[k] = f[k][0];
            cnt[f[k][0]]++;
        }
    }

    for(int k = 0; k < m; k++) {
        if(f[k].size() == 1) {
            continue;
        }

        int mn = f[k][0];

        for(int i = 1; i < f[k].size(); i++) {
            if(cnt[f[k][i]] < cnt[mn]) {
                mn = f[k][i];
            }
        }

        ans[k] = mn;
        cnt[mn]++;
    }

    for(int i = 1; i <= n; i++ ) {
        if(cnt[i] > ceildiv(m, 2)) {
            cout << "NO" << endl;
            return;
        }
    }

    cout << "YES" << endl;
    for(int i = 0; i < m; i++) {
        cout << (ans[i]) << " ";
    }
    cout << endl;
}


/**
2

4 6

1 1
2 1 2
3 1 2 3
4 1 2 3 4
2 2 3
1 3



2 2

1 1
1 1
*/

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t = 1;
    cin >> t;

    while(t--) {
        solve();
    }

    return 0;
}
