#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
template<typename T> void mdebug_out(T* a, int n) { for (int i = 0; i < n; ++i) cerr << a[i] << ' '; cerr << endl; }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a) { for (auto &x : a) stream << x << ' '; return stream; }
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2> &p) { return stream << p.first << ' ' << p.second; }

int gcd(int a, int b)
{
    if (!a) return b;
    if (!b) return a;
    return __gcd(a, b);
}

int md(int a, int m)
{
    a %= m;
    if (a < 0)
        a += m;
    return a;
}

vector<int> a[200005];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--)
    {
        int n, m;
        cin >> n >> m;
        vector<int> cnt(n + 1, 0);
        for (int i = 0; i < m; ++i)
        {
            int k;
            cin >> k;
            a[i].resize(k);
            for (auto &x : a[i]) cin >> x;
            ++cnt[a[i][0]];
        }
        vector<int> ans(m);
        for (int j = 0; j < m; ++j)
            ans[j] = a[j][0];
        int i = max_element(all(cnt)) - cnt.begin();
        if (cnt[i] > (m + 1) / 2)
        {
            for (int j = 0; j < m && cnt[i] > (m + 1) / 2; ++j)
            {
                if (a[j][0] == i && a[j].size() > 1)
                {
                    --cnt[i];
                    ++cnt[a[j][1]];
                    ans[j] = a[j][1];
                }
            }
            if (cnt[i] > (m + 1) / 2)
            {
                cout << "NO\n";
                continue;
            }
        }
        cout << "YES\n";
        cout << ans << '\n';
    }

    return 0;
}