#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define pii pair < int, int >
#define ll long long
#define F first
#define S second
#define TIME 1.0 * clock() / CLOCKS_PER_SEC
#define pb push_back
#define endl '\n'
#define Endl '\n'

const int mod = 1e9 + 7;
const ll inf = 1e18;

mt19937 gen(time(0));

const int SX[4] = {1, -1, 0, 0};
const int SY[4] = {0, 0, -1, 1};

void solve(){
    int n;
    cin >> n;
    vector < int > a(n);
    for (auto &to : a)cin >> to;

    vector < pii > nxt(n);
    ordered_set < int > bad;

    for (int i = 0;i < n; ++i){
        nxt[i].F = (!i ? n - 1 : i - 1);
        nxt[i].S = (i + 1 < n ? i + 1 : 0);
        if (__gcd(a[i], a[nxt[i].F]) == 1){
            bad.insert(i);
        }
    }

    if (n == 1 && a[0] == 1){
        cout << 1 << " " << 1 <<  " " << endl;
        return;
    }

    vector < int > ans;
    int tech = 1;
    int kk = n;
    while(1){
//        if (kk == 1 && a[tech] == 1){
//            ans.pb(tech);
//            break;
//        }
        if (kk == 2 && __gcd(a[tech], a[nxt[tech].S]) == 1){
            ans.pb(tech);
            if (a[nxt[tech].S] == 1){
                ans.pb({nxt[tech].S});
            }
            break;
        }
        if (bad.size() == 0)break;
        int kol = bad.order_of_key(tech);
        if (kol == bad.size()){
            tech = *bad.begin();
        }else{
            tech = *bad.find_by_order(kol);
        }

        bad.erase(tech);
        ans.pb(tech);
        kk--;
        int sl = nxt[tech].S;
        int pr = nxt[tech].F;

        nxt[sl].F = pr;
        nxt[pr].S = sl;
        bad.erase(sl);
        if (__gcd(a[sl], a[pr]) == 1){
            bad.insert(sl);
        }
        tech = nxt[sl].S;
    }
    cout << ans.size() <<  " ";
    for (auto to : ans)cout << to + 1 << " ";
    cout << endl;
}

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t --> 0)solve();
    return 0;
}
