#include <bits/stdc++.h>

using namespace std;
#define int long long

inline int gcd(int a, int b) {
    for (; b > 0; a %= b, swap(a, b)) {}
    return a;
}

int n;

inline void add(int i, vector <int>& f, int pl) {
    for (++i; i <= n; i += (i & (-i))) f[i] += pl;
}

inline int get_pref(int i, vector <int>& f) {
    int sum = 0;
    for (++i; i > 0; i -= (i & (-i))) sum += f[i];
    return sum;
}

inline int get_first(int i, vector <int>& f) {
    int l = 0, r = n - 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int j = (i + m) % n;
        if (j > i) {
            if (get_pref(j, f) - get_pref(i, f) > 0) r = m;
            else l = m;
        } else {
            if (get_pref(n - 1, f) - get_pref(i, f) + get_pref(j, f) > 0) r = m;
            else l = m;
        }
    }
    return (i + r) % n;
}

inline vector <vector <int>> solve1(const int& t, const vector <pair <int, vector <int>>>& all) {
    vector <vector <int>> res;
    for (int kek = 0; kek < t; ++kek) {
        n = all[kek].first;
        vector <int> a = all[kek].second;
        vector<int> cur(n);
        vector<int> f1(n + 1), f2(n + 1);
        for (int i = 0; i < n; ++i) {
            cur[i] = (i + 1) % n;
            add(i, f1, 1);
            if (gcd(a[i], a[(i + 1) % n]) == 1) {
                add(i, f2, 1);
            }
        }
        int cha = 0;
        vector<int> ans;
        vector<bool> now(n);
        while (get_pref(n - 1, f2) > 0) {
            if (get_pref(n - 1, f1) < 1) {
                break;
            }
            if (get_pref(n - 1, f1) == 1) {
                for (int i = 0; i < n; ++i) {
                    if (!now[i]) {
                        if (a[i] == 1) {
                            ans.push_back(i);
                        }
                    }
                }
                break;
            }
            int bl = get_first(cha, f2);
            if (gcd(a[cha], a[cur[cha]]) == 1) bl = cha;
            ans.push_back(cur[bl]);
            add(cur[bl], f1, -1);
            add(bl, f2, -1);
            now[cur[bl]] = true;
            if (gcd(a[cur[bl]], a[cur[cur[bl]]]) == 1) add(cur[bl], f2, -1);
            int fir = get_first(bl, f1);
            cur[bl] = fir;
            if (gcd(a[bl], a[fir]) == 1) {
                add(bl, f2, 1);
            }
            cha = cur[bl];
        }
        res.push_back(ans);
    }
    return res;
}

inline vector <vector <int>> solve2(const int& t, const vector <pair <int, vector <int>>>& all) {
    vector <vector <int>> res;
    for (int kek = 0; kek < t; ++kek) {
        n = all[kek].first;
        vector <int> a = all[kek].second;
        int cha = 0;
        vector <bool> now(n);
        vector <int> ans;
        int kol = 0, flex = 0;
        while (kol < 2 * n) {
            if (flex == n - 1) {
                for (int i = 0; i < n; ++i) {
                    if (!now[i] && a[i] == 1) {
                        ans.push_back(i);
                    }
                }
                break;
            }
            for (int i = (cha + 1) % n; i != cha; i = (i + 1) % n) {
                if (!now[i]) {
                    if (gcd(a[cha], a[i]) == 1) {
                        ans.push_back(i);
                        now[i] = true;
                        ++flex;
                        kol = 0;
                    }
                    break;
                }
            }
            ++kol;
            for (int i = (cha + 1) % n; i != cha; i = (i + 1) % n) {
                if (!now[i]) {
                    cha = i;
                    break;
                }
            }
        }
        res.push_back(ans);
    }
    return res;
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int t;
        cin >> t;
        vector <pair <int, vector <int>>> all(t);
        for (int i = 0; i < t; ++i) {
            cin >> all[i].first;
            all[i].second.resize(all[i].first);
            for (int j = 0; j < all[i].first; ++j) cin >> all[i].second[j];
        }
        auto ans = solve1(t, all);
        for (auto& i : ans) {
            cout << i.size() << " ";
            for (int j : i) cout << j + 1 << " ";
            cout << "\n";
        }
    } else {
        srand(time(nullptr));
        int t;
        cin >> t;
        while (t--) {
            cout << t << "\n";
            vector <pair <int, vector <int>>> all(1);
            all[0].first = rand() % 5 + 1;
            all[0].second.resize(all[0].first);
            for (int i = 0; i < all[0].first; ++i) {
                all[0].second[i] = rand() % 10 + 1;
            }
            cout << t << "\n";
            cout << all[0].first << "\n";
            for (int i : all[0].second) cout << i << " ";
            cout << "\n-------------\n";
            if (solve1(1, all) != solve2(1, all)) {
                return 0;
            }
        }
    }
}

/*
1
 5
1 5 6 10 2
 */