#include <bits/stdc++.h>

#define fastio ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define fi first
#define se second

using namespace std;

typedef long long ll;

struct el {
	int val;
	int next;
};

void solve()
{
	int n;
	cin >> n;
	vector<el> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].val;
		a[i].next = (i + 1)%n;
	}
	queue<int> pr;
	for (int i = 0; i < n; i++) {
		if (__gcd(a[i].val, a[a[i].next].val) == 1) {
			pr.push(i);
		}
	}
	vector<int> ans;
	while (!pr.empty()) {
		if (pr.size() == 1 && a[pr.front()].val == 1) {
			ans.push_back(pr.front());
			break;
		}
		int cur = pr.front();
		pr.pop();
		ans.push_back(a[cur].next);
		if (!pr.empty() && pr.front() == a[cur].next) {
			pr.pop();
		}
		a[cur].next = a[a[cur].next].next;
		if (__gcd(a[cur].val, a[a[cur].next].val) == 1) {
			pr.push(cur);
		}
	}
	cout << ans.size() << " ";
	for (int i: ans) {
		cout << i + 1 << " ";
	}
	cout << "\n";
}

int main()
{
	fastio
	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}