#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;
#define endl "\n"

#define int long long
#define double long double

#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

void solve() {
    int n;
    cin >> n;
    int a[n];
    int prev[n];
    int next[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        prev[i] = i - 1;
        next[i] = i + 1;
    }
    prev[0] = n - 1;
    next[n - 1] = 0;
    if (n == 1) {
        if (a[0] == 1) {
            cout << "1 1\n";
        } else {
            cout << "0\n";
        }
        return;
    }
    deque<int> rmt;
    for (int i = 1; i < n; i++) {
        rmt.push_back(i);
    }
    rmt.push_back(0);
    vector<int> res;
    while (!rmt.empty()) {
        int i = rmt.front();
        rmt.pop_front();
        if (gcd(a[prev[i]], a[i]) == 1) {
            res.push_back(i);
            if ((int)res.size() == n - 1) {
                bool used[n];
                memset(used, false, sizeof(used));
                for (int z : res) {
                    used[z] = true;
                }
                for (int z = 0; z < n; z++) {
                    if (!used[z] && a[z] == 1) {
                        res.push_back(z);
                    }
                }
                break;
            }
            prev[next[i]] = prev[i];
            next[prev[i]] = next[i];
            if (!rmt.empty() && rmt.front() == next[i]) {
                rmt.pop_front();
            }
            rmt.push_back(next[i]);
        }
    }
    cout << res.size() << " ";
    for (int i = 0; i < (int)res.size(); i++) {
        cout << res[i] + 1 << (i == (int)res.size() - 1 ? endl : " ");
    }
}

#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("./in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t T_;
    cin >> T_;
    for (int32_t T_i = 0; T_i < T_; T_i++) {
#endif
        solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}
