#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <cstring>
#include <immintrin.h>
#include <cstdint>
#include <iomanip>
#include <random>
#include <queue>
#include <stack>
#include <list>

int32_t gcd(int32_t a, int32_t b) {
    if(b == 0)
	return a;
    return gcd(b, a % b);
}

struct Node {
    std::deque<int32_t> val;
    Node* next, *prev;

    Node(){}
};

int main() {
    int32_t num_tests;
    std::cin >> num_tests;

    for(int32_t t = 0; t < num_tests; t++) {
	int32_t n;
	std::cin >> n;

	int32_t* arr = new int32_t[n];
	for(int32_t i = 0 ; i < n ; i++) {
	    std::cin >> arr[i];
	    //arr[i] = rand() % 100 + 1;
	    //std::cout << arr[i] << " ";
	}
	//std::cout << "\n";

	if(n == 1) {
	    if(arr[0] == 1)
		std::cout << 1 << " " << 1 << "\n";
	    else
		std::cout << 0 << "\n";
	    continue;
	}

	/*std::vector<int32_t> test;
	for(int32_t i = 0;  i < n ; i++)
	    test.push_back(i);
	std::vector<int32_t> answer2;
	for(int32_t i = 0; i < n; i++) {
	    bool did = false;
	    for(int32_t j = 0; j < test.size(); j++) {
		if(gcd(arr[test[j]], arr[test[(j + 1) % test.size()]]) == 1) {
		    answer2.push_back(test[(j + 1) % test.size()]);
		    test.erase(test.begin() + ((j + 1) % test.size()));
		    did = true;
		}
	    }
	    if(!did)
		break;
	}

	std::cout << answer2.size() << " ";
	for(int32_t i = 0 ; i < answer2.size(); i++)
	    std::cout << answer2[i] + 1 << " ";
	std::cout << "\n";*/

	int32_t first_bad = -1;
	for(int32_t i = 0; i < n; i++) {
	    if(gcd(arr[i], arr[(i + 1) % n]) == 1) {
		first_bad = i;
		break;
	    }
	}
	if(first_bad == -1) {
	    std::cout << 0 << "\n";
	    continue;
	}

	std::vector<int32_t> arr2;
	for(int32_t i = (first_bad + 1) % n; i < (first_bad + 1) % n + n; i++) {
	    arr2.emplace_back(i % n);
	}

	std::vector<Node* > islands;
	islands.push_back(new Node);
	for(int32_t i = 0 ;i  < n; i++) {
	    islands.back()->val.push_back(arr2[i]);
	    if(i != n - 1 && gcd(arr[arr2[i]], arr[arr2[i + 1]]) == 1)
		islands.push_back(new Node);
	}
	for(int32_t i = 0; i < islands.size(); i++) {
	    islands[i]->prev = islands[(i - 1 + (int32_t)islands.size()) % islands.size()];
	    islands[i]->next = islands[(i + 1) % (int32_t)islands.size()];
	}

	std::vector<int32_t> answer;
	Node* cur = islands.front();
	int32_t remains = islands.size();
	while(remains > 1) {
	    answer.push_back(cur->val.front());
	    cur->val.pop_front();
	    //Delete this if necessary
	    if(cur->val.size() == 0) {
		Node* next = cur->next, *prev = cur->prev;
		next->prev = prev;
		prev->next = next;
		delete cur;
		cur = next;
		remains--;
	    }
	    if(remains > 1 && gcd(arr[cur->val.front()], arr[cur->prev->val.back()]) != 1) {
		while(cur->prev->val.size() > 0) {
		    cur->val.push_front(cur->prev->val.back());
		    cur->prev->val.pop_back();
		}

		Node* next = cur, *prev = cur->prev->prev;
		next->prev = prev;
		prev->next = next;
		remains--;
	    }
	    cur = cur->next;
	}

	while(cur->val.size() > 1 && gcd(arr[cur->val.front()], arr[cur->val.back()]) == 1) {
	    answer.push_back(cur->val.front());
	    cur->val.pop_front();
	}
	if(cur->val.size() == 1 && arr[cur->val[0]] == 1)
	    answer.push_back(cur->val.front());

	std::cout << answer.size() << " ";
	for(int32_t i = 0 ; i < answer.size(); i++)
	    std::cout << answer[i] + 1 << " ";
	std::cout << "\n";
    }
    return 0;
}










