#include <bits/stdc++.h>

#define ll long long
#define fi first
#define se second
#define vec vector
#define all(x) x.begin(), x.end()

using namespace std;

//#define int long long
//#define endl "\n"

int gcd(int x, int y) {
    if (x == 0) return y;
    return gcd(y % x, x);
}

struct ST{
    int sz;
    vec<int> tree;
    ST(){};
    ST (vec<int>& v) {
        sz = 1;
        while (v.size() > sz) sz *= 2;
        tree.resize(sz * 2, INT_MAX);
        for (int i = 0; i < v.size(); ++i) {
            tree[i + sz] = v[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    int get_ans(int id, int l, int r, int lq, int rq) {
        //cout << id << ' ' << l << ' ' << r << ' ' << lq << ' ' << rq << endl;
        if (rq <= l || r <= lq) return INT_MAX;
        if (lq <= l && r <= rq) return tree[id];

        int la = get_ans(id * 2, l, (l + r) / 2, lq, rq);
        int ra = get_ans(id * 2 + 1, (l + r) / 2, r, lq, rq);
        return min(la, ra);
    }
    void set_val(int id, int l, int r, int lq, int rq, int val) {
        if (rq <= l || r <= lq) return;
        if (lq <= l && r <= rq) {tree[id] = val; return;}

        set_val(id * 2, l, (l + r) / 2, lq, rq, val);
        set_val(id * 2 + 1, (l + r) / 2, r, lq, rq, val);
        tree[id] = min(tree[id * 2], tree[id * 2 + 1]);
    }
    void pr() {
        int x = 0, y = 1;
        for (int i = 1; i < tree.size(); ++i) {
            cout << tree[i] << ' ';
            x++;
            if (x == y) {
                x = 0;
                y *= 2;
                cout << endl;
            }
        }
    }
};

int get_nl(ST& tree, int lb, int rb) {
    if (lb > rb) return -1;
    //cout << "GET_NL " << lb << ' ' << rb << endl;
    if (tree.get_ans(1, 0, tree.sz, lb, rb + 1) != 0) return -1;
    int l = lb - 1, r = rb;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int x = tree.get_ans(1, 0, tree.sz, lb, m + 1);
        if (x == 0) r = m;
        else l = m;
    }
    return r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    for (int q = 0; q < t; ++q) {
        int n; cin >> n;
        vec<int> vv(n), v(n);
        for (auto& it: vv) cin >> it;
        set<pair<int, int>> st;
        for (int i = 0; i < n; ++i) {
            v[i] = (gcd(vv[i], vv[(i + 1) % n]) != 1);
            st.insert({i, vv[i]});
        }
        ST tree(v);
        //cout << "V ";
        //for (auto it: v) cout << it << ' ';
        //cout << endl;
        //tree.pr();
        int now = 0;
        vec<int> ans;
        while (st.size() > 0) {
            //cout << "NOW " << now << endl;
            //tree.pr();
            //for (auto it: st) cout << "{ " << it.fi << ' ' << it.se << " } ";
            //cout << endl;
            int x = get_nl(tree, now, n - 1);
            if (x == -1) {
                if (now == 0) break;
                now = 0;
            } else {
                auto it = st.lower_bound({x, 0});
                auto it2 = it;
                it2++;
                if (it2 == st.end()) it2 = st.begin();
                int a = (*it2).fi, b = (*it2).se;
                ans.push_back(a);
                tree.set_val(1, 0, tree.sz, a, a + 1, 1);
                auto it3 = it2;
                it3++;
                if (it3 == st.end()) it3 = st.begin();
                int a1 = (*it).fi, b1 = (*it).se, a2 = (*it3).fi, b2 = (*it3).se;
                tree.set_val(1, 0, tree.sz, a1, a1 + 1, (gcd(b1, b2) != 1));
                now = a2;
                st.erase(it2);
            }
        }
        //cout << "ANS ";
        cout << ans.size() << ' ';
        for (auto it: ans) cout << it + 1 << ' ';
        cout << endl;
    }
}
/*
8
2 3 9 0 8 5 1 3
*/







