#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <functional>
#include <random>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <list>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int INF = 1e9 + 7;
const ll LINF = 2e18;
const int MOD = INF;
const int N = 1e5;

typedef list <pair <int, int>>::iterator lit;


int gcd(int a, int b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

lit Prv(lit th, list <pair <int, int>> &str) {
	if (th == str.begin()) {
		return prev(str.end());
	}
	else return prev(th);
}

lit Nxt(lit th, list <pair <int, int>>& str) {
	if (next(th) == str.end()) {
		return str.begin();
	}
	else return next(th);
}



void Solve() {
	int n;
	cin >> n;
	list <pair <int, int>> v;


	vector <lit> its(n);
	for (int i = 0; i < n;i++) {
		int a;
		cin >> a;
		v.push_back({ a, i });
		its[i] = prev(v.end());
	}
	set <int> s;
	for (int i = 0; i < n; i++) {
		int k = gcd(its[i]->first, Prv(its[i], v)->first);
		if (k == 1)
			s.insert(i);
	}
	int ndx = 1;
	int cnt = 0;
	
	vector <int> ans;

	while (!s.empty()) {
		auto i = s.lower_bound(ndx);
		if (i == s.end()) {
			ndx = -1;
			continue;
		}
		auto j = its[*i];
		auto pr = Prv(j, v);
		auto nx = Nxt(j, v);
		if (j == pr && nx == pr) {
			ans.push_back(j->second + 1);
			break;
		}
		s.erase(j->second);
		if (gcd(nx->first, j->first) == 1 && s.count(nx->second))
			s.erase(nx->second);
		if (gcd(pr->first, nx->first) == 1)
			s.insert(nx->second);
		ans.push_back(j->second + 1);
		ndx = nx->second + 1;
		v.erase(j);

	}
	cout << ans.size() << " ";
	for (auto i : ans) cout << i << " ";
	cout << '\n';
}

int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--)
	Solve();
}