#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <iomanip>

#define endl '\n'

using namespace std;

const int Base = 1e5 + 55;

int t;
int n;
int musik[Base];
int lastGood[Base];
int nextMusik[Base];
bool last[Base];

int gcd(int a, int b)
{
	while (a != 0 && b != 0)
	{
		if (a > b)
		{
			a %= b;
		}
		else
		{
			b %= a;
		}
	}

	return a + b;
}

void push(int id)
{
	if (last[id])
	{
		return;
	}

	lastGood[nextMusik[id]] = max(lastGood[nextMusik[id]], lastGood[id]);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> t;
	while (t--)
	{
		cin >> n;

		for (int i = 0; i < n; i++)
		{
			cin >> musik[i];
			lastGood[i] = i;
			nextMusik[i] = i + 1;
			last[i] = false;
		}
		last[n - 1] = true;
		nextMusik[n - 1] = 0;

		bool deleted = false;
		vector<int> delOrd;

		int id = 0;
		do
		{
			deleted = false;
			while (!last[id])
			{
				int lastId = id;
				id = lastGood[id];
				while (!last[id] && gcd(musik[id], musik[nextMusik[id]]) != 1)
				{
					id = nextMusik[id];
				}
				lastGood[lastId] = id;
				if (!last[id])
				{
					deleted = true;
					delOrd.push_back(nextMusik[id]);
					push(nextMusik[id]);
					last[id] = last[nextMusik[id]];
					nextMusik[id] = nextMusik[nextMusik[id]];
					id = nextMusik[id];
					if (delOrd.size() == n)
					{
						break;
					}
				}
			}
			if (gcd(musik[id], musik[nextMusik[id]]) == 1)
			{
				deleted = true;
				delOrd.push_back(nextMusik[id]);
				push(nextMusik[id]);
				nextMusik[id] = nextMusik[nextMusik[id]];
				if (delOrd.size() == n)
				{
					break;
				}
			}
			id = nextMusik[id];

		} while (deleted);

		cout << delOrd.size() << ' ';
		for (auto k : delOrd)
		{
			cout << k + 1 << ' ';
		}
		cout << endl;
	}
}