#include <iostream>
#include <string>
#include <map>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <iomanip>
#include <queue>
#include <vector>

using namespace std;

typedef long long ll;

const int N = 2e5 + 1;
const int inf = 1e9 + 10;
const int mod = 1e9 + 7;
const int R = (1 << 17);

//#define int long long

ll a[N], b[N];
ll ans[N];
bool f[N];
vector<ll> d[N];
pair<pair<ll, vector<ll>>, int> c[N];
set<int> all;

ll gcd(ll a, ll b)
{
	if (a % b == 0)
	{
		return b;
	}
	else
	{
		return gcd(b, a % b);
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll n, m, k;
	int test = 1;
	cin >> test;
	while (test--)
	{
		cin >> n;
		for (int q = 0; q < n; q++)
		{
			cin >> a[q];
			b[q] = (q + 1) % n;
			f[q] = true;
		}
		queue<int> all;
		vector<int> ans;
		for (int q = 0; q < n; q++)
		{
			all.push(q);
		}
		while (all.size())
		{
			if (f[all.front()] == true && gcd(a[all.front()], a[b[all.front()]]) == 1)
			{
				ans.push_back(b[all.front()]);
				f[b[all.front()]] = false;
				b[all.front()] = b[b[all.front()]];
				all.push(all.front());
			}
			all.pop();
		}
		cout << ans.size() << " ";
		for (int q = 0; q < ans.size(); q++)
		{
			cout << ans[q] + 1 << " ";
		}
		cout << '\n';
	}
}