#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll alp = 26;

#define ff first
#define ss second
#define pb push_back
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define fopen(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout)

ll gcd(ll a, ll b) {
	return b ? gcd(b, a%b) : a;
}

void run() {
	ll n;
	cin >> n;
	vi a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vi ans;
	if (n == 1) {
		if (a[0] != 1)
			cout << 0;
		else 
			cout << "1 1";
			return;
	}
	set<pll> s;
	set<ll> st;
	for (ll i = 0; i < n; ++i)
		st.insert(i);
	ll tmp;
	vi to(n, -1);
	for (ll i = 0; i < n; ++i) {
		tmp = gcd(a[i], a[(i + 1)%n]);
		if (tmp == 1) {
			s.insert({i, (i + 1)%n});
			to[i] = (i + 1)%n;
		}
	}
	ll i = 0;
	while (!s.empty()) {
		auto t = s.lower_bound({i, 0});
		if (t == s.end()) {
			t = s.begin();
		}
		ans.pb(t->ss);
		to[t->ff] = -1;
		st.erase(t->ss);
		if (to[t->ss] != -1) {
			s.erase({t->ss, to[t->ss]});
			if (t->ff == to[t->ss]) {
				if (a[t->ff] == 1)
					ans.pb(t->ff);
				s.erase(t);
				break;
			}
			tmp = gcd(a[t->ff], a[to[t->ss]]);
			if (tmp == 1) {
				to[t->ff] = to[t->ss];
				s.insert({t->ff, to[t->ss]});
			}
			i = to[t->ss];
			s.erase(t);
		}
		else {
			auto p = st.lower_bound(t->ss);
			if (p == st.end()) {
				p = st.begin();
			}
			tmp = gcd(a[t->ff], a[*p]);
			if (tmp == 1) {
				if (*p == t->ff) {
					ans.pb(t->ff);
					break;
				}
				to[t->ff] = *p;
				s.insert({t->ff, *p});
			}
			i = *p;
			s.erase(t);
		}
	}
	cout << ans.size() << ' ';
	for (auto v : ans)
		cout << v + 1 << ' ';
}

signed main() {
	// fopen("input.txt", "output.txt");
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll kk = 0, tkk = 1;
	cin >> tkk;
	while (kk++ < tkk) {
		run();
		cout << '\n';
	}
	return 0;
}