#include <bits/stdc++.h>
#include <random>
#include <time.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define pll pair<ll,ll>
#define pii pair<int,int>
#define all(v) v.begin(),v.end()
#define fi first
#define se second

using namespace std;

mt19937_64 rnd(time(0));

ll n, m, a[100001], d[100001];

ll binpow(ll h,ll r)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h;
        h*=h;
        r/=2;
    }
    return l;
}

ll binpow(ll h,ll r,ll md)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h, l%=md;
        h*=h;
        h%=md;
        r/=2;
    }
    return l;
}

ll gcd(ll x,ll y)
{
    while (x && y)
    {
        if (x<y) swap(x, y);
        x%=y;
    }
    return x+y;
}

ll find_set(int h)
{
    if (h==d[h]) return h; else return d[h]=find_set(d[h]);
}

void unite_sets(int x,int y)
{
    x=find_set(x);
    y=find_set(y);
    d[x]=y;
}

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        d[i]=i;
    }
    queue<pll> q;
    vector<int> ans;
    for (int i = 2; i <= n; i++)
        if (gcd(a[i], a[i-1])==1)
        {
            q.push(mp(i-1, i));
        }
    if (n==1 && a[1]==1)
    {
        cout << "1 1\n";
        return;
    }
    if (gcd(a[1], a[n])==1)
        q.push(mp(n, 1));
    while (!q.empty())
    {
        ll x=q.front().fi, y=q.front().se;
        q.pop();
        ll o=y+1;
        if (o>n) o-=n;
        unite_sets(y, o);
        if (!q.empty() && q.front().se==find_set(o))
        {
            q.pop();
        }
        ans.pb(y);
        if (find_set(y)==x)
        {
            if (a[x]==1)
            {
                ans.pb(x);
            }
            break;
        }
        if (gcd(a[find_set(y)], a[x])==1)
            q.push(mp(x, find_set(y)));
    }
    cout << ans.size() << " ";
    for (int i = 0; i < ans.size(); i++) cout << ans[i] << " ";
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t=1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
