#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)

const ll INF = 2e9;
const ll inf = 2e18;
const ll MAXN = 2e5;

istream& operator >>(istream &in, pii x) {
    in >> x.first >> x.second;
    return in;
}

template <class T>
istream& operator >>(istream &in, vector<T> &a) {
    for (T &i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> a) {
    for (T i : a) {
        out << i << " ";
    }
    out << "\n";
    return out;
}

void solve() {
    ll n; cin >> n;
    vi a(n); cin >> a;
    vi next(n);
    vi del(n);
    deque<ll> q;
    for (ll i = 0; i < n; ++i) {
        q.push_back(i);
        next[i] = (i + 1) % n;
    }
    vi ans;
    while (q.size()) {
        ll i = q.front();
        q.pop_front();
        if (del[i]) continue;
        if (__gcd(a[i], a[next[i]]) == 1) {
            del[next[i]] = 1;
            ans.push_back(next[i]);
            next[i] = next[next[i]];
            q.push_back(i);
        }
    }
    cout << ans.size() << " ";
    for (ll i : ans) cout << i + 1 << " ";
    cout << "\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif

    ll t; cin >> t;
    while (t--)
    solve();

    return 0;
}