#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define int long long
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    a[n] = a[0];
    set<int> alive;
    set<pair<int, int>> ban;
    for (int i = 0; i < n; i++) {
        alive.insert(i);
    }
    for (int i = 0; i < n; i++) {
        if (__gcd(a[i], a[i + 1]) == 1) {
            ban.insert(MP(i, (i + 1) % n));
        }
    }
    vector<int> ans;

    auto getNxt = [&](int x) {
        auto it = alive.upper_bound(x);
        if (it == alive.end()) it = alive.begin();
        return (*it);
    };

    while (sz(ban)) {
        set<pair<int, int>> nextBan;
        for (auto &[x, y] : ban) {
            if (!alive.count(x)) continue;
            ans.push_back(y);
            alive.erase(y);
            int nxt = getNxt(x);
            if (__gcd(a[x], a[nxt]) == 1) {
                nextBan.insert({x, nxt});
            }
        }
        swap(ban, nextBan);
    }

    cout << sz(ans) << ' ';
    for (auto x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
#endif
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
