#include <vector>
#include <algorithm>
#include <iostream>
#include <queue>
#include <set>
using namespace std;

//#define int long long

int gcd(int a, int b){
    if (a == 0 || b == 0){
        return a + b;
    }
    return gcd(b, a % b);
}
signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
//    for (int i = 1; i < 20; i++){
//        for (int j = 1; j < 20; j++){
//            cerr << i << " " << j << " " << gcd(i, j) << '\n';
//        }
//    }
    for (int q =0; q < t; q++){
        int n;
        cin >> n;
        vector<int> lst;
        for (int i =0; i < n; i++){
            int x;
            cin >> x;
            lst.push_back(x);
        }
        queue<pair<int, int>> cur;
        for (int i = 1; i < n; i++){
            if (gcd(lst[i], lst[i - 1]) == 1){
                cur.push({i - 1, i});
            }
        }
        if (gcd(lst[0], lst.back()) == 1){
            cur.push({n - 1, 0});
        }
        set<int> nw;
        for (int i =0; i < n; i++){
            nw.insert(i);
        }
        vector<int> used(n, 1);
        vector<int> ans;
        while (!cur.empty()){
            pair<int, int> xx = cur.front();
            cur.pop();
            int x = xx.second, y = xx.first;
            if (used[x] && used[y]){
                used[x] = 0;
                ans.push_back(x);
                nw.erase(x);
                auto it =  nw.lower_bound(x);
                int nxt = *nw.begin();
                if (it != nw.end()){
                    nxt= *it;
                }
                if (gcd(lst[nxt], lst[y]) == 1){
                    cur.push({y, nxt});
                }
            }
        }
        cout << ans.size() << " ";
        for (int i : ans ){
            cout << i + 1 << " ";
        }
        cout << '\n';
    }
}