#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
const int inf = 1e9 + 113;
int gcd(int a, int b)
{
    if(a > b)
        swap(a, b);
    if(!a)
        return b;
    return gcd(b % a, a);
}
void merge(int i1, int i2, vector<deque<int>> &decks)
{
    if(decks[i1].size() < decks[i2].size())
    {
        decks[i1].swap(decks[i2]);
        for(int i = decks[i2].size() - 1; i > -1; i--)
            decks[i1].push_front(decks[i2][i]);
        return;
    }
    for(auto i : decks[i2])
        decks[i1].push_back(i);
}
void solve()
{
    int n;
    cin>>n;
    vector<int> v(n);
    deque<int> d;
    vector<deque<int>> decks;
    for(int i = 0; i < n; i++)
        cin>>v[i], d.push_back(i), decks.push_back({i});
    bool e = 0;
    vector<int> ans;
    deque<int> d1;
    for(auto i : d)
    {
        if(d1.empty())
        {
            d1.push_back(i);
            e = 0;
            continue;
        }
        if(!e && gcd(v[decks[d1.back()].back()], v[decks[i].front()]) == 1)
        {
            e = 1;
            ans.push_back(decks[i].front());
            continue;
        }
        if(e)
        {
            d1.push_back(i);
            e = 0;
            continue;
        }
        merge(d1.back(), decks[i].front(), decks);
        e = 0;
    }
    d = d1;
     while(d.size() > 1)
     {
         if(!e && gcd(v[decks[d.back()].back()], v[decks[d.front()].front()]) == 1)
         {
             ans.push_back(decks[d.front()].front());
             decks[d.front()].pop_front();
             if(!decks[d.front()].empty())
                 d.push_back(d.front());
             else
                 e = 1;
             d.pop_front();
             continue;
         }
         if(e)
         {
             d.push_back(d.front());
             d.pop_front();
             e = 0;
             continue;
         }
         e = 0;
         merge(d.back(), d.front(), decks);
         d.pop_front();
     }
    auto i = d.back();
    while(decks[i].size() && gcd(v[decks[i].front()], v[decks[i].back()]) == 1)
        ans.push_back(decks[i].front()), decks[i].pop_front();
    cout<<ans.size()<<" ";
    for(auto i : ans)
        cout<<i + 1<<" ";
    cout<<endl;
}
signed main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int t;
    cin>>t;
    while(t--)
    {
        solve();
    }
}
