#include <bits/stdc++.h>

using namespace std;
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
#pragma optimaze("O3")

#define int long long

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll sm(ll a, ll b) {
    if (a + b < mod) return a + b;
    return (a + b - mod);
}

ll divv(ll a, ll b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

ll pw(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2) return mul(a, pw(a, k - 1));
    return pw(mul(a, a), k / 2);
}

int maxn = 1e5 + 5;
vector<int> p(maxn);
vector<int> sz(maxn);
vector<int> fi(maxn);
vector<int> nxt(maxn);

void clear_(int n) {
    for (int i = 0; i < n; i++) {
        p[i] = i;
        sz[i] = 1;
        fi[i] = i;
        nxt[i] = (i + 1) % n;
    }
    return;
}


int get(int i) {
   if (p[i] == i) return i;
   p[i] = get(p[i]);
   return p[i];
}

bool is(int a, int b) {
    return get(a) == get(b);
}


void upd(int a, int b) {
    a = get(a); b = get(b);
    int frst = fi[b];
    // cout << a << b << endl;
    if (a == b) assert(0);
    if (sz[a] < sz[b]) {
        swap(a, b);
    }
    p[b] = a;
    sz[a] += sz[b];
    fi[a] = frst;
    return;
}



int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;  cin >> t;
    while (t--) {
        int n; cin >> n;
        clear_(n);
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        int lst = n - 1;
        while (lst != -1 && gcd(a[(lst + 1) % n], a[lst]) != 1) {
            lst--;
        }
        if (lst == -1) {
            cout << 0 << endl;
            continue;
        }
        lst++;
        lst %= n;
        int cnt = 0;
        while (cnt < n) {
                // cout << lst << endl;
            while (cnt < n && gcd(a[(lst + 1) % n], a[lst]) != 1) {
                    // cout << "gdfhdf" << lst << lst + 1 << endl;
                upd(lst, (lst + 1) % n);
                // cout << "dsg" << endl;
                lst++;
                lst %= n;
                cnt++;
            }
            lst++;
            lst %= n;
            cnt++;
        }
        vector<int> ans;
        int curr = lst;
        // cout << "Wow" << endl;
        while (true) {
            curr = fi[get(curr)];
            // cout << curr << endl;
            int nx = nxt[curr];
            if (is(nx, curr)) {
                if (nx == curr) {
                    if (a[curr] == 1) {
                        ans.push_back(curr + 1);
                    }
                    break;
                }
                ans.push_back(nx + 1);
                nx = nxt[nx];
                nxt[curr] = nx;
                if (gcd(a[nx], a[curr]) != 1) break;
            } else {
                ans.push_back(nx + 1);
                nx = nxt[nx];
                nxt[curr] = nx;
                if (is(nx, curr)) {
                    if (nx == curr) {
                        if (a[curr] == 1) {
                            ans.push_back(curr + 1);
                        }
                        break;
                    }
                    if (gcd(a[nx], a[curr]) != 1) break;
                } else {
                    if (gcd(a[nx], a[curr]) != 1) {
                        upd(curr, nx);
                    }
                    curr = nx;
                }
            }
        }
        cout << ans.size() << " ";
        for (auto el : ans) cout << el << " ";
        cout << endl;






    }


    return 0;
}
