﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
using namespace std;

long long gcd(long long a, long long b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

void solve() {
	int n;
	cin >> n;
	vector<long long>all(n);
	for (int i = 0; i < n; i++)
		cin >> all[i];
	vector<bool>del(n);
	vector<int>nx(n);
	queue<pair<int, int>>q;
	for (int i = 0; i < n; i++) {
		nx[i] = (i + 1) % n;
		if (gcd(all[i], all[(i + 1) % n]) == 1)
			q.push({ i,(i + 1) % n });
	}
	vector<int>res;
	while (q.size()) {
		int v = q.front().first;
		int u = q.front().second;
		q.pop();
		if (del[v])
			continue;
		res.push_back(u);
		del[u] = 1;
		nx[v] = nx[u];
		if (gcd(all[v], all[nx[v]]) == 1)
			q.push({ v,nx[v] });
	}
	cout << res.size() <<' ';
	for (auto c : res)
		cout << c + 1 << ' ';
	cout << '\n';
}


int main() {
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
	int t;
	cin >> t;
	//t = 1;
	while (t) {
		t--;
		solve();
	}
}