#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define fi first
#define se second
#define pb push_back
#define re return

#define all(x) x.begin(), x.end()
#define sz(x) (int)(x).size()
#define fout(x){cout << x << endl; return;}

#define fr(i, a, b) for(int i = (a); i <= (b); i++)
#define rf(i, a, b) for(int i = (a); i >= (b); i--)
#define fe(x, y) for(auto& x : y)

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef double db;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef bool bl;

template<typename T> using o_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> void vout(T s){cout << s << endl;exit(0);}
template<typename T> void umin(T &a, T b){a = min(a, b);}
template<typename T> void umax(T &a, T b){a = max(a, b);}

mt19937_64 rnd(time(0));

const int MX = 1e5;
int a[MX], n, t[MX * 4], g[MX * 4], pos;

void build(int v, int tl, int tr){

    if(tl == tr){
        t[v] = 1;

        if(tl == 1)g[v] = __gcd(a[1], a[n]);
        else g[v] = __gcd(a[tl], a[tl - 1]);
    }
    else {
        int tc = (tr + tl) / 2;

        build(2 * v, tl, tc);
        build(2 * v + 1, tc + 1, tr);

        t[v] = t[v * 2] + t[v * 2 + 1];
        g[v] = min(g[v * 2], g[v * 2 + 1]);
    }
}
void ddd(int v, int tl, int tr){

    if(tl == tr){
        t[v] = 0, g[v] = 1e9 + 7, pos = tl;
    }
    else {
        int tc = (tr + tl) / 2;

        if(t[v * 2] && g[v * 2] == 1)ddd(2 * v, tl, tc);
        else ddd(2 * v + 1, tc + 1, tr);

        t[v] = t[v * 2] + t[v * 2 + 1];
        g[v] = min(g[v * 2], g[v * 2 + 1]);
    }

}
void upd(int v, int tl, int tr, int l, int r){

    if(l > r)return;

    if(tl == l && tr == r){
        if(g[v] == 1 && t[v] && !pos)ddd(v, tl, tr);
    }
    else {
        int tc = (tr + tl) / 2;

        upd(2 * v, tl, tc, l, min(r, tc));
        upd(2 * v + 1, tc + 1, tr, max(l, tc + 1), r);

        t[v] = t[v * 2] + t[v * 2 + 1];
        g[v] = min(g[v * 2], g[v * 2 + 1]);
    }
}
int sum(int v, int tl, int tr, int l, int r){

    if(l > r)return 0;

    if(tl == l && tr == r)return t[v];

    int tc = (tr + tl) / 2;

return sum(2 * v, tl, tc, l, min(r, tc)) + sum(2 * v + 1, tc + 1, tr, max(l, tc + 1), r);
}
int mmm(int v, int tl, int tr, int l, int r){

    if(l > r)return 1e9;

    if(tl == l && tr == r)return g[v];

    int tc = (tr + tl) / 2;

return min(mmm(2 * v, tl, tc, l, min(r, tc)), mmm(2 * v + 1, tc + 1, tr, max(l, tc + 1), r));
}
int ppp(int v, int tl, int tr, int k){

    if(tl == tr)return tl;

    int tc = (tr + tl) / 2;

    if(t[v * 2] >= k)return ppp(2 * v, tl, tc, k);
    else return ppp(2 * v + 1, tc + 1, tr, k - t[v * 2]);
}
void nnn(int v, int tl, int tr, int pos, int x){

    if(tl == tr)g[v] = x;
    else {
        int tc = (tr + tl) / 2;

        if(tc >= pos)nnn(2 * v, tl, tc, pos, x);
        else nnn(2 * v + 1, tc + 1, tr, pos, x);

        t[v] = t[v * 2] + t[v * 2 + 1];
        g[v] = min(g[v * 2], g[v * 2 + 1]);
    }
}
void solve(){

    cin >> n;
    fr(i, 1, n)cin >> a[i];

    build(1, 1, n);

    vector<int> ans;
    int l = 2;
    while(g[1] == 1 && t[1] > 1){
        if(l > n || mmm(1, 1, n, l, n) != 1 || !sum(1, 1, n, l, n))l = 1;
        pos = 0;
        upd(1, 1, n, l, n);

        ans.pb(pos);
//        l = pos + 1;

//    cout << pos << " ";

        pos = sum(1, 1, n, 1, pos);

        if(pos == t[1])pos = 1;
        else pos++;

        if(pos == 1){
            int pos2 = t[1];
            pos = ppp(1, 1, n, pos);
            pos2 = ppp(1, 1, n, pos2);

//            cout << pos2 << endl;

            l = pos + 1;

            nnn(1, 1, n, pos, __gcd(a[pos], a[pos2]));
        }
        else {
            int pos2 = pos - 1;
            pos = ppp(1, 1, n, pos);
            pos2 = ppp(1, 1, n, pos2);

            l = pos + 1;

            nnn(1, 1, n, pos, __gcd(a[pos], a[pos2]));
        }
    }

    if(t[1] == 1 && g[1] == 1){
        ans.pb(ppp(1, 1, n, 1));
    }

    cout << sz(ans) << " ";
    fe(x, ans)cout << x << " ";
    cout << endl;

//    exit(0);
}
int main(){
#ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

#endif // LOCAL

    ios::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int q = 1;
    cin >> q;
    while(q--)solve();

return 0;}

