#include<bits/stdc++.h>

using namespace std;

string tostr(string s) {
    string res = "";
    res.push_back('"');
    res += s;
    res.push_back('"');
    return res;
}

string tostr(char c) {
    string res = "";
    res += "'";
    res.push_back(c);
    res += "'";
    return res;
}

string tostr(long long x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + (x % 10));
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

string tostr(int x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + x % 10);
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

template<typename A, typename B>
string tostr(pair<A, B> a) {
    return "{" + tostr(a.first) + ", " + tostr(a.second) + "}";
}

template<typename A>
string tostr(vector<A> a) {
    string res = "{";
    bool f = false;
    for (auto x : a) {
        if (!f) {
            f = true;
        }
        else {
            res += ", ";
        }
        res += tostr(x);
    }
    res += "}";
    return res;
}

#define debug(x) cout << #x << " = " << tostr(x) << endl
#define int long long
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

vector<int> t;

void update(int v, int l, int r, int i, int x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) update(v * 2 + 1, l, m, i, x);
    else update(v * 2 + 2, m, r, i, x);
    t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int l, int r, int l1, int r1) {
    if (l1 >= r || l >= r1 || t[v] > 1) return -1;
    if (l + 1 == r) return l;
    int m = (l + r) / 2;
    int res = get(v * 2 + 1, l, m, l1, r1);
    if (res != -1) return res;
    return get(v * 2 + 2, m, r, l1, r1);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    t.clear();
    t.resize(4 * n, 1e18);
    for (int i = 0; i < n; i++) {
        update(0, 0, n, i, __gcd(a[i], a[(i + n - 1) % n]));
    }
    int tmp = 1 % n;
    vector<int> ans;
    set<int> b;
    for (int i = 0; i < n; i++) {
        b.insert(i);
    }
    while (true) {
        int res = get(0, 0, n, tmp, n);
        if (res == -1) {
            res = get(0, 0, n, 0, tmp);
        }
        if (res == -1) break;
        //debug(res);
        ans.pb(res);
        b.erase(res);
        if (sz(b) == 0) break;
        tmp = res;
        update(0, 0, n, res, 1e18);
        for (int T = 0; T < 2; T++) {
            auto it = b.upper_bound(tmp);
            if (it == b.end()) it = b.begin();
            tmp = *it;
        }
        auto it = b.lower_bound(res);
        if (it == b.end()) it = b.begin();
        int x = *it, y;
        if (it != b.begin()) {
            it--;
            y = *it;
        }
        else {
            y = *b.rbegin();
        }
        //debug(x); debug(y);
        update(0, 0, n, x, __gcd(a[x], a[y]));
    }
    cout << sz(ans) << " ";
    for (auto x : ans) cout << x + 1 << " "; cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
