//Komershan
//@defineintlonglong (telegramm channel)
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <queue>
#include <map>
#include <stack>
#include <unordered_map>
#include <set>
using namespace std;


#define int long long
#define double long double

//for coding
#define rd(a) for(auto &i : a) cin >> i;
#define ct(a) for(auto i : a) cout << i << ' ';
#define ctp(a) for(auto i : a) cout << i << '\n';
#define all(a) a.begin(), a.end()

struct node {
	node* l, * r;
	int elem, index;
};

int gcd(int a, int b) {
	if (!a || !b)
		return a + b;
	if (a < b)
		return gcd(a, b % a);
	else
		return gcd(a % b, b);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector <node*> a(n);
		for (int i = 0; i < n; i++)
			a[i] = new node();
		for (int i = 0; i < n; i++) {
			int num;
			cin >> num;
			a[i]->elem = num;
			a[i]->l = a[((i - 1) % n + n) % n];
			a[i]->r = a[(i + 1) % n];
			a[i]->index = i;
		}
		set <pair <int, node*>> system;
		for (int i = 0; i < n; i++) {
			if (gcd(a[i]->elem, a[(i + 1) % n]->elem) == 1) {
				system.insert({ i, a[i] });
			}
		}
		int past = -1;
		vector <int> res;
		while (system.size()) {
			set <pair <int, node*>> ::iterator it = system.upper_bound({ past + 1, nullptr });
			if (it == system.end())
				it = system.begin();
			res.push_back(it->second->r->index + 1);
			if (it->second->r == it->second) {
				system.erase({ it->second->r->index, it->second->r });
				continue;
			}
			if (system.count({ it->second->r->index, it->second->r })) {
				system.erase({ it->second->r->index, it->second->r });
			}
			past = it->second->index + 1;
			node* l = it->second, * r = it->second->r->r;
			l->r = r;
			r->l = l;
			if (gcd(l->elem, r->elem) == 1)
				system.insert({ l->index, l });
			else
				system.erase({ it->second->index, it->second });
		}
		cout << res.size() << ' ';
		ct(res);
		cout << '\n';
	}
}