#include <bits/stdc++.h>

#define range(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

typedef long long ll;
typedef long double ld;

using namespace std;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;
const int md = 1e9 + 7;


void solve() {
    int n; cin >> n;
    vector<int> a(n);
    range(i, n) cin >> a[i];
    set<int> alive;
    range(i, n) alive.insert(i);
    deque<int> bad;
    range(i, n) {
        int x = __gcd(a[i], a[(i + 1) % n]);
        if (x == 1) bad.push_back(i);
    }
    vector<int> ans;
    while(!bad.empty()) {
        int i = bad.front();
        bad.pop_front();
        auto it2 = alive.upper_bound(i);
        if (it2 == alive.end()) {
            it2 = alive.begin();
        }
        int j = *it2;
        if (!bad.empty() && bad.front() == j) bad.pop_front();
        ans.push_back(j);
        alive.erase(j);
        if (i == j) break;
        auto it = alive.upper_bound(i);
        if (it == alive.end()) {
            it = alive.begin();
        }
        int g = __gcd(a[i], a[*it]);
        if (g == 1) bad.push_back(i);
    }
    cout << ans.size() << ' ';
    for(auto &x : ans) cout << x + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tests = 1;
    cin >> tests;
    range(_, tests) {
        solve();
    }
    return 0;
}