#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

#define all(x) (x.begin(), x.end())
#define endl '\n'
#define fi first
#define mp make_pair
#define pb emplace_back
#define re return
#define rep(i, n) for (int i = 0; i < (n); i++)
#define se second
#define sz(x) int(x.size())
#define sqrt(x) sqrt(abs(x))

typedef pair<int, int> ii;
typedef long double ld;
typedef long long ll;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<int> vi;
typedef vector<string> vs;
typedef vector<vector<bool>> vvb;
typedef vector<vector<int>> vvi;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int gcd(int a, int b)
{
    while (b != 0)
    {
        a %= b;
        swap(a, b);
    }
    re a;
}

ii get_next(ii cur, set<ii> &s)
{
    auto it = s.find(cur);
    if (it == (--s.end())) {
        re *s.begin();
    }
    it++;
    re *it;
}

ii get_prev(ii cur, set<ii> &s)
{
    auto it = s.find(cur);
    if (it == s.begin()) {
        re *(--s.end());
    }
    it--;
    re *it;
}

bool exists(ii cur, set<ii> &s)
{
    auto it = s.upper_bound(mp(cur.fi, -1));
    if ((*it).fi != cur.fi) re 0;
    re 1;
}

ii get_cur(int x, set<ii> &s)
{
    auto it = s.upper_bound(mp(x, -1));
    re *it;
}

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    set<ii> s;
    rep(i, n)
    {
        cin >> a[i];
        s.insert(mp(i, a[i]));
    }
    queue<ii> q;
    vi ans, p;
    for (int i = 1; i < n; i++)
    {
        p.pb(i);
    }
    p.pb(0);
    for (int x = 0; x < n; x++)
    {
        int i = p[x], k = (i + 1) % n, j = (i - 1 + n) % n;
        if (gcd(a[j], a[i]) == 1) {
            q.push(mp(j, i));
            x++;
        }
    }
    while (!q.empty() && sz(s) > 0)
    {
        ii cur = q.front(), nxt, prv;
        q.pop();
        if (!exists(cur, s)) continue;
        cur = get_cur(cur.se, s);
        prv = get_prev(cur, s);
        if (gcd(cur.se, prv.se) > 1) continue;
        nxt = get_next(cur, s);
        ans.pb(cur.fi);
        s.erase(cur);
        if (sz(s) > 0 && gcd(nxt.se, prv.se) == 1) {
            q.push(mp(prv.fi, nxt.fi));
        }
    }
    cout << sz(ans) << ' ';
    rep(i, sz(ans)) cout << ans[i] + 1 << ' ';
    cout << endl;
}

int main()
{
    ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    re 0;
}
