#include<bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define F0R(i, n) for(int i = 0; i < n; ++i)
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;

ll nx() {
    ll X; cin >> X;
    return X;
}

int gcd(int a, int b) { return (a ? gcd(b % a, a) : b); }

void solve() {
    int n; cin >> n;
    vi a(n); F0R(i, n) cin >> a[i];
    vi nxt(n); F0R(i, n) nxt[i] = (i + 1) % n;
    vi fast(n); F0R(i, n) fast[i] = -1;
    int start = 0;
    vector<int> ans;
    while (!(start == fast[start] || start == nxt[start])) {
        if (fast[start] != -1) start = fast[start];
        if (gcd(a[start], a[nxt[start]]) == 1) {
            ans.push_back(nxt[start]);
            nxt[start] = nxt[nxt[start]];
            start = nxt[start];
        } else {
            int cur = nxt[start];
            bool flag = true;
            while (fast[cur] != -1)
                cur = fast[cur];
            if (!flag) break;
            int cur2 = nxt[start];
            while (fast[cur2] != -1) {
                int cur3 = fast[cur2];
                fast[cur2] = cur;
                cur2 = cur3;
            }
            fast[start] = cur;
        }
    }
    if (start == nxt[start])
        if (a[start] == 1)
            ans.push_back(start);
    cout << ans.size() << ' ';
    F0R(i, ans.size()) cout << ans[i]+1 << ' ';
    cout << '\n';
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    int t; cin >> t;
    while (t--) solve();

    return 0;
}
