#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

#define ll long long
#define ld long double
#define all(x)  (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second
#define _ nullptr

using namespace std;

int gcd(int a, int b) {
    return __gcd(a, b);
}

vector<int> p;

int get_par(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get_par(p[v]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i<n; i++) {
            cin >> a[i];
        }
        p.clear();
        p.resize(n);
        for (int i = 0; i<n; i++) {
            p[i] = i;
        }
        vector<int> bad;
        vector<int> ans;

        vector<bool> used(n);
        for (int i=0; i<n; i++) {
            if (gcd(a[i], a[(i+1)%n])==1) {
                ans.pb((i+1)%n);
                bad.pb(i);
                p[(i+1)%n] = (i+2)%n;
                used[(i+1)%n] = 1;
                i++;

            }
        }
        while (!bad.empty()) {

            vector<int> now;

            for (int i : bad) {
                if (used[i]) continue;
                int w = get_par((i+1)%n);
                if (gcd(a[i], a[w]) == 1) {
                    ans.pb(w);
                    now.pb(i);
                    used[w] = 1;
                    p[w] = get_par((w+1)%n);
                }
            }
            bad = now;
        }
        cout << ans.size() << " ";
        for (int i : ans) {
            cout << i+1 << " ";
        }
        cout << "\n";

    }
    return 0;
}

