#include <algorithm>
#include <iomanip>
#include <iostream>
#include <set>
#include <string>
#include <vector>
#include <queue>

#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int gcd(int a, int b) {
  while (b) {
    a %= b;
    swap(a, b);
  }
  return a;
}

void solve() {
  int n;
  cin >> n;
  vector<int> v(n);
  for (int i = 0; i < n; ++i) {
    cin >> v[i];
  }
  queue<int> q;
  for (int i = 0; i < n; ++i) {
    q.push(i);
  }
  vector<int> del(n, 0), ans, next(n);
  for (int i = 0; i < n; ++i) {
    next[i] = (i + 1) % n;
  }
  while (!q.empty()) {
    int i = q.front();
    q.pop();
    if (del[i]) {
      continue;
    }
    int j = next[i];
    if (gcd(v[i], v[j]) == 1) {
      del[j] = 1;
      next[i] = next[j];
      ans.push_back(j);
      q.push(i);
    }
  }
  cout << ans.size() << " ";
  for (const int &e : ans) {
    cout << e + 1 << " ";
  }
  cout << endl;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
  int t;
  cin >> t;
  for (int i = 0 ; i < t; ++i) {
    solve();
  }
  return 0;
}
