#include <iostream>
#include <vector>
#include <set>

#define ll long long
#define ld double
#define ft first
#define sd second
#define pb push_back

using namespace std;

ll gcd(ll x, ll y) {
    if (x == 0)
        return y;
    return gcd(y % x, x);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector <ll> a(n);
        set <ll> all, notcheck;
        for (ll i = 0; i < n; ++i) {
            cin >> a[i];
            all.insert(i);
            notcheck.insert(i);
        }
        ll cur = 0;
        vector <ll> del;
        bool er = 1;
        while (!all.empty()) {
            auto prv = all.find(cur);
            auto nxt = prv;
            if (prv == all.begin())
                prv = all.end();
            --prv;
            ++nxt;
            if (nxt == all.end())
                nxt = all.begin();
            auto it = notcheck.find(cur);
            ++it;
            if (it == notcheck.end())
                it = notcheck.begin();
            bool bl = gcd(a[*prv], a[cur]) == 1;
            if (er) {
                er = 0;
                cur = *it;
                continue;
            }
            if (bl) {
                notcheck.insert(*nxt);
                all.erase(cur);
                er = 1;
                del.pb(cur + 1);
            }
            it = notcheck.find(cur);
            ++it;
            if (it == notcheck.end())
                it = notcheck.begin();

            if (notcheck.size() == 1)
                break;
            ll nx = *it;
            notcheck.erase(cur);
            cur = nx;
        }
        cout << del.size() << ' ';
        for (auto &i: del) {
            cout << i << ' ';
        }
        cout << '\n';
    }

    return 0;
}
