#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vvi = vector<vi>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

mt19937 rng(1337228);

struct RC {
    int32_t H = 1337228;

    template<class T>
    friend RC& operator >> (RC& rin, T& x) {
        cin >> x;
        return rin;
    }

    friend RC& operator >> (RC& rin, int& x) {
        cin >> x;
        rin.H ^= x * 1337;
        rin.H *= 3;
        return rin;
    }

    friend RC& operator >> (RC& rin, ll& x) {
        cin >> x;
        rin.H ^= x * 229;
        rin.H *= 7;
        return rin;
    }

    friend RC& operator >> (RC& rin, string& s) {
        cin >> s;
        static const int P = 97;
        for (char c : s) {
            rin.H = rin.H * P ^ c;
        }
        return rin;
    }
} rin;

void initRandom() {
    rng.seed(rin.H);
}

void solve() {
    int n; cin >> n;
    vi a(n), f(n, 1); for(int & x : a) cin >> x;
    for (int i = 0; i < n; ++i) {
        int j = i | i + 1;
        if (j < n) f[j] += f[i];
    }
    set<int> s;
    for (int i = 0; i < 2*n; ++i) s.insert(i);
    a.resize(2*n);
    copy(a.begin(), a.begin()+n, a.begin()+n);
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
    vector<int> ans, del(n);

    ll tour = 0;
    for (int i = 0; i < n; ++i) {
        if (__gcd(a[i], a[i+1]) == 1) q.emplace(i+1+tour, i), tour += n;         
    }
    tour += n;

    while (!q.empty()) {
        if (s.size() == 2) break;
        ll v = q.top().first; 
        int pp = q.top().second; q.pop();
        
        // cout << "pop << " << v << ", " << v%n << ", " << pp << endl;
        if (del[pp] || del[v%n]) continue;

        s.erase(v % n);
        s.erase(v % n + n);

        del[v%n] = 1;
        ans.push_back(v % n + 1);

        if (s.size() == 2) break;

        auto it = s.lower_bound(v % n);
        int i = *s.lower_bound(v % n) % n;
        int j = *prev(s.lower_bound(v % n + n)) % n;
        if (__gcd(a[i], a[j]) == 1) {
            ll d = i + tour;
            //cout << "push << " << d << ", " << i << ", " << j << endl;
            tour += n;
            q.emplace(d, j);
        }
    }

    if (s.size() == 2) {
        if (a[*s.begin()] == 1) {
            ans.push_back(*s.begin() + 1);
        }
    }

    cout << sz(ans);
    for (int i : ans) cout << ' ' << i;
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while(t--) solve();
}