#include <bits/stdc++.h>


using namespace std;

#define all(x) x.begin(),x.end()
#define ld long double


struct dsu {
    int n;
    vector<int> p;

    dsu(int N) {
        n = N;
        p.resize(n);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }

    int find(int x) {
        if (x == p[x])return x;
        return (p[x] = find(p[x]));
    }

    void unite(int x, int y) {
        //y > x
        x = find(x);
        y = find(y);
        p[x] = y;
    }

};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) cin >> a[i];


        dsu d(n);
        for (int i = 1; i < n; ++i) {
            if (__gcd(a[i], a[i - 1]) != 1)d.unite(i - 1, i);
        }
        set<int> free;
        for (int i = 0; i < n; ++i) {
            free.insert(i);
        }

        vector<int> re;
        int last = -1;
        int id = 0;
        int nc = 0;
        int last_id = -1;

        while (nc != 2 * n && re.size() != n) {
            bool remov = false;
            if (last == -1) {
                last = a[d.find(id)];
                nc++;
            } else {
                if (__gcd(last, a[id]) == 1) {
                    remov = true;
                    re.push_back(id);
                    free.erase(id);
                    last = -1;
                    nc = 0;
                } else {
                    if (last_id < id)d.unite(last_id, id);
                    last = a[d.find(id)];
                    nc++;
                }
            }
            last_id = id;
            if (remov) {
                if (free.empty())break;
                auto f = free.upper_bound(id);
                if (f == free.end())f = free.begin();
                id = *f;
                continue;
            }
            id = d.find(id);
            if (free.empty())break;
            auto f = free.upper_bound(id);
            if (f == free.end())f = free.begin();
            id = *f;
        }
        cout << re.size() << " ";
        for (int x : re) cout << x + 1 << " ";
        cout << "\n";
    }
}