// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast,unroll-all-loops")
#include <bits/stdc++.h>

#define ll long long
// #define int ll
#define pii pair<int, int>
#define pb push_back
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define all(a) a.begin(), a.end()
#define mp make_pair

using namespace std;

const int max_n = 1e5 + 5;
const int inf = 1e9;
const int log_n = 21;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int get_next(set<int> &setik, int i) {
    if (setik.size() == 0) return -1;
    auto it = setik.upper_bound(i);
    if (it == setik.end()) return *setik.begin();
    return *it;
}

int get_prev(set<int> &setik, int i) {
    if (setik.size() == 0) return -1;
    auto it = setik.lower_bound(i);
    if (it == setik.begin()) return *(--setik.end());
    return *(--it);
}

void run() {
    int n;
    cin >> n;
    vector<int> a(n);
    rep(i, n) {
        cin >> a[i];
    }
    set<int> cur;
    rep(i, n - 1) {
        if (gcd(a[i], a[i + 1]) == 1) {
            cur.insert(i);
        }
    }
    if (gcd(a.back(), a[0]) == 1) {
        cur.insert(n - 1);
    }
    set<int> rem;
    rep(i, n) {
        rem.insert(i);
    }
    vector<int> ans;
    while (!cur.empty()) {
        set<int> nxt;
        for (auto el : cur) {
            if (rem.count(el) == 0) continue;
            int sled = get_next(rem, el);
            rem.erase(sled);
            ans.pb(sled);
            if (rem.size() == 0) break;
            sled = get_next(rem, el);
            if (gcd(a[el], a[sled]) == 1) nxt.insert(el);
        }
        cur = nxt;
    }
    cout << ans.size() << ' ';
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    #ifndef ONLINE_JUDGE
        // files("input.txt", "output.txt");
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        run();
    }
    return 0;
}