#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <random>
#include <cassert>
#include <iomanip>
#include <algorithm>
#include <bitset>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 1

void solve();

const int MAXN = 3e5 + 7;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 9;
const int INF1 = 2e18;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*---------------------------------------------------------------*/

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    set<int> s;
    queue<int> luk;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        luk.push(i);
        cin >> v[i];
        s.insert(i);
    }
    vector<int> ans;
    while (!luk.empty()) {
        int cur = luk.front();
        luk.pop();
        auto it = s.find(cur);
        if (it == s.end())
            continue;
        ++it;
        if (it == s.end())
            it = s.begin();
        int next = *it;
        if (gcd(v[cur], v[next]) == 1) {
            ans.push_back(next);
            s.erase(it);
            luk.push(cur);
        }
    }
    cout << ans.size() << ' ';
    for (int i : ans)
        cout << i + 1 << ' ';
    cout << '\n';
}