#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500010;
const int MOD = 1000000007;

set < int > s, d;

int gcd(int a, int b) {
	while (b)
		a %= b, swap(a, b);
	return a;
}

int a[N];

signed main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int t;
	cin >> t;

	while (t--) {
		s.clear();
		d.clear();
		int n;
		cin >> n;
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			s.insert(i);
		}
		for (int i = 0; i < n; ++i) {
			if (gcd(a[i], a[(i + 1) % n]) == 1)
				d.insert(i);
		}
		int ind = 0;
		vector < int > res;
		while (!d.empty() && s.size() != 1) {
			auto it = d.lower_bound(ind);
			if (it == d.end())
				ind = 0;
			it = d.lower_bound(ind);
			auto jt = s.lower_bound((*it) + 1);
			if (jt == s.end())
				jt = s.lower_bound(0);
			int i_t = *it;
			int j_t = *jt;
			d.erase(*it);
			d.erase(*jt);
			res.push_back(j_t + 1);
			s.erase(jt++);
			if (jt == s.end())
				jt = s.begin();
			if (gcd(a[i_t], a[*jt]) == 1)
				d.insert(i_t);
			ind = *jt;
		}
		if (s.size() == 1) {
			if (a[(*s.begin())] == 1)
				res.push_back(*s.begin() + 1);
		}
		cout << res.size() << ' ';
		for (int j : res)
			cout << j << ' ';
		cout << '\n';
	}
	
}