#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define sz(a) (int) (a).size()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << endl;

//template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
//template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
//template<class t> using vc = vector<t>;
//template<class t> using vvc = vector<vector<t>>;

//using pi = pair<int, int>;
//using vi = vc<int>;
//using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 1e5 + 10;

int a[maxn];
int n;
set<pair<int, int> > s;
set<int> q;

void add(int i) {
    set<pair<int, int> >::iterator it = s.lower_bound(pair<int, int> {i + 1, -1});
    if (it == s.end()) {
        it = s.begin();
    }
    int j = (*it).x;
    int x = a[i], y = a[j];
    if (__gcd(x, y) == 1) {
        q.insert(j);
        return;
    }
}

void del(int i) {
    set<pair<int, int> >::iterator it = s.lower_bound({i + 1, -1});
    if (it == s.end()) {
        it = s.begin();
    }
    int j = (*it).x;
    int x = a[i], y = a[j];
    if (__gcd(x, y) == 1) {
        set<int>::iterator it2 = q.find(j);
        if (it2 != q.end()) q.erase(it2);
        return;
    }
}

int get_nxt(int i) {
    set<pair<int, int> >::iterator it = s.lower_bound({i + 1, -1});
    if (it == s.end()) {
        it = s.begin();
    }
    return (*it).x;
}

int get_nxt_q(int i) {
    set<int>::iterator it = q.lower_bound(i + 1);
    if (it == q.end()) {
        it = q.begin();
    }
    return (*it);
}

int get_prev(int i) {
    set<pair<int, int> >::iterator it = s.lower_bound({i, -1});
    if (it == s.begin()) {
        it = --s.end();
    } else {
    --it;}
    return (*it).x;
}


void solve() {
    s.clear();
    q.clear();
        cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s.insert({i, a[i]});
    }
    for (int i = 0; i < n; i++) {
        add(i);
    }
/*
    for (set<pair<int, int> >::iterator it = s.begin(); it != s.end(); ++it) {
            cout << (*it).x << ' ';
        }
        cout << '\n';
        for (set<int >::iterator it = q.begin(); it != q.end(); ++it) {
            cout << (*it) << ' ';
        }
        cout << '\n';*/
    int cur = 0;
    vector<int> ans;
    int cnt = 0;
    while (sz(q) > 0 && sz(s)) {
        int i = get_nxt_q(cur);
        //debug(i);
        ans.push_back(i);
        del(get_prev(i));
        //debug(get_prev(i));
        del(i);
        set<pair<int, int> >::iterator it = s.find({i, a[i]});
        if (it != s.end()) s.erase(it);
        if (sz(s) == 0) break;
        cur = get_nxt(i);
        add(get_prev(i));
        /*for (set<pair<int, int> >::iterator it = s.begin(); it != s.end(); ++it) {
            cout << (*it).x << ' ';
        }
        cout << '\n';
        for (set<int >::iterator it = q.begin(); it != q.end(); ++it) {
            cout << (*it) << ' ';
        }
        cout << '\n';
        debug(cur)*/
        //cnt++;
        //if (cnt == 2) break;
    }
    cout << sz(ans) << ' ';
    for (int i = 0; i < sz(ans); i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << '\n';

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
