#include <bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define eb emplace_back

using namespace std;

template <typename T>
bool chmin(T& a, const T& b){
  if (a > b){
    a = b;
    return true;
  }
  return false;
}

template <typename T>
bool chmax(T& a, const T& b){
  if (a < b){
    a = b;
    return true;
  }
  return false;
}

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

#ifdef ONPC
mt19937 rnd(54);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 54LL;
const ld PI = acos(-1);

#ifdef ONPC
const int MAXN = 154;
#else
const int MAXN = 300100;
#endif

//#define int long long
const int INF = 1e9;

int gcd(int a, int b){
  while (b){
    a %= b;
    swap(a, b);
  }
  return a;
}

void solve(){
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++) cin >> a[i];

  deque<int> q;
  vector<int> ans;
  vector<int> next(n);
  for (int i = 0; i < n; i++){
    next[i] = (i + 1) % n;
  }

  for (int i = 0; i < n; i++){
    int a1 = a[i];
    int a2 = a[next[i]];
    if (gcd(a1, a2) == 1) q.eb(i);
  }

  vector<int> used(n);
  while (!q.empty()){
    int i = q.front();
    q.pop_front();
    if (used[i]) continue;
    int j = next[i];
    ans.eb(j + 1);
    used[j] = 1;
    next[i] = next[j];

    int a1 = a[i];
    int a2 = a[next[i]];
    if (gcd(a1, a2) == 1) q.eb(i);
  }

  cout << ans.size() << ' ';
  for (auto i : ans) cout << i << ' ';
  cout << '\n';
}

signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  int Q;
  cin >> Q;
  while (Q--)
    solve();
}