#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <utility>
#include <numeric>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <bitset>
#include <cstdlib>
#include <cassert>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        vector<int> prev(n), next(n);
        for (int i = 1; i < n; ++i) {
            prev[i] = i - 1;
        }
        prev[0] = n - 1;
        for (int i = 0; i < n - 1; ++i) {
            next[i] = i + 1;
        }
        next[n - 1] = 0;
        deque<int> del;
        for (int i = 1; i < n; ++i) {
            del.emplace_back(i);
        }
        del.emplace_back(0);
        vector<int> ans;
        while (!del.empty()) {
            int posnow = del.front();
            del.pop_front();
            if (gcd(a[posnow], a[prev[posnow]]) != 1) {
                continue;
            }
            if (!del.empty() && del.front() == next[posnow]) {
                del.pop_front();
            }
            if (posnow != next[posnow]) {
                del.emplace_back(next[posnow]);
            }
            prev[next[posnow]] = prev[posnow];
            next[prev[posnow]] = next[posnow];
            ans.emplace_back(posnow);
        }
        cout << ans.size() << " ";
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i] + 1 << " ";
        }
        cout << "\n";
    }

    return 0;
}