#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <map>
#include <iomanip>
#include <queue>

#define int long long

using namespace std;

int gcd(int a, int b){
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

signed main(){
    int t;
    cin >> t;
    while (t--){
        int n;
        cin >> n;
        vector<int> v(n);
        for (int i = 0; i < n; ++i){
            cin >> v[i];
        }
        vector<int> deleted(n);
        vector<int> p;
        for (int i = 0; i < n; ++i){
            p.push_back(i);
        }
        vector<int> next(n);
        for (int i = 0; i < n; ++i){
            next[i] = (i + 1) % n;
        }
        vector<int> prev(n);
        for (int i = 0; i < n; ++i){
            prev[i] = (i + n - 1) % n;
        }
        vector<int> ans;
        while (p.size()){
            vector<int> p2;
            for (int i : p){
                if (deleted[i])
                    continue;
                if (gcd(v[i], v[next[i]]) == 1){
                    deleted[next[i]] = 1;
                    ans.push_back(next[i]);
                    next[i] = next[next[i]];
                    prev[next[i]] = i;
                    p2.push_back(i);
                }
            }
            p = p2;
        }
        cout << ans.size() << " ";
        for (int i : ans){
            cout << i + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}
