#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <queue>
#include <math.h>
#define ll long long
const int X = 1e6;
using namespace std;
ll mac[X];
ll cnt[X];
vector<ll> day[X];
struct mList {
	ll x;
	int next;
};
mList mL[X];
int used[X];
queue <int> switchs;


ll gcd(ll a, ll b)
{
	if (a < b)
	{
		swap(a, b);
	}
	if (b == 0)
	{
		return a;
	}
	return gcd(b, a % b);
}

vector <int> ans;

int main()
{
	int t;
	cin >> t;
	while (t--)
	{
		ll a, b, c;
		cin >> a;
		for (int i = 0;i < a;i++)
		{
			cin >> mL[i].x;
			mL[i].next = (i + 1)%a;
		}
		for (int i = 0;i < a;i++)
		{
			int y = mL[i].next;
			if (gcd(mL[i].x, mL[y].x) == 1 && used[i]==0)
			{
				switchs.push(i);
				mL[i].next = mL[y].next;
				used[y] = 1;
				ans.push_back(y);
			}
		}
		while (!switchs.empty())
		{

			int i = switchs.front();
			switchs.pop();
			if (used[i] == 1)
			{
				continue;
			}
			int y = mL[i].next;
			if (gcd(mL[i].x, mL[y].x)==1)
			{
				mL[i].next = mL[y].next;
				ans.push_back(y);
				used[y] = 1;
				switchs.push(i);

			}
		}
		cout << ans.size() << endl;
		for (int y : ans)
		{
			cout << y+1 << " ";
		}
		ans.clear();
		for (int i = 0;i <= a;i++)
		{
			used[i] = 0;
		}
		cout << endl;
	}
}