#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5 + 5;

int n;
int a[N];

set<int> s;
set<int> order;

int getNext(set<int>& s, int pos) {
    auto it = s.upper_bound(pos);
    if(it == s.end()) return *s.begin();
    else return *it;
}

void solve_slow() {
    ve<int> v;
    fr(i, 0, n - 1) v.pb(i);

    ve<int> ers;
    int ptr = 0;
    int cnt = 0;
    while(1) {
        if(sz(v) == 0) break;
        if(__gcd(a[v[ptr % sz(v)]], a[v[(ptr + 1) % sz(v)]]) == 1) {
            ers.pb(v[(ptr + 1) % sz(v)]);
            v.erase(v.begin() + (ptr + 1) % sz(v));
            cnt = 0;
            ptr++;
        } else {
            ptr++;
            cnt++;
            if(cnt > n) break;
        }
    }

    cout << sz(ers) << " ";
    fe(x, ers) cout << x + 1 << " ";
    cout << "\n";
}

void solve() {
    cin >> n;
    fr(i, 0, n - 1) cin >> a[i];

    // solve_slow();

    s.clear();

    fr(i, 0, n - 1) order.insert(i), s.insert(i);

    ve<int> ers;

    int pos = *order.begin();
    while(sz(order) > 0) {
        // cout << "order: ";
        // fe(x, order) cout << x << " ";
        // cout << "\n";
        // cout << "s: ";
        // fe(x, s) cout << x << " ";
        // cout << "\n";
        // cout << "\n";
        order.erase(pos);
        int nxt = getNext(s, pos);

        if(__gcd(a[nxt], a[pos]) > 1) {
            order.erase(pos);
            if(!sz(order)) break;
            pos = getNext(order, pos);
        } else {
            ers.pb(nxt);
            order.insert(pos);

            s.erase(nxt);
            order.erase(nxt);

            if(!sz(order)) break;

            pos = getNext(order, nxt);
        }

    }

    cout << sz(ers) << " ";
    fe(x, ers) cout << x + 1 << " ";
    cout << "\n";

    // solve_slow();
}

int main() {
#ifndef LOCAL
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int T;
    cin >> T;

    while(T--) {
        solve();
    }

    return 0;
}