#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <functional>
#include <random>
#include <ctime>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <list>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

const int INF = 1e9 + 7;
const ll LINF = 2e18;
const int MOD = INF;

#ifdef _DEBUG
const int N = 20;
#else
const int N = 4e5;
#endif
//void Read(vector <int>& a1, vector <int>& b1) {
//	int n;
//	cin >> n;
//	vector <int> v(n);
//	vector <int> u(n);
//	for (int i = 0; i < n; i++)
//		cin >> v[i];
//	for (int j = 0; j < n; j++)
//		cin >> u[j];
//	vector <int> a, b;
//	for (int i = 0; i < n; i++) {
//		if (u[i] < 0 && !b.empty() && b.back() < 0) {
//			if (v[i] < a.back()) {
//				a.back() = v[i];
//				b.back() = u[i];
//			}
//		}
//		else {
//			a.push_back(v[i]);
//			b.push_back(u[i]);
//		}
//	}
//	for (int i = 0; i < n; i++) {
//		if (b[i] < 0) {
//			if (!(i > 0 && a[i - 1] < a[i]) && !(i +1 < a.size() && a[i + 1] < a[i])) {
//				a1.push_back(v[i]);
//				b1.push_back(u[i]);
//			}
//		}
//		else {
//			a1.push_back(v[i]);
//			b1.push_back(u[i]);
//		}
//	}
//}

ll tr[8 * N + 100];

void Update(int pos, ll val, int ndx = 1, int L = 0, int R = N - 1) {
	if (R < pos || pos < L) return;
	if (pos == R && pos == L) {
		tr[ndx] = val;
	}
	else {
		Update(pos, val, 2 * ndx, L, (L + R) / 2);
		Update(pos, val, 2 * ndx + 1, (L + R) / 2 + 1, R);
		tr[ndx] = max(tr[2 * ndx], tr[2 * ndx + 1]);
	}
}

ll Get(int l, int r, int ndx = 1, int L = 0, int R = N - 1) {
	if (r < L || R < l || R < L) return -LINF;
	if (l <= L && R <= r) return tr[ndx];
	return max(Get(l, r, 2 * ndx, L, (L + R) / 2), Get(l, r, 2 * ndx + 1, (L + R) / 2 + 1, R));
}

void Solve() {
	int n;
	cin >> n;
	for (int i = 0; i < 8 * N + 100; i++)
		tr[i] = -LINF;
	vector <ll> a(n + 1), b(n + 1);
	for (int i = 1; i <= n; i++) cin >> a[i];
	for (int i = 1; i <= n; i++) cin >> b[i];

	vector <ll> lendx = { 0 };
	//multiset <ll> leans = { -LINF };
	vector <ll> anses(n + 1, -LINF);
	Update(0, 0);
	for (int i = 1; i <= n; i++) {
		while (a[lendx.back()] > a[i]) {
			//leans.erase(leans.find(anses[lendx.back()]));
			lendx.pop_back();
		}
		anses[i] = anses[lendx.back()];
		ll kek = Get(lendx.back(), i - 1);
		anses[i] = max(anses[i],
			kek + b[i]);
		Update(i, anses[i]);
		lendx.push_back(i);
		//leans.insert(anses[i]);
	}
	cout << anses.back();
}

int main() {
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	/*int t;
	cin >> t;
	while (t--)
	*/Solve();
}