#include <bits/stdc++.h>

using namespace std;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//template < typename T > using ordered_set = tree < T, null_type, less <>, rb_tree_tag, tree_order_statistics_node_update >;

#define F first
#define S second
#define pb push_back
#define ll long long
#define ld long double
#define sz(a) int32_t(a.size())
#define endl '\n'
//#define int long long

const int N = 3e5 + 100;
const int M = 26;
const ll inf = 1e18 + 7;
const int mod = 1e9 + 7;

struct DO
{
    vector < ll > t;
    int pr = 2;

    void build(int n)
    {
        while (pr < n) pr *= 2;
        t.resize(2 * pr, 0);
    }

    ll get(int l, int r, int v, int cl, int cr)
    {
        if (cr < l || r < cl) return -inf;
        if (l <= cl && cr <= r) return t[v];
        int mid = (cl + cr) / 2;
        return max(get(l, r, v * 2, cl, mid), get(l, r, v * 2 + 1, mid + 1, cr));
    }

    void upd(int v, ll zn)
    {
        v += pr;
        t[v] = zn;
        v /= 2;
        while (v)
        {
            t[v] = max(t[v * 2], t[v * 2 + 1]);
            v /= 2;
        }
    }
};

int a[N], b[N], l[N], r[N];
DO t;

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    for(int i = 0; i < n; i++)
        cin >> b[i];
    vector < int > ve;
    for(int i = 0; i < n; i++)
    {
        while (sz(ve) && a[ve.back()] > a[i])
            ve.pop_back();
        if (sz(ve)) l[i] = ve.back();
        else l[i] = -1;
        ve.pb(i);
    }
    ve.clear();
    for(int i = n - 1; i >= 0; i--)
    {
        while (sz(ve) && a[ve.back()] > a[i])
            ve.pop_back();
        if (sz(ve)) r[i] = ve.back();
        else r[i] = n;
        ve.pb(i);
    }
    t.build(n);
    ll ans = -inf;
    for(int i = 0; i < n; i++)
    {
        ll cnt = -inf;
        if (l[i] == -1) cnt = 0;
        cnt = max(cnt, t.get(l[i], i - 1, 1, 0, t.pr - 1));
        cnt += b[i];
        ll mx = t.get(l[i], l[i], 1, 0, t.pr - 1);
        cnt = max(cnt, mx);
        t.upd(i, cnt);
        if (r[i] == n) ans = max(ans, cnt);
    }
    cout << ans;
}
