#include <bits/stdc++.h>
#include <random>
#include <time.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define pll pair<ll,ll>
#define pii pair<int,int>
#define all(v) v.begin(),v.end()
#define fi first
#define se second

using namespace std;

mt19937_64 rnd(time(0));

ll n, m, a[300005], b[300005], lf[300005], rg[300005];

ll binpow(ll h,ll r)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h;
        h*=h;
        r/=2;
    }
    return l;
}

ll binpow(ll h,ll r,ll md)
{
    ll l=1;
    while (r)
    {
        if (r&1) l*=h, l%=md;
        h*=h;
        h%=md;
        r/=2;
    }
    return l;
}

ll gcd(ll x,ll y)
{
    while (x && y)
    {
        if (x<y) swap(x, y);
        x%=y;
    }
    return x+y;
}

struct segment_tree_1
{
    pii d[1200001];

    void build(int h,int l,int r)
    {
        if (l==r)
        {
            d[h]=mp(1e9,-1e9);
            return;
        }
        int w=(l+r)/2;
        build(h*2,l,w);
        build(h*2+1,w+1,r);
        d[h]=mp(1e9,-1e9);
    }

    void update(int h,int l,int r,int x)
    {
        if (l==r)
        {
            d[h]=mp(x, x);
            return;
        }
        int w=(l+r)/2;
        if (x<=w) update(h*2,l,w,x); else update(h*2+1,w+1,r,x);
        d[h].fi=min(d[h*2].fi,d[h*2+1].fi);
        d[h].se=max(d[h*2].se,d[h*2+1].se);
    }

    pii get(int h,int l,int r,int x,int y)
    {
        if (x>y) return mp(1e9,-1e9);
        if (l==x && y==r) return d[h];
        int w=(l+r)/2;
        pll o1=get(h*2,l,w,x,min(y,w)), o2=get(h*2+1,w+1,r,max(x,w+1),y);
        return mp(min(o1.fi,o2.fi), max(o1.se,o2.se));
    }
};

segment_tree_1 q;

struct segment_tree_2
{
    ll d[1200001];

    void build(int h,int l,int r)
    {
        if (l==r)
        {
            d[h]=-1e18;
            return;
        }
        int w=(l+r)/2;
        build(h*2,l,w);
        build(h*2+1,w+1,r);
        d[h]=-1e18;
    }

    void update(int h,int l,int r,int x,ll k)
    {
        if (l==r)
        {
            d[h]=k;
            return;
        }
        int w=(l+r)/2;
        if (x<=w) update(h*2,l,w,x,k); else update(h*2+1,w+1,r,x,k);
        d[h]=max(d[h*2],d[h*2+1]);
    }

    ll get(int h,int l,int r,int x,int y)
    {
        if (x>y) return -1e18;
        if (l==x && y==r)
        {
            //cout << " " << l << " " << r << " " << d[h] << "\n";
            return d[h];
        }
        int w=(l+r)/2;
        return max(get(h*2,l,w,x,min(y,w)), get(h*2+1,w+1,r,max(x,w+1),y));
    }
};

segment_tree_2 g;

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
    vector<pll> v;
    for (int i = 1; i <= n; i++)
    {
        cin >> b[i];
        v.pb(mp(a[i], i));
    }
    sort(all(v));
    q.build(1,0,n+1);
    q.update(1,0,n+1,0);
    q.update(1,0,n+1,n+1);
    for (int i = 0; i < v.size(); i++)
    {
        ll o1=q.get(1,0,n+1,0,v[i].se-1).se, o2=q.get(1,0,n+1,v[i].se+1,n+1).fi;
        lf[v[i].se]=o1;
        rg[v[i].se]=o2;
        //cout << v[i].se << " " << lf[v[i].se] << " " << rg[v[i].se] << "\n";
        q.update(1,0,n+1,v[i].se);
    }
    //cout << "----\n";
    g.build(1,0,n);
    g.update(1,0,n,0,0);
    set<pll> s;
    for (int i = 1; i <= n; i++)
    {
        ll p=g.get(1,0,n,lf[i],i-1)+b[i];
        s.insert(mp(-p, rg[i]));
        while (s.size() && (*s.begin()).se<=i) s.erase(s.begin());
        //cout << i << " " << p << " " << lf[i] << " " << i-1 << " " << s.size() << " " << -(*s.begin()).fi << "\n";
        g.update(1,0,n,i,-(*s.begin()).fi);
    }
    cout << g.get(1,0,n,n,n) << "\n";
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    ll t=1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}
