#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
const int inf = 1e9 + 113;
const int N = 3e5 + 113;
ll h[N], b[N];
struct segtree{
    int l, r;
    ll maxval;
    segtree *lson, *rson;
    segtree(int l1, int r1):l(l1), r(r1), lson(0), rson(0), maxval(-inf){};
};
segtree *build(int l, int r)
{
    segtree *ans = new segtree(l, r);
    if(l != r)
        ans->lson = build(l, (l + r) / 2), ans->rson = build((l + r) / 2 + 1, r);
    return ans;
}
void add(segtree *t, int pos, ll val)
{
    if(t->l > pos || t->r < pos)
        return;
    if(t->l == t->r)
    {
        t->maxval = val;
        return;
    }
    add(t->lson, pos, val), add(t->rson, pos, val);
    t->maxval = max(t->lson->maxval, t->rson->maxval);
}
ll getmax(segtree *t, int l, int r)
{
    if(l > r)
        return -inf;
    if(t->l > r || l > t->r)
        return -inf;
    if(l <= t->l && t->r <= r)
        return t->maxval;
    return max(getmax(t->lson, l, r), getmax(t->rson, l, r));
}

signed main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n;
    cin>>n;
    for(int i = 1; i <= n; i++)
        cin>>h[i];
    for(int i = 1; i <= n; i++)
        cin>>b[i];
    set<pair<ll, ll>> bestans;
    vector<pair<ll, ll>> hs;
    segtree *dp = build(1, n + 1);
    add(dp, 1, 0);
    for(int i = 1; i <= n; i++)
    {
        while(hs.size() && h[hs.back().second] > h[i])
        {
            bestans.erase(hs.back());
            hs.pop_back();
        }
        ll ind = 0, lolkek = -inf;
        if(hs.size())
            ind = hs.back().second, lolkek = -(*bestans.begin()).first;
        ll f = max(lolkek, b[i] + getmax(dp, ind + 1, i));
        add(dp, i + 1, f);
        hs.push_back({-f, i});
        bestans.insert({-f, i});
    }
    cout<<getmax(dp, n + 1, n + 1)<<endl;
}
