#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define pii pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define dist dist666
#define prev prev666
#define left left666
#define right right666
#define tm tm666

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10;
const int inf = 1e9 + 10, N = 3e5 + 10, P = 1e9 + 7, X = 2007;
const ld EPS = 1e-9;
int tree[N * 4], dp[N], h[N], b[N], n;
vector<pair<pii, pii> > st;
multiset<int> pos;

void upd(int t, int l, int r, int x, int vl) {
    if (x < l || r <= x) {
        return;
    }
    if (l + 1 == r) {
        tree[t] = vl;
        return;
    }
    int mid = (l + r) / 2;
    upd(t * 2 + 1, l, mid, x, vl);
    upd(t * 2 + 2, mid, r, x, vl);
    tree[t] = max(tree[t * 2 + 1], tree[t * 2 + 2]);
}

int get_max(int t, int l, int r, int x, int y) {
    if (y <= l || r <= x) {
        return -INF;
    }
    if (x <= l && r <= y) {
        return tree[t];
    }
    int mid = (l + r) / 2;
    return max(get_max(t * 2 + 1, l, mid, x, y), get_max(t * 2 + 2, mid, r, x, y));
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < n; i++) {
        //cout << "i: " << i << "\n";

        int l = i, r = i;
        while (st.size() > 0) {
            auto p = st.back();
            if (p.second.first >= h[i]) {
                l = p.first.first;
                pos.erase(pos.find(p.second.second));
                st.pop_back();
            } else {
                break;
            }
        }
        //cout << "! " << l << ' ' << r << " | " << get_max(0, 0, n, l, r + 1) << ' '  << b[i] << "\n";
        int ans_for_bl = get_max(0, 0, n, l, r + 1) + b[i];
        st.push_back({{l, r}, {h[i], ans_for_bl}});
        /*cout << "st\n";
        for (auto elem : st) {
            cout <<  elem.ff.ff << ' ' << elem.ff.ss << ' ' << elem.ss.ff << ' ' << elem.ss.ss << "\n";
        }*/
        pos.insert(ans_for_bl);
        /*cout << "pos ";
        for (int elem : pos) {
            cout << elem << ' ';
        }
        cout << "\n";*/
        dp[i] = *--pos.end();
        //cout << "dp[i] " << dp[i] << "\n";
        upd(0, 0, n, i + 1, dp[i]);
        //cout << "====\n";
    }
    cout << dp[n - 1] << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    //cout << setprecision(15) << fixed;
    solve();
    return 0;
}
