#include <bits/stdc++.h>
#define x first
#define y second
#define deb if(debug)

using namespace std;

typedef long long ll;
typedef long double ld;
const bool debug = 0;
int n;

void add(int i,vector<ll> &dptree,ll s)
{
    i += n;
    dptree[i] = s;
    i/=2;
    while(i > 0)
    {
        dptree[i] = max(dptree[2*i],dptree[2*i+1]);
        i/=2;
    }
}

ll getMax(int l,int r,vector<ll> &dptree)
{
    l += n;
    r += n;
    ll out = -(1LL<<60);
    for(;l<=r;l/=2,r/=2)
    {
        if(l%2 == 1)
            out = max(dptree[l++],out);
        if(r%2 == 0)
            out = max(dptree[r--],out);
    }
    return out;
}

int main()
{
    if(!debug)
    {
        cin.tie(0);
        cout.tie(0);
        ios::sync_with_stdio(0);
    }

    cin >> n;
    vector<ll> h(n),b(n);
    for(int i=0;i<n;i++)
        cin >> h[i];
    for(int i=0;i<n;i++)
        cin >> b[i];
    vector<ll> stk;
    vector<ll> dptree(2*n,0);
    for(int i=0;i<n;i++)
    {
        while(stk.size() && h[stk.back()] > h[i])
            stk.pop_back();
        int l = 0;
        if(stk.size())
            l = stk.back();
        ll max1 = getMax(l,i-1,dptree) + b[i];
        if(stk.size())
            max1 = max(dptree[stk.back() + n], max1);
        else
            max1 = max(max1, b[i]);
        //cout << max1 << ' ';
        add(i,dptree,max1);
        stk.push_back(i);
    }
    //cout << '\n';
  // for(int i=0;i<n;i++)
    //    cout << dptree[i+n] << ' ';
    cout << dptree.back();
    return 0;
}
