#include <bits/stdc++.h>

//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>

//#define int long long

typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;
//using namespace __gnu_pbds;
//
//#define ord_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

const int N = 3e5+5;
const ll INF = 1e18;

int h[N], b[N];
ll dp[N];

int t1[N*4];

void build1(int v, int tl, int tr) {
    if(tl == tr) {
        t1[v] = h[tl];
        return;
    }
    int tm = (tl+tr)/2;
    build1(v*2, tl, tm);
    build1(v*2+1, tm+1, tr);
    t1[v] = min(t1[v*2], t1[v*2+1]);
}

int get_mn(int v, int tl, int tr, int l, int r) {
    if(l > r)
        return N;
    if(l == tl && r == tr)
        return t1[v];
    int tm = (tl+tr)/2;
    return min(get_mn(v*2, tl, tm, l, min(r, tm)), get_mn(v*2+1, tm+1, tr, max(l, tm+1), r));
}




ll t[N*4];

void update(int v, int tl, int tr, int ind) {
    if(tl == tr) {
        t[v] = dp[tl];
        return;
    }
    int tm = (tl+tr)/2;
    if(ind <= tm)
        update(v*2, tl, tm, ind);
    else
        update(v*2+1, tm+1, tr, ind);
    t[v] = max(t[v*2], t[v*2+1]);
}

ll get(int v, int tl, int tr, int l, int r) {
    if(l > r)
        return -INF;
    if(l == tl && r == tr)
        return t[v];
    int tm = (tl+tr)/2;
    return max(get(v*2, tl, tm, l, min(r, tm)), get(v*2+1, tm+1, tr, max(l, tm+1), r));
}

int32_t main() {
//  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;

    for(int i = 1; i <= n; i++)
        cin >> h[i];
    for(int i = 1; i <= n; i++)
        cin >> b[i];

    h[0] = N;

    build1(1, 0, n);
//    fill(dp, dp+N, -INF);
    dp[0] = 0;

    for(int i = 1; i <= n; i++) {
//        if(i == 1) {
//            dp[i] = b[i];
//            update(1, 0, n, i);
//            continue;
//        }

        int l = 0, r = i, ind = -1;

        while(r >= l) {
            int mid = (l+r)/2;
            int res = get_mn(1, 0, n, mid, i-1);

            if(res >= h[i]) {
                ind = mid;
                r = mid-1;
            }
            else {
                l = mid+1;
            }
        }

//        cout << i << ' ' << ind << '\n';

        if(ind > 0)
            dp[i] = max(get(1, 0, n, max(ind-1, 0), i-1) + b[i], dp[ind-1]);
        else
            dp[i] = get(1, 0, n, max(ind-1, 0), i-1) + b[i];
        update(1, 0, n, i);

//        if(ind == -1) {
//            dp[i] = max(dp[i-1]+b[i], dp[i-1]);
//        }
//        else {
//            dp[i] = dp[ind-1];
//            dp[i] = max(dp[i], get(1, 0, n, ind-1, i-1) + b[i]);
//        }
//
//        update(1, 0, n, i);
    }

    cout << dp[n];

    return 0;
}
