#include "iostream"
#include "vector"
#include "numeric"
#include "algorithm"
#include "set"
#include "list"
#define all(x) (x).begin(), (x).end()
using namespace std;
#define Dasha signed
#define Top main
#define int long long
struct segtree {
    vector<pair<int, int>> tree;
    int sz;
    void make(int n) {
        sz = 1;
        while (sz <= n)
            sz *= 2;
        tree.assign(sz * 2, {-1, 0});
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = {-1, i};
        }
        for (int i = sz; i > 0; --i) {
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    void upd(int v, int x){
        tree[v + sz].first = x;
        v += sz;
        while (v > 1) {
            v /= 2;
            tree[v] = max(tree[v * 2 + 1], tree[v * 2]);
        }
    }
    int get(int l, int r) {
        l += sz;
        r += sz;
        pair<int, int> res = {-1e17, 0};
        while (l < r) {
            if (l % 2 == 1){
                res = max(res, tree[l]);
                l++;
            }
            if (r % 2 == 0) {
                res = max(res, tree[r]);
                r--;
            }
            l /= 2;
            r /= 2;
        }
        if (l == r){
            res = max(res, tree[l]);
        }
        return res.first;
    }
};
Dasha Top() {
    int n;
    cin >> n;
    vector<int> h(n), b(n);
    for (auto & i : h)
        cin >> i;
    for (auto & i : b)
        cin >> i;
    segtree st;
    st.make(n + 5);
    vector<int> nextless(n);
    for (int i = 0; i < n; ++i) {
        nextless[i] = i - 1;
        while (nextless[i] != -1 and h[i] < h[nextless[i]]) {
            nextless[i] = nextless[nextless[i]];
        }
    }
    vector<int> dp(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        st.upd(i, dp[i]);
        dp[i + 1] = -1e17;
        if (nextless[i] != -1)
            dp[i + 1] = dp[nextless[i] + 1];
       //cout << i << ' ' << nextless[i] << ' ' << nextless[i] + 1 << ' ' << i << ' ' << st.get(nextless[i] + 1, i) << endl;
        dp[i + 1] = max(dp[i + 1], st.get(nextless[i] + 1, i) + b[i]);
    }
    //for (auto i : dp)
    //    cout << i << ' ';
    cout << dp[n];
}
// 5
// 3 1 2 4 5