#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define fi first
#define se second

using namespace std;

const int MAXN = 5e5 + 10, inf = 2e9;
const ll INF = 1e16;

ll t[4 * MAXN], h[MAXN], d[MAXN], l[MAXN], r[MAXN], dp[MAXN];
ll ans = 0, p[MAXN];

void build(int v, int tl, int tr) {
    t[v] = 0;
    if (tl == tr)
        return;
    int tm = (tl + tr)>>1;
    build((v << 1), tl, tm);
    build(((v << 1)|1), tm + 1, tr);
}

void upd(int v, int tl, int tr, int pos, ll x) {
    if (tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl + tr)>>1;
    if (pos <= tm)
        upd((v << 1), tl, tm, pos, x);
    else
        upd(((v << 1)|1), tm + 1, tr, pos, x);
    t[v] = max(t[(v << 1)], t[((v << 1)|1)]);
}

ll get(int v, int tl, int tr, int l, int r) {
    if (r < tl || tr < l)
        return -INF;
    if (l <= tl && tr <= r)
        return t[v];
    int tm = (tl + tr)>>1;
    return max(get((v << 1), tl, tm, l, r), get(((v << 1)|1), tm + 1, tr, l, r));
}

// void build(int v, int tl, int tr) {
//     add[v] = inf;
//     if (tl == tr) {
//         t[v] = a[tl];
//         return;
//     }
//     int tm = (tl + tr)>>1;
//     build((v << 1), tl, tm);
//     build(((v << 1)|1), tm + 1, tr);
//     t[v] = t[(v << 1)] + t[((v << 1)|1)];
// }

// void push(int v, int tl, int tm, int tr) {
//     if (tl == tr || add[v] == inf)
//         return;
//     t[(v << 1)] += (tm - tl + 1) * add[v];
//     t[((v << 1)|1)] += (tr - tm) * add[v];
//     if (add[(v << 1)] == inf)
//         add[(v << 1)] = add[v];
//     else
//         add[(v << 1)] += add[v];
//     if (add[((v << 1)|1)] == inf)
//         add[((v << 1)|1)] = add[v];
//     else
//         add[((v << 1)|1)] += add[v];
//     add[v] = inf;
// }

// void upd(int v, int tl, int tr, int l, int r, int x) {
//     if (r < tl || tr < l)
//         return;
//     if (l <= tl && tr <= r) {
//         t[v] += (tr - tl + 1) * x;
//         if (add[v] == inf)
//             add[v] = x;
//         else
//             add[v] += x;
//         return;
//     }
//     int tm = (tl + tr)>>1;
//     push(v, tl, tm, tr);
//     upd((v << 1), tl, tm, l, r, x);
//     upd(((v << 1)|1), tm + 1, tr, l, r, x);
//     t[v] = t[(v << 1)] + t[((v << 1)|1)];
// }

// int get(int v, int tl, int tr, int l, int r) {
//     if (r < tl || tr < l)
//         return 0;
//     int tm = (tl + tr)>>1;
//     push(v, tl, tm, tr);
//     if (l <= tl && tr <= r)
//         return t[v];
//     return get((v << 1), tl, tm, l, r) + get(((v << 1)|1), tm + 1, tr, l, r);
// }

// struct node {
//     node *l, *r;
//     int key, sm, pr;
//     node(int x, int y) {
//         key = x; pr = y; sm = 1;
//         l = r = NULL;
//     }
// };

// typedef node* pn;

// int getsm(pn v) {
//     if (!v) return 0;
//     return v->sm;
// }

// void upd(pn v) {
//     if (!v) return;
//     v->sm = 1 + getsm(v->l) + getsm(v->r);
// }

// pair<pn, pn> split(pn v, int key) {
//     if (!v) return {v, v};
//     pair<pn, pn> res;
//     if (v->key <= key) {
//         res = split(v->r, key);
//         v->r = res.fi;
//         res.fi = v;
//     } else {
//         res = split(v->l, key);
//         v->l = res.se;
//         res.se = v;
//     }
//     upd(res.fi); upd(res.se);
//     return res;
// }

// pn merge(pn v, pn u) {
//     if (!v) return u;
//     if (!u) return v;
//     if (v->pr < u->pr) {
//         u->l = merge(v, u->l);
//         upd(u);
//         return u;
//     } else {
//         v->r = merge(v->r, u);
//         upd(v);
//         return v;
//     }
// }

main() {
    ios_base::sync_with_stdio(NULL); cin.tie(NULL); cout.tie(NULL);
    ll test, n;
    test = 1;
    while (test--) {
        cin >> n;
        for (ll i = 1; i <= n; i++)
            cin >> h[i];
        for (ll i = 1; i <= n; i++)
            cin >> d[i];
        build(1, 1, n);
        stack <ll> st;
        while (!st.empty())
            st.pop();
        for (ll i = 1; i <= n; i++) {
            while (!st.empty() && h[st.top()] > h[i])
                st.pop();
            if (st.empty())
                l[i] = 1;
            else
                l[i] = st.top() + 1;
            st.push(i);
        }
        // for (int i = 1; i <= n; i++)
        //     cout << i << " " << l[i] << endl;
        for (ll i = 1; i <= n; i++) {
            if (l[i] == 1) {
                dp[i] = max(d[i], get(1, 1, n, 1, i - 1) + d[i]);
            } else {
                dp[i] = max(dp[l[i] - 1], get(1, 1, n, l[i] - 1, i - 1) + d[i]);
            }
            // cout << dp[i] << " ";
            upd(1, 1, n, i, dp[i]);
        }
        cout << dp[n];
    }
}