#include <bits/stdc++.h>

#define N 300500
#define PB push_back
#define endl '\n'
#define pri(x) cout << x << endl
#define _ << " " <<
#define sz(x) int(x.size())
#define F first
#define S second

using namespace std;

typedef long long ll;

ll INF = 1e18;

ll n, a[N], h[N], t[N * 4], psh[N * 4], l[N], r[N], mx[N * 4], mn[N * 4];

void updr(ll v, ll tl, ll tr, ll ps)
{
    if (tl == tr)
    {
        mx[v] = mn[v] = tl;

        return;
    }

    ll md = (tl + tr) >> 1;

    if (ps <= md)
        updr(v + v, tl, md, ps);
            else updr(v + v + 1, md + 1, tr, ps);

    if (mn[v + v] != -1)
        mn[v] = mn[v + v];
            else mn[v] = mn[v + v + 1];

    if (mx[v + v + 1] != -1)
        mx[v] = mx[v + v + 1];
            else mx[v] = mx[v + v];
}

void push(ll v, ll tl, ll tr)
{
    if (psh[v] == -INF) return;

    t[v] = max(t[v], psh[v]);

    if (tl != tr)
    {
        psh[v + v] = max(psh[v + v], psh[v]);

        psh[v + v + 1] = max(psh[v + v + 1], psh[v]);
    }

    psh[v] = -INF;
}

void upd(ll v, ll tl, ll tr, ll ps, ll val)
{
    push(v, tl, tr);

    if (tl == tr)
    {
        t[v] = val;

        return;
    }

    ll md = (tl + tr) >> 1;

    if (ps <= md)
        upd(v + v, tl, md, ps, val);
            else upd(v + v + 1, md + 1, tr, ps, val);

    t[v] = max(t[v + v], t[v + v + 1]);
}

void updr(ll v, ll tl, ll tr, ll l, ll r, ll val)
{
    push(v, tl, tr);

    if (tr < l || r < tl || l > r || tl > tr) return;

    if (l <= tl && tr <= r)
    {
        psh[v] = val;

        push(v, tl, tr);

        return;
    }

    ll md = (tl + tr) >> 1;

    updr(v + v, tl, md, l, r, val);

    updr(v + v + 1, md + 1, tr, l, r, val);

    t[v] = max(t[v + v], t[v + v + 1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r)
{
    push(v, tl, tr);

    if (tr < l || r < tl || l > r || tl > tr)
        return -INF;

    if (l <= tl && tr <= r)
        return t[v];

    ll md = (tl + tr) >> 1;

    ll a = max(get(v + v, tl, md, l, r), get(v + v + 1, md + 1, tr, l, r));

    t[v] = max(t[v + v], t[v + v + 1]);

    return a;
}

ll getr(ll v, ll tl, ll tr, ll ps)
{
    push(v, tl, tr);

    if (tl == tr)
        return t[v];

    ll md = (tl + tr) >> 1;

    ll a;

    if (ps <= md)
        a = getr(v + v, tl, md, ps);
            else a = getr(v + v + 1, md + 1, tr, ps);

    return a;
}

ll fnd_mx(ll v, ll tl, ll tr, ll l, ll r)
{
    if (tr < l || r < tl || tl > tr || l > r || mx[v] == -1) return -1;

    if (l <= tl && tr <= r)
        return mx[v];

    ll md = (tl + tr) >> 1;

    ll a = fnd_mx(v + v + 1, md + 1, tr, l, r);

    if (a == -1)
        a = fnd_mx(v + v, tl, md, l, r);

    return a;
}

ll fnd_mn(ll v, ll tl, ll tr, ll l, ll r)
{
    if (tr < l || r < tl || tl > tr || l > r || mn[v] == -1) return -1;

    if (l <= tl && tr <= r)
        return mn[v];

    ll md = (tl + tr) >> 1;

    ll a = fnd_mn(v + v, tl, md, l, r);

    if (a == -1)
        a = fnd_mn(v + v + 1, md + 1, tr, l, r);

    return a;
}
int main()
{
    ios_base::sync_with_stdio(0); istream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    freopen("1.in", "r", stdin);

    for (ll i = 0; i < N * 4; i++)
        {t[i] = -INF; mn[i] = mx[i] = -1; psh[i] = -INF;}

    cin >> n;

    ll pos[n + 1];

    for (ll i = 1; i <= n; i++)
        {cin >> h[i]; pos[h[i]] = i;}

    for (ll i = 1; i <= n; i++)
        cin >> a[i];

    for (ll i = 1; i <= n; i++)
    {
        ll ps = pos[i];

        l[ps] = fnd_mx(1, 1, n, 1, ps - 1);

        r[ps] = fnd_mn(1, 1, n, ps + 1, n);

        if (l[ps] == -1)
            l[ps] = 0;
                else l[ps]++;
        if (r[ps] == -1)
            r[ps] = n;
                else r[ps]--;

        updr(1, 1, n, ps);
    }

    upd(1, 0, n, 0, 0);

    for (ll i = 1; i <= n; i++)
    {
        ll cur = getr(1, 0, n, i);

        ll mxr = get(1, 0, n, l[i], i);

        cur = max(cur, mxr + a[i]);

        updr(1, 0, n, i + 1, r[i], cur);

        upd(1, 0, n, i, cur);
    }

    pri(getr(1, 0, n, n));
}
