#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back

#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using vi = vector<int>;
using pi = pair<int, int>;
using vvi = vector<vi>;
using vpi = vector<pi>;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, true : false; }

mt19937 rng(1337228);

struct RC {
    int32_t H = 1337228;

    template<class T>
    friend RC& operator >> (RC& rin, T& x) {
        cin >> x;
        return rin;
    }

    friend RC& operator >> (RC& rin, int& x) {
        cin >> x;
        rin.H ^= x * 1337;
        rin.H *= 3;
        return rin;
    }

    friend RC& operator >> (RC& rin, ll& x) {
        cin >> x;
        rin.H ^= x * 229;
        rin.H *= 7;
        return rin;
    }

    friend RC& operator >> (RC& rin, string& s) {
        cin >> s;
        static const int P = 97;
        for (char c : s) {
            rin.H = rin.H * P ^ c;
        }
        return rin;
    }
} rin;

void initRandom() {
    rng.seed(rin.H);
}

const int N = 3e5+7;
const int K = 19;

int n, h[N], b[N];
ll dp[4][N];
int tg[K][N];
vi g[N];

const ll LINF = 1e18;

bool cmp(int i, int j) {
    return h[i] < h[j];
}

int getMin(int l, int r) {
    int lvl = __lg(r - l + 1);
    int len = 1 << lvl;
    return min(tg[lvl][l], tg[lvl][r-len+1], cmp);
}

int solve(int l, int r) {
    if (r < l) return n;
    int v = getMin(l, r);
    int vl = solve(l, v-1);
    int vr = solve(v+1, r);

    for (int i = 0; i < 4; ++i) dp[i][v] = -LINF;
    for (int i = 0; i < 4; ++i) {
        ckmax(dp[i][v], dp[i|2][vl] + dp[i|1][vr] + b[v]);
        if (i & 1) ckmax(dp[i][v], dp[i][vr]);
        if (i & 2) ckmax(dp[i][v], dp[i][vl]);
    }

    return v;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> h[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    iota(tg[0], tg[0]+n, 0);
    for (int i = 1; i < K; ++i) {
        int l = 1 << i-1;
        for (int j = 0; j+2*l <= n; ++j) {
            tg[i][j] = min(tg[i-1][j], tg[i-1][j+l], cmp);
        }
    }

    cout << dp[0][solve(0, n-1)] << '\n';
}