#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;

const ll Inf = 1e18;

int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int n;
  cin >> n;
  vector <int> h(n);
  for (int i = 0; i < n; ++i) cin >> h[i];
  vector <int> b(n);
  for (int i = 0; i < n; ++i) cin >> b[i];
  vector <int> l(n, -1);
  vector <pair <int, int>> st;
  for (int i = 0; i < n; ++i) {
    while (!st.empty() && st.back().first > h[i]) st.pop_back();
    if (!st.empty()) l[i] = st.back().second;
    st.push_back({h[i], i});
  }
  vector <int> r(n, n);
  st.clear();
  for (int i = n - 1; i >= 0; --i) {
    while (!st.empty() && st.back().first > h[i]) st.pop_back();
    if (!st.empty()) r[i] = st.back().second;
    st.push_back({h[i], i});
  }
  vector <vector <int>> who(n + 1);
  for (int i = 0; i < n; ++i) who[r[i]].push_back(i);
  vector <ll> dp(n + 1, -Inf);
  dp[0] = 0;
  vector <pair <int, ll>> s;
  s.push_back({0, 0});
  multiset <ll> have;
  for (int i = 0; i < n; ++i) {
    int id = l[i];
    auto it = lower_bound(s.begin(), s.end(), make_pair(id + 1, -Inf));
    /*if (i == 1) {
      for (auto p : s) {
        cout << p.first << ' ' << p.second << endl;
      }
      cout << id + 1 << endl;
      cout << it->first << ' ' << it->second << endl;
    }*/
    dp[i + 1] = it->second + b[i];
    if (!have.empty()) dp[i + 1] = max(dp[i + 1], *have.rbegin() + b[i]);
    for (auto id : who[i]) {
      have.erase(have.find(dp[id + 1]));
    }
    have.insert(dp[i + 1]);
    while (!s.empty() && dp[i + 1] >= s.back().second) {
      s.pop_back();
    }
    s.push_back({i + 1, dp[i + 1]});
  }
  /*for (int i = 0; i <= n; ++i) {
    cout << dp[i] << ' ';
  }
  cout << endl;*/
  ll ans = -Inf;
  for (int i = 0; i < n; ++i) {
    if (r[i] == n) ans = max(ans, dp[i + 1]);
  }
  cout << ans << '\n';
}

