#include <bits/stdc++.h>
#define MOD 1000000007
using namespace std;
typedef long long ll;
typedef pair<ll,ll>pll;
typedef long double ld;
ll bin_pow(ll a,ll b){
    if(b==0)return 1;
    if(b%2==0){
        ll t=bin_pow(a,b/2);
        return t*t%MOD;
    }
    else return a*bin_pow(a,b-1)%MOD;
}
ll dp[500001];
struct cat{ll a,b,c;};
cat tree[2000001];
void build_tree(ll v,ll tl,ll tr){
    if(tl==tr)tree[v].a=dp[tl],tree[v].b=LLONG_MIN;
    else{
        ll tm=(tl+tr)/2;
        build_tree(2*v,tl,tm),build_tree(2*v+1,tm+1,tr);
        tree[v].a=max(tree[2*v].a,tree[2*v+1].a);
        tree[v].b=LLONG_MIN;
    }
}
void push(ll v){
    tree[2*v].a=max(tree[2*v].a,tree[v].b);
    tree[2*v].b=max(tree[2*v].b,tree[v].b);
    tree[2*v+1].a=max(tree[2*v+1].a,tree[v].b);
    tree[2*v+1].b=max(tree[2*v+1].b,tree[v].b);
    tree[v].b=LLONG_MIN;
}
ll get_max(ll l,ll r,ll v,ll tl,ll tr){
    if(tl>=l&&tr<=r)return tree[v].a;
    else if(tl>r||tr<l)return LLONG_MIN;
    else{
        ll tm=(tl+tr)/2;
        push(v);
        return max(get_max(l,r,2*v,tl,tm),get_max(l,r,2*v+1,tm+1,tr));
    }
}
void update(ll l,ll r,ll x,ll v,ll tl,ll tr){
    if(tl>=l&&tr<=r){
            tree[v].a=max(tree[v].a,x);
            tree[v].b=max(tree[v].b,x);
    }
    else if(tl>r||tr<l)return;
    else{
        ll tm=(tl+tr)/2;
        push(v);
        update(l,r,x,2*v,tl,tm),update(l,r,x,2*v+1,tm+1,tr);
        tree[v].a=max(tree[2*v].a,tree[2*v+1].a);
    }
}
ll blizh1[500001],blizh2[500001];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    ll t=1,n,m,k=0,x=0,y=0,z=0,l=0,r=0,sum=0,ans=0,mn=LLONG_MAX,mx=LLONG_MIN;
    string s="",s1="";
    while(t--){
        ans=z=0;
        cin>>n;
        vector<ll>a(n+1),b(n+1);
        for(int i=0;i<=n;i++)blizh1[i]=0,blizh2[i]=n+1,dp[i]=LLONG_MIN;
        build_tree(1,0,n);
    for(int i=1;i<=n;i++)cin>>a[i];
    for(int i=1;i<=n;i++)cin>>b[i];
    stack<ll>s;
    for(int i=1;i<=n;i++){
        while(s.size()&&a[s.top()]>a[i])s.pop();
        if(s.size())blizh1[i]=s.top();
        s.push(i);
    }
    while(s.size())s.pop();
    for(int i=n;i>=1;i--){
        while(s.size()&&a[s.top()]>a[i])s.pop();
        if(s.size())blizh2[i]=s.top();
        s.push(i);
    }
    dp[0]=0;
    update(0,0,0,1,0,n);
    for(int i=1;i<=n;i++){
        x=get_max(blizh1[i],i-1,1,0,n);
        dp[i]=get_max(i,i,1,0,n);
        dp[i]=max(dp[i],x+b[i]);
        update(i,blizh2[i]-1,dp[i],1,0,n);
    }
    cout<<dp[n];
        cout<<"\n";
    }
    return 0;
}
