#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

int n;
ll h[300010];
ll a[300010];
ll dp[300010];

ll tree[4 * 300010];

void change(int i, int l, int r, int q, int v)
{
	if (l + 1 == r)
	{
		tree[i] = v;
		return;
	}

	int m = (l + r) >> 1;
	if (q < m) change(2 * i + 1, l, m, q, v);
	else change(2 * i + 2, m, r, q, v);

	tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

ll gt(int i, int l, int r, int ql, int qr)
{
	if (ql <= l && r <= qr) return tree[i];
	if (qr <= l || r <= ql) return -1e18;

	int m = (l + r) >> 1;
	return max(
		gt(2 * i + 1, l, m, ql, qr),
		gt(2 * i + 2, m, r, ql, qr)
	);
}


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 0; i < 4 * 300010; ++i) tree[i] = -1e18;

	for (int i = 1; i <= n; ++i)
	{
		cin >> h[i];
	}

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}

	deque <int> queue;
	h[0] = -1;

	queue.push_back(0);
	change(0, 0, n + 1, 0, 0);

	for (int i = 1; i <= n; ++i)
	{
		dp[i] = dp[i - 1] + a[i];

		while (h[queue.back()] > h[i]) queue.pop_back();

		dp[i] = max(dp[i], gt(0, 0, n + 1, queue.back(), i) + a[i]);
		if (queue.back() > 0) dp[i] = max(dp[i], dp[queue.back()]);

		queue.push_back(i);

		change(0, 0, n + 1, i, dp[i]);
	}

	cout << dp[n];
	return 0;
}