#include <bits/stdc++.h>

#define x first
#define y second
#define mp make_pair
#define eb emplace_back

using namespace std;

template <typename T>
bool chmin(T& a, const T& b){
  if (a > b){
    a = b;
    return true;
  }
  return false;
}

template <typename T>
bool chmax(T& a, const T& b){
  if (a < b){
    a = b;
    return true;
  }
  return false;
}

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pt;

#ifdef ONPC
mt19937 rnd(54);
#else
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll MOD = 1000000007LL;
const ll MOD2 = 54LL;
const ld PI = acos(-1);

#ifdef ONPC
const int MAXN = 154;
#else
const int MAXN = 300100;
#endif

#define int long long
const ll INF = 1e18;

struct st {
  ll t[4 * MAXN];

  void pull(int v){
    t[v] = max(t[v << 1], t[v << 1 | 1]);
  }

  void add(int v, int l, int r, int pos, ll x){
    if (l == r-1){
      t[v] = x;
      return;
    }
    int md = (l + r) >> 1;
    if (pos < md) add(v << 1, l, md, pos, x);
    else add(v << 1 | 1, md, r, pos, x);
    pull(v);
  }

  ll gmax(int v, int l, int r, int tl, int tr){
    if (l >= tr || r <= tl){
      return -INF;
    }
    if (l >= tl && r <= tr){
      return t[v];
    }
    int md = (l + r) >> 1;
    ll r1 = gmax(v << 1, l, md, tl, tr);
    ll r2 = gmax(v << 1 | 1, md, r, tl, tr);
    return max(r1, r2);
  }
};

struct sh {
  ll val;
  int h;
  int id;
  sh() {}
  sh(int _v, int _h, int _i){
    val = _v;
    h = _h;
    id = _i;
  }
};

st t;
int n;
struct stk {
  set<pair<ll, int>> q;
  vector<sh> a;

  void add(int h, int b, int i){
    while (!a.empty() && a.back().h > h){
      ll v = a.back().val;
      int i = a.back().id;
      q.erase(mp(-v, i));
      a.pop_back();
    }
    int prv = 0;
    if (!a.empty()) prv = a.back().id;
    ll vl = t.gmax(1, 0, n + 1, prv, i);
    //cerr << vl << '\n';
    a.eb(vl + (ll)b, h, i);
    q.insert(mp(-vl - (ll)b, i));
  }

  ll get(){
    return -(q.begin()->x);
  }
};

void solve(){
  cin >> n;
  vector<int> h(n), b(n);
  for (int i = 0; i < n; i++){
    cin >> h[i];
  }
  for (int i = 0; i < n; i++){
    cin >> b[i];
  }

  for (int i = 0; i < n + 1; i++) t.add(1, 0, n + 1, i, -INF);
  t.add(1, 0, n + 1, 0, 0);

  vector<ll> dp(n + 1, -INF);
  dp[0] = 0;
  stk s;
  for (int i = 0; i < n; i++){
    s.add(h[i], b[i], i + 1);
    dp[i + 1] = s.get();
    t.add(1, 0, n + 1, i + 1, dp[i + 1]);
    //cerr << dp[i + 1] << '\n';
  }

  cout << dp[n] << '\n';
}



signed main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  solve();
}