#include <iostream>
#include <vector>
#define int long long

using namespace std;

int n;
vector <int> t;
vector <int> dp;

int get(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r)
        return t[v];
    if (r < tl || tr < l)
        return -1e18;
    int tm = (tl + tr) / 2;
    int a1 = get(2 * v + 1, tl, tm, l, r);
    int a2 = get(2 * v + 2, tm + 1, tr, l, r);
    return max(a1, a2);
}

void upd(int v, int tl, int tr, int i) {
    if (tl == tr)
        t[v] = dp[i];
    else {
        int tm = (tl + tr) / 2;
        if (i <= tm)
            upd(2 * v + 1, tl, tm, i);
        else
            upd(2 * v + 2, tm + 1, tr, i);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n;
    vector <int> h(n);
    vector <int> b(n);
    dp.resize(n);
    t.resize(4 * n);
    for (auto &el: h)
        cin >> el;
    for (auto &el: b)
        cin >> el;

    vector <int> st = {0};
    dp[0] = b[0];
    upd(0, 0, n - 1, 0);
    for (int i = 1; i < n; i++) {
        while (!st.empty() && h[st.back()] > h[i])
            st.pop_back();
        int pos;
        if (st.empty())
            pos = 0;
        else
            pos = st.back();
        dp[i] = get(0, 0, n - 1, pos, i - 1) + b[i];
        if (!st.empty())
            dp[i] = max(dp[i], dp[pos]);
        else 
            dp[i] = max(dp[i], b[i]);
        upd(0, 0, n - 1, i);
        st.push_back(i);
    }
    cout << dp[n - 1] << endl;

    return 0;
}
