#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>
#include <queue>
#include <deque>
#include <iterator>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <time.h>
#include <bitset>
#include <stdio.h>

#define ll long long
#define ld long double
#define MAXINT 2000000000
#define MININT -2000000000
#define MAXLL 9000000000000000000LL
#define MINLL -9000000000000000000LL
#define y1 absdasd
#define x1 asdbasdbas
#define pb push_back
#define fi first
#define se second
#define endl '\n'
#define pll pair < ll, ll >

using namespace std;

const ld pi = acos(-1);
const ll md = 1e9 + 7;
clock_t start_time = clock();

ll n, a[300501], bc[300501], b[300501], i, sz;

struct node
{
    ll z = 0, ca = 0, pa = 0;
};

node t[2000001];

void propagate(ll nom, ll l, ll r)
{
    if (l == r || t[nom].z == 0) return;

    t[nom * 2].pa = t[nom * 2].ca = t[nom * 2 + 1].pa = t[nom * 2 + 1].ca = -1000000000000000LL;
    t[nom * 2].z = t[nom * 2 + 1].z = 1;
    t[nom].z = 0;
}

void st(ll nom, ll l, ll r, ll cl, ll cr)
{
    propagate(nom, l, r);

    if (l > cr || r < cl) return;

    if (l >= cl && r <= cr){
        t[nom].z = 1;
        t[nom].ca = t[nom].pa = -1000000000000000LL;
        return;
    }

    ll mid = (l + r) / 2;
    st(nom * 2, l, mid, cl, cr);
    st(nom * 2 + 1, mid + 1, r, cl, cr);

    t[nom].ca = max(t[nom * 2].ca, t[nom * 2 + 1].ca);
    t[nom].pa = max(t[nom * 2].pa, t[nom * 2 + 1].pa);
}

void update(ll nom, ll l, ll r, ll c, ll x)
{
    propagate(nom, l, r);

    if (l > c || r < c) return;

    if (l == r){
        t[nom].ca = x + b[c];
        t[nom].pa = x;
        return;
    }

    ll mid = (l + r) / 2;
    update(nom * 2, l, mid, c, x);
    update(nom * 2 + 1, mid + 1, r, c, x);

    t[nom].ca = max(t[nom * 2].ca, t[nom * 2 + 1].ca);
    t[nom].pa = max(t[nom * 2].pa, t[nom * 2 + 1].pa);
}

ll get1(ll nom, ll l, ll r, ll cl, ll cr)
{
    propagate(nom, l, r);

    if (l > cr || r < cl) return MINLL;

    if (l >= cl && r <= cr) return t[nom].ca;

    ll mid = (l + r) / 2;
    return max(get1(nom * 2, l, mid, cl, cr), get1(nom * 2 + 1, mid + 1, r, cl, cr));
}

ll get2(ll nom, ll l, ll r, ll cl, ll cr)
{
    propagate(nom, l, r);

    if (l > cr || r < cl) return MINLL;

    if (l >= cl && r <= cr) return t[nom].pa;

    ll mid = (l + r) / 2;
    return max(get2(nom * 2, l, mid, cl, cr), get2(nom * 2 + 1, mid + 1, r, cl, cr));
}

void solve()
{
    cin >> n;

    sz = 1;
    while (sz < n) sz *= 2;

    for (i = 1; i <= sz * 2 - 1; i++) t[i].ca = t[i].pa = -1000000000000000LL;

    for (i = 1; i <= n; i++){
        cin >> a[i];
    }

    for (i = 1; i <= n; i++){
        cin >> bc[i];
        b[a[i]] = bc[i];
    }

    update(1, 1, sz, a[1], 0);

    for (i = 2; i <= n; i++){
        ll c;
        if (a[i] < n) c = max(get1(1, 1, sz, a[i] + 1, n), get2(1, 1, sz, a[i] + 1, n));
        else c = -1000000000000000LL;
        if (a[i] > 1) c = max(c, get1(1, 1, sz, 1, a[i] - 1));
        else c = max(c, 0LL);
        update(1, 1, sz, a[i], c);
        if (a[i] < n) st(1, 1, sz, a[i] + 1, n);
    }

    cout << get1(1, 1, sz, 1, n) << endl;
}

int main()
{
    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // ONLINE_JUDGE

    ios::sync_with_stdio(0);
    cin.tie(0);

    ll q = 1;
//    cin >> q;

    while (q--){
        solve();
    }

    #ifndef ONLINE_JUDGE
        cout << endl;
        cout << "Time = " << (ld)(clock() - start_time) / CLOCKS_PER_SEC << endl;
    #endif // ONLINE_JUDGE
    return 0;
}
