#include <bits/stdc++.h>
#define ll long long int
#define ld long double
using namespace std;

const ll inf0 = -1 * 1e15;
int n;
vector<int> h, p, mn;
vector<ll> b, dp, mx;

struct Seg2{
	vector<ll> tree; int len = 1;
	int left(int v){
		return 2 * v + 1;
	}
	int right(int v){
		return 2 * v + 2;
	}
	void init(){
		while (len < n) len <<= 1;
		tree.resize(2 * len - 1, inf0);
	}
	void upd(int v, ll h){
		v += len - 1;
		tree[v] = h;
		while (v > 0){
			v = (v - 1) / 2;
			int lc = left(v), rc = right(v);
			tree[v] = max(tree[lc], tree[rc]);
		}
	}
	ll get(int v, int lx, int rx, int l, int r){
		if (lx > r or rx < l) return inf0;
		if (lx >= l and rx <= r) return tree[v];
		int lc = left(v), rc = right(v), mid = (lx + rx) / 2;
		return max(get(lc, lx, mid, l, r), get(rc, mid + 1, rx, l, r));
	}
} Q;

int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n; h.resize(n); b.resize(n);
	p.resize(n); dp.resize(n); mx.resize(n);
	mn.resize(n);
	for (int i = 0; i < n; i++){
		cin >> h[i];
	}
	for (int i = 0; i < n; i++){
		cin >> b[i];
	}
	Q.init();
	for (int i = 0; i < n; i++){
		int t = -1;
		if (i == 0 or mn[i - 1] > h[i]) t = -1;
		else{
			for (int j = i - 1; j >= 0; j--){
				if (h[i] > h[j]){
					t = j;
					break;
				}
			}
		}
		p[i] = t;
	}
	for (int i = 0; i < n; i++){
		if (i == 0) dp[i] = b[i];
		else if (p[i] == -1){
			dp[i] = max(mx[i - 1] + b[i], b[i]);
		}
		else{
			dp[i] = dp[i - 1] + b[i];
			ll x = Q.get(0, 0, Q.len - 1, p[i] + 1, i - 1);
			dp[i] = max(x + b[i], dp[i]);
			dp[i] = max(dp[i], dp[p[i]]);
		}
		if (i == 0) mx[i] = dp[i];
		else mx[i] = max(mx[i - 1], dp[i]);
		Q.upd(i, dp[i]);
	}
	cout << dp[n - 1];
	return 0;
}
