#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <map>
#include <iomanip>
#include <queue>

#define int long long

using namespace std;

signed main(){
    int n;
    cin >> n;
    vector<int> h(n);
    vector<int> next(n);
    vector<int> prev(n);
    for (int i = 0; i < n; ++i){
        cin >> h[i];
    }
    vector<pair<int, int>> st;
    for (int i = 0; i < n; ++i){
        while (st.size() && h[i] < st.back().first){
            st.pop_back();
        }
        if (st.size()) {
            prev[i] = st.back().second;
        } else {
            prev[i] = -1;
        }
        st.push_back({h[i], i});
    }
    st.clear();
    for (int i = n - 1; i >= 0; --i){
        while (st.size() && h[i] < st.back().first){
            st.pop_back();
        }
        if (st.size()) {
            next[i] = st.back().second;
        } else {
            next[i] = -1;
        }
        st.push_back({h[i], i});
    }
    vector<int> v(n);
    for (int i = 0; i < n; ++i){
        cin >> v[i];
    }
    vector<int> dp(n + 1);
    vector<int> dp2(n + 1, -1e9);
    vector<int> counted(n + 1);
    for (int i = 1; i <= n; ++i){
        if (!counted[i]){
            dp[i] = max(dp2[i - 1], dp[i - 1]) + v[i - 1];
        } else {
            dp[i] = max(dp[i], max(dp[i - 1], dp2[i - 1]) + v[i - 1]);
        }
        if (prev[i - 1] != -1){
            dp2[i] = max(dp[prev[i - 1] + 1], dp2[prev[i - 1] + 1]);
        }
        if (next[i - 1] != -1){
            if (counted[next[i - 1] + 1]){
                dp[next[i - 1] + 1] = max(dp[next[i - 1] + 1], max(dp[i] - v[i - 1], dp2[i - 1]) + v[next[i - 1]]);
            } else {
                dp[next[i - 1] + 1] = max(dp[i] - v[i - 1], dp2[i - 1]) + v[next[i - 1]];
                counted[next[i - 1] + 1] = 1;
            }
        }
    }
    /*for (int i = 0; i <= n; ++i){
        cout << dp[i] << " ";
    } cout << endl;
    for (int i = 0; i <= n; ++i){
        cout << dp2[i] << " ";
    } cout << endl;*/
    cout << max(dp2[n], dp[n]);
    return 0;
}
