#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

struct ST {
    vector<int> st, add;

    ST(int n) {
        st.resize(4 * n);
        add.resize(4 * n);
    }

    void push(int i, int l, int r) {
        st[i] += add[i];
        if (l + 1 < r) {
            add[i * 2 + 1] += add[i];
            add[i * 2 + 2] += add[i];
        }
        add[i] = 0;
    }

    void upd(int i, int l, int r, int ql, int qr, int qd) {
        push(i, l, r);
        if (l == ql && r == qr) {
            add[i] += qd;
            push(i, l, r);
            return;
        }
        int m = (l + r) / 2;
        if (qr <= m) {
            upd(i * 2 + 1, l, m, ql, qr, qd);
        } else if (ql >= m) {
            upd(i * 2 + 2, m, r, ql, qr, qd);
        } else {
            upd(i * 2 + 1, l, m, ql, m, qd);
            upd(i * 2 + 2, m, r, m, qr, qd);
        }
        push(i * 2 + 1, l, m);
        push(i * 2 + 2, m, r);
        st[i] = max(st[i * 2 + 1], st[i * 2 + 2]);
    }

    int sm(int i, int l, int r, int ql, int qr) {
        push(i, l, r);
        if (l == ql && r == qr) {
            return st[i];
        }
        int m = (l + r) / 2;
        if (qr <= m) {
            return sm(i * 2 + 1, l, m, ql, qr);
        }
        if (ql >= m) {
            return sm(i * 2 + 2, m, r, ql, qr);
        }
        return max(sm(i * 2 + 1, l, m, ql, m), sm(i * 2 + 2, m, r, m, qr));
    }
};

void sol() {
    int n;
    cin >> n;
    vector<int> h(n), b(n);
    for (int &el : h) {
        cin >> el;
    }
    for (int &el : b) {
        cin >> el;
    }
    vector<pair<int, int>> mn;
    ST st(n);
    vector<int> dp(n);
    for (int i = 0; i < n; i++) {
        int ind = -1;
        while (!mn.empty()) {
            auto now = mn.back();
            int hj = now.first, j = now.second;
            if (hj < h[i]) {
                ind = j;
                break;
            }
            mn.pop_back();
            int prev = -1;
            if (!mn.empty()) {
                prev = mn.back().second;
            }
            st.upd(0, 0, n, prev + 1, j + 1, -b[j]);
        }
        mn.emplace_back(h[i], i);
        st.upd(0, 0, n, ind + 1, i + 1, b[i]);
        if (i == 0) {
            dp[i] = b[i];
        } else {
            dp[i] = st.sm(0, 0, n, 0, i);
            if (dp[i] < dp[i - 1] + b[i]) {
                dp[i] = dp[i - 1] + b[i];
            }
            st.upd(0, 0, n, i, i + 1, dp[i - 1]);
        }
    }
    cout << dp.back() << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        sol();
    }
}