/*
 * created by @kamil.sharipov
 */

//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,popcnt,tune=native")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all (x).begin(), (x).end()
#define pii pair<int, int>
#define int long long

int n;
vector<ll> h, b;
ll inf = 1e18;

vector<ll> tree;

void upd(int v, int l, int r, int p, int x) {
    if (r <= p || l > p) return;
    if (l + 1 == r) {
        tree[v] = x;
        return;
    }

    upd(2 * v, l, (l + r) / 2, p, x);
    upd(2 * v + 1, (l + r) / 2, r, p, x);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int mx(int v, int l, int r, int ql, int qr) {
    if (qr <= l || ql >= r) return -inf;
    if (ql <= l && r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return max(mx(v * 2, l, mid, ql, qr), mx(v * 2 + 1, mid, r, ql, qr));
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n;
    h.resize(n);
    b.resize(n);
    vector<int> lft(n, -1);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        int bef = i - 1;
        while (bef != -1) {
            if (h[bef] < h[i]) {
                break;
            }
            bef = lft[bef];
        }
        lft[i] = bef;
    }

    vector<ll> dp(n + 1, -inf);
    dp[0] = 0;

    tree.resize(4 * (n + 1));
    for (int i = 0; i < tree.size(); ++i) {
        tree[i] = -inf;
    }


    upd(1, 0, n + 1, 0, 0);

    for (int i = 0; i < n; ++i) {
        if (lft[i] != -1)dp[i + 1] = dp[lft[i] + 1];
        else dp[i + 1] = b[i];

        dp[i + 1] = max(dp[i + 1], mx(1, 0, n + 1, lft[i] + 1, i + 1) + b[i]);
        upd(1, 0, n + 1, i + 1, dp[i + 1]);
        /*for (int j = lft[i] + 1; j <= i; ++j) {
            if (dp[j] + b[i] > dp[i + 1]) {
                dp[i + 1] = dp[j] + b[i];
            }
        }*/
    }
    cout << dp[n] << "\n";
}
