#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#define int long long
using namespace std;
typedef vector<int> vi;

int gcd(int a, int b){
	return (b ? gcd(b, a%b) : a);
}

const int maxn = 3e5 + 228;
int t[maxn * 4];

void upd(int v, int l, int r, int k, int k_new){
	if(l == r){
		t[v] = k_new;
	} else{
		int mid = (l + r)/2;
		if(k <= mid)
			upd(v * 2, l, mid, k, k_new);
		else
			upd(v * 2 + 1, mid + 1, r, k, k_new);
		t[v] = max(t[v*2], t[v*2+1]);
	}
}

int get(int v, int l, int r, int ql, int qr){
	if(ql <= l && r <= qr){
		return t[v];
	} else if(l > qr || ql > r){
		return -1e18;
	} else{
		int mid = (l + r)/2;
		return max(get(v*2, l, mid, ql, qr), get(v*2+1, mid+1, r, ql, qr));
	}
}

void solve(){
	int n;
	cin >> n;
	vi h(n), c(n);
	for(int i=0; i<n; i++){
		cin >> h[i];
	}
	for(int i=0; i<n; i++){
		cin >> c[i];
	}
	vi dp(n + 1);
	stack<pair<int, int> > kek;
	for(int i=1; i<=n; i++){
		while(!kek.empty() && h[kek.top().first-1] > h[i-1])
			kek.pop();
		if(kek.empty()){
			kek.push(make_pair(i, get(1, 0, maxn, 0, i-1) + c[i-1]));
		} else{
			kek.push(make_pair(i, max(get(1, 0, maxn, kek.top().first, i-1) + c[i-1], kek.top().second)));
		}
		dp[i] = kek.top().second;
		upd(1, 0, maxn, i, dp[i]);
	}
	cout << dp[n] << endl;
	
}

signed main(){
	int q = 1;
	// cin >> q;
	while(q--){
		solve();
	}
	// cin >> q;
	return 0;
}