//
// Created by watemus on 21.03.2021.
//
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

const int INFI = 1'000'000'228;
const ll INFL = 1'000'000'000'000'000'228;

mt19937 rnd(228);

#define int ll
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

void precalc() {

}

const int N = 3e5 + 10;

int t[N * 4];

void modify(int u, int l, int r, int at, int val) {
  if (r - l == 1) {
    t[u] = val;
  } else {
    int mid = (l + r) / 2;
    if (at < mid) {
      modify(u * 2 + 1, l, mid, at, val);
    } else {
      modify(u * 2 + 2, mid, r, at, val);
    }
    t[u] = max(t[u * 2 + 1], t[u * 2 + 2]);
  }
}

int get(int u, int l, int r, int lq, int rq) {
  if (lq <= l && r <= rq) {
    return t[u];
  } else if (rq <= l || r <= lq) {
    return -INFI;
  } else {
    int mid = (l + r) / 2;
    return max(get(u * 2 +1, l, mid, lq, rq), get(u * 2 + 2, mid, r, lq, rq));
  }
}

void run() {
  int n;
  cin >> n;
  vec<int> h(n), b(n);
  for (int i = 0; i < n; i++) {
    cin >> h[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  vec<tuple<int, int, int>> st {{0, -1, -INFL}};
  for (int i = 0; i < n; i++) {
    while (get<0>(st.back()) > h[i]) {
      st.pop_back();
    }
    int cval = get(0, 0, n + 1, get<1>(st.back()) + 1, i + 1) + b[i];
    st.emplace_back(h[i], i, max(cval, get<2>(st.back())));
    modify(0, 0, n + 1, i + 1, get<2>(st.back()));
//    cerr << get(0, 0, n + 1, i, i + 1) << endl;
  }
  int ans = get<2>(st.back());
  cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  precalc();
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}