#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
int const maxn = 605;
ll d[maxn][maxn];
vector < pair < int, int > > g[maxn];
ll inf = 1e18;
int start[maxn * maxn], stop[maxn * maxn], l[maxn * maxn];
ll need[maxn][maxn];

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q, u, v, w;
    cin >> n >> m;
    vector < vector < int > > T;
    for (int i = 1; i <= m; ++i) {
        cin >> u >> v >> w;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        T.push_back({u, v, w});
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) d[i][j] = inf;
    }
    for (int i = 1; i <= n; ++i) {
        for (auto key : g[i]) d[i][key.first] = key.second;
        d[i][i] = 0;
    }
    for (int k = 1; k <= n; ++k) {
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= n; ++j) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        cin >> start[i] >> stop[i] >> l[i];
        need[start[i]][stop[i]] = l[i];
    }
    for (int k = 1; k <= n; ++k) {
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= n; ++j) {
                if (d[i][k] + d[k][j] <= need[i][j]) {
                    need[i][k] = max(need[i][k], need[i][j] - d[k][j]);
                    need[k][j] = max(need[k][j], need[i][j] - d[i][k]);
                }
            }
        }
    }
    int ans = 0;
    for (auto key : T) {
        if (max(need[key[0]][key[1]], need[key[1]][key[0]]) >= key[2]) ans++;
    }
    cout << ans << '\n';
    return 0;
}

