#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <string.h>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>


using namespace std;
template<class T1, class T2> inline bool chkmin(T1 &x, const T2& y) {
	if (x > y) {
		x = y;
		return true;
	}
	return false;
}
template<class T1, class T2> inline bool chkmax(T1 &x, const T2& y) {
	if (x < y) {
		x = y;
		return true;
	}
	return false;
}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define rall(c) (c).rbegin(), (c).rend()
#define left left228
#define right right228
#define mp make_pair
#define pb push_back
using ll = long long;
using ld = long double;
const int MAXN = 605;




int n, m;
int dist[MAXN][MAXN];
int z[MAXN][MAXN];
int e[MAXN][MAXN];
int g[MAXN];
bool ok[MAXN][MAXN];


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			dist[i][j] = 1e9 + 228;
			z[i][j] = -1;
			e[i][j] = -1;
		}
		dist[i][i] = 0;
	}
	for (int i = 0; i < m; i++) {
		int a, b, l;
		cin >> a >> b >> l;
		dist[a][b] = l;
		dist[b][a] = l;
		e[a][b] = l;
		e[b][a] = l;
	}
	for (int k = 1; k <= n; k++) {
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= n; j++) {
				chkmin(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int a, b, l;
		cin >> a >> b >> l;
		z[a][b] = l;
		z[b][a] = l;
	}
	for (int j = 1; j <= n; j++) {
		for (int i = 1; i <= n; i++) {
			g[i] = -1;
		}
		for (int i = 1; i <= n; i++) {
			if (z[i][j] == -1) {
				continue;
			}
			for (int f = 1; f <= n; f++) {
				int val = z[i][j] - dist[i][f];
				chkmax(g[f], val);
			}
		}
		for (int i = 1; i <= n; i++) {
			for (int k = 1; k <= n; k++) {
				if (e[i][k] == -1) {
					continue;
				}
				if (e[i][k] + dist[k][j] <= g[i]) {
					ok[i][k] = true;
					ok[k][i] = true;
				}
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int k = i + 1; k <= n; k++) {
			if (ok[i][k]) {
				ans++;
			}
		}
	}
	cout << ans << '\n';
}