#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define int long long
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 600 + 10;
const int INF = 1e9 + 123;
int n, m;
int dst[N][N], kek[N], pairs[N][N], e[N][N];
int exists[N][N];
int ans = 0;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
#endif
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            dst[i][j] = INF;
            pairs[i][j] = -INF;
            e[i][j] = INF;
        }
    }
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        dst[v][u] = w;
        dst[u][v] = w;
        e[v][u] = e[u][v] = w;
        exists[v][u] = 1;
        exists[u][v] = 1;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int v, u, l;
        cin >> v >> u >> l;
        v--; u--;
        pairs[v][u] = l;
        pairs[u][v] = l;
    }
    for (int i = 0; i < n; i++) {
        dst[i][i] = 0;
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dst[i][j] = min(dst[i][j], dst[i][k] + dst[k][j]);
            }
        }
    }
    for (int root = 0; root < n; root++) {
        for (int x = 0; x < n; x++) {
            kek[x] = -INF;
        }
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < n; y++) {
                kek[y] = max(kek[y], pairs[root][x] - dst[x][y]);
            }
        }
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < n; y++) {
                if (exists[x][y] && e[x][y] + dst[root][x] <= kek[y])  {
                    exists[x][y] = exists[y][x] = false;
                    ans += 1;
                }
            }
        }
    }
    cout << ans << '\n';
}
