#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef pair<int, int> pii;

#define forn(i, n) for (int (i) = 0; (i) < (n); (i)++)
#define all(x) (x).begin(), (x).end()
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - x.begin())

const ll MOD = 1e9 + 7;
const ll INF = 1e9 + 55;
const ll INFLL = 1e18;

const int N = 600;
int sp[N][N];
int w[N][N];
int E[N][N];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            sp[i][j] = INF;
        }
        sp[i][i] = 0;
    }
    for (int i = 0; i < m; i++)
    {
        int f, t, w;
        cin >> f >> t >> w;
        f--, t--;
        E[f][t] = w;
        E[t][f] = w;
        sp[f][t] = w;
        sp[t][f] = w;
    }
    for (int k = 0; k < n; k++)
    {
        forn(i, n) forn(j, n) sp[i][j] = min(sp[i][k] + sp[k][j], sp[i][j]);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int v, u;
        cin >> v >> u;
        v--, u--;
        cin >> w[v][u];
        w[u][v] = w[v][u];
    }
    //forn(_, n)
    for (int k = 0; k < n; k++)
    {
        forn(i, n) forn(j, n)
        {
            w[i][j] = max(w[i][j], w[i][k] - sp[k][j]);
            w[i][j] = max(w[i][j], w[k][i] - sp[k][j]);
            w[i][j] = max(w[i][j], w[k][j] - sp[k][i]);
            w[i][j] = max(w[i][j], w[j][k] - sp[k][i]);
        }
    }
    int ans = 0;
//    forn(i, n)
//    {
//        forn(j, n)
//        {
//            cout << sp[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
//    forn(i, n)
//    {
//        forn(j, n)
//        {
//            cout << w[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
    forn(i, n) forn(j, n) ans += (E[i][j] > 0 && E[i][j] <= max(w[j][i], w[i][j]));
    cout << ans / 2 << "\n";
}
