﻿#include <iostream>
#include <string>
#include <math.h>
#include <cstring>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <assert.h>
#include <istream>
#include <ostream>
#include <vector>
#include <algorithm>

#define ll long long
#define ld long double

#define int long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

#define all(a) a.begin(), a.end()
#define mysort(a) sort(all(a))
#define myreverse(a) reverse(all(a))
#define myunique(a) unique(all(a))
#define superunique(a) a.resize(myunique(a) - a.begin())

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FOD(i, r, l) for (int i = r; i >= l; i--)


using namespace std;

template <class T1, class T2>
istream& operator>>(istream & in, pair<T1, T2>&val) {
    return in >> val.ft >> val.sd;
}

template <class T1, class T2>
ostream& operator<<(ostream & out, pair<T1, T2>&val) {
    return out << val.ft << ' ' << val.sd;
}

template <class T1>
istream& operator>>(istream& in, vector<T1>& val) {
    FOR(i, 0, val.size())
        in >> val[i];
    return in;
}

template <class T1>
ostream& operator<<(ostream& out, vector<T1>& val) {
    FOR(i, 0, val.size())
        out << val[i] << ' ';
    out << '\n';
    return out;
}

const int MAX_N = 600 + 228;

vector<pii> gr[MAX_N];

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<pii, int>> edges(m);
    for (int i = 0; i < m; i++) {
        cin >> edges[i];
        edges[i].ft.ft--;
        edges[i].ft.sd--;
        gr[edges[i].ft.ft].push_back(mp(edges[i].ft.sd, edges[i].sd));
        gr[edges[i].ft.sd].push_back(mp(edges[i].ft.ft, edges[i].sd));
    }
    vector<vector<pii>> paths(n);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        u--; v--;
        paths[u].push_back(mp(v, l));
        paths[v].push_back(mp(u, l));
    }
    vector<bool> good(m);
    for (int v = 0; v < n; v++) 
        if (paths[v].size()) {
            vector<int> d0(n, 1000000000000000ll);
            d0[v] = 0;
            vector<bool> used0(n);
            for (int i = 0; i < n; i++) {
                int minind = -1;
                for (int j = 0; j < n; j++)
                    if (!used0[j])
                        if (minind == -1 || d0[j] < d0[minind])
                            minind = j;
                used0[minind] = true;
                for (auto e : gr[minind])
                    d0[e.ft] = min(d0[e.ft], d0[minind] + e.sd);
            }

            vector<int> d(n, 1000000000000000ll);
            for (pii ul : paths[v])
                d[ul.ft] = -ul.sd;
            vector<bool> used(n);
            for (int i = 0; i < n; i++) {
                int minind = -1;
                for (int j = 0; j < n; j++)
                    if (!used[j])
                        if (minind == -1 || d[j] < d[minind])
                            minind = j;
                used[minind] = true;
                for (auto e : gr[minind]) {
                    d[e.ft] = min(d[e.ft], d[minind] + e.sd);
                }
            }
            for (int i = 0; i < m; i++) {
                if (d0[edges[i].ft.ft] + edges[i].sd + d[edges[i].ft.sd] <= 0) {
                    good[i] = true;
                }
            }
        }
    int ans = 0;
    FOR(i, 0, m)
        if (good[i])
            ans++;
    cout << ans;
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}