#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pii pair<int, int>

const int maxn = 605, inf = 1e16;
int g[maxn][maxn];
int dist[maxn][maxn];
vector<pii> p[maxn];
bool used2[maxn][maxn];
int p2[maxn];
bool used[maxn];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u][v] = g[v][u] = w;
    }
    int q;
    cin >> q;
    vector<pair<pii, int>> kek(q);
    for (int i = 0; i < q; ++i) {
        cin >> kek[i].f.f >> kek[i].f.s >> kek[i].s;
        kek[i].f.f--, kek[i].f.s--;
        p[kek[i].f.f].pb({kek[i].f.s, kek[i].s});
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            dist[i][j] = inf;
            used[j] = 0;
        }
        dist[i][i] = 0;
        while (1) {
            int v = -1;
            for (int j = 0; j < n; ++j) {
                if (!used[j] && (v == -1 || dist[i][v] > dist[i][j])) {
                    v = j;
                }
            }
            if (v == -1 || dist[i][v] == inf) {
                break;
            }
            used[v] = 1;
            for (int u = 0; u < n; ++u) {
                if (g[v][u] != 0) {
                    if (dist[i][u] > dist[i][v] + g[u][v]) {
                        dist[i][u] = dist[i][v] + g[u][v];
                    }
                }
            }
        }
    }
    int ans = 0;
    for (int u = 0; u < n; ++u) {
        for (int i = 0; i < n; ++i) {
            if (dist[i][u] == inf) {
                continue;
            }
            p2[i] = inf;
            for (auto [j, l]: p[i]) {
                if (dist[u][j] == inf) {
                    continue;
                }
                p2[i] = min(p2[i], dist[u][j] - l);
            }
        }
        for (int v = 0; v < n; ++v) {
            if (used2[u][v]) {
                continue;
            }
            if (g[u][v] == 0) {
                continue;
            }
            for (int i = 0; i < n; ++i) {
                if (dist[i][v] == inf) {
                    continue;
                }
                if (dist[i][v] + g[u][v] + p2[i] <= 0) {
                    ans++;
                    used2[v][u] = used2[u][v] = 1;
                    break;
                }
            }
        }
    }
    cout << ans;
    return 0;
}