#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
using namespace std;
#define int long long
#define ii pair <int, int> 
#define ll long long
#define vi vector <int>
#define debug(x) cerr << #x << ": " << x << endl;
#define mp make_pair
#define app push_back
#define x first
#define y second
void ckmin(int &a, int b) { a = min(a, b); }
void ckmax(int &a, int b) { a = max(a, b); }
int gcd(int a, int b) {
    while (b) {
        int t = a%b;
        a = b;
        b = t;
    }
    return a;
}

const int N = 607, INF = 1e18;

int n, m;
int g[N][N], d[N][N], dp[N][N];

signed main() {
    #ifdef LOCAL
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #define endl '\n'
    #endif
    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            g[i][j] = d[i][j] = INF;

    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u][v] = g[v][u] = d[u][v] = d[v][u] = c; 
    }

    for (int i = 1; i <= n; ++i)
        d[i][i] = 0;

    for (int k = 1; k <= n; ++k)
        for (int i = 1; i <= n; ++i)
            for (int j = 1; j <= n; ++j)
                ckmin(d[i][j], d[i][k] + d[k][j]);

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        dp[u][v] = dp[v][u] = c;
    }

    for (int k = 1; k <= n; ++k)
        for (int i = 1; i <= n; ++i)
            for (int j = 1; j <= n; ++j) {
                ckmax(dp[i][k], dp[i][j] - d[k][j]);
                ckmax(dp[k][j], dp[i][j] - d[i][k]);
            }

    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = i + 1; j <= n; ++j) {

            //cout << i << ' ' << j << ' ' << dp[i][j] << ' ' << g[i][j] << endl;

            if (dp[i][j] >= g[i][j]) {
                ans++;
            }
        }
    }
    cout << ans << endl;
}