#include <iostream>

using namespace std;

typedef long long ll;
const ll INF = 1e18 + 7;

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	ll** gr = new ll* [n];
	for (int i = 0; i < n; i++)
	{
		gr[i] = new ll[n];
		for (int j = 0; j < n; j++)
			gr[i][j] = INF;
	}
	int u, v, w;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v >> w;
		u--, v--;
		gr[u][v] = w;
		gr[v][u] = w;
	}
	ll** dist = new ll * [n];
	for (int i = 0; i < n; i++)
	{
		dist[i] = new ll[n];
		for (int j = 0; j < n; j++)
			dist[i][j] = gr[i][j];
		dist[i][i] = 0;
	}
	for (int k = 0; k < n; k++)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}
	ll** max_l = new ll * [n];
	for (int i = 0; i < n; i++)
	{
		max_l[i] = new ll[n];
		for (int j = 0; j < n; j++)
			max_l[i][j] = -INF;
	}
	int q, l;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		cin >> u >> v >> l;
		u--, v--;
		max_l[u][v] = l;
		max_l[v][u] = l;
	}
	ll** max_dist = new ll * [n];
	for (int i = 0; i < n; i++)
	{
		max_dist[i] = new ll[n];
		for (int j = 0; j < n; j++)
		{
			max_dist[i][j] = -INF;
			for (int k = 0; k < n; k++)
			{
				max_dist[i][j] = max(max_dist[i][j], max_l[k][j] - dist[k][i]);
			}
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			for (int k = 0; k < n; k++)
			{
				if (max_dist[i][k] >= dist[k][j] + gr[i][j])
				{
					//cout << "pair " << i << " and " << j << "\n";
					cnt++;
					break;
				}
			}
		}
	}
	cout << cnt / 2 << "\n";
}
