#include<bits/stdc++.h>

using namespace std;

string tostr(string s) {
    string res = "";
    res.push_back('"');
    res += s;
    res.push_back('"');
    return res;
}

string tostr(char c) {
    string res = "";
    res += "'";
    res.push_back(c);
    res += "'";
    return res;
}

string tostr(long long x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + (x % 10));
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

string tostr(int x) {
    if (x == 0) return "0";
    string res = "";
    bool f = false;
    if (x < 0) f = true;
    x = abs(x);
    while (x) {
        res.push_back('0' + x % 10);
        x /= 10;
    }
    if (f) res.push_back('-');
    reverse(res.begin(), res.end());
    return res;
}

template<typename A, typename B>
string tostr(pair<A, B> a) {
    return "{" + tostr(a.first) + ", " + tostr(a.second) + "}";
}

template<typename A>
string tostr(vector<A> a) {
    string res = "{";
    bool f = false;
    for (auto x : a) {
        if (!f) {
            f = true;
        }
        else {
            res += ", ";
        }
        res += tostr(x);
    }
    res += "}";
    return res;
}

#define debug(x) cout << #x << " = " << tostr(x) << endl
#define int long long
#define pb push_back
#define pii pair<int, int>
#define fi first
#define se second
#define ld long double
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) (int) (a).size()

void solve() {
    int n, m;
    cin >> n >> m;
    cout << n * m << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
