//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse42,avx,bmi,popcnt")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <cstdio>
#include <climits>
#include <cmath>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

struct point
{
	int64_t x, y;
	point operator + (const point& rhs) const
	{
		return {x+rhs.x, y+rhs.y};
	}
	point operator - (const point& rhs) const
	{
		return {x-rhs.x, y-rhs.y};
	}
	int64_t operator * (const point& rhs) const
	{
		return x*rhs.x + y*rhs.y;
	}
	int64_t operator % (const point& rhs) const
	{
		return x*rhs.y - y*rhs.x;
	}
	double dist() const
	{
		return std::hypot(x, y);
	}
};
int main()
{
	int t; std::cin >> t;
	while(t --> 0)
	{
		int a, b; std::cin >> a >> b;
		printf("%d\n", a*b);
	}
}
