#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define sz(x) (long long)((x).size())
#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

void initial()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef PC
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
}
mt19937 rnd(time(0));
ll mod1, mod2;
bool ok(ll a)
{
    for (int i = 2; i * i <= a; i++)
    {
        if (a % i == 0)
            return false;
    }
    return true;
}
void init_mods()
{
    vector <ll> mods = {(ll)1e9 + 7, (ll)1e9 + 9};
    for (int i = 0; i < 100; i++)
    {
        ll kek = rnd() % (ll)1e9;
        kek += 1e9;
        if (ok(kek))
            mods.pb(kek);
    }
    shuffle(all(mods), rnd);
    mod1 = mods[0];
    mod2 = mods[1];
}
struct myHash{
    ll x, y;
    myHash(){}
    myHash(ll x, ll y) : x(x), y(y) {}
    myHash operator +(myHash a)
    {
        return myHash((x + a.x) % mod1, (y + a.y) % mod2);
    }
    myHash operator -(myHash a)
    {
        return myHash((x - a.x + mod1 * 2) % mod1, (y - a.y + mod2 * 2) % mod2);
    }
    myHash operator *(myHash a)
    {
        return myHash((a.x * x) % mod1, (a.y + y) % mod2);
    }
    bool operator ==(myHash a)
    {
        return a.x == x && a.y == y;
    }
};
struct Hash{
    vector <myHash> h, p;
    myHash pr = myHash(101, 103);
    ll n;
    Hash(string &s)
    {
        h.resize(sz(s) + 1, myHash(0, 0));
        p.resize(sz(s) + 1, myHash(1, 1));
        n = sz(s);
        for (int i = 1; i <= n; i++)
        {
            h[i] = h[i - 1] * pr + myHash(s[i - 1] - 'a' + 1, s[i - 1] + 'a' - 1);
            p[i] = p[i - 1] * pr;
        }
    }
    myHash get_hash(ll l, ll r)
    {
        return h[r] - h[l] * p[r - l];
    }
    bool eq(ll l, ll r, ll l1, ll r1)
    {
        return get_hash(l - 1, r) == get_hash(l1 - 1, r1);
    }
};
void solve()
{
    ll a, b;
    cin >> a >> b;
    cout << a * b << endl;
}
signed main() {
    initial();
    //init_mods();
    ll t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}