﻿#define ll long long

#include<iostream>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<string>

using namespace std;

struct el {
    ll a = 0, b = 0;
    el(ll v1 = 0, ll v2 = 0) {
        a = v1;
        b = v2;
    }
    const bool operator <(const el& e) const {
        return tie(a) < tie(e.a);
    }
};

/////////////////// SEGMENT_TREE //////////////////////
/*

void build(vector<ll> &tree, vector<ll> &a, ll now, ll l, ll r) {
    if (l == r) {
        tree[now] = a[l];
        return;
    }
    ll mid = (r + l) / 2;
    build(tree, a, now * 2 + 1, l, mid);
    build(tree, a, now * 2 + 2, mid + 1, r);
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

void change(vector<ll>& tree, ll now, ll l, ll r, ll pos, ll x) {
    if (l == r) {
        tree[l] = x;
        return;
    }
    ll mid = (l + r) / 2;
    if (pos <= mid) {
        change(tree, now * 2 + 1, l, mid, pos, x);
    }
    else {
        change(tree, now * 2 + 2, mid + 1, r, pos, x);
    }
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

ll qw(vector<ll>& tree, ll now, ll l, ll r, ll ql, ll qr) {
    ql = max(ql, l);
    qr = min(qr, r);
    if (ql > qr) {
        return -1e9;
    }
    if (l == ql && r == qr) {
        return tree[now];
    }
    ll mid = (l + r) / 2;
    return max(
        qw(tree, now * 2 + 1, l, mid, ql, qr),
        qw(tree, now * 2 + 2, mid + 1, r, ql, qr));
}

*/
/////////////////// SEGMENT_TREE //////////////////////

void true_main() {
    ll a, b;
    cin >> a >> b;
    cout << a * b;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    ll t = 1;
    cin >> t;
    
    while (t--) {
        true_main();
        cout << "\n";
    }
}