#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <random>
#include <iomanip>

#define mp make_pair
#define pb push_back
#define endl '\n'
#define sqr(x) ((x) * (x))
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

int gcd(int a, int b) {
	if (!b)
		return a;
	return gcd(b, a % b);
}

void solve() {

	int n;
	cin >> n;
	vi a(n);
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		mx = max(mx, a[i]);
	}
	vi b(n - 1);
	for (int i = 0; i < n - 1; ++i)
		b[i] = a[i + 1] - a[i];
	int ans = 0;
	for (int i = 0; i < n - 2; ++i)
		ans = gcd(ans, abs(b[i + 1] - b[i]));
	if (ans == 0)
		cout << 0;
	else if (ans <= mx)
		cout << -1;
	else
		cout << ans << ' ' << (b[0] % ans + ans) % ans;
	cout << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
		solve();

	return 0;
}