#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ff first
#define ss second
#define m_p make_pair
#define p_b push_back

const int MAXN = (int) 2e5;

ll a[MAXN];
set <ll> st, st1;


bool check(ll c, ll m, ll n){
	if (a[0] >= m)
		return 0;
	for (ll i = 0; i + 1 < n; i++){
		if (a[i + 1] != (a[i] + c) % m)
			return 0;
	}
	return 1;
}


int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	ll _;
	cin >> _;
	while (_--){
		st.clear();
		st1.clear();
		ll n;
		cin >> n;
		for (ll i = 0; i < n; i++){
			cin >> a[i];
		}
		for (ll i = 0; i + 1 < n; i++){
			if (a[i] > a[i + 1])
				st1.insert(a[i] - a[i + 1]);
			else
				st.insert(a[i + 1] - a[i]);
		}
		if (st.size() > 1 || st1.size() > 1){
			cout << "-1\n";
		}
		else if (st.size() && (*st.begin()) == 0 && st1.size()){
			cout << "-1\n";
		}
		else if (st.size() && (*st.begin() == 0) || st.size() == 0){
			cout << "0\n";
		}
		else if (st.size() && st1.size() == 0){
			cout << "0\n";
		}
		else if (st.size() && st1.size()){
			ll c = (*st.begin()), m = (*st1.begin()) + (*st.begin());
			if (check(c, m, n)){
				cout << m << ' ' << c << '\n';
			}
			else{
				cout << "-1\n";
			}
		}
	}

	return 0;
}