#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <assert.h>

#define ll long long
#define ld long double
#define sz(x) (int)x.size()
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define all(x) x.begin(),x.end()
#define in insert
#define F first
#define S second

using namespace std;

const int N = (int)3e5 + 123;
const int mod = (int)1e9 + 7;
const ll inf = (ll)3e18 + 123;

int n, a[N];

inline void boost () {
   ios_base :: sync_with_stdio(0);
   cin.tie(0);
   cout.tie(0);
}

inline bool check (int g, int c) {
   int st = a[1] % g;
   if (a[1] >= g) return 0;
   for (int i = 2; i <= n; i ++) {
      st = (st + c) % g;
      if (st != a[i]) return 0; 
   }
   return 1;
}

int gcd (int a, int b) {
   if (!b) return a;
   return gcd (b, a % b);
}

int main () {
   //freopen ("input", "r", stdin);
   boost ();
   int t;
   cin >> t;
   while (t --) {
      cin >> n;
      int mn = mod, mx = -mod;
      for (int i = 1; i <= n; i ++) cin >> a[i], mn = min (mn, a[i]), mx = max (mx, a[i]);
      if (mx == mn) {
         cout << "0\n";
         continue;
      }
      mn = mod;
      mx = -mod;
      bool ok = 1;
      for (int i = 1; i < n; i ++) ok &= (a[i] >= a[i + 1]), mn = min (mn, a[i] - a[i + 1]), mx = max (mx, a[i] - a[i + 1]);
      if (ok) {
         if (mn == mx) {
            cout << "0\n";
            continue;
         }
         cout << "-1\n";
         continue;
      }        
      int c = 0;
      for (int i = 1; i < n; i ++) {
         if (a[i] < a[i + 1]) {
            c = max (c, a[i + 1] - a[i]);
         }
      }
      int g = 0;
      for (int i = 1; i < n; i ++) {
         if (a[i] >= a[i + 1]) {
            g = gcd (g, a[i] + c - a[i + 1]);
         }
      }
      if (g == 0) {
         mn = mod;
         mx = -mod;
         for (int i = 1; i < n; i ++) mn = min (mn, a[i] - a[i + 1]), mx = max (mx, a[i] - a[i + 1]);
         if (mn == mx) {
            cout << "0\n";
            continue;
         }
         cout << "-1\n";
         continue;
               
      }
      else {
         int ans = -1;
         for (int i = 1; i * i <= g; i ++) {
            if (g % i == 0) {
               if (check (i, c)) ans = max (ans, i);
               if (check (g / i, c)) ans = max (ans, g / i);
            }
         }
         if (ans != -1 && ans > c) cout << ans << ' ' << c << endl;
         else cout << -1 << endl;
      }
   }
   return 0;
}