#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
    #pragma GCC optimize("O3")
    #pragma GCC optimize("Ofast")
    #pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
ll MAX = 1e18;


void solve(){
    mt19937_64 gen;

    ll n;
    cin >> n;
    vector<ll> nums(n);
    for(ll i=0; i<n; i++){
        cin >> nums[i];
    }
    bool inc=false;
    bool dec=false;
    set<ll> C;
    set<ll> DIFF;
    ll maxM = nums[0];
    for(ll i=1; i<n; i++){
        maxM = max(maxM, nums[i]);
        if(nums[i]-nums[i-1]>=0){
            //c = nums[i]-nums[i-1];
            C.insert(nums[i]-nums[i-1]);
            inc=true;
        }
        else {
            dec=true;
            DIFF.insert(nums[i]-nums[i-1]);
        }
    }
    if(C.size()>1 || DIFF.size()>1){
        cout << "-1\n";
        return;
    }
    if(!dec || !inc){
        cout << "0\n";
        return;
    }
    ll c = *C.begin();
    ll m=-1;
    for(ll i=1; i<n; i++){
        if(nums[i]-nums[i-1]<0){
            m = c+nums[i-1]-nums[i];
            break;
        }
    }
    if(m<=maxM){
        cout << "-1\n";
        return;
    }
    vector<ll> a(n);
    a[0] = nums[0];
    for(ll i=1; i<n; i++){
        a[i] = (a[i-1]+c)%m;
    }
    if(a!=nums){
        cout << "-1\n";
        return;
    }
    cout << m << " " << c << "\n";
}




int main() {
    #ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // ONLINE_JUDGE

    ll t=1;
    cin >> t;

    while(t--){
        solve();
    }
    return 0;
}
