#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <bitset>
#include <random>
#include <queue>
#include <ctime>
#include <deque>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()
#define an cerr <<"--->"; cerr.flush();

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;

const ll inf = (ll)1e18 + 228;
const ll cst = 3e5 + 5;
const ll mod = 1e9 + 7;

void operator delete(void*);

void solve() {
	ll n;
	cin >> n;
	vector<ll> vc(n);
	for (ll& i : vc) cin >> i;
	an;
	if (n == 1) {
		cout << 0;
		return;
	}
	ll c = vc[1] - vc[0];
	bool sorted = 1;
	for (ll i = 0; i < n - 1; i++) {
		if (vc[i + 1] - vc[i] != c) {
			sorted = 0;
			break;
		}
	}
	if (sorted) {
		cout << 0;
		return;
	}
	if (c >= 0) {
		set<ll> st;
		for (ll i = 0; i < n - 1; i++) {
			if (vc[i + 1] >= vc[i]) {
				if (vc[i + 1] - vc[i] != c) {
					cout << -1;
					return;
				}
			}
			else {
				st.insert(vc[i + 1] - vc[i]);
			}
		}
		if (st.size() > 1) {
			cout << -1;
			return;
		}
		ll c2 = *st.begin();
		ll md = c - c2;
		ll a = vc[0];
		if (vc[0] >= md) {
			cout << -1;
			return;
		}
		c %= md;
		for (ll i = 1; i < n; i++) {
			a = (a + c) % md;
			if (a != vc[i]) {
				cout << -1;
				return;
			}
		}
		cout << md << " " << c;
	}
	else {
		set<ll> st;
		for (ll i = 0; i < n - 1; i++) {
			if (vc[i + 1] < vc[i]) {
				if (vc[i + 1] - vc[i] != c) {
					cout << -1;
					return;
				}
			}
			else {
				st.insert(vc[i + 1] - vc[i]);
			}
		}
		if (st.size() > 1) {
			cout << -1;
			return;
		}
		ll c2 = *st.begin();
		ll md = c2 - c;
		ll a = vc[0];
		if (vc[0] >= md) {
			cout << -1;
			return;
		}
		c2 %= md;
		for (ll i = 1; i < n; i++) {
			a = (a + c2) % md;
			if (a != vc[i]) {
				cout << -1;
				return;
			}
		}
		cout << md << " " << c2;
	}
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
#ifdef _DEBUG
		cout << endl;
#else
		cout << "\n";
#endif
	}
	return 0;
}
