#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

void Sol() {
	int n;
	bool err = 0;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];

	int c = -1, m = 0;
	for (int i = 0; i < n-1; i++) {
		if (a[i] <= a[i+1]) {
			if (c == -1) c = a[i+1] - a[i];
			else if (c != a[i+1] - a[i]) {
				err = 1;
				break;
			}
		}
	}
	if (err) {
		cout << "-1\n";
		return;
	}
	
	for (int i = 0; i < n - 1; i++) {
		if (a[i] > a[i + 1]) {
			if (c != -1 && c <= a[i + 1]) {
				err = 1;
				break;
			}
			if(m == 0) m = abs(c) + a[i] - a[i + 1];
			else if (m != abs(c) + a[i] - a[i + 1]) {
				err = 1;
				break;
			}
		}
	}
	if (err) {
		cout << "-1\n";
		return;
	}
	if (c == -1 || m == 0) {
		cout << "0\n";
		return;
	}
	vector<int> b(n);
	b[0] = a[0];
	for (int i = 1; i < n; i++) {
		b[i] = (b[i - 1] + c) % m;
	}
	if (a != b) {
		cout << "-1\n";
		return;
	}
	cout << m << " " << c << "\n";
	return;
}

int main() {
	int t=1;
	cin >> t;
	while (t--) Sol();

	//system("pause");
}
