#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mp make_pair
#define mt make_tuple

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = (int)1e18;
const int MAXN = 2 * 100000 + 5;
const int MOD = 1027703639;

int gcd(int a, int b){
    return (b ? gcd(b, a % b) : a);
}

int binpow(int a, int n){
    if(n == 0)
        return 1;
    if(n % 2 == 1)
        return a * binpow(a, n - 1);
    int t = binpow(a, n / 2);
    return t * t;
}

/*void make(int v){
    parent[v] = v;
    rnk[v] = 0;
}

int find(int v){
    return (parent[v] == v ? v : parent[v] = find(parent[v]));
}

void unite(int a, int b){
    a = find(a);
    b = find(b);
    if(a == b)
        return;
    if(rnk[a] < rnk[b])
        swap(a, b);
    parent[b] = a;
    if(rnk[a] == rnk[b])
        ++rnk[a];
}*/

bool check(const vector<int> &a, int m, int c){
    if(a[0] >= m)
        return false;
    for(int i = 1; i < (int)a.size(); ++i){
        if(a[i] != (a[i - 1] + c) % m)
            return false;
    }
    return true;
}

signed main() {
    fastio;
    /*#define FILENAME "river"
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);*/
    /*freopen(input".txt", "r", stdin);
    freopen(output".txt", "w", stdout);*/
    int T;
    cin >> T;
    while(T--){
        int n;
        cin >> n;
        vector<int> a(n);
        for(int i = 0; i < n; ++i)
            cin >> a[i];
        if(n == 1)
            cout << 0 << '\n';
        else{
            int d = a[1] - a[0];
            int ans = 0;
            int m = -1, c = -1;
            for(int i = 2; i < n; ++i){
                int d1 = a[i] - a[i - 1];
                if(d1 == d)continue;
                if(d1 * d >= 0){
                    ans = -1;
                    break;
                }
                else{
                    c = max(d1, d);
                    m = abs(d1) + abs(d);
                    break;
                }
            }
            if(ans == -1)
                cout << -1 << '\n';
            else if(c == -1)
                cout << 0 << '\n';
            else if(check(a, m, c))
                cout << m << ' ' << c << '\n';
            else
                cout << -1 << '\n';
        }
    }
    return 0;
}