#include <bits/stdc++.h>

using namespace std;
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,popcnt,tune=native")
#pragma optimaze("O3")

#define int long long

typedef long long ll;

ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (a * b) % mod;
}

ll sm(ll a, ll b) {
    if (a + b < mod) return a + b;
    return (a + b - mod);
}

ll divv(ll a, ll b) {
    if (a >= b) return a - b;
    return a - b + mod;
}

ll pw(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2) return mul(a, pw(a, k - 1));
    return pw(mul(a, a), k / 2);
}



int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;  cin >> t;
    while (t--) {
        int n; cin >> n;
        vector<int> a(n);
        int mx = 0;
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            mx = max(mx, a[i]);
        }
        mx++;
        int s = a[0];
        bool fl = true;
        int c1 = -1, c2 = -1;
        for (int i = 1; i < n; i++) {
            if (a[i - 1] < a[i]) {
                if (c2 == -1) {
                    c2 = a[i] - a[i - 1];
                } else {
                    if (c2 != a[i] - a[i - 1]) fl = false;
                }
            } else {
                if (c1 == -1) {
                    c1 = a[i - 1] - a[i];
                } else {
                    if (c1 != a[i - 1] - a[i]) fl = false;
                }
            }
        }
        if (!fl) {
            cout << -1 << endl;
            continue;
        }
        if (c1 == -1 || c2 == -1) {
            cout << 0 << endl;
            continue;
        }
        if (c1 + c2 < mx) {
            cout << -1 << endl;
            continue;
        }
        cout << c1 + c2 << " " << c2 << endl;




    }


    return 0;
}
