#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const long long INF = 1e16;

void solve()
{
    int n;
    cin >> n;
    vector<ll> a(n);

    for (int i = 0; i < n; i++) cin >> a[i];

    if (n == 1)
    {
        cout << 0 << '\n';
        return;
    }

    ll c = -1;

    for (int i = 0; i < n - 1; i++)
    {
        ll nC = -1;
        if (a[i] <= a[i + 1])
            nC = a[i + 1] - a[i];
        else
            continue;
        
        if (c != -1 && nC != c)
        {
            cout << -1 << '\n';
            return;
        }
        else
            c = nC;
    }

    if (c != -1)
    {
        ll mod = -1;

        for (int i = 0; i < n - 1; i++)
        {
            if (a[i + 1] >= a[i])
            {
                if (a[i + 1] - a[i] != c)
                {
                    cout << -1 << '\n';
                    return;
                }
            }
            else
            {
                if (mod != -1)
                {
                    if (a[i + 1] != a[i] + c - mod)
                    {
                        cout << -1 << '\n';
                        return;
                    }
                }
                else
                {
                    mod = a[i] + c - a[i + 1];
                }
            }
        }
        
        if (mod == -1)
            cout << "0\n";
        else
        {
            for (int i = 0; i < n - 1; i++)
            {
                
                if (a[i] >= mod || a[i + 1] > mod || a[i + 1] != (a[i] + c) % mod)
                {
                    cout << "-1\n";
                    return;
                }
            }
            cout << mod << " " << c << '\n';
        }
    }
    else
    {
        for (int i = 0; i < n - 1; i++)
        {
            if (a[i + 1] - a[i] != a[1] - a[0])
            {
                cout << "-1\n";
                return;
            }
        }
        cout << "0\n";
    }
    return;
}

int main()
{
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}