#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 10, INF = 1e9 + 10, MOD = 1e9 + 7;
const ll LINF = ll(1e18) + 10;

ll arr[N];

int n;

bool check0() {
    bool f = true;

    for (int i = 1; i < n-1; i++) {
        if (arr[i-1] - arr[i] != arr[i] - arr[i+1]) {
            f = false;
            break;
        }
    }
    return f;
}

void solve() {
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    if (check0()) {
        cout << "0\n";
        return;
    }

    ll c = -1;
    for (int i = 1; i < n; i++) {
        if (arr[i-1] < arr[i]) {
            c = arr[i] - arr[i-1];
        }
    }

    if (c == -1) {
        cout << "-1\n";
        return;
    }
    ll m = -1;
    for (int i = 1; i < n; i++) {
        if (arr[i-1] <= arr[i]) {
            if (arr[i] - arr[i-1] != c) {
                cout << "-1\n";
                return;
            }
        } else {
            m = arr[i-1] + c - arr[i];
        }
    }
    if (m == -1) {
        cout << "-1\n";
        return;
    }
    for (int i = 1; i < n; i++) {
        if ((arr[i-1] + c) % m != arr[i] || arr[i-1] >= m || arr[i] >= m) {
            cout << "-1\n";
            return;
        }
    }
    cout << m << " " << c << "\n";
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}