#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <cmath>
#include <time.h>
#include <random>
#include <chrono>
#include <cassert>
#include <limits>

using namespace std;

#define int long long 
#define pb push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define ld long double

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) out << k << " ";
	return out;
}

ostream& operator<< (ostream& out, const pii& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else 
	#define dbg(x) 
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

vector<int> make(int n, int m, int c, int s) {
	vector<int> ans(n, 0);
	ans[0] = s % m;
	for (int i = 1; i < n; i++) {
		ans[i] = ans[i - 1] + c;
		if (ans[i] >= m) ans[i] -= m;
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> have;
	for (int i = 1; i < n; i++) {
		if (a[i] >= a[i - 1]) {
			have.pb(a[i] - a[i - 1]);
		}
	}
	sort(all(have));
	have.resize(unique(all(have)) - have.begin());
	vector<int> neg;
	for (int i = 1; i < n; i++) {
		if (a[i] < a[i - 1]) {
			neg.pb(a[i - 1] - a[i]);
		}
	}
	sort(all(neg));
	neg.resize(unique(all(neg)) - neg.begin());
	if (have.size() > 1 || neg.size() > 1) {
		cout << "-1\n";
		return;
	}
	if (neg.empty() || have.empty()) {
		cout << "0\n";
		return;
	}
	int c = have[0];
	int m = -1;
	for (int i = 1; i < n; i++) {
		if (a[i - 1] > a[i]) {
			m = a[i - 1] + c - a[i];
			break;
		}
	}
	vector<int> check = make(n, m, c, a[0]);
	if (check == a) cout << m << " " << c << "\n";
	else cout << "-1\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    int q = 1;
    cin >> q;
    while (q--) {
    	solve();
    }
}
/*

*/