#include <iostream>
#include <string>
#include <math.h>
#include <cstring>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <assert.h>
#include <istream>
#include <ostream>
#include <vector>
#include <algorithm>

#define ll long long
#define ld long double

#define int long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

#define all(a) a.begin(), a.end()
#define mysort(a) sort(all(a))
#define myreverse(a) reverse(all(a))
#define myunique(a) unique(all(a))
#define superunique(a) a.resize(myunique(a) - a.begin())

#define FOR(i, l, r) for(int i = l; i < r; i++)
#define FOD(i, r, l) for (int i = r; i >= l; i--)


using namespace std;

template <class T1, class T2>
istream& operator>>(istream & in, pair<T1, T2>&val) {
    return in >> val.ft >> val.sd;
}

template <class T1, class T2>
ostream& operator<<(ostream & out, pair<T1, T2>&val) {
    return out << val.ft << ' ' << val.sd;
}

template <class T1>
istream& operator>>(istream& in, vector<T1>& val) {
    FOR(i, 0, val.size())
        in >> val[i];
    return in;
}

template <class T1>
ostream& operator<<(ostream& out, vector<T1>& val) {
    FOR(i, 0, val.size())
        out << val[i] << ' ';
    out << '\n';
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> cs;
    vector<int> diffs;
    for (int i = 0; i < n - 1; i++) {
        if (a[i + 1] > a[i])
            cs.push_back(a[i + 1] - a[i]);
        else {
            diffs.push_back(a[i + 1] - a[i]);
        }
    }
    mysort(cs);
    superunique(cs);

    mysort(diffs);
    superunique(diffs);
    if (cs.size() > 1) {
        cout << "-1\n";
        return;
    }
    if (diffs.size() > 1) {
        cout << "-1\n";
        return;
    }
    if (cs.size() == 1) {
        if (diffs.size() == 0) {
            cout << "0\n";
            return;
        }
        else {
            int m = cs[0] - diffs[0];
            int c = cs[0];
            if (a[0] >= m) {
                cout << "-1\n";
                return;
            }
            for (int i = 1; i < n; i++)
                if (a[i] != (a[i - 1] + c) % m) {
                    cout << "-1\n";
                    return;
                }
            cout << m << ' ' << c << '\n';
            return;
        }
    }
    else {
        cout << "0\n";
        return;
    }
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}