import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = nextInt();
//        int t = 1;
        for (int qq = 0; qq < t; qq++) {
            int n = nextInt();
            int[] a = new int[n];
            for (int i = 0; i < n; i++) {
                a[i] = nextInt();
            }
            int c_p = Integer.MAX_VALUE;
            int c_n = Integer.MIN_VALUE;
            int max = a[0];
            boolean ch = true;
            for (int i = 1; i < n; i++) {
                max = max(max, a[i]);
                if (a[i] > a[i - 1]) {
                    if (c_p != Integer.MAX_VALUE && a[i] - a[i - 1] != c_p) {
                        ch = false;
                        break;
                    } else {
                        c_p = a[i] - a[i - 1];
                    }
                } else {
                    if (c_n != Integer.MIN_VALUE && a[i] - a[i - 1] != c_n) {
                        ch = false;
                        break;
                    } else {
                        c_n = a[i] - a[i - 1];
                    }
                }
            }
            if (ch) {
                if (c_p == Integer.MAX_VALUE || c_n == Integer.MIN_VALUE) pw.println(0);
                else {
                    if (abs(c_n) + c_p <= max) pw.println(-1);
                    else pw.println((abs(c_n) + c_p) + " " + c_p);
                }
            } else {
                pw.println(-1);
            }
        }
        pw.close();
    }

    static int ans;

    static void rec(int a, int b) {
        if (a == 1 || b == 1) {
            ans += max(a, b);
        } else if (a == 2 || b == 2) {
            ans += 2 * (a + b) - 4;
        } else {
            ans += 2 * (a + b) - 4;
            rec(a - 2, b - 2);
        }
    }

    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader br;
    static PrintWriter pw;

    static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    static long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}

class Pair {
    int first, second;

    public Pair(int first, int second) {
        this.first = first;
        this.second = second;
    }
}

class PairSort implements Comparator<Pair> {
    @Override
    public int compare(Pair o1, Pair o2) {
        if (o1.first == o2.first) return Integer.compare(o1.second, o2.second);
        return Integer.compare(o1.first, o2.first);
    }
}