#include <stdio.h>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <cassert>

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	const int UNDEF = -1;
	int nT;
	scanf("%d", &nT);
	for (int t = 0; t < nT; t++) {
		int n;
		scanf("%d", &n);
		std::vector<int> a(n);
		//std::vector<int> diff(n, 0);
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			
		}
		// for 0
		{
			bool equal = true;
			int diff = a[1] - a[0];
			for (int i = 1; i < n; i++) {
				int curDiff = a[i] - a[i - 1];
				if (curDiff != diff) {
					equal = false;
					break;
				}
			}
			if (equal) {
				printf("0\n");
				continue;
			}
		}
		// for -1
		int minDiff = 1;
		int maxDiff = 0;
		for (int i = 1; i < n; i++) {
			int diff = a[i] - a[i - 1];
			minDiff = std::min(minDiff, diff);
			maxDiff = std::max(maxDiff, diff);
		}
		int mod = std::abs(minDiff) + maxDiff;
		bool possible = true;
		for (int i = 0; i < n; i++) {
			if (a[i] >= mod) {
				possible = false;
				break;
			}
		}
		for (int i = 1; i < n; i++) {
			int diff = a[i] - a[i - 1];
			if (diff < 0 && diff != minDiff) {
				possible = false;
				break;
			} else if (diff >= 0 && diff != maxDiff) {
				possible = false;
				break;
			}
		}
		if (possible) {
			printf("%d %d", mod, maxDiff);
		} else {
			printf("-1");
		}
		printf("\n");

	}
	return 0;
}