#include <bits/stdc++.h>

#define int long long

#define FOR(s, e) for(int i = s;i <= e;i++)
#define READ(v) for(int i = 0;i < v.size();i++) cin >> v[i];
#define PRINT(v) for(int i = 0;i < v.size();i++) cout << v[i] << ' ';
#define MREAD(v) for(int i = 0;i < v.size();i++) for(int j = 0;j < v[0].size();j++) cin >> v[i][j];
#define MPRINT(v) for(int i = 0;i < v.size();i++, cout << '\n') for(int j = 0;j < v[0].size();j++) cout << v[i][j] << ' ';

#define vii vector<vector<int>>
#define vi vector<int>
#define vb vector<bool>

#define pi pair<int, int>
#define x first
#define y second

#define pb push_back
#define eb emplace_back

using namespace std;

const int FACT_COUNT = 100;


int binpow(int a, int n, int MOD) {
    if(n == 0) return 1;
    if(n % 2 == 0) return binpow(a * a % MOD, n / 2, MOD);
    return a * binpow(a, n - 1, MOD) % MOD;
}

int binpow(int a, int n) {
    if(n == 0) return 1;
    if(n % 2 == 0) return binpow(a * a, n / 2);
    return a * binpow(a, n - 1);
}

int obr(int a, int MOD) {
    return binpow(a, MOD - 2, MOD);
}

int f[FACT_COUNT];

void init_fact() {
    f[0] = 1;
}

int fact(int n) {
    if(f[n] == 0) f[n] = fact(n - 1) * n;
    return f[n];
}

int fact(int n, int MOD) {
    if(f[n] == 0) f[n] = fact(n - 1) * n % MOD;
    return f[n];
}

int C(int n, int k) {
    return fact(n) / fact(k) / fact(n - k);
}

int C(int n, int k, int MOD) {
    return fact(n, MOD) * obr(fact(k, MOD), MOD) % MOD * obr(fact(n - k, MOD), MOD) % MOD;
}


void INITALL() {
    init_fact();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////SOL////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////

void solve() {
    int n;
    cin >> n;
    vi v(n);
    READ(v);

    int c = -1;
    int oc = 1;

    FOR(1, n - 1) {
        if(v[i - 1] > v[i]) {
            if(oc == 1) {
                oc = v[i] - v[i - 1];
            } else if(oc != v[i] - v[i - 1]) {
                cout << "-1\n";
                return;
            }
        }
        if(v[i - 1] <= v[i]) {
            if(c == -1) {
                c = v[i] - v[i - 1];
            } else if(c != v[i] - v[i - 1]) {
                cout << "-1\n";
                return;
            }
        }
    }

    if(oc == 1 || c == -1) {
        cout << "0\n";
        return;
    }

    FOR(0, n - 1) {
        if(v[i] >= c - oc) {
            cout << "-1\n";
            return;
        }
    }

    cout << c - oc << ' ' << c << '\n';
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    INITALL();

    int t;
    // t = 1;
    cin >> t;
    while(t--) solve();
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////