#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;

const ll N = 2e5;
const ll inf = 1e18;

ll gcd(ll a, ll b) {
	if (a > b) {
		swap(a, b);
	}
	if (a == 0) {
		return b;
	}
	return gcd(a, b % a);
}
ll A[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll t = 1;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		for (ll i = 0; i < n; i++) {
			cin >> A[i];
		}
		if (n <= 2) {
			cout << 0 << '\n';
			continue;
		}
		ll ans = 0;
		for (ll i = 0; i < n - 2; i++) {
			ans = gcd(ans, abs(A[i] + A[i + 2] - 2 * A[i + 1]));
		}
		ll ma = 0;
		for (ll i = 0; i < n; i++) {
			ma = max(A[i], ma);
		}
		if (ans == 0) {
			cout << 0 << '\n';
			continue;
		}
		if (ma >= ans) {
			cout << -1 << '\n';
			continue;
		}
		cout << ans << " " << (A[1] - A[0] + ans) % ans << '\n';
	}
}