#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

void solve() {
    set<int> cands_c;
    set<int> cands_dl;
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &t : a) {
        cin >> t;
    }
    for (int i = 0; i + 1 < n; i++) {
        if (a[i] == a[i + 1]) {
            if (*min_element(a.begin(), a.end()) == *max_element(a.begin(), a.end())) {
                cout << 0 << '\n';
                return;
            } else {
                cout << -1 << '\n';
                return;
            }
        }
        if (a[i] < a[i + 1]) {
            cands_c.insert(a[i + 1] - a[i]);
        } else {
            cands_dl.insert(a[i] - a[i + 1]);
        }
    }
    if (cands_dl.size() > 1 || cands_c.size() > 1) {
        cout << -1 << '\n';
        return;
    }
    if (cands_c.empty() || cands_dl.empty()) {
        cout << 0 << '\n';
        return;
    } else {
        int m = *cands_c.begin() + *cands_dl.begin();
        int c = *cands_c.begin();
        if (a[0] >= m) {
            cout << -1 << '\n';
            return;
        }
        int s = a[0];
        for (int i = 1; i < n; i++) {
            s = (s + c) % m;
            if (s != a[i]) {
                cout << -1 << '\n';
                return;
            }
        }
        cout << m << ' ' << c << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
