// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;

// #define cout fout
// ofstream fout("output.txt");


void solve() {
	// cout << "**************\n";



	int n;
	cin >> n;
	vector<int>v(n);
	for (auto &e : v) cin >> e;


	int c = -1;
	for (int i = 1; i < n; i++)
		if (v[i - 1] <= v[i])
			c = v[i] - v[i - 1];

	if (c == -1) {
		int k = v[0] - v[1];
		for (int i = 1; i < n; i++)
			if (v[i - 1] - v[i] != k) {
				cout << "-1\n";
				return;
			}
		cout << "0\n";
		return;
	}

	set<int>pos;
	int vmax = v[0];
	for (int i = 1; i < n; i++) {
		vmax = max(vmax, v[i]);


		if (v[i - 1] <= v[i]) {
			if (v[i] - v[i - 1] != c) {
				cout << "-1\n";
				return;
			}
		}
		else if (v[i - 1] > v[i]) {
			pos.insert(v[i - 1] + c - v[i]);
		}

	}


	if (pos.size() > 1 || (pos.size() == 1 && *pos.begin() <= vmax)) {
		cout << "-1\n";
		return;
	}

	if (pos.size() == 0) cout << "0\n";
	else cout << *pos.begin() << " " << c % (*pos.begin()) << "\n";


}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int tt = 1;
	cin >> tt;
	for (int t = 0; t < tt; t++)
		solve();


	return 0;
}
