#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define size(x) x.size()
#define all(x) x.begin(), x.end()

void solve()
{
	int n; cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (n < 3)
	{
		cout << "0\n"; return;
	}
	set<ll> dif; ll mmx = max(a[0], a[n - 1]);
	for (int i = 0; i < n - 1; ++i)
		dif.insert(a[i + 1] - a[i]), mmx = max(mmx, a[i]);
	if (size(dif) > 2)
	{
		cout << "-1\n"; return;
	}
	if (size(dif) == 1)
	{
		cout << "0\n"; return;
	}
	ll f = (*dif.begin());
	dif.erase(f);
	ll s = (*dif.begin());
	if (f >= 0)
		swap(f, s);
	if (f >= 0 || s <= 0)
	{
		cout << "-1\n"; return;
	}
	int m = s - f;
	int c = s;
	if (m > mmx)
		cout << m << ' ' << s << '\n';
	else
		cout << "-1\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while(t--)
		solve();
	//cin.get(); cin.get();
	return 0;
}