#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector <ll> create(ll n, ll m, ll s, ll c) {
  if (c >= m)
    return {};
  vector <ll> a(n);
  a[0] = s % m;
  for (ll i = 1; i < n; i++) {
    a[i] = a[i - 1] + c;
    while (a[i] >= m)
      a[i] -= m;
  }
  return a;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  ll t;
  cin >> t;
  while (t--) {
    ll n;
    cin >> n;
    vector <ll> a(n);
    for (ll i = 0; i < n; i++)
      cin >> a[i];
    bool allEqual = true;
    for (ll i = 0; i + 1 < n; i++)
      if (a[i] != a[i + 1])
        allEqual = false;
    if (allEqual) {
      cout << 0 << '\n';
      continue;
    }
    ll c = -1;
    for (ll i = 0; i + 1 < n; i++)
      if (a[i] < a[i + 1])
        c = a[i + 1] - a[i];
    if (c != -1) {
      bool higherAndHigher = true;
      for (ll i = 0; i + 1 < n; i++)
        if (a[i] >= a[i + 1])
          higherAndHigher = false;
      if (higherAndHigher) {
        bool answer = true;
        for (ll i = 0; i + 1 < n; i++)
          if (a[i] + c != a[i + 1])
            answer = false;
        if (answer) {
          cout << 0 << '\n';
        } else {
          cout << -1 << '\n';
        }
        continue;
      }
      ll id = -1;
      for (ll i = 0; i + 1 < n; i++)
        if (a[i] >= a[i + 1])
          id = i;
      ll m = a[id] - a[id + 1] + c;
      vector <ll> res = create(n, m, a[0], c);
      if (res != a) {
        cout << -1 << '\n';
      } else {
        cout << m << ' ' << c << '\n';
      }
      continue;
    }
    c = a[0] - a[1];
    bool flag = true;
    for (ll i = 1; i + 1 < n; i++)
      if (a[i] - a[i + 1] != c)
        flag = false;
    if (flag) {
      cout << 0 << '\n';
    } else {
      cout << -1 << '\n';
    }
  }
  return 0;
}
