#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <cmath>


using namespace std;
typedef long long ll;

const int INF = (int) 1e9 + 1;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T & i : v) {
        in >> i;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T & i : v) {
        out << i;
    }
    return out;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t, n;
    cin >> t;
    vector<int> a;
    while(t--) {
        cin >> n;
        a.resize(n);
        cin >> a;
        int c = -1;
        for (int i = 1; i < n; ++i) {
            if(a[i] >= a[i-1]) {
                if(c == -1)
                    c = a[i] - a[i-1];
                else if(c != a[i] - a[i-1]) {
                    c = -2;
                    break;
                }
            }
        }
        if(c == -2) {
            cout << "-1\n";
        } else if(c == -1) {
            int m = 0;
            for (int i = 1; i < n; ++i) {
                if(m == 0) {
                    m = a[i] - a[i-1];
                } else if(m != a[i] - a[i-1]) {
                    m = -1;
                    break;
                }
            }
            if(m == -1) {
                cout << "-1\n";
            } else
                cout << "0\n";
        } else if(c == 0) {
            for (int i = 1; i < n; ++i) {
                if(a[i] != a[0]) {
                    c = -1;
                    break;
                }
            }
            if(c == 0) {
                cout << "0\n";
            } else {
                cout << "-1\n";
            }
        } else {
            int m = 0, max = a[0];
            for (int i = 1; i < n; ++i) {
                if (a[i] < a[i - 1]) {
                    if (m == 0)
                        m = a[i - 1] + c - a[i];
                    else if (m != a[i - 1] + c - a[i]) {
                        m = -1;
                        break;
                    }
                }
            }
            for (int i = 0; i < n; ++i) {
                if(a[i] > max) {
                    max = a[i];
                }
            }
            if(m == 0) {
                cout << "0\n";
            } else if(m == -1 || m <= max || c >= m) {
                cout << "-1\n";
            } else {
                cout << m << " " << c << "\n";
            }
        }
    }


    return 0;
}