#pragma comment(linker, "/STACK:16777216")
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include<iostream>
#include<cmath>
#include<cstring>
#include<algorithm>
#include<string>
#include<vector>
#include<queue>
#include<deque>
#include<set>
#include<map>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pudge ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(13); cout << fixed

using namespace std;

using ll = long long;
const ll INF = 1e9;
const ll MOD = 1e9 + 7;
const double PI = atan2(0, -1);

bool bit(ll x, int i) {
    return (x >> i) & 1;
}
    
template<class T, class R> istream& operator>>(istream& in, pair<T, R>& p) {
    in >> p.first >> p.second;
    return in;
}

template<class T, class R> ostream& operator<<(ostream & out, pair<T, R> & p) {
    out << "{ " << p.first << ", " << p.second << " }";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& a) {
    inl(x, a) {
        in >> x;
    }
    return in;
}

template<class T> ostream& operator<<(ostream& out, vector<T>& a) {
    if (!a.empty()) {
        rep(i, a.size() - 1) {
            out << a[i] << " ";
        }
        out << a.back();
    }
    return out;
}

template<class T> void print(vector<T>& a, string sep=" ", string end = "\n") {
    if (!a.empty()) {
        rep(i, a.size() - 1) {
            cout << a[i] << sep;
        }
        cout << a.back() << end;
    }
}

int main() {
    pudge;
    int t;
    cin >> t;
    rep(_, t) {
        int n;
        cin >> n;
        vector<int> a(n);
        cin >> a;
        int cp = -INF, cm = INF, m = -INF;
        bool f = 0;
        rep(i, n - 2) {
            if (a[i + 2] - a[i + 1] != a[i + 1] - a[i]) {
                f = 1;
                break;
            }
        }
        if (!f) {
            cout << "0\n";
            continue;
        }
        f = 0;
        rep(i, n - 1) {
            if (a[i + 1] > a[i]) {
                if (cp == -INF) {
                    cp = a[i + 1] - a[i];
                }
                if (cp != a[i + 1] - a[i]) {
                    f = 1;
                    break;
                }
            }
            if (a[i + 1] < a[i]) {
                if (cm == INF) {
                    cm = a[i] - a[i + 1];
                }
                if (cm != a[i] - a[i + 1]) {
                    f = 1;
                    break;
                }
            }
            if (a[i + 1] == a[i]) {
                if (cp == -INF) {
                    cp = 0;
                }
                if (cm == INF) {
                    cm = 0;
                }
                if (cp != 0) {
                    f = 1;
                    break;
                }
                if (cm != 0) {
                    f = 1;
                    break;
                }
            }
        }
        if (f) {
            cout << "-1\n";
            continue;
        }
        m = cp + cm;
        f = 0;
        in(x, a) {
            if (x >= m) {
                f = 1;
                break;
            }
        }
        if (f) {
            cout << "-1\n";
        }
        else {
            cout << m << " " << cp << "\n";
        }
    }
}