#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> arr(n);
        for (auto &x : arr) {
            cin >> x;
        }
        vector<int> diff(n - 1);
        for (int i = 0; i < n - 1; i++) {
            diff[i] = arr[i + 1] - arr[i];
        }
        sort(diff.begin(), diff.end());
        diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
        if (diff.size() > 2) {
            cout << -1 << '\n';
        } else if (diff.size() < 2) {
            cout << 0 << '\n';
        } else {
            int m = diff[1] - diff[0], c = diff[1];
            vector<int> b(n);
            b[0] = arr[0] % m;
            for (int i = 0; i + 1 < n; i++) {
                b[i + 1] = (b[i] + c) % m;
            }
            if (b == arr) {
                cout << m << ' ' << c << '\n';
            } else {
                cout << -1 << '\n';
            }
        }
    }
    return 0;
}
