#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <ctime>
#include <climits>

using namespace std;

#pragma warning (disable : 4996)

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    set<int> tmp;
    for (int& i : v)
        cin >> i, tmp.insert(i);
    if (tmp.size() == 1) {
        cout << 0;
        return;
    }
    set<int> d1, d2;
    for (int i = 1; i < n; i++) {
        if (v[i] - v[i - 1] == 0) {
            cout << -1;
            return;
        }
        if (v[i] - v[i - 1] > 0)
            d1.insert(v[i] - v[i - 1]);
        else
            d2.insert(v[i] - v[i - 1]);
    }
    if (d1.size() > 1 || d2.size() > 1) {
        cout << -1;
        return;
    }
    if (d2.size() == 0 || d1.size() == 0) {
        cout << 0;
        return;
    }
    if (*d1.begin() + abs(*d2.begin()) <= *max_element(v.begin(), v.end())) {
        cout << -1;
        return;
    }
    cout << *d1.begin() + abs(*d2.begin()) << " " << *d1.begin();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}