#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define int long long

void solveOne() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> deltas;
    for (int i = 0; i < n - 1; i++) {
        deltas.push_back(a[i + 1] - a[i]);
    }
    sort(deltas.begin(), deltas.end());
    deltas.resize(unique(deltas.begin(), deltas.end()) - deltas.begin());
    if (deltas.size() > 2) {
        cout << -1 << endl;
    }
    if (deltas.size() == 2) {
        int x = min(deltas[0], deltas[1]);
        int y = max(deltas[0], deltas[1]);
        int m = y - x;
        int c = y;
        if (a[0] >= m) {
            cout << -1 << endl;
            return;
        }
        for (int i = 0; i < n - 1; i++) {
            if ((a[i] + c + 2 * m) % m != a[i + 1]) {
                cout << -1 << endl;
                return;
            }
        }
        cout << m << ' ' << c << endl;
    }
    if (deltas.size() == 1) {
        int x = deltas[0];
        if (x >= 0) {
            cout << 0 << endl;
            return;
        }
        if (x < 0) {
            if (a[n - 2] < x) {
                cout << -1 << endl;
            } else {
                cout << 0 << endl;
            }
        }
    }
    if (deltas.size() == 0) {
        cout << 0 << endl;
    }
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solveOne();
    }
}
