#include <bits/stdc++.h>
using namespace std;

typedef long long ll;


void solve() {
  int n;
  cin >> n;
  vector<ll> a(n);
  vector<ll> delpl, delmi;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  if (n == 1) {
    cout << "0\n";
    return;
  }
  for (int i = 1; i < n; ++i) {
    if (a[i] > a[i - 1])
      delpl.push_back(a[i] - a[i - 1]);
    else
      delmi.push_back(a[i] - a[i - 1]);
  }
  sort(delpl.begin(), delpl.end());
  sort(delmi.begin(), delmi.end());
  if (!delpl.empty()) {
    if (delpl[0] != delpl.back()) {
      cout << "-1\n";
      return;
    }
    if (delmi.empty()) {
      cout << "0\n";
      return;
    }
    if (delmi[0] != delmi.back()) {
      cout << "-1\n";
      return;
    }
    ll C = delpl[0];
    ll M = abs(delmi[0]) + C;
    for (int i = 0; i < n - 1; ++i) {
      if (a[i] >= M || a[i + 1] != (a[i] + C) % M || C >= M) {
        cout << "-1\n";
        return;
      }
    }
    assert(C < M);
    cout << M << ' ' << C << '\n';
  } else {
    if (delmi[0] != delmi.back()) {
      cout << "-1\n";
      return;
    }
    cout << "0\n";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t;
  cin >> t;
  while (t--) {
    solve();
  }
}