#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
template<typename T> void mdebug_out(T* a, int n) { for (int i = 0; i < n; ++i) cerr << a[i] << ' '; cerr << endl; }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a) { for (auto &x : a) stream << x << ' '; return stream; }
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2> &p) { return stream << p.first << ' ' << p.second; }

int gcd(int a, int b)
{
    if (!a) return b;
    if (!b) return a;
    return __gcd(a, b);
}

int md(int a, int m)
{
    a %= m;
    if (a < 0)
        a += m;
    return a;
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int tests;
    cin >> tests;
    while (tests--)
    {
        int n;
        cin >> n;
        vector<int> a(n);
        for (auto &x : a) cin >> x;
        if (n == 1)
        {
            cout << "0\n";
            continue;
        }
        set<int> S;
        for (int i = 0; i + 1 < n; ++i)
            S.insert(a[i + 1] - a[i]);
        if (S.size() == 1)
        {
            cout << "0\n";
            continue;
        }
        int mn = *max_element(all(a)) + 1;
        vector<int> b;
        for (auto s : S)
            b.push_back(s);
        int g = 0;
        for (int i = 1; i < b.size(); ++i)
        {
            g = gcd(g, labs(b[i] - b[0]));
        }
        if (g < mn)
        {
            cout << "-1\n";
        }
        else
        {
            cout << g << ' ' << md(a[1] - a[0], g) << '\n';
        }
    }

    return 0;
}