#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int> a(n);
		for (auto& i : a) cin >> i;

		set<int> del;
		for (int i = 1; i < n; ++i)
			del.insert(a[i] - a[i - 1]);

		if (del.size() <= 1) cout << 0 << '\n';
		else if (del.size() > 2) cout << -1 << '\n';
		else if (*del.begin() > 0 || *del.rbegin() < 0) cout << -1 << '\n';
		else {
			int m = abs(*del.begin()) + *del.rbegin();
			if (*max_element(a.begin(), a.end()) >= m) {
				cout << -1 << '\n';
				continue;
			}

			cout << m << ' ' << *del.rbegin() << '\n';
		}
	}
}