#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>
using namespace std;

#define endl '\n'

struct x
{
    int pos;
    vector<int> friends;

    bool operator < (x a) const
    {
        if (friends.size() < a.friends.size())
        {
            return true;
        }
        return false;
    }
};

void task()
{
    int n, m;
    cin >> n >> m;

    vector<int> count(n, 0);
    vector<x> days(m);

    for (int i = 0; i < m; i++)
    {
        days[i].pos = i;

        int k;
        cin >> k;

        for (int j = 0; j < k; j++)
        {
            int a;
            cin >> a;
            a--;

            days[i].friends.push_back(a);
        }
    }

    sort(days.begin(), days.end());

    vector <int> ans(m);

    for (int i = 0; i < m; i++)
    {
        int pos = 0;

        for (int j = 1; j < days[i].friends.size(); j++)
        {
            if (count[days[i].friends[pos]] > count[days[i].friends[j]])
            {
                pos = j;
            }
        }

        count[days[i].friends[pos]]++;
        ans[days[i].pos] = days[i].friends[pos];
    }

    int max = (m + 1) / 2;

    for (int i = 0; i < n; i++)
    {
        if (count[i] > max)
        {
            cout << "NO" << endl;
            return;
        }
    }

    cout << "YES" << endl;

    for (int i = 0; i < m; i++)
    {
        cout << ans[i] + 1 << ' ';
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
    long long t;
    cin >> t;
    while (t--)
    {
        task();
    }
    return 0;
}

