#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;
int main()
{
	int t;
	cin >> t;
	while (t)
	{
		--t;
		int n, m;
		cin >> n >> m;
		int limit = m / 2 + m % 2;
		vector<int> cnt(n);
		vector<vector<int>> friends(m);
		vector<int> ans(m); 
		for (int i = 0; i < m; ++i)
		{
			int k;
			cin >> k;
			vector<int> f(k); 
			for (int i = 0; i < k; ++i)
				cin >> f[i];
			if (k == 1)
			{
				cnt[f[0] - 1]++;
				ans[i] = f[0];
			}
			else
				for (auto x : f)
					friends[i].push_back(x - 1);
		}
		for (int i = 0; i < m; ++i)
		{
			if (!friends[i].size()) continue;
			int best = -1;
			for (auto x : friends[i])
				if (best == -1 || cnt[best] > cnt[x])
					best = x;
			ans[i] = best + 1;
			++cnt[best]; 
		}

		bool check = true;
		for(auto x: cnt)
			if (x > limit)
			{
				cout << "NO\n";
				check = false;
				break;
			}

		if (check)
		{
			cout << "YES\n";
			for (auto x : ans)
				cout << x << " ";
			cout << endl;

		}
	}
	return 0;
}