#ifdef MANSON
#define BUGO(x) cerr << #x << "->" << (x) << endl;
#define BUGOARR(a) {cerr << #a << "->{ "; for (auto i: a) cerr << i << ' '; cerr << "}" << endl;}
#else
#define BUGO(x) ;
#define BUGOARR(a) {}
#endif
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <set>
using namespace std;
using llong = long long;
ostream& operator<<(ostream& out, const pair<int, int>& p) {
    return out << '{' << p.first << ", " << p.second << '}';
}

vector<int> a[100'000];
int cnt[100'000];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        int m, n;
        cin >> m >> n;
        int bnd = (n + 1) / 2;
        static vector<int> ans; ans.resize(n);
        fill(ans.begin(), ans.end(), -1);
        bool ujs = false;
        for (int i = 0; i < n; ++i)
        {
            int k;
            cin >> k;
            a[i].resize(k);
            for (int& j: a[i]) cin >> j, --j;
            if (k == 1)
                if (++cnt[ans[i] = a[i][0]] > bnd)
                    ujs = true;
        }
        for (int i = 0; i < n; ++i)
            if (a[i].size() > 1) {
                if (cnt[a[i][1]] < cnt[a[i][0]])
                    swap(a[i][0], a[i][1]);
                ++cnt[ans[i] = a[i][0]];
            }
        for (int i = 0; i < n; ++i)
            for (int j: a[i])
                cnt[j] = 0;
        if (ujs) cout << "NO\n";
        else {
            cout << "YES\n";
            for (int i: ans) cout << i + 1 << ' ';
            cout << '\n';
        }
    }
}
