#include <bits/extc++.h>

using namespace std;

//#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) int((a).size())
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd(2342309423);

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio();
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}

void Solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<vector<int>, int>> days(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        auto &day = days[i];
        day.second = i;
        day.first.resize(k);
        for (auto &j : day.first)
            cin >> j;
    }
    sort(all(days), [](const pair<vi, int> &a, const pair<vi, int> &b) {
        return sz(a.first) < sz(b.first);
    });
    int b = (m + 1) / 2;
    vi cnt(n + 1);
    vi ans(m);
    for (auto&[day, id] : days) {
        bool take = false;
        for (auto& guy : day) {
            if (cnt[guy] == b)
                continue;
            cnt[guy]++;
            ans[id] = guy;
            take = true;
            break;
        }
        if (!take) {
            cout << "NO" << nl;
            return;
        }
    }
    cout << "YES" << nl;
    for (auto& i : ans) {
        cout << i << ' ';
    }
    cout << nl;
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; i++) {
        Solve();
    }
    return 0;
}
