#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define out(x); { for (auto &i : x) cout << i << ' '; cout << endl; }

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;

void compress(vector <long long> &v) {
    vector <long long> u = v;
    sort(u.begin(), u.end());
    u.resize(unique(u.begin(), u.end()) - u.begin());
    for (long long &i : v)
        i = lower_bound(u.begin(), u.end(), i) - u.begin();
}

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 2e9;
const long long INFll = 2e18;
const long long mod = 1e9 + 7;
const int base1 = 239;
const int base2 = 653;
const long double eps = 1e-4;
const long double pi = acos(-1);
const int N = 2e5;

vector <int> g[N];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        g[i].clear();
    }
    for (int i = 1; i <= m; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int x; cin >> x;
            g[i].pb(x);
        }
    }
    vi cnt(n + 1), ans(m + 1);
    for (int i = 1; i <= m; i++) {
        if (g[i].size() == 0) {
            cout << "NO\n"; return;
        }
        if (g[i].size() == 1) {
            ans[i] = g[i][0];
            cnt[g[i][0]]++;
        }
    }
    for (int i = 1; i <= m; i++) {
        if (g[i].size() < 2) continue;
        int c = g[i][0];
        for (int j : g[i]) {
            if (cnt[j] < cnt[c])
                c = j;
        }
        ans[i] = c;
        cnt[c]++;
    }

    if (*max_element(all(cnt)) > (m + 1) / 2) {
        cout << "NO\n"; return;
    }

    cout << "YES\n";
    for (int i = 1; i <= m; i++)
        cout << ans[i] << ' ';
    cout << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
