#ifdef _LOCAL_MSVC
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")*/

using namespace std;
using ll = long long;
using ld = long double;

void solve() {
	int n, m;
	cin >> n >> m;
	
	vector<vector<int>> f(m);
	for (int i = 0; i < m; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			cin >> x;
			f[i].push_back(x - 1);
		}
	}

	vector<int> conn(n), ord(m);
	iota(all(ord), 0);
	sort(all(ord), [&f](const int &i, const int &j) { return f[i].size() < f[j].size(); });
	vector<int> ans(m);
	for (int i : ord) {
		int ind = -1;
		for (int to : f[i])
			if (ind == -1 || conn[to] < conn[ind])
				ind = to;

		++conn[ind];
		ans[i] = ind;
	}

	if (*max_element(all(conn)) <= (m + 1) / 2) {
		cout << "YES\n";
		for (int i = 0; i < m; ++i)
			cout << ans[i] + 1 << ' ';
		cout << '\n';
	} else {
		cout << "NO\n";
	}
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	if (argc > 1)
		freopen(argv[1], "r", stdin);
	if (argc > 2)
		freopen(argv[2], "w", stdout);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}