#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <queue>

using namespace std;

void resolve()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> v(m);
	vector<int> ans(m, -1);
	vector<int> k(n + 1);
	for (int i = 0; i < m; i++)
	{
		int q;
		cin >> q;
		v[i].resize(q);
		for (int j = 0; j < q; j++)
			cin >> v[i][j];
		if (q == 1)
			ans[i] = v[i][0], k[v[i][0]]++;
	}
	for (int i = 1; i <= n; i++)
		if (k[i] > m / 2 + (m % 2 > 0))
		{
			cout << "NO";
			return;
		}
	for (int i = 0; i < m; i++)
	{
		if (ans[i] != -1)
			continue;
		for (int num : v[i])
			if (k[num] < m / 2 + (m % 2 > 0))
			{
				ans[i] = num;
				k[num]++;
				break;
			}
	}
	cout << "YES\n";
	for (int e : ans)
		cout << e << ' ';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		resolve();
		cout << '\n';
	}
}