#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <cmath>
#include <time.h>
#include <random>
#include <chrono>
#include <cassert>
#include <limits>

using namespace std;

#define int long long 
#define pb push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define ld long double

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) out << k << " ";
	return out;
}

ostream& operator<< (ostream& out, const pii& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else 
	#define dbg(x) 
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> have(m);
	vector<int> sz(m);
	vector<int> cnt(n + 1, 0);
	vector<int> ans(m, -1);
	for (int i = 0; i < m; i++) {
		cin >> sz[i];
		have[i].resize(sz[i]);
		for (int j = 0; j < sz[i]; j++) {
			cin >> have[i][j];
		}
		if (sz[i] == 1) {
			cnt[have[i][0]]++;
			ans[i] = have[i][0];
		}
	}
	for (int i = 0; i < m; i++) {
		if (sz[i] > 1) {
			if (cnt[have[i][0]] < cnt[have[i][1]]) {
				cnt[have[i][0]]++;
				ans[i] = have[i][0];
			} else {
				cnt[have[i][1]]++;
				ans[i] = have[i][1];
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		if (cnt[i] > (m + 1) / 2) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n" << ans << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    int q = 1;
    cin >> q;
    while (q--) {
    	solve();
    }
}
/*

*/