#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int main(){
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    int mx = (m + 1) / 2;
    vector<int> cnt(n);
    vector<vector<int>> kek(m);
    vector<int> ans(m);
    for (int i = 0; i < m; ++i) {
      int k;
      cin >> k;
      kek[i].resize(k);
      for (int j = 0; j < k; ++j) {
        cin >> kek[i][j];
        --kek[i][j];
      }
      ++cnt[kek[i][0]];
      ans[i] = kek[i][0];
    }
    int id = 0;
    for (int i = 1; i < n; ++i) {
      if (cnt[i] > cnt[id])
        id = i;
    }
    if (cnt[id] <= mx) {
      cout << "YES\n";
      for (int x : ans)
        cout << x + 1 << ' ';
      cout << '\n';
      continue;
    }
    int need = cnt[id] - mx;
    for (int i = 0; i < m && need; ++i) {
      if (kek[i][0] == id && kek[i].size() >= 2) {
        ans[i] = kek[i][1];
        --need;
      }
    }
    if (need) {
      cout << "NO\n";
    } else {
      cout << "YES\n";
      for (int x : ans)
        cout << x + 1 << ' ';
      cout << '\n';
    }
  }
  return 0;
}
