#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <map>
#include <cstdio>
#include <queue>
using namespace std;
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define pb push_back
#define forn(i, e, n) for(int i = e; i < int(n); i++)
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pt;
typedef long double ld;
typedef pair<ll, ll> pll;
const int INF = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 1e5 + 100;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(m);
	vector<int> ost(n, 0);
	vector<vector<int>> day(n);
	forn(i, 0, m) {
		int cnt;
		cin >> cnt;
		forn(j, 0, cnt) {
			int x;
			cin >> x;
			x--;
			a[i].push_back(x);
			ost[x]++;
			day[x].push_back(i);
		}
	}
	vector<int> cnt(n, 0);
	vector<int> ans(m, -1);
	forn(i, 0, n) {
		if (sz(day[i]) > (m + 1) / 2) continue;
		forn(j, 0, sz(day[i])) {
			int id = day[i][j];
			if (ans[id] == -1)
				ans[id] = i;
		}
	}
	forn(i, 0, m) {
		if (ans[i] != -1) continue;
		int id = -1;
		int best = INF;
		forn(j, 0, sz(a[i])) {
			int x = a[i][j];
			if (cnt[x] < (m + 1) / 2 && ost[x] + cnt[x] < best) {
				best = ost[x] + cnt[x];
				id = x;
			}
		}
		if (id == -1) {
			cout << "NO" << '\n';
			return;
		}
		cnt[id]++;
		ans[i] = id;
		forn(j, 0, sz(a[i])) {
			int x = a[i][j];
			ost[x]--;
		}
	}
	bool fl = 1;
	forn(i, 0, n) {
		if (cnt[i] > (m + 1) / 2)
			fl = 0;
	}
	if (fl == 0) {
		cout << "NO" << '\n';
		return;
	}
	cout << "YES" << '\n';
	forn(i, 0, m)
		cout << ans[i] + 1 << ' ';
	cout << '\n';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _DEBUG
	int t;
	cin >> t;
	forn(i, 0, t)
		solve();
	return 0;
}