import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int t = nextInt();
//        int t = 1;
        for (int qq = 0; qq < t; qq++) {
            int n = nextInt();
            int m = nextInt();
            int[] cost = new int[n];
            int max = (m + 1) / 2;
            boolean ch = true;
            int[] ans = new int[m];
            Dipl[] a = new Dipl[m];
            for (int i = 0; i < m; i++) {
                int c = nextInt();
                a[i] = new Dipl(new int[c], i, c);
                for (int j = 0; j < c; j++) {
                    a[i].array[j] = nextInt() - 1;
                }
            }
            Arrays.sort(a, new DiplComp());
            for (int i = 0; i < m; i++) {
                int min = Integer.MAX_VALUE;
                int ind = 0;
                for (int j = 0; j < a[i].len; j++) {
                    if (cost[a[i].array[j]] < min) {
                        min = cost[a[i].array[j]];
                        ind = a[i].array[j];
                    }
                }
                ans[a[i].ind] = ind + 1;
                cost[ind]++;
                if (cost[ind] > max){
                    ch = false;
                    break;
                }
            }
            if (ch){
                pw.print("YES");
                pw.println();
                for (int i: ans) {
                    pw.print(i + " ");
                }
                pw.println();
            }else{
                pw.println("NO");
            }
        }
        pw.close();
    }

    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader br;
    static PrintWriter pw;

    static String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    static double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    static long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}

class Dipl {
    int[] array;
    int ind, len;

    public Dipl(int[] array, int ind, int len) {
        this.array = array;
        this.ind = ind;
        this.len = len;
    }
}

class DiplComp implements Comparator<Dipl> {

    @Override
    public int compare(Dipl o1, Dipl o2) {
        if (o1.len == o2.len) return Integer.compare(o1.ind, o2.ind);
        return Integer.compare(o1.len, o2.len);
    }
}