#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <deque>

#define ll long long int
#define F first
#define S second
#define MP make_pair

using namespace std;

bool prov(pair < ll, set <ll>> a, pair<ll,set <ll>> b) {
	return a.second.size() < b.second.size();
}



int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll _;
	cin >> _;
	while (_--) {
		ll n, m;
		cin >> n >> m;
		vector <pair<ll, set<ll>>> a(m);
		vector <ll> k(n + 1), now(n + 1);
		vector <ll> res(m);

		for (int i = 0; i < m; ++i) {
			ll l;
			cin >> l;

			set <ll> d;
			for (int j = 0; j < l; ++j) {
				ll q;
				cin >> q;
				d.insert(q);
			}
			a[i] = { i, d };

		}

		sort(a.begin(), a.end(), prov);

		for (int i = 0; i < m; ++i) {
			for (auto j : a[i].second) {
				if (now[j] < (m + 1) / 2) {
					res[a[i].first] = j;
					++now[j];
					break;
				}
			}
		}
		bool prover = true;
		for (int i = 0; i < m; ++i) prover = prover && res[i] != 0;
		if (prover) {
			cout << "YES\n";
			for (auto i : res) cout << i << " ";
			cout << "\n";
		}
		else cout << "NO\n";
	}
	return 0;
}

