#include <iostream>
#include <fstream>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <ctime>
#include <chrono>
#include <algorithm>

#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define fill(v, n) for(int i = 0;i<n;i++)cin>>v[i];
#define sqr(x) (x)*(x)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

vector<vector<int>> friends;

bool comp(int a, int b) {
	return friends[a].size() < friends[b].size();
}

int main() {
	fast;
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		friends.clear();
		friends.resize(m);
		vector<int> order(m), ans(m);
		vector<int> times(n);
		for (int i = 0; i < m; i++) {
			int s;
			cin >> s;
			friends[i].resize(s);
			for (int j = 0; j < s; j++) {
				cin >> friends[i][j];
				friends[i][j]--;
			}
			order[i] = i;
		}
		sort(order.begin(), order.end(), comp);
		for (int i = 0; i < m; i++) {
			int pos = order[i];
			if (friends[pos].size() == 1) {
				times[friends[pos][0]]++;
				ans[pos] = friends[pos][0];
			}
			else {
				int a = friends[pos][0], b = friends[pos][1];
				if (times[a] < times[b]) {
					times[a]++;
					ans[pos] = a;
				}
				else{
				times[b]++;
				ans[pos] = b;
				}
			}
		}
		bool flag = 1;
		for (int i = 0; i < n; i++)
			if (times[i] > (m + 1) / 2)
				flag = 0;
		if (!flag) {
			cout << "NO\n";
			continue;
		}
		cout << "YES\n";
		for (int i = 0; i < m; i++)
			cout << ans[i] + 1 << " ";
		cout << "\n";
	}
}