#include <iostream>
#include <vector>
#include <string.h>
#include <algorithm>

typedef long long ll;
using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;
	int md = (m+1) / 2;
	vector<int> cnt(n);
	vector<vector<int> > g(m);
	vector<int> bfr;
	for(int i = 0; i < m; ++i) 
	{
		int k;
		cin >> k;
		g[i].resize(k);
		for(int j = 0; j < k; ++j) {
			cin >> g[i][j], --g[i][j];
			cnt[g[i][j]]++;
			if (cnt[g[i][j]] == m/2)
			bfr.push_back(g[i][j]);
		}
	}
	if(bfr.empty()) 
	{
		cout << "YES\n";
		for(int i = 0; i < m; ++i) 
		{
			cout << g[i][0] + 1 << ' ';
		}
		cout << '\n';
		return;
	}
	for(int t : bfr) 
	{
		vector<int> res(m);
		int has = 0;
		for(int i = 0; i < m; ++i) 
		{
			if(g[i].size() == 1 && g[i][0] == t)
				++has, res[i] = t;
		}
		if(has <= md) 
		{
			for(int i = 0; i < m; ++i) {
				res[i] = g[i][0];
				if(g[i].size() == 1) continue;
				for(int tt : g[i]) 
				{
					if(has < md && tt == t) {
						++has, res[i] = tt;
						break;
					} else if(has == md && tt != t) 
					{
						res[i] = tt;
						break;
					}
				}
			}
			cout << "YES\n";
			for (int i = 0; i < m; ++i)
			{
				cout << res[i] + 1 << ' ';
			}
			cout << '\n';
			return;
		}
	}
	cout << "NO\n";

}

int main() {
	int t;
	cin >> t;
	while(t--) {
		solve();
	}
	//system("pause");
}