#include <bits/stdc++.h>

using namespace std;

clock_t StartTime;

typedef long long ll;

const int N = 5e5 + 3e2;
const int M = 555;

#define all(x) (x).begin(), (x).end()

vector<int> v[N];
int sz[N];

int cnt[N];
int ans[N];

void solve(){
    int n, m;
    cin >> n >> m;

    vector<int> perm;

    for (int i = 1; i <= m; i++){
        v[i].clear();
        cin >> sz[i];
        for (int j = 0; j < sz[i]; j++){
            int x;
            cin >> x;
            v[i].push_back(x);
        }
        perm.push_back(i);
    }

    sort(all(perm), [](int i, int j){
        return sz[i] < sz[j];
    });

    fill(cnt + 1, cnt + n + 1, 0);

    for (int i : perm){
        int k = v[i].front();
        for (int x : v[i]){
            if (cnt[x] < cnt[k]) k = x;
        }
        cnt[k]++;
        ans[i] = k;
    }

    if (*max_element(cnt + 1, cnt + n + 1) <= (m + 1) / 2){
        cout << "YES\n";
        for (int i = 1; i <= m; i++) cout << ans[i] << ' ';
        cout << endl;
    } else cout << "NO\n";

}

int main() {
    StartTime = clock();

    ios_base::sync_with_stdio(false);

#ifdef dxz05
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int TC = 1;
    cin >> TC;

    while (TC--){
        solve();
    }

#ifdef dxz05
    cerr << endl << 1000.0 * (clock() - StartTime) / CLOCKS_PER_SEC << " ms";
#endif

    return 0;
}
