#include <iostream>
#include <vector>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <unordered_set>
#define int long long
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()

using namespace std;

const int INF = 1e9;
const int MOD = 1e9 + 7;
const int LOG = 21;

typedef pair <int, int> pii;

void fast()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}


signed main()
{
    fast();
    int t;
    cin >> t;
    while (t--)
    {
        int n, m;
        cin >> n >> m;
        vector <tuple <int, vector <int>, int>> a(m);
        for (int i = 0; i < m; ++i)
        {
            cin >> get<0>(a[i]);
            get<2>(a[i]) = i;
            for (int j = 0; j < get<0>(a[i]); ++j)
            {
                int x;
                cin >> x;
                get<1>(a[i]).push_back(x);
            }
        }

        sort(all(a));
        vector <int> left(n, (m + 1) / 2);
        vector <int> cnt(n, 0);
        vector <int> ans(m);
        for (int i = 0; i < m; ++i)
        {
            for (auto & e : get<1>(a[i]))
            {
                ++cnt[e - 1];
            }
        }

        bool pos = 1;
        for (int i = 0; i < m; ++i)
        {
            int best = -1;
            for (int j = 0; j < get<0>(a[i]); ++j)
            {
                int k = get<1>(a[i])[j] - 1;
                if (left[k] > 0)
                {
                    if (best == -1 || cnt[k] < cnt[best])
                    {
                        best = k;
                    }
                }
            }

            if (best == -1)
            {
                pos = 0;
                break;
            }

            for (int j = 0; j < get<0>(a[i]); ++j)
            {
                --cnt[get<1>(a[i])[j] - 1];
            }

            ans[get<2>(a[i])] = best + 1;
            --left[best];
        }

        if (pos)
        {
            cout << "YES\n";
            for (int & e : ans)
                cout << e << " ";
            cout << '\n';
        }
        else
        {
            cout << "NO\n";
        }
    }
    return 0;
}