#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;

const ll N = 2e5;
const ll inf = 1e18;

ll gcd(ll a, ll b) {
	if (a > b) {
		swap(a, b);
	}
	if (a == 0) {
		return b;
	}
	return gcd(a, b % a);
}
ll kol[N];
vector <ll> drug[N];
ll ans[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll t = 1;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		for (ll i = 1; i <=n; i++) {
			kol[i] = 0;
		}
		for (ll i = 0; i < m; i++) {
			ll sz; cin >> sz;
			drug[i].clear();
			for (ll j = 0; j < sz; j++) {
				ll x; cin >> x;
				drug[i].push_back(x);
			}
			if (sz == 1) {
				kol[drug[i][0]]++;
				ans[i] = drug[i][0];
			}
		}
		for (ll i = 0; i < m; i++) {
			ll sz = drug[i].size();
			if (sz == 1) {
				continue;
			}
			ll mi = inf, h;
			for (ll j = 0; j < sz; j++) {
				if (mi > kol[drug[i][j]]) {
					h = drug[i][j];
					mi = kol[drug[i][j]];
				}
			}
			ans[i] = h;
			kol[h]++;
		}
		bool f = 0;
		for (ll i = 1; i <= n; i++) {
			if (kol[i] > (m + 1) / 2) {
				cout << "NO" << '\n';
				f = 1;
				break;
			}
		}
		if (f) {
			continue;
		}
		cout << "YES\n";
		for (ll i = 0; i < m; i++) {
			cout << ans[i] << " ";
		}
		cout << '\n';
	}
}