#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    int mx = (m + 1) / 2;
    vector<int> cnt(n);
    vector<vector<int>> c(m);
    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        c[i].resize(k);
        for (auto &t : c[i]) {
            cin >> t;
            t--;
        }
    }
    vector<int> ans(m, -1);
    for (int i = 0; i < m; i++) {
        if (c[i].size() == 1) {
            cnt[c[i].front()]++;
            ans[i] = c[i].front();
        }
    }
    for (int i = 0; i < m; i++) {
        if (c[i].size() > 1) {
            for (auto j : c[i]) {
                if (ans[i] == -1 && cnt[j] + 1 <= mx) {
                    ans[i] = j;
                    cnt[j]++;
                }
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (ans[i] == -1) {
            cout << "NO\n";
            return;
        }
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] > mx) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (auto t : ans) {
        cout << t + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> q;
    while (q--) {
        solve();
    }
}
