#include <algorithm>
#include <iostream>
#include <math.h>
#include <vector>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define ld long double
#define int ll

//#define x first
//#define y second

#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define vs vector<string>
#define pipii pair<int, pii>
#define piipi pair<pii, int>

const int inf = 1e9;
const ll INF = 1e18;
const ld PI = 3.1415926535;
const int N = 1e5;
const ll M = 1e9 + 7; //92359417

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

vi cnt, ans;
bool cmp(pair<int, vi>& a, pair<int, vi>& b) {
    return a.second.size() < b.second.size();
}
bool cmp2(int i, int j) {
    return cnt[i] < cnt[j];
}
void solve() {
    int n, m; cin >> n >> m;
    cnt = vi(n);
    ans = vi(m);
    vector<pair<int, vector<int>>> a(m);
    for (int i = 0; i < m; ++i) {
        int k; cin >> k;
        a[i].second.resize(k);
        a[i].first = i;
        for (int j = 0; j < k; ++j) {
            int x; cin >> x;
            a[i].second[j] = --x;
        }
    }
    sort(a.begin(), a.end(), cmp);
    for (int i = 0; i < m; ++i) {
        sort(a[i].second.begin(), a[i].second.end(), cmp2);
        ans[a[i].first] = (a[i].second[0] + 1);
        ++cnt[a[i].second[0]];
        if (cnt[a[i].second[0]] > (m + 1) / 2) {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    for (auto a : ans) cout << a << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}