#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define real long double
#define f first
#define s second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pi M_PI
#define elif else if
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;


const int INF = 2e18, MOD = 1e9 + 7, RANDOM = chrono::steady_clock::now().time_since_epoch().count();
const real EPS = 1e-12;
mt19937 rng(RANDOM);
struct chash {

    int operator() (int x) const { return (x ^ RANDOM) % MOD; }
};


int n, m, d;
vector<vector<int>> days;
vector<int> answer;
vector<int> cnt;


bool search(){
	for (int i=0; i<m; ++i){
		if (days[i].size() == 1){
			++cnt[days[i][0]];
			answer[i] = days[i][0];
		}
	}
	for (int i=0; i<n; ++i) if (cnt[i] > d) return false;
	for (int i=0; i<m; ++i){
		if (days[i].size() > 1){
			int t = days[i].size();
			for (int j=0; j<t; ++j){
				if (cnt[days[i][j]] <= d){
					++cnt[days[i][j]];
					answer[i] = days[i][j];
					break;
				}
			}
		}
	}
	for (int i=0; i<n; ++i){
		if (cnt[i] > d){
			for (int j=0; j<m; ++j){
				if (days[j].size() == 1 or answer[j] != i) continue;
				int t = days[j].size();
				bool fl = false;
				for (int g=0; g<t; ++g){
					if (days[j][g] == i) continue;
					--cnt[i];
					++cnt[days[j][g]];
					answer[j] = days[j][g];
					fl = true;
					break;
				}
				if (fl) break;
			}
		}
	}
	for (int i=0; i<n; ++i) if (cnt[i] > d) return false;
	return true;
}


void debug(){
    cerr << "\n";

    cerr << "\n";
}


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while (t--){
    	cin >> n >> m;
    	d = (m + 1) >> 1;
    	days.assign(m, vector<int>());
    	answer.assign(m, 0);
    	cnt.assign(n, 0);
    	for (int i=0; i<m; ++i){
    		int k; cin >> k;
    		for (int j=0; j<k; ++j){
    			int v; cin >> v;
    			days[i].push_back(v - 1);
    		}
    	}
    	bool res = search();
    	if (!res) cout << "NO\n";
    	else{
    		cout << "YES\n";
    		for (auto i: answer) cout << i + 1 << " ";
    		cout << "\n";
    	}
    }
}