#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define size(x) x.size()
#define all(x) x.begin(), x.end()

void solve()
{
	int n, m; cin >> n >> m;
	vector<vector<int>> who(m);
	for (int i = 0; i < m; ++i)
	{
		int k; cin >> k;
		who[i].resize(k);
		for (int j = 0; j < k; ++j)
			cin >> who[i][j];
	}
	vector<int> cnt(n, 0);
	vector<int> days(m);
	for (int i = 0; i < m; ++i)
		if (size(who[i]) == 1)
			++cnt[who[i][0] - 1], days[i] = who[i][0];
	for (int i = 0; i < m; ++i)
		if (size(who[i]) > 1)
		{
			int k = size(who[i]);
			int mn = who[i][0];
			int cntmn = cnt[mn - 1];
			for (int j = 1; j < k; ++j)
				if (cnt[who[i][j] - 1] < cntmn)
					mn = who[i][j], cntmn = cnt[who[i][j] - 1];
			++cnt[mn - 1]; days[i] = mn;
		}
	int mmx = (m + 1) / 2;
	for (int i = 0; i < n; ++i)
		if (cnt[i] > mmx)
		{
			cout << "NO\n"; return;
		}
	cout << "YES\n";
	for (int i = 0; i < m; ++i)
		cout << days[i] << ' ';
	cout << '\n';
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while(t--)
		solve();
	//cin.get(); cin.get(); cin.get();
	return 0;
}