#include <bits/stdc++.h>

using namespace std;
#define all(o) o.begin(), o.end()
using ll = long long;

#define MULTITASK 1


void warm_up() {

}


void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> free(m);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x; cin >> x; x--;
            free[i].push_back(x);
        }
    }

    vector<int> allocated(n, 0);
    vector<bool> done(m, false);
    vector<int> people(m, -1);
    bool ok = true;

    auto allocate = [&](int p, int i){
        allocated[p]++;
        people[i] = p;
        done[i] = true;
        if (allocated[p] > (m + 1) / 2) {
            ok = false;
        }
    };

    for (int i = 0; i < m; ++i) {
        if (free[i].size() == 1) {
            allocate(free[i][0], i);
        }
    }

    for (int i = 0; i < m; ++i) {
        if (done[i]) continue;
        int best_e = -1;
        int best_e_v = INT32_MAX;
        for (int p : free[i]) {
            if (best_e_v > allocated[p]) {
                best_e_v = allocated[p];
                best_e = p;
            }
        }
        allocate(best_e, i);
    }
    if (ok) {
        cout << "YES\n";
        for (int i = 0; i < m; ++i) {
            cout << people[i] + 1 << " ";
        }
        cout << "\n";
    } else {
        cout << "NO\n";
    }
}


int main() {
#if ELT
    freopen("../C/input.txt", "r", stdin);
#endif
#if MULTITASK
    warm_up();
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
#else
    warm_up();
    solve();
#endif
}
