#include <iostream>
#include <string>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <random>
#include <iomanip>
#include <functional>
#include <cassert>
#include <bitset>
#include <chrono>
 
using namespace std;
 
typedef long long ll;
 
int main() {
  ios_base::sync_with_stdio(false); cin.tie(0);
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  int t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    vector <vector <int>> have(m);
    vector <int> cnt(n + 1);
    vector <int> ans(m);

    for (int i = 0; i < m; ++i) {
      int k;
      cin >> k;
      for (int j = 0; j < k; ++j) {
        int x;
        cin >> x;
        have[i].push_back(x);
      }
      if (k == 1) {
        ++cnt[have[i][0]];
        ans[i] = have[i][0];
      }
    }

    for (int i = 0; i < m; ++i) {
      if (have[i].size() == 1) continue;
      int a = have[i][0], b = have[i][1];
      if (cnt[b] < cnt[a]) swap(a, b);
      ++cnt[a];
      ans[i] = a;
    }   
    int mx = *max_element(cnt.begin(), cnt.end());
    if (mx > (m + 1) / 2) {
      cout << "NO\n";
    } else {
      cout << "YES\n";
      for (int i = 0; i < m; ++i) {
        cout << ans[i] << ' ';
      }
      cout << '\n';
    }
  }
}

