#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;

bool ok(ll k, ll m){
    if(m & 1)
        return k <= m/2 + 1;
    return k <= m/2;
}

void solve(){
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(m);
    vector<ll> cnt(n+1,0);
    for(ll i = 0; i < m; i++){
        ll u;
        cin >> u;
        for(ll j = 0; j < u; j++){
            ll x;
            cin >> x;
            if(u == 1)
                cnt[x]++;
            a[i].push_back(x);
        }
    }
    ll r = 0;
    for(auto &i : cnt)
        r = max(r, i);
    if(((m & 1) && r > m/2+1) || (!(m & 1) && r > m/2)){
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    vector<ll> ans(m);
    vector<ll> w(n+1,0);
    for(ll i = 0; i < m; i++){
        ll d = rand() % a[i].size();
        ans[i] = a[i][d];
        w[ans[i]]++;
    }
    for(ll i = 0; i < m; i++){
        if(!ok(w[ans[i]],m) && a[i].size() > 1){
            ll e = rand() % a[i].size();
            while(a[i][e] == ans[i] && !ok(w[a[i][e]] + 1,m))
                e = rand() % a[i].size();
            w[ans[i]]-=1;
            ans[i] = a[i][e];
            w[ans[i]]+=1;
        }
    }
    for(auto &i : ans)
        cout << i << " ";
    cout << "\n";
}

signed main(){
    srand(time(NULL));
    ll t;
    cin >> t;
    while(t--)
        solve();
}
