#include <bits/stdc++.h>

using namespace std;

#define _ << " " <<
#define pb push_back
#define ff first
#define ss second

typedef long long ll;
typedef long double ld;

#ifdef LOCAL
	#define err cerr
#else	
	#define err if (0) cerr
#endif //LOCAL

void solve() {
	int n, m;
	cin >> n >> m;
	
	vector<int> cnt(n + 5);
	vector<vector<int> > arr(m, vector<int>());
	vector<vector<pair<int, int> > > d(n + 5, vector<pair<int, int> >());
	int k, f;
	for (int i = 0; i < m; ++i) {
		cin >> k;
		for (int j = 0; j < k; ++j) {
			cin >> f;
			d[f].pb({k, i});
			cnt[f]++;
			arr[i].pb(f);
		}
	}
	
	for (int i = 1; i <= n; ++i) {
		sort(d[i].begin(), d[i].end());
	}
	
	if (n == 1 && m == 1) {
		cout << "YES" << "\n";
		cout << 1 << "\n";
		return;
	}
	if (n == 1) {
		cout << "NO" << "\n";
		return;
	}
	
	vector<pair<int, int> > v(n);
	for (int i = 1; i <= n; ++i) {
		v[i - 1] = {cnt[i], i};
	}
	sort(v.rbegin(), v.rend());
	int mx = v[0].ss;
	
	vector<int> ans(m);
	if (cnt[mx] > (m + 1) / 2) {
		int c = 0;
		for (int i = 0; i < d[mx].size(); ++i) {
			ans[d[mx][i].ss] = mx;
			c++;
			if (c == (m + 1) / 2) break;
		}
		
		for (int i = 0; i < m; ++i) {
			if (ans[i] == 0) {
				if (arr[i].size() == 1 && arr[i][0] == mx) {
					cout << "NO" << "\n";
					return;
				}
				
				if (arr[i][0] != mx) ans[i] = arr[i][0];
				else ans[i] = arr[i][1];
			}
		}
	} else {
		for (int i = 0; i < m; ++i) {
			ans[i] = arr[i][0];
		}
	}
	
	cout << "YES" << "\n";
	for (auto to : ans) {
		cout << to << " ";
	}
	cout << "\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int tests = 1;
	cin >> tests;
	while (tests--) {
		solve();
	}
}