#include <iostream>
#include <stdio.h>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <numeric>
#include <utility>
#include <random>
#include <cmath>
#include <algorithm>

using namespace std;

typedef int64_t ll;
#define endl "\n"

void solve() {
    int n, m; cin >> n >> m;
    int mx = (m + 1) / 2;
    vector<int> lft(n + 1, mx);
    vector<pair<vector<int>, int>> ar(m);
    int c = 0;
    for (auto& it : ar) {
        int sz; cin >> sz;
        it.first.resize(sz);
        it.second = c++;
        for (auto& it : it.first) cin >> it;
    }
    sort(ar.begin(), ar.end(), [](pair<vector<int>, int>& l, pair<vector<int>, int>& r) {
        return l.first.size() < r.first.size();
    });
    vector<pair<int, int>> ans;
    for (auto& it : ar) {
        int kk = *max_element(it.first.begin(), it.first.end(), [&](int l, int r) {
            return lft[l] < lft[r];
        });
        if (lft[kk] == 0) {
            cout << "NO\n";
            return;
        }
        lft[kk]--;
        ans.push_back({it.second, kk});
    }
    cout << "YES\n";
    sort(ans.begin(), ans.end());
    for (auto& it : ans) {
        cout << it.second << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q; cin >> q;
    while (q--) solve();
}
