#pragma comment(linker, "/STACK:16777216")
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include<iostream>
#include<cmath>
#include<cstring>
#include<algorithm>
#include<string>
#include<vector>
#include<queue>
#include<deque>
#include<set>
#include<map>

#define rep(i, n) for(ll i = 0; i < n; ++i)
#define in(x, a) for(auto x : a)
#define inl(x, a) for(auto& x : a)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pudge ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0); cout.precision(13); cout << fixed

using namespace std;

using ll = long long;
const ll INF = 1e9;
const ll MOD = 1e9 + 7;
const double PI = atan2(0, -1);

bool bit(ll x, int i) {
    return (x >> i) & 1;
}
    
template<class T, class R> istream& operator>>(istream& in, pair<T, R>& p) {
    in >> p.first >> p.second;
    return in;
}

template<class T, class R> ostream& operator<<(ostream & out, pair<T, R> & p) {
    out << "{ " << p.first << ", " << p.second << " }";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& a) {
    inl(x, a) {
        in >> x;
    }
    return in;
}

template<class T> ostream& operator<<(ostream& out, vector<T>& a) {
    if (!a.empty()) {
        rep(i, a.size() - 1) {
            out << a[i] << " ";
        }
        out << a.back();
    }
    return out;
}

template<class T> void print(vector<T>& a, string sep=" ", string end = "\n") {
    if (!a.empty()) {
        rep(i, a.size() - 1) {
            cout << a[i] << sep;
        }
        cout << a.back() << end;
    }
}

bool comp(vector<int>& a, vector<int>& b) {
    return a.size() < b.size();
}

int main() {
    pudge;
    int t;
    cin >> t;
    rep(_, t) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> d(m);
        vector<int> c(m, -1), cnt(n + 1, 0);
        rep(i, m) {
            int k;
            cin >> k;
            d[i].resize(k);
            cin >> d[i];
            d[i].push_back(i);
        }
        sort(all(d), comp);
        rep(i, m) {
            rep(j, d[i].size() - 1) {
                if (cnt[d[i][j]] < (m + 1) / 2) {
                    ++cnt[d[i][j]];
                    c[d[i].back()] = d[i][j];
                    break;
                }
            }
        }
        bool f = 0;
        rep(i, m) {
            if (c[i] == -1) {
                f = 1;
                break;
            }
        }
        if (f) {
            cout << "NO\n";
        }
        else {
            cout << "YES\n";
            cout << c << "\n";
        }
    }
}