#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define int long long

using namespace std;


int mod(int x, int y) {
    return ((x % y + y) % y + y) % y;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t-- > 0) {
        int n, m;
        cin >> n >> m;
        vector<int> res(m, -1);
        vector<set<int>> friends(n, set<int>());
        vector<vector<int>> days(m, vector<int>());
        for (int i = 0; i < m; ++i) {
            int k;
            cin >> k;
            days[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> days[i][j];
                days[i][j]--;
                friends[days[i][j]].insert(i);
            }
        }
        map<int, int> cnt;
        auto comp = [&](int l, int r) -> bool {
            int lsz = friends[l].size(), rsz = friends[r].size();
            int lcnt = cnt[l], rcnt = cnt[r];
            return tie(lcnt, lsz) < tie(rcnt, rsz);
        };
        auto comp_days = [&](int l, int r) -> bool {
            return days[l].size() < days[r].size();
        };
        vector<int> order(m, 0);
        iota(all(order), 0);
        sort(all(order), comp_days);
        for (int i:order) {
            sort(all(days[i]), comp);
            res[i] = days[i][0];
            cnt[days[i][0]]++;
        }
        bool good = true;
        for (int i = 0; i < m; ++i) {
            if (res[i] == -1) good = false;
        }
        for (auto[k, v]: cnt) {
            if ((m + 1) / 2 < v) {
                good = false;
            }
        }
        if (good) {
            cout << "YES\n";
            for (int i = 0; i < m; ++i) {
                cout << res[i] + 1 << " ";
            }
            cout << "\n";
        } else {
            cout << "NO\n";
        }

    }
    return 0;
}