#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>
#include <map>

#define F first
#define S second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define siz(a) int(a.size())

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vll = vector<ll>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false;}
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false;}

const int N = 2e5 + 7;
const int INF = 1e9;
const ll LINF = 1e18;


void solve() {
    int n, m; cin >> n >> m;
    vector<int> cnt(n), ans(m, -1);
    vector<vector<int>> go(m);
    set<pair<int, int>> st;
    for (int i = 0; i < m; ++i) {
        int k; cin >> k;
        st.insert({k, i});
        for (int j = 0; j < k; ++j) {
            int c; cin >> c;
            go[i].pb(--c);
        }
    }
    while(!st.empty()) {
        int k = st.begin() -> F, id = st.begin() -> S;
        st.erase(st.begin());
        for (auto c:go[id]) {
            if(cnt[c] < m/2 + m%2) {cnt[c]++, ans[id] = c; break;}
        }
    }
    int f = 1;
    for (auto x: ans) {
        if(x == -1) f = 0;
    }
    if(f == 0) cout << "NO\n";
    else {
        cout << "YES\n";
        for (auto &x:ans) cout << x+1 << " ";cout << "\n";
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while(t--) solve();
    return 0;
}
