#include <bits/stdc++.h>

#define int long long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<vector<int>, int>>can(m);
    for(int i = 0; i < m; ++i){
        int k;
        cin >> k;
        can[i].second = i;
        for(int j = 0; j < k; ++j){
            int a;
            cin >> a;
            can[i].first.push_back(a);
        }
    }
    vector<vector<int> >person_can(n);
    for(int i = 0; i < m; ++i){
        for(auto j : can[i].first) {
            person_can[j - 1].push_back(i);
        }
    }
    vector<int>res(m);
    for(auto &el : can){
        sort(rall(el.first), [&](int a, int b){
           return person_can[a - 1].size() < person_can[b - 1].size();
        });
    }
    sort(all(can), [&](pair<vector<int>, int>&a, pair<vector<int>, int> &b){
           return a.first.size() < b.first.size();
        });
    vector<int>cnt(n + 1);
    for(int i = 0; i < m; ++i){
        while (!can[i].first.empty() && cnt[can[i].first.back()] >= (m + 1) / 2){
            can[i].first.pop_back();
        }
        if(can[i].first.empty()){
            cout << "NO\n";
            return;
        }
        cnt[can[i].first.back()]++;
        res[can[i].second] = can[i].first.back();
    }
    cout << "YES\n";
    for(auto & i : res){
        cout << i << " ";
    }
    cout << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t--) solve();
}
