#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> cnt(n), uni(n);
        vector<int> f[m];
        for (int i = 0; i < m; i++) {
            int k;
            cin >> k;
            f[i].resize(k);
            for (auto &x : f[i]) {
                cin >> x;
                cnt[--x]++;
            }
            if (k == 1) {
                uni[f[i][0]]++;
            }
        }
        int vertex = -1;
        for (int i = 0; i < n; i++) {
            if (cnt[i] > (m + 1) / 2) {
                vertex = i;
                break;
            }
        }
        if (vertex == -1) {
            cout << "YES\n";
            for (int i = 0; i < m; i++) {
                cout << f[i][0] + 1 << ' ';
            }
            cout << '\n';
        } else if (uni[vertex] > (m + 1) / 2) {
            cout << "NO\n";
        } else {
            vector<int> ans(m, -1);
            int cnt = (m + 1) / 2;
            for (int i = 0; i < m; i++) {
                if (f[i].size() == 1 && f[i][0] == vertex) {
                    ans[i] = vertex + 1;
                    cnt--;
                }
            }
            for (int i = 0; i < m && cnt > 0; i++) {
                if (f[i].size() != 1 && find(f[i].begin(), f[i].end(), vertex) != f[i].end()) {
                    ans[i] = vertex + 1;
                    cnt--;
                }
            }
            for (int i = 0; i < m; i++) {
                if (ans[i] == -1) {
                    if (f[i][0] == vertex) {
                        ans[i] = f[i][1] + 1;
                    } else {
                        ans[i] = f[i][0] + 1;
                    }
                }
            }
            cout << "YES\n";
            for (auto &x : ans) {
                cout << x << ' ';
            }
            cout << '\n';
        }
    }
    return 0;
}
