﻿#include <iostream>
#include <vector>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

bool cmp(pair<int, vector<int>>& a, pair<int, vector<int>>& b) {
	if (a.second.size() == b.second.size()) {
		return a.first < b.first;
	}
	return a.second.size() < b.second.size();
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		vector<int>cnt(n);
		vector<pair<int, vector<int>>>can_take(m);
		vector<int>ans(m);
		for (int i = 0; i < m; i++) {
			int k; cin >> k;
			can_take[i].first = i;
			for (int j = 0; j < k; j++) {
				int num; cin >> num;
				can_take[i].second.push_back(num - 1);
			}
		}
		sort(all(can_take), cmp);
		for (int i = 0; i < can_take.size(); i++) {
			int num_take = can_take[i].second[0];
			for (int j = 0; j < can_take[i].second.size(); j++) {
				if (cnt[can_take[i].second[j]] < cnt[num_take]) {
					num_take = can_take[i].second[j];
				}
			}
			cnt[num_take]++;
			ans[can_take[i].first] = num_take;
		}
		bool good = true;
		for (int i = 0; i < cnt.size(); i++) {
			if (cnt[i] > ceil(m / 2.0)) {
				good = false;
				break;
			}
		}
		if (!good) {
			cout << "NO\n";
			continue;
		}
		else {
			cout << "YES\n";
		}
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] + 1 << " ";
		}
		cout << "\n";
	}
}