#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <numeric>
#include <queue>
#include <deque>
#include <iterator>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <time.h>
#include <bitset>
#include <stdio.h>

#define ll long long
#define ld long double
#define MAXINT 2000000000
#define MININT -2000000000
#define MAXLL 9000000000000000000LL
#define MINLL -9000000000000000000LL
#define y1 absdasd
#define x1 asdbasdbas
#define pb push_back
#define fi first
#define se second
#define endl '\n'
#define pll pair < ll, ll >

using namespace std;

const ld pi = acos(-1);
const ll md = 1e9 + 7;
clock_t start_time = clock();

ll n, m, i, j, x, y, c, cnt[100501], ans[200501], k[100501], ck;

vector < ll > v[100501], g[100501];

set < pll > st;

bool used[100501], used1[100501];

void solve()
{
    cin >> n >> m;

    st.clear();

    for (i = 1; i <= n; i++){
        g[i].clear();
        cnt[i] = k[i] = 0;
        used1[i] = false;
    }

    for (i = 1; i <= m; i++) v[i].clear();

    for (i = 1; i <= m; i++){
        cin >> ck;
        used[i] = false;

        v[i].resize(ck + 1);
        for (j = 1; j <= ck; j++){
            cin >> v[i][j];

            cnt[v[i][j]]++;
            g[v[i][j]].pb(i);
        }
    }

    for (i = 1; i <= n; i++){
        st.insert({cnt[i], i});
    }

    ck = 0;

    while (!st.empty() && (*st.begin()).fi <= (m + 1) / 2){
        ll nom = (*st.begin()).se;
        st.erase(st.begin());
        used1[nom] = true;

        for (ll x : g[nom]){
            if (used[x]) continue;

            for (i = 1; i < v[x].size(); i++){
                if (!used1[v[x][i]]){
                    st.erase({cnt[v[x][i]], v[x][i]});
                    cnt[v[x][i]]--;
                    st.insert({cnt[v[x][i]], v[x][i]});
                }
            }

            used[x] = true;
            ans[x] = nom;
            ck++;
        }
    }

    if (ck == m){
        cout << "YES" << endl;
        for (i = 1; i <= m; i++) cout << ans[i] << " ";
        cout << endl;
        return;
    }

    if (st.size() < 2){
        cout << "NO" << endl;
        return;
    }

    ll v1 = (*st.begin()).se;
    st.erase(st.begin());
    ll v2 = (*st.begin()).se;
    ll c1 = 0, c2 = 0;

    for (i = 1; i <= m; i++){
        if (used[i]) continue;
        bool f = false;

        for (j = 1; j < v[i].size(); j++) if (v[i][j] == v1 || v[i][j] == v2) f = true;
        if (f) continue;

        for (j = 1; j < v[i].size(); j++){
            if (!used1[v[i][j]]){
                ans[i] = v[i][j];
                used[i] = true;
                break;
            }
        }
    }

    for (i = 1; i <= m; i++){
        if (used[i]) continue;

        bool f1 = false, f2 = false;

        for (j = 1; j < v[i].size(); j++){
            if (v[i][j] == v1) f1 = true;
            if (v[i][j] == v2) f2 = true;
        }

        if (f1 && !f2){
            used[i] = true;
            ans[i] = v1;
            c1++;
        }
        else if (f2 && !f1){
            used[i] = true;
            ans[i] = v2;
            c2++;
        }
    }

    for (i = 1; i <= m; i++){
        if (used[i]) continue;

        if (c1 < (m + 1) / 2){
            c1++;
            ans[i] = v1;
        }
        else{
            c2++;
            ans[i] = v2;
        }
    }

    cout << "YES" << endl;
    for (i = 1; i <= m; i++) cout << ans[i] << " ";
    cout << endl;
}

int main()
{
    #ifndef ONLINE_JUDGE
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // ONLINE_JUDGE

    ios::sync_with_stdio(0);
    cin.tie(0);

    ll q = 1;
    cin >> q;

    while (q--){
        solve();
    }

    #ifndef ONLINE_JUDGE
        cout << endl;
        cout << "Time = " << (ld)(clock() - start_time) / CLOCKS_PER_SEC << endl;
    #endif // ONLINE_JUDGE
    return 0;
}
