#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

inline void solve() {
	int n, m;
	cin >> n >> m;

	vector <int> daycnt(m);
	vector <pair <int, vector <int>>> friends(n);
	
	for (int i = 0; i < n; i++)
		friends[i].first = i;
	
	int k, x;
	for (int i = 0; i < m; i++) {
		cin >> k;
		daycnt[i] = k;

		for (int j = 0; j < k; j++) {
			cin >> x;
			friends[x - 1].second.push_back(i);
		}
	}

	auto cmp = [] (const pair<int, vector <int>> &a, const pair<int, vector <int>> &b) {
		return a.second.size() < b.second.size();
	};

	sort(friends.begin(), friends.end(), cmp);

	vector <int> answer(m, -1);
	for (int i = 0; i < n; i++) {
		int count = 0;

		sort(friends[i].second.begin(), friends[i].second.end(), [&daycnt] (int a, int b) {
			return daycnt[a] < daycnt[b];
		});

		for (int x: friends[i].second) {
			if (count + 1 > (m + 1) / 2) break;
			if (answer[x] != -1) continue;

			answer[x] = friends[i].first + 1;
			count++;
		}
	}

	for (int x: answer) {
		if (x == -1) {
			cout << "NO\n";
			return;
		}
	}

	cout << "YES\n";
	for (int x: answer) 
		cout << x << ' ';
	cout << '\n';
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	while (t--)
	solve();
}