#include <bits/stdc++.h>
using namespace std;

int bugged (vector <int> a, int n, int m) {
	vector <int> cnt(n + 1, 0);
	for (int x: a)
		++cnt[x];
	for (int i = 0; i <= n; ++i) {
		if (cnt[i] > (m + 1) / 2)
			return i;
	}
	return 0;
}

int32_t main () {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int tests; 
	cin >> tests;
	while (tests--) {
		int n, m;
		cin >> n >> m;
		vector <vector <int> > free(m);
		for (int i = 0; i < m; ++i) {
			int k;
			cin >> k;
			free[i].resize(k);
			for (int j = 0; j < k; ++j)
				cin >> free[i][j];
		}
		vector <int> attempt;
		for (int i = 0; i < m; ++i) 
			attempt.push_back(free[i][0]);
		int c = bugged(attempt, n, m);
		if (c) {
			int cnt = 0;
			for (int x: attempt) {
				if (x == c)
					++cnt;
			}
			for (int i = 0; i < m; ++i) {
				if (cnt > (m + 1) / 2 && int(free[i].size()) > 1 && free[i][0] == c) {
					--cnt;
					attempt[i] = free[i][1];
				}
			}
			if (bugged(attempt, n, m))
				cout << "NO\n";
			else{
				cout << "YES\n";
				for (int x: attempt)
					cout << x << ' ';
				cout << '\n';
			}		
		}
		else {
			cout << "YES\n";
			for (int x: attempt)
				cout << x << ' ';
			cout << '\n';
		}
	}
}
