#include <bits/stdc++.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = (ll)(1e9 + 7);
const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

mt19937 rnd(time(0));

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    fast_stream();
    ll tests;
    cin >> tests;
    while (tests--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> a(n + 1, 0LL);
        vector<vector<ll>> b(m);
        vector<ll> ans(m, 0LL);
        vector<vector<ll>> pos(n + 1);
        for (ll i = 0; i < m; ++i) {
            ll sizee;
            cin >> sizee;
            b[i].resize(sizee);
            for (ll j = 0; j < sizee; ++j) {
                cin >> b[i][j];
                pos[b[i][j]].push_back(i);
            }
            if (sizee == 1) {
                ll ind_chela = b[i][0];
                ++a[ind_chela];
                ans[i] = ind_chela;
            }
        }
        bool flag = false;
        //ll ind_chela_with_max_sum = 0LL;
        for (ll i = 0; i < n + 1; ++i) {
            if (a[i] > (m + 1) / 2) {
                cout << "NO\n";
                flag = true;
                break;
            }
        }
        if (flag) continue;
        vector<pair<ll, ll>> f(n + 1);
        for (ll i = 0; i < n + 1; ++i) {
            f[i] = {pos[i].size(), i};
        }
        sort(f.begin(), f.end());
        for (auto i : f) {
            ll ind_chela = i.second;
            ll cnt = (m + 1) / 2 - a[ind_chela];
            for (auto j : pos[ind_chela]) {
                if (ans[j] == 0LL) {
                    ans[j] = ind_chela;
                    --cnt;
                    if (!cnt) break;
                }
            }
        }
        flag = true;
        for (auto i : ans) {
            if (!i) {
                flag = false;
                break;
            }
        }
        if (flag) {
            cout << "YES\n";
            for (auto i : ans) {
                cout << i << ' ';
            }
            cout << '\n';
        }
        else {
            cout << "NO\n";
        }
    }
}