#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Day {
	int num;
	vector<int> g;

	bool operator<(const Day& d) {
		return g.size() < d.g.size();
	}
};

int main() {
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;

		vector<int> counter(n + 1, 0), ans(m);
		counter[0] = 1e9;
		vector<Day> d(m);
		for (int i = 0; i < m; ++i) {
			d[i].num = i;
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int u;
				cin >> u;
				d[i].g.push_back(u);
			}
		}

		sort(d.begin(), d.end());
		for (int i = 0; i < m; ++i) {
			int x = 0;
			for (auto j : d[i].g)
				if (counter[j] < counter[x])
					x = j;
			ans[d[i].num] = x;
			counter[x]++;
		}

		if (*max_element(counter.begin() + 1, counter.end()) > m / 2 + (m % 2 == 0 ? 0 : 1))
			cout << "NO" << '\n';
		else {
			cout << "YES" << '\n';
			for (auto i : ans) cout << i << ' ';
			cout << '\n';
		}
	}
}