#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <random>
#include <ctime>
#define all(z) z.begin(), z.end()
#define rall(z) z.rbegin(), z.rend()
#define pb push_back
#define eb emplace_back
#define int long long
using namespace std;
using vi = vector<int>;
using vc = vector<char>;
using pii = pair<int, int>;
using vvi = vector<vector<int>>;


inline void solve()
{
    int n, m;
    cin >> n >> m;

    vi k(m);
    vvi f(m);

    for (int i = 0; i < m; i++)
    {
        cin >> k[i];
        f[i].resize(k[i]);
        for (int j = 0; j < k[i]; j++)
            cin >> f[i][j], f[i][j]--;
    }

    vi p(m);
    for (int i = 0; i < m; i++)
        p[i] = i;

    sort(all(p), [&f](int x, int y) {
        return f[x].size() < f[y].size();
    });

    int mx = (m+1)/2;

    vi a(n, 0);
    vi r(m);
    bool ok = true;
    for (int i = 0; i < m && ok; i++)
    {
        int i0 = p[i];
        sort(all(f[i0]), [&a](int x, int y) {
            return a[x] < a[y];
        });
        r[i0] = f[i0][0];
        a[r[i0]]++;
        ok = (a[r[i0]] <= mx);
    }

    if (ok)
    {
        cout << "YES\n";
        for (int i = 0 ; i < m; i++)
            cout << r[i]+1 << ' ';
        cout << '\n';
    }
    else
        cout << "NO\n";
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;
    while (T--)
        solve();

    return 0;
}
