﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;

#define int long long
typedef int ll;
typedef pair<ll, ll> pll;
typedef vector <ll> vec;
typedef vector <char> vecc;
typedef vector <pll> vecp;
typedef vector <vec> graph;
typedef vector <vecp> graphp;
#define FF ios::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define FOR(I, ST, N) for (ll I = (ST); I < (N); ++I)
#define FORB(I, ST, N) for (ll I = (ST) - 1; I >= (N); --I)
#define rep(I, N) for (ll I = 0; I < (N); ++I)
#define rep1(I, N) for (ll I = 1; I < (N); ++I)
#define rep2(I, N) for (ll I = 1; I <= (N); ++I)
#define repb(I, N) for (ll I = (N) - 1; I >= 0; --I)
#define repb1(I, N) for (ll I = (N) - 1; I >= 1; --I)
#define repb2(I, N) for (ll I = (N); I >= 1; --I)
#define el '\n'
#define yep cout << "YES" << el
#define nope cout << "NO" << el
#define unordered_set US
#define rsz resize
#define sz(a) ll(a.size())
#define INF INT64_MAX
#define pb push_back
#define F first
#define S second
#define all(a) a.begin(), a.end()

ll nod(ll a, ll b) {
	return b == 0 ? a : nod(b, a % b);
}

signed main() {
	FF;

	ll nt; cin >> nt;
	while (nt--) {
		ll n;
		cin >> n;
		vec arr(n);
		vec nxt(n);
		set <ll> q;
		rep(i, n) {
			cin >> arr[i];
			nxt[i] = i + 1;
			if (i == n - 1) nxt[i] = 0;
		}

		vec ans;

		rep(i, n) {
			if (arr[i] == 0) continue;
			if (nod(arr[i], arr[nxt[i]]) == 1) {
				arr[nxt[i]] = 0;
				q.insert(i);
				q.erase(nxt[i]);
				ans.pb(nxt[i] + 1);
				nxt[i] = nxt[nxt[i]];
			}
		}

		while (1) {
			set <ll> to_er;
			bool f = 0;
			for (ll a : q) {
				if (to_er.find(a) != to_er.end()) {
					continue;
				}
				if (nod(arr[a], arr[nxt[a]]) == 1) {
					to_er.insert(nxt[a]);
					ans.pb(nxt[a] + 1);
					nxt[a] = nxt[nxt[a]];
					f = 1;
				}
				else to_er.insert(a);
			}
			if (!f || q.empty()) break;
			for (ll a : to_er) {
				q.erase(a);
			}
		}
		cout << sz(ans) << ' ';
		for (ll a : ans) cout << a << ' ';
		cout << el;
	}



	return 0;
}

/*
2
2 6
2 1 2
2 1 2
2 1 2
2 1 2
2 1 2
2 1 2
*/

/*
const ll md = 1e9 + 7;

ll add(ll a, ll b) {
	return (a + b) % md;
}

ll mul(ll a, ll b) {
	return (a * b) % md;
}

ll sub(ll a, ll b) {
	return b > a ? a - b + md : a - b;
}

ll sqr(ll a) {
	return a * a % md;
}

ll up(ll a, ll n) {
	if (n == 0) return 1;
	if (n & 1) return up(a, n - 1) * a % md;
	return sqr(up(a, n / 2));
}

ll div1(ll a, ll b) {
	ll q = up(b, md - 2);
	return mul(a, q);
}
*/

/*
ll N;
vec tree;

void build() {
	while (N & (N - 1)) ++N;
	tree.rsz(N * 2 - 1, 0);
}

void upd(ll i, ll x) {
	i += (N - 1);
	tree[i] = x;
	while (i > 0) {
		i = (i - 1) / 2;
		tree[i] = max(tree[i * 2 + 1], tree[i * 2 + 2]);
	}
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
	if (tl >= l && tr <= r) return tree[v];
	if (tl >= r || tr <= l) return 0;
	ll m = (tr + tl) / 2, v1 = v * 2 + 1, v2 = v * 2 + 2;
	return max(get(v1, tl, m, l, r), get(v2, m, tr, l, r));
}
*/

/*
graph gr;
vecc used;

void dfs(ll v) {
	used[v] = 1;
	for (ll to : gr[v]) {
		if (used[to]) continue;
		dfs(to);
	}
}
*/

/*
struct treap {
	ll x, mn, sz;
	treap* l, * r;

	treap(ll xx) {
		x = xx;
		mn = INF;
		sz = 1;
		l = r = nullptr;
	}
};

ll get_sz(treap* my) {
	return (my == nullptr) ? 0 : my->sz;
}

ll get_mn(treap* my) {
	return (my == nullptr) ? INF : my->mn;
}

void upd(treap* my) {
	if (my == nullptr) return;
	my->sz = get_sz(my->l) + get_sz(my->r) + 1;
	my->mn = min(my->x, min(get_mn(my->l), get_mn(my->r)));
}

void split(ll x, treap* my, treap*& L, treap*& R) {
	L = R = nullptr;
	if (my == nullptr) return;
	ll x1 = get_sz(my->l) + 1;
	if (x1 < x) {
		split()
	}
}
*/