#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    set <int> alive;
    vector <pair <int, int>> in;

    for (int i = 0; i < n; i++) {
        alive.insert(i);
        in.emplace_back(i, (i + 1) % n);
    }

    vector <int> del;
    int last = -1;
    while (!in.empty()) {
        vector <pair <int, int>> nw;
        for (int pos = 0; pos < (int) in.size(); pos++) {
            auto [x, y] = in[pos];
            if (x == last) {
                last = -1;
                continue;
            }

            if (gcd(line[x], line[y]) == 1) {
                auto it = alive.find(y);
                it++;
                if (it == alive.end()) {
                    it = alive.begin();
                }
                del.push_back(y + 1);
                nw.emplace_back(x, *it);
                alive.erase(y);
                last = y;
            } else {
                last = -1;
            }
        }
        in = nw;
    }
    cout << del.size() << " ";
    for (int i : del)
        cout << i << " ";
    cout << endl;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;
    while (q--)
        solve();
    return 0;
}
