#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb emplace_back

const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;

int find_bad(int i, set<int> &s) {
    auto it = s.lower_bound(i);
    if (it != s.end()) return *it;
    return *s.begin();
}

int find_next(int i, set<int> &s) {
    auto it = s.upper_bound(i);
    if (it != s.end()) return *it;
    return *s.begin();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (auto &c : a) cin >> c;
        set<int> ind, bad;
        for (int i = 0; i < n; i++) {
            ind.insert(i);
            if (__gcd(a[i], a[(i + 1) % n]) == 1) bad.insert(i);
        }
        vector<int> ans;
        int cur = 0;
        while ((int)bad.size()) {
            cur = find_bad(cur, bad);
            int nxt1 = find_next(cur, ind);
            if (nxt1 == cur) {
                ans.pb(cur);
                break;
            }
            int nxt2 = find_next(nxt1, ind);
            //cout << '!' << " " << cur << " " << nxt1 << " " << nxt2 << endl;
            bad.erase(cur);
            bad.erase(nxt1);
            ind.erase(nxt1);
            ans.pb(nxt1);
            if (__gcd(a[cur], a[nxt2]) == 1) bad.insert(cur);
            cur = nxt2;
        }
        cout << ans.size() << " ";
        for (auto &c : ans) cout << c + 1 << " ";
        cout << "\n";
    }
    return 0;
}
