#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pll pair<ll, ll>

const ll mod1 = 1e9 + 7;
const ll inf = 1e18;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> r(a, b);
    return r(rng);
}


void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    set<vector<int>> order;
    int st = 0;
    vector<int> nxtAlive(n), alive(n);
    for (int i = 0; i < n; i++) {
        if (__gcd(arr[i], arr[(i + 1) % n]) == 1) {
            order.insert({st, i, (i + 1) % n});
            st++;
        }
        nxtAlive[i] = (i + 1) % n;
        alive[i] = 1;
    }

    function<int(int)> getNxt = [&](int x) {
        if (alive[x]) {
            return x;
        }
        nxtAlive[x] = getNxt(nxtAlive[x]);
        return nxtAlive[x];
    };

    vector<int> answer;
    while (!order.empty()) {
        auto p = *order.begin();
        order.erase(order.begin());
        int i = p[2], pr = p[1];
        if (alive[pr] == 0) {
            continue;
        }
        answer.pb(i);
        int nxt = getNxt(nxtAlive[i]);
        alive[i] = 0;
        if (__gcd(arr[pr], arr[nxt]) == 1 and alive[nxt]) {
            order.insert({st, pr, nxt});
            st++;
        }
    }
    cout << answer.size() << " ";
    for (auto x : answer) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
