//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define mp std::make_pair
#define int long long

std::mt19937 myRandom(clock());

template<class T>
T mx(T &l, const T& r) {
    if(r > l) l = r;
    return l;
}

template<class T>
T mn(T &l, const T& r) {
    if(r < l) l = r;
    return l;
}

int32_t main() {
    std::ios::sync_with_stdio(0), std::cin.tie(0);

    int t;
    std::cin >> t;
    while(t--) {
        int n;
        std::cin >> n;
        int a[n];
        for(auto &i : a) std::cin >> i;
        std::set<int> alive;

        for(int i = 0; i < n; i++) alive.insert(i);

        auto getRight = [&](int cell) {
            auto ind = alive.upper_bound(cell);
            if(ind == alive.end()) return *alive.begin();
            else return *ind;
        };

        std::set<int> badPairs;
        for(int i = 0; i < n; i++) {
            if(std::gcd(a[i], a[getRight(i)]) == 1) badPairs.insert(i);
        }

        std::vector<int> ans;

        int ind = 0;
        while(!badPairs.empty() && alive.size() > 1) {
            {
                auto it = badPairs.lower_bound(ind);
                if(it != badPairs.end()) ind = *it;
                else ind = *badPairs.begin();
            }
            badPairs.erase(ind);
            int right = getRight(ind);
            if(std::gcd(a[ind], a[right]) != 1) break;

            alive.erase(right);
            badPairs.erase(right);
            ans.push_back(right);

            int nextInd = getRight(ind);
            if(std::gcd(a[ind], a[nextInd]) == 1) badPairs.insert(ind);

            ind = nextInd;
        }

        if(alive.size() == 1) {
            ind = *alive.begin();
            if(a[ind] == 1) ans.push_back(ind);
        }

        std::cout << ans.size() << ' ';
        for(auto &i : ans) std::cout << i + 1 << ' ';
        std::cout << '\n';
    }
}
