#include<bits/stdc++.h>

using namespace std;

//#define int long long

using ll = long long;

namespace {
    template<typename T>
    ostream &operator<<(ostream &os, const vector<T> &v) {
        for (auto &e : v) os << e << (is_integral_v<T> && !is_same_v<T, char> ? " " : "");
        return os << '\n';
    }

    template<typename T>
    istream &operator>>(istream &is, vector<T> &v) {
        for (auto &e : v) is >> e;
        return is;
    }

    template<typename F, typename S>
    ostream &operator<<(ostream &os, const pair<F, S> &v) {
        os << v.first << " " << v.second << '\n';
        return os;
    }

    template<typename F, typename S>
    istream &operator>>(istream &is, const pair<F, S> &v) {
        is >> v.first >> v.second;
        return is;
    }
}

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    map<int, int> playlist;
    set<int> eraseful;
    for (int i = 0; i < n; ++i) {
        playlist[i] = a[i];
        if ((i && __gcd(a[i], a[i - 1]) == 1) || (!i && __gcd(a[0], a[n - 1]) == 1)) eraseful.insert(i);
    }
    int cur = 0;
    vector<int> ans;
    while (!eraseful.empty()) {
        auto iter = eraseful.upper_bound(cur);
        if (iter == eraseful.end()) iter = eraseful.begin();
        int x = *iter;
        ans.push_back(x);
        playlist.erase(x);
        eraseful.erase(x);
        if (playlist.empty()) break;
        pair<int, int> next;
        if (auto nxt = playlist.upper_bound(x); nxt == playlist.end()) next = *playlist.begin(); else next = *nxt;
        pair<int, int> prev;
        if (auto prv = playlist.lower_bound(x); prv == playlist.begin()) prev = *playlist.rbegin(); else prev = *(--prv);
        if (__gcd(next.second, prev.second) == 1) eraseful.insert(next.first); else eraseful.erase(next.first);
        cur = next.first;
    }
    for (int &x : ans) ++x;
    cout << ans.size() << ' ' << ans;
}