#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
using namespace std;

long long Nod(long long a, long long b){
    if (b == 0)
        return a;
    return Nod(b , a % b);
}

int main(){
    long long t, i, j, n;
    cin >> t;
    for (j = 0; j < t; ++j){
        cin >> n;
        deque <pair <int, int>> all;
        vector <int> next(n), a(n), otv;
        vector <bool> del(n, false);
        int past = -1;
        for (i = 0; i < n; ++i){
            cin >> a[i];
            next[i] = (i + 1) % n;
        }
        for (i = 0; i < n; ++i){
            if (Nod(a[i], a[next[i]]) == 1){
                all.push_back({i, next[i]});
            }
        }
        while (all.size() > 0){
            int ax = all.front().first, b = all.front().second;
            all.pop_front();
            if (!del[ax] && !del[b]){
                next[ax] = next[b];
                del[b] = true;
                otv.push_back(b);
                if (Nod(a[ax], a[next[ax]]) == 1){
                    all.push_back({ax, next[ax]});
                }
            }
        }
        cout << otv.size() << ' ';
        for (i = 0; i < otv.size(); ++i){
            cout << otv[i] + 1 << ' ';
        }
        cout << "\n";
    }
    return 0;
}
