#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <math.h>
#include <cmath>
#include <complex>
#include <algorithm>

using namespace std;

#define rep(i, n) for (ll i = 0; i < n; i++)
#define reep(i, a, n) for (ll i = a; i < n; i++)
#define per(i, n) for (ll i = n - 1; i >= 0; i--)

#define all(x) x.begin(), x.end()
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define sz(x) (int)x.size()
#define len() length()

#define ff first
#define ss second

#define print2(a, b) cout << a << ' ' << b << endl
#define print3(a, b, c) cout << a << ' ' << b << ' ' << c << endl
#define print4(a, b, c, d) cout << a << ' ' << b << ' ' << c << '' << d << endl
#define printvec(a)       \
    for (auto _ : a)      \
        cout << _ << ' '; \
    cout << endl

typedef long long ll;
typedef long double ld;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main()
{
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);

    int n = 1;

    cin >> n;

    rep(i, n) solve();
}

ll gcd(ll a, ll b)
{
    if (max(a, b) % min(a, b) == 0)
        return min(a, b);
    return gcd(min(a, b), max(a, b) % min(a, b));
}
ll n;
vb del;
vi nex;
vi pre;

int jmin(int i)
{
    return pre[i];
}

int jmax(int i)
{
    return nex[i];
}

void solve()
{

    cin >> n;
    vll a(n);
    rep(i, n)
    {
        cin >> a[i];
    }
    del.resize(n);
    del.assign(n, 0);
    nex.resize(n);
    pre.resize(n);
    rep(i, n)
    {
        nex[i] = i + 1;
    }
    nex.back() = 0;
    rep(i, n)
    {
        pre[i] = i - 1;
    }
    pre[0] = n - 1;
    vi ans;
    bool t = 1;
    ll lastf = -1;
    queue<pii> q;
    ll lastdel = -1;
    rep(i, n)
    {
        if (lastf == -1)
            lastf = a[i];
        else if (gcd(a[i], lastf) == 1)
        {
            del[i] = 1;
            ans.pb(i);
            lastf = -1;
            nex[pre[i]] = nex[i];
            pre[nex[i]] = pre[i];
            q.push(mp(jmin(i), jmax(i)));
            q.push(mp((i + 1) % n, jmax((i + 1) % n)));
            lastdel = i;
        }
        else
        {
            lastf = a[i];
        }
    }
    if (lastf != -1)
    {
        if (gcd(a[0], lastf) == 1)
        {
            del[0] = 1;
            ans.pb(0);
            lastf = -1;
            nex[pre[0]] = nex[0];
            pre[nex[0]] = pre[0];
            q.push(mp(jmin(0), jmax(0)));
            lastdel = 0;
        }
    }
    while (sz(q) > 0)
    {
        pii p = q.front();
        //print2(p.ff, p.ss);
        q.pop();
        if (del[p.ff] || del[p.ss])
            continue;
        else
        {
            if (gcd(a[p.ff], a[p.ss]) == 1)
            {
                del[p.ss] = 1;
                ans.pb(p.ss);
                nex[pre[p.ss]] = nex[p.ss];
                pre[nex[p.ss]] = pre[p.ss];
                q.push(mp(jmin(p.ss), jmax(p.ss)));
            }
        }
    }
    //printvec(del);
    cout << sz(ans) << ' ';
    rep (i, sz(ans)) cout << ans[i] + 1 << ' ';
    cout << endl;
}