#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 1e5;

int main() {
    #ifndef LOCAL
        std::ios::sync_with_stdio(false);
        std::cin.tie(0); std::cout.tie(0);
    #endif
    int t;
    std::cin >> t;
    while(t--) {
        int n;
        std::cin >> n;
        std::vector<int> a(n);
        std::set<int> alive;

        auto nxt1 = [&](auto it) {
            if (std::next(it) == alive.end()) {
                return alive.begin();
            }
            return std::next(it);
        };
        auto prev1 = [&](auto it) {
            if (it == alive.begin()) {
                return std::prev(alive.end());
            }
            return std::prev(it);
        };

        FOR(i, n) {
            std::cin >> a[i];
            alive.insert(i);
        }
        std::set<int> event;
        for (int i = 0; i < n; ++i) {
            if (std::__gcd(a[i], a[(i + 1) % n]) == 1) {
                event.insert((i + 1) % n);
            }
        }
        std::vector<int> del;
        int curEvent = 1;
        while (!event.empty()) {
            auto check = event.lower_bound(curEvent);
            if (check == event.end()) {
                check = event.begin();
            }
            int id = *check;
            auto it = alive.lower_bound(id);

            auto pr = *prev1(it);
            auto nx = *nxt1(it);

            event.erase(id);
            event.erase(nx);

            del.pb(*it);
            alive.erase(*it);
            if (std::__gcd(a[pr], a[nx]) == 1 && alive.count(nx)) {
                event.insert(nx);
            }
            curEvent = (nx + 1);
        }
        std::cout << del.size() << ' ';
        for (auto e : del) {
            std::cout << e + 1 << ' ';
        }
        std::cout << '\n';
    }
}