//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <complex>
#include <cstdio>
#include <deque>
#include <cmath>
#include <bitset>
#include <cassert>

using namespace std;

#define ll long long
#define ull unsigned long long
#define pb push_back
#define se second
#define fi first
#define forn(i,n) for(int i = 0; i < (n); i++)
#define read(a) for(int i = 0; i < a.size(); i++){cin >> a[i];}
#define all(a) a.begin(),a.end()
#define make_unique(a) sort(all(a)); a.resize(unique(a.begin(),a.end())-a.begin());
const int mod = 1e9 + 7;
//#define int long long

int gcd(int a, int b){
    return (a == 0) ? b : gcd(b % a, a);
}

void solve() {
    int n;
    cin >> n;
    if(n == 0){
        cout << "0\n";
        return;
    }
    vector<int> a(n);
    read(a);
    vector<int> ans;
    deque<int> de;
    vector<int> left(n);
    vector<int> right(n);
    for(int i = 0; i < n;++i){
        if(i == 0){
            left[i] = n;
        }
        else{
            left[i] = i - 1;
        }
        if(i == n-1){
            right[i] = 0;
        }
        else{
            right[i] = i + 1;
        }
    }
    forn(i,n){
        if(gcd(a[i],a[(i+1)%n]) == 1){
            de.push_back(i);
            //cout << '!' << i << "! ";
        }
    }
    while(!de.empty() && ans.size() != n){

        int nw = de.front();
        de.pop_front();
        if(!de.empty() && de.front() == right[nw]){
            de.pop_front();
        }
        ans.push_back(right[nw]+1);
        right[nw] = right[right[nw]];
        if(gcd(a[nw],a[right[nw]]) == 1){
            de.push_back(nw);
        }
    }

    cout << ans.size() << ' ';
    for(int i = 0; i < ans.size(); ++i){
        cout << ans[i] << ' ';
    }
    cout << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef Debugg
    freopen("ain.txt","r",stdin);
    freopen("aout.txt","w",stdout);
#endif
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
#ifdef Debugg
    cout << '\n' << (double)clock()/CLOCKS_PER_SEC;
#endif
}

