#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <deque>

using namespace std;

struct svsp{
    int val;
    int prev;
    int next;
};

struct rem{
    int cyc;
    int del;
    int bec;
};

bool operator<(rem a, rem b){
    if(a.cyc != b.cyc){
        return a.cyc < b.cyc;
    }else{
        return a.bec < b.bec;
    }
}

int gcd(int a, int b){
    while(b != 0){
        a = a % b;
        swap(a, b);
    }
    return a;
}

void solve(){
    set<rem> que;
    int n;
    cin >> n;
    vector<svsp> a;
    a.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].val;
    }
    for(int i = 1; i < n; ++i){
        a[i-1].next = i;
        a[i].prev = i -1;
    }
    a[0].prev = n - 1;
    a[n - 1].next = 0;
    for(int i = 1; i < n; ++i){
        if(gcd(a[i].val, a[i-1].val) == 1){
            que.insert({0, i, i - 1});
        }
    }
    if(gcd(a[0].val, a[n-1].val) == 1){
        que.insert({0, 0, n - 1});
    }
    vector<int> ans;
    ans.push_back(-1);
    rem cur;
    //cout << "vvvvvvvvvvvvvvvvvvvvvv\n";
    //for(rem i : que){
    //    cout << i.cyc << ' ' << i.del << ' ' << i.bec << endl;
    //}
    //cout << "^^^^^^^^^^^^^^^^^^^^^^\n";
    while(que.size() != 0){
        cur = *que.begin();
        que.erase(*que.begin());
        if(ans.back() == cur.bec + 1){
            continue;
        }
        a[a[cur.del].prev].next = a[cur.del].next;
        a[a[cur.del].next].prev = a[cur.del].prev;
        ans.push_back(cur.del + 1);
        if(gcd(a[a[cur.del].prev].val, a[a[cur.del].next].val) == 1){
            que.insert({cur.cyc + 1, a[cur.del].next, a[cur.del].prev});
        }
        //cout << "vvvvvvvvvvvvvvvvvvvvvv\n";
        //for(rem i : que){
        //    cout << i.cyc << ' ' << i.del << ' ' << i.bec << endl;
        //}
        //cout << "^^^^^^^^^^^^^^^^^^^^^^\n";
    }
    cout << ans.size() - 1 << ' ';
    for(int i = 1; i < ans.size(); ++i){
        cout << ans[i] << ' ';
    }
    cout << endl;
}

int main(){
    int t;
    cin >> t;
    for(int i = 0; i < t; ++i){
        solve();
    }
}
