#include <bits/stdc++.h>

#define N 100500
#define PB push_back
#define endl '\n'
#define pri(x) cout << x << endl
#define _ << " " <<
#define sz(x) int(x.size())

using namespace std;

int mx[N * 4], mn[N * 4], mnt[N * 4];

void bld(int v, int tl, int tr)
{
    if (tl == tr)
    {
        mnt[v] = mx[v] = tl;

        mn[v] = -1;

        return;
    }

    int md = (tl + tr) >> 1;

    bld(v + v, tl, md);

    bld(v + v + 1, md + 1, tr);

    mn[v] = mn[v + v];

    mnt[v] = mnt[v + v];

    mx[v] = mx[v + v + 1];
}

void upd(int v, int tl, int tr, int ps)
{
    if (tl == tr)
    {
        mnt[v] = mx[v] = -1;

        return;
    }

    int md = (tl + tr) >> 1;

    if (ps <= md)
    {
        upd(v + v, tl, md, ps);

        if (mx[v + v + 1] != -1)
            mx[v] = mx[v + v + 1];
                else mx[v] = mx[v + v];

        if (mnt[v + v] != -1)
            mnt[v] = mnt[v + v];
                else mnt[v] = mnt[v + v + 1];
    }
    else
    {
        upd(v + v + 1, md + 1, tr, ps);

        if (mx[v + v + 1] != -1)
            mx[v] = mx[v + v + 1];
                else mx[v] = mx[v + v];

        if (mnt[v + v] != -1)
            mnt[v] = mnt[v + v];
                else mnt[v] = mnt[v + v + 1];
    }
}

void updr(int v, int tl, int tr, int ps)
{
    if (tl == tr)
    {
        if (mn[v] == -1)
            mn[v] = tl;
                else mn[v] = -1;

        return;
    }

    int md = (tl + tr) >> 1;

    if (ps <= md)
    {
        updr(v + v, tl, md, ps);
    }
    else
    {
        updr(v + v + 1, md + 1, tr, ps);
    }

    if (mn[v + v] == -1)
        mn[v] = mn[v + v + 1];
            else mn[v] = mn[v + v];
}

int fnd_mn(int v, int tl, int tr, int l, int r)
{
    if (tr < l || r < tl || l > r || tl > tr || mn[v] == -1) return -1;

    if (l <= tl && tr <= r) return mn[v];

    int md = (tl + tr) >> 1;

    int a = fnd_mn(v + v, tl, md, l, r);

    int b = fnd_mn(v + v + 1, md + 1, tr, l, r);

    if (a != -1)
        return a;

    return b;
}

int fnd_mx(int v, int tl, int tr, int l, int r)
{
    if (tr < l || r < tl || l > r || tl > tr || mx[v] == -1) return -1;

    if (l <= tl && tr <= r) return mx[v];

    int md = (tl + tr) >> 1;

    int a = fnd_mx(v + v, tl, md, l, r);

    int b = fnd_mx(v + v + 1, md + 1, tr, l, r);

    if (b != -1)
        return b;

    return a;
}

int get_mn(int v, int tl, int tr, int l, int r)
{
    if (tr < l || r < tl || l > r || tl > tr || mnt[v] == -1) return -1;

    if (l <= tl && tr <= r) return mnt[v];

    int md = (tl + tr) >> 1;

    int a = get_mn(v + v, tl, md, l, r);

    int b = get_mn(v + v + 1, md + 1, tr, l, r);

    if (a != -1)
        return a;

    return b;
}
int main()
{
    ios_base::sync_with_stdio(0); istream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

//    freopen("1.in", "r", stdin);

    int q;

    cin >> q;

    for (; q > 0; q--)
    {
        int n;

        cin >> n;

        int a[n];

        for (int i = 0; i < n; i++)
            cin >> a[i];

        bld(1, 0, n - 1);

        for (int i = 0; i < n; i++)
        {
            int lst = (i - 1 + n) % n;

            if (__gcd(a[lst], a[i]) == 1)
                updr(1, 0, n - 1, i);
        }

        int cur = fnd_mn(1, 0, n - 1, 1, n - 1);

        if (cur == -1)
            cur = fnd_mn(1, 0, n - 1, 0, n - 1);

        vector <int> ans; ans.clear();

        while(cur != -1)
        {
            ans.PB(cur);

            upd(1, 0, n - 1, cur);

            updr(1, 0, n - 1, cur);

            int gt = get_mn(1, 0, n - 1, cur + 1, n - 1);

            if (gt == -1)
                gt = get_mn(1, 0, n - 1, 0, cur - 1);

            if (gt == -1)
                break;

            if (__gcd(a[gt], a[cur]) == 1)
                updr(1, 0, n - 1, gt);

            int pos = gt;

            gt = fnd_mx(1, 0, n - 1, 0, pos - 1);

            if (gt == -1)
                gt = fnd_mx(1, 0, n - 1, pos, n - 1);

            if (__gcd(a[gt], a[pos]) == 1)
                updr(1, 0, n - 1, pos);

            int ps = cur;

            cur = get_mn(1, 0, n - 1, ps + 1, n - 1);

            if (cur == -1)
                cur = get_mn(1, 0, n - 1, 0, ps - 1);

            if (cur == -1)
                break;

            gt = fnd_mn(1, 0, n - 1, cur + 1, n - 1);

            if (gt == -1)
                gt = fnd_mn(1, 0, n - 1, 0, cur);

            if (gt == -1)
                break;

            cur = gt;
        }

        cout << sz(ans) << " ";

        for (auto it : ans)
            cout << it + 1 << " ";

        cout << endl;
    }
}
