#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;

const ll N = 2e5;
const ll inf = 1e18;

ll gcd(ll a, ll b) {
	if (a > b) {
		swap(a, b);
	}
	if (a == 0) {
		return b;
	}
	return gcd(a, b % a);
}

ll pre[N];
ll nxt[N];
bool used[N];
vector <ll> v;
ll A[N];
vector <ll> ans;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll t = 1;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		for (ll i = 0; i < n; i++) {
			cin >> A[i];
			nxt[i] = (i + 1) % n;
			pre[i] = (i + n - 1) % n;
			used[i] = 0;
		}
		for (ll i = 0; i < n; i++) {
			if (gcd(A[i], A[nxt[i]]) == 1) {
				v.push_back(i);
			}
		}
		ans.clear();
		while (!v.empty()) {
			vector <ll> nv;
			for (ll i = 0; i < v.size(); i++) {
				if (used[v[i]]) {
					continue;
				}
				used[nxt[v[i]]] = 1;
				ans.push_back(nxt[v[i]]);
				nxt[v[i]] = nxt[nxt[v[i]]];
				pre[nxt[v[i]]] = v[i];
				if (gcd(A[v[i]], A[nxt[v[i]]]) == 1) {
					nv.push_back(v[i]);
				}
			}
			v = nv;
		}
		cout << ans.size() << " ";
		for (ll i = 0; i < ans.size(); i++) {
			cout << ans[i] + 1 << " ";
		}
		cout << '\n';
	}
}