#include <iostream>
#include <iomanip>
#include <vector>
#include <stack>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>


#define ll long long
#define ld long double

using namespace std;

ll gcd(ll a, ll b) {
	if (a == 0) return b;
	while (b > 0) {
		ll c = a % b;
		a = b;
		b = c;
	}
	return a;
}

int main()
{
	ll t;
	cin >> t;
	for (ll ii = 0; ii < t; ++ii) {
		ll n;
		cin >> n;
		vector<ll>a(n);
		for (ll i = 0; i < n; ++i) {
			cin >> a[i];
		}
		vector<ll>ans;
		set<ll>st;
		vector<ll>l(n);
		vector<ll>next(n);
		for (ll i = 0; i < n; ++i) {
			l[(i + 1) % n] = i;
			next[i] = (i + 1) % n;
			if (gcd(a[i], a[(i + 1) % n]) == 1) { 
				st.insert(i);
			}
		}
		while (st.size() > 0) {
			auto indt = st.begin();
			vector<ll>c;
			while (indt != st.end()) {
				ll x = *indt;
				if (ans.size() == 0 || ans[ans.size() - 1] != x) {
					ans.push_back(next[x]);
					c.push_back(next[x]);
				}
				++indt;
			}
			for (ll i = 0; i < c.size(); ++i) {
				st.erase(l[c[i]]);
				st.erase(c[i]);
				l[next[c[i]]] = l[c[i]];
				next[l[c[i]]] = next[c[i]];
				if (next[c[i]] != c[i] && gcd(a[next[c[i]]], a[l[c[i]]]) == 1) {
					st.insert(l[c[i]]);
				}
			}
		}
		cout << ans.size() << ' ';
		for (ll i = 0; i < ans.size(); ++i) {
			cout << ans[i] + 1 << ' ';
		}
		cout << '\n';
	}
}
