#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<fstream>
#include<algorithm>
#include<math.h>
#include<cmath>
#include<vector>
#include<set>
#include<queue>
#include<map>
#include<string>

//#define int long long
#define ll long long
#define ld long double
#define pii pair<int,int>
#define endl '\n'
#define range(i,n) for(int i=0;i<n;i++)
#define BE(v) v.begin(), v.end()
#define cint(a) int a; cin>>a;
#define pb push_back

using namespace std;

int maxeq(int& a, int b)
{
	a = max(a, b);
	return a;
}

int mineq(int& a, int b)
{
	a = min(a, b);
	return a;
}

pii operator+=(pii& a, pii b)
{
	a.first += b.first;
	a.second += b.second;
	return a;
}

pii operator+(pii a, pii b)
{
	return a += b;
}

pii operator-=(pii& a, pii b)
{
	a.first -= b.first;
	a.second -= b.second;
	return a;
}

pii operator-(pii a, pii b)
{
	return a -= b;
}

int gcd(int a, int b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

const int bes = 2e9;
const int N = 2e5;
const ll mod = 1e9 + 7;

struct Node
{
	int ind;
	Node* l, *r;
	int x;
	Node() {}
	int del()
	{
		l->r = r;
		r->l = l;
		x = -3;
		return ind;
	}
	int ch()
	{
		if (x == -3)
			return -1;
		if (gcd(x, r->x) == 1)
		{
			return r->del();
		}
		return -1;
	}
};

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cint(t);
	while (t--)
	{
		vector<Node*> v;
		Node* f = 0;
		Node* l = 0;
		cint(n);
		vector<int> ans;
		range(i, n)
		{
			Node* now = new Node;
			cint(a);
			now->x = a;
			now->ind = i;
			if (f)
			{
				now->l = l;
				l->r = now;
			}
			else
			{
				f = now;
			}
			l = now;
			v.pb(now);
		}
		l->r = f;
		f->l = l;
		while (v.size())
		{
			vector<Node*> now;
			for (int i = 0; i < v.size(); i++)
			{
				int a = v[i]->ch();
				if (a != -1)
				{
					ans.pb(a);
					now.push_back(v[i]);
				}
			}
			v = now;
		}
		cout << ans.size() << " ";
		for (int i : ans)
		{
			cout << i + 1 << " ";
		}
		cout << endl;
	}
}