#include <bits/stdc++.h>

using namespace std;

int t[800005], a[100005];
void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = tr;
    }
    else {
        int m = (tl + tr) / 2;
        build(v * 2, tl, m);
        build(v * 2 + 1, m + 1, tr);
        t[v] = tr;
    }
}

int get(int v, int tl, int tr, int l) {
    if (l > tr) {
        return 1e9;
    }
    if (tl == tr) {
        return t[v];
    }
    int m = (tl + tr) / 2;
    if (t[v * 2] != 1e9 && t[v * 2] >= l) {
        return get(v * 2, tl, m, l);
    }
    else {
        return get(v * 2 + 1, m + 1, tr, l);
    }
}

void modify(int v, int tl, int tr, int pos) {
    if (tl == tr) {
        t[v] = 1e9;
        return;
    }
    int m = (tl + tr) / 2;
    if (pos <= m) {
        modify(v * 2, tl, m, pos);
    }
    else {
        modify(v * 2 + 1, m + 1, tr, pos);
    }
    if (t[v * 2 + 1] == 1e9) {
        t[v] = t[v * 2];
    }
    else {
        t[v] = t[v * 2 + 1];
    }
}

int main() {
    int t;
   // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        queue<int> q;
        vector <bool> del(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            if (i != 0 && __gcd(a[i], a[i - 1]) == 1) {
                q.push(i - 1);
            }
        }

        if (__gcd(a[n - 1], 1) == 1) {
            q.push(n - 1);
        }
        build(1, 0, n - 1);
        vector <int> ans;
        while(!q.empty()) {
            int x = q.front(); // delete first element after x
            q.pop();
            if (del[x]) {
                continue;
            }
            int r = get(1, 0, n - 1, x + 1);
            if (r == 1e9) {
                r = get(1, 0, n - 1, 0);
                if (r > x) {
                    break;
                }
            }
            if (__gcd(a[x], a[r]) == 1) {
                ans.push_back(r + 1);
                modify(1, 0, n - 1, r);
                del[r] = 1;
                q.push(x);
            }
        }
        cout << ans.size() << " ";
        for (int i = 0; i < ans.size(); i++) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
    return 0;
}
