#include <bits/stdc++.h>

using namespace std;
#define int long long
vector<int> parent;

int find(int x) {
    if (x == parent[x])
        return x;
    return (parent[x] = find(parent[x]));
}

void solve() {
    int n;
    cin >> n;
    vector<int> next(n);
    for (int i = 0; i < n; ++i)
        next[i] = (i + 1) % n;
    parent.assign(n, 0);
    for (int i = 0; i < n; ++i)
        parent[i] = i;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int cur = 0;
    vector<int> ans;
    while (true) {
        if (cur == next[cur])
            break;
        if (cur == next[find(cur)] && __gcd(a[cur], a[find(cur)]) != 1)
            break;
        int last = find(cur);
        if (__gcd(a[last], a[next[last]]) == 1) {
            ans.push_back(next[last]);
            next[last] = next[next[last]];
            cur = next[last];
        } else {
            parent[last] = find(next[last]);
            parent[cur] = parent[last];
        }
    }
    if (a[cur] == 1)
        ans.push_back(cur);
    cout << ans.size() << " ";
    for (int i = 0; i < ans.size(); ++i)
        cout << ans[i] + 1 << " ";
    cout << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}