#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;


const int MAX_N = 1e5;
int a[MAX_N];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    set <int> alive_indexes;
    for (int i = 0; i < n; ++i) {
        alive_indexes.insert(i);
    }
    set <tuple <int, int, int>> events;
    int t = 0;
    for (int i = 0; i < n; ++i) {
        int g = gcd(a[i], a[(i + 1) % n]);
        if (g != 1)
            continue;
        events.insert({t++, i, (i + 1) % n});
    }
    vector <int> answ;
    while (!events.empty()) {
        auto [cur_t, i, j] = *events.begin();
        events.erase(events.begin());
        if (alive_indexes.count(i) + alive_indexes.count(j) != 2)
            continue;
        alive_indexes.erase(j);
        answ.push_back(j);
        if (i != j) {
            auto it = alive_indexes.upper_bound(i);
            if (it == alive_indexes.end())
                it = alive_indexes.begin();
            if (gcd(a[i], a[*it]) == 1)
                events.insert({t++, i, *it});
        }
    }
    cout << answ.size() << ' ';
    for (auto e : answ)
        cout << e + 1 << ' ';
    cout << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
