#include <bits/stdc++.h>

/// #pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

ll gcd(ll x, ll y) {
    while(y) {
        ll tmp = x % y;
        x = y;
        y = tmp;
    }
    return x;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a;
    for(ll i = 0; i < n; i++) {
        ll cur;
        cin >> cur;
        a.pb(cur);
    }

    vector<ll> prev(n, 0);
    vector<ll> nxt(n, 0);
    for(ll i = 0; i < n; i++) {
        prev[i] = (i - 1 + n) % n;
        nxt[i] = (i + 1) % n;
    }

    set<ll> ps;
    for(ll i = 0; i < n; i++) {
        ll g = gcd(a[i], a[nxt[i]]);
        if(g == 1) {
            ps.insert(i);
        }
    }

    vector<ll> ans;

    while(ps.size() > 0) {
        ll deld = -2;
        set<ll> used;
        set<ll> to_rem;
        set<ll> to_add;
        for(auto pos : ps) {
            if(pos == deld) continue;
            ans.pb(nxt[pos]);
            deld = nxt[pos];

            used.insert(pos);
            to_rem.insert(nxt[pos]);

            // cout << pos << " " << nxt[pos] << " " << nxt[nxt[pos]] << endl;

            ll nw = nxt[nxt[pos]];
            prev[nw] = pos;
            nxt[pos] = nw;
            if(gcd(a[pos], a[nxt[pos]]) == 1) {
                // cout << "here" << endl;
                to_add.insert(pos);
            }
        }

        for(auto el : used) {
            ps.erase(el);
        }
        for(auto el : to_add) {
            ps.insert(el);
        }
        for(auto el : to_rem) {
            ps.erase(el);
        }
    }

    cout << ans.size() << " ";
    for(auto el : ans) {
        cout << el+1 << " ";
    }
    cout << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q;
    cin >> q;
    for(ll i = 0; i < q; i++)
    solve();

    return 0;
}
