//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double
#define all(x) (x).begin(), (x).end()
const int MX = 2e18;

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> right(n), left(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        right[i] = (i + 1) % n;
        left[i] = (i - 1 + n) % n;
    }
    if(n == 1 && a[0] == 1){
        cout << 1 << " " << 1 << "\n";
        return;
    }
    if(n == 1){
        cout << 0 << "\n";
        return;
    }
    set<int> b;
    for (int i = 0; i < n; ++i) {
        if (gcd(a[i], a[(i + 1) % n]) == 1)
            b.insert(i);
    }
    int last = 0;
    vector<int> ans;
    while (!b.empty()) {
        if (*b.rbegin() < last) {
            last = 0;
        }
        int x = *b.lower_bound(last);
        b.erase(x);
        int y = right[x];
        ans.push_back(y + 1);
        if(x == y){
            continue;
        }
        right[x] = right[y];
        left[right[y]] = x;
        if(b.find(y) != b.end())
            b.erase(y);
        if(gcd(a[x], a[right[x]]) == 1)
            b.insert(x);
        last = (y + 1) % n;
    }
    cout << ans.size() << " ";
    for(int i = 0;i<ans.size();++i)
        cout << ans[i] << " ";
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
//    t = 1;
    while (t--) {
        solve();
    }
}