#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <map>

#define F first
#define S second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define siz(a) int(a.size())

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vll = vector<ll>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false;}
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false;}

const int N = 2e5 + 7;
const int INF = 1e9;
const ll LINF = 1e18;


void solve() {
    int n; cin >> n;
    vi l(n), r(n), a(n);
    set<int> st;
    for (auto &x:a) cin >> x;
    for (int i = 0; i < n; ++i) {
        r[i] = (i + 1) % n;
        l[i] = (i - 1 + n) % n;
        if(__gcd(a[i], a[r[i]]) == 1) st.insert(i);
    }
    vector<int> ans;
    int prev_id = 0;
    while(!st.empty()) {
        auto it = st.lower_bound(prev_id);
        if(it == st.end()) it = st.begin();
        //cout << *it << "\n";
        auto id = r[*it]; st.erase(id);
        //cout << st.size() << " " << id << endl;
        int ir = r[id], il = l[id];
        //cout << id << " " << il << " - " << ir << " " << a[ir] << "\n";
        ans.pb(id);  st.erase(il);
        r[il] = ir; l[ir] = il;
        if(id == il) break;
        if(__gcd(a[il], a[ir]) == 1) st.insert(il);
        prev_id = ir;
    }
    cout << ans.size() << " ";
    for (auto x:ans) cout << x+1 << " ";cout << "\n";
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while(t--) solve();
    return 0;
}
