#include <bits/stdc++.h>
#define int long long
using namespace std;

const int mod = 1e9 + 7, inf = 1e9;
vector<int> t;
int k;

void Minus(vector<int> &t, int v) {
    for (; v > 0; v /= 2) --t[v];
}

int Sum(vector<int> &t, int v, int tl, int tr, int l, int r) {
    if (l > r) return 0;
    if (tl == l && tr == r) return t[v];
    int tm = (tr + tl) / 2;
    return Sum(t, v * 2, tl, tm, l, min(r, tm)) +
            Sum(t, v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

int Get(vector<int> &t, int v) {
    int have = Sum(t, 1, 0, k - 1, 0, v - k - 1) + 1;
    int i;
    for (i = 1; i < k; ) {
        if (t[2 * i] < have) {
            have -= t[2 * i];
            i = 2 * i + 1;
        } else i = 2 * i;
    }
    return i - k;
}

void solve() {
    int n;
    cin >> n;
    vector<int> aa(n), next(n);
    for (int i = 0; i < n; ++i) cin >> aa[i];
    for (int i = 0; i < n; ++i) next[i] = (i + 1) % n;
    k = 1 << (int)ceil(log2(n));
    t.resize(2 * k, 0);
    for (int i = 0; i < n; ++i) {
        t[i + k] = gcd(aa[i], aa[next[i]]) == 1;
    }
    for (int i = k - 1; i > 0; --i)
        t[i] = t[2 * i] + t[2 * i + 1];
    int cur = 0;
    vector<int> ans;
    while (t[1] > 0) {
        if (Sum(t, 1, 0, k - 1, cur, n - 1) == 0) {
            cur = 0;
            continue;
        }
        cur = Get(t, cur + k);
        ans.push_back(next[cur] + 1);
        if (t[k + next[cur]]) Minus(t, k + next[cur]);
        if (ans.size() == n) break;
        next[cur] = next[next[cur]];
        if (gcd(aa[cur], aa[next[cur]]) != 1) Minus(t, k + cur);
        cur = next[cur];
    }
    cout << ans.size() << " ";
    for (int i = 0; i < ans.size(); ++i) cout << ans[i] << " ";
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}
