#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

#define sz(x) (int((x).size()))
#define pb push_back
#define ins insert
#define ers erase

template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll MAXN = 1e5 + 10;

int a[MAXN], nxt[MAXN];
vector<int> ans;
set<int> positions, positions2;

void solve() {
    ans.clear();

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        nxt[i] = i + 1;
    }

    nxt[n - 1] = 0;

    for (int i = 0; i < n; i++) {
        if (ans.size() && ans.back() == i) {
            continue;
        }

        if (gcd(a[i], a[nxt[i]]) == 1) {
            ans.pb(nxt[i]);

            if (gcd(a[i], a[nxt[nxt[i]]]) == 1) {
                positions.ins(i);
            }

            positions.ers(nxt[i]);

            nxt[i] = nxt[nxt[i]];
        }
    }

    while (true) {
        while (!positions.empty()) {
            int i = *positions.begin();
            if (gcd(a[i], a[nxt[i]]) == 1) {
                ans.pb(nxt[i]);


                if (gcd(a[i], a[nxt[nxt[i]]]) == 1) {
                    positions2.ins(i);
                }

                positions.ers(i);
                positions.ers(nxt[i]);
                positions2.ers(nxt[i]);
                nxt[i] = nxt[nxt[i]];
            } else {
                positions.erase(i);
                break;
            }
        }

        if (positions2.empty()) {
            break;
        }

        positions.swap(positions2);
    }

    cout << ans.size() << " ";
    for (int i : ans) {
        cout << (i + 1) << " ";
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;

#ifdef _LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> t;
#else
    cin >> t;
#endif

    while (t--) {
        cerr << t << "\n";
        solve();
        cout << "\n";
    }

    return 0;
}
