#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define ld long double
#define pb push_back
#define pii pair<int,int>
#define f first
#define s second
#define pld pair<ld,ld>
#define emp nullptr
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
const int MAX_N = 2e5 + 7;
vector<int> g[MAX_N];
bool used[MAX_N];
int t[MAX_N], d[MAX_N];

void find(int l, int r, int v, int vl, int vr) {
    if (vr < l || r < vl)return;
    if (l <= vl && vr <= r)return;
    int mid = (l + r) / 2;
    find(l, r, v * 2, vl, mid);
    find(l, r, v * 2 + 1, mid + 1, vr);
}

void change(int l, int r, int v, int vl, int vr, int val) {
    if (vr < l || r < vl)return;
    if (l <= vl && vr <= r) {
        t[v] = val;
        d[v] = val;
        return;
    }
    // push(v)
    int mid = (l + r) / 2;
    change(l, r, v * 2, vl, mid, val);
    change(l, r, v * 2 + 1, mid + 1, vr, val);
    //upd(v)
}

void dfs(int v) {
    used[v] = true;
    for (int to : g[v]) {
        if (!used[to])dfs(to);
    }
}

int gcd(int a, int b) {
    if (a == 0)return b;
    return gcd(b % a, a);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int q;
    cin >> q;
    while (q--) {
        int n;
        cin >> n;
        int a[n];

        set<pii > seg;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            seg.insert({i, i});
        }
        pii cur = *seg.begin();
        bool banned[n];
        fill(banned, banned + n, false);
        vector<int> ans;
        while (seg.size() > 1) {
            pii last = *(--seg.end());
            if (last.f == cur.f) {
                pii next = *seg.begin();
                if (gcd(a[next.f], a[cur.s]) == 1) {
                    seg.erase(next);
                    ans.pb(next.f);
                    banned[next.f] = true;
                    while (next.f < n && banned[next.f]) next.f++;
                    if (next.f <= next.second) {
                        seg.insert(next);
                        cur = next;
                    }
                    else{
                        cur = *seg.begin();
                    }
                } else {
                    cur = next;
                }
            } else {
                pii next = *seg.upper_bound(cur);
                if (gcd(a[cur.s], a[next.f]) == 1) {
                    seg.erase(next);
                    ans.pb(next.f);
                    banned[next.f] = true;
                    while (next.f < n && banned[next.f])next.f++;
                    if (next.f <= next.s) {
                        seg.insert(next);
                        cur = next;
                    } else {
                        if (cur.f == (--seg.end())->f) {
                            cur = *seg.begin();
                        } else cur = *seg.upper_bound(cur);
                    }
                } else {
                    seg.erase(next);
                    seg.erase(cur);
                    cur.s = next.s;
                    seg.insert(cur);
                }
            }
        }
        pii last = *seg.begin();
        int l = last.f, r = last.s;
        while (l <= r && gcd(a[l], a[r]) == 1) {
            ans.pb(l);
            banned[l] = true;
            while (banned[l])l++;
        }
        cout << ans.size() << " ";
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i] + 1 << " ";
        }
        cout << endl;
    }
}