/*
 * created by @kamil.sharipov
 */

#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,popcnt,tune=native")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define all (x).begin(), (x).end()
#define pii pair<int, int>
//#define int long long

struct node {
    int x;
    int beg = -1;
    int en = -1;
    int pos;
    int next;
};
vector<node> a;

void child(node p, int x = 1) {
    if (p.en == p.pos) return;
    if (x == 1) a[p.en].beg = p.next;
    a[p.next].en = p.en;
}

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        a.clear();
        a.resize(n);
        vector<int> ans;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].x;
            a[i].pos = i;
            a[i].next = i + 1;
            if (i == n - 1) a[i].next = 0;
            a[i].beg = i;
            a[i].en = i;
        }

        int st = 0, cur = 1;
        int cnt = 0;
        while (true) {
            if (ans.size() == n) break;
            cnt++;
            if (cur == 0) {
                child(a[st], 0);
                cur = 1;
                continue;
            }
            if (a[st].en == a[st].pos) {
                if (gcd(a[st].x, a[a[st].next].x) != 1) {
                    a[a[st].beg].en = a[a[st].next].en;
                    a[a[a[st].next].en].beg = a[st].beg;
                } else {
                    cnt = 0;
                    ans.push_back(a[a[st].next].pos + 1);
                    if (ans.size() == n) break;
                    child(a[a[st].next]);
                    a[st].next = a[a[st].next].next;
                    cur = 0;
                }
                st = a[st].next;
            } else {
                st = a[st].en;
            }
            if (cnt > 2 * n) break;
        }

        cout << ans.size() << " ";
        for (int i = 0; i < ans.size(); ++i) {
            cout << ans[i] << " ";
        }
        cout << "\n";
    }
}
