#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <map>
#include <set>


#define int long long
#define ll long long
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define sz(a) a.size()



using namespace std;


int gcd(int a, int b) {
	while (a != 0) {
		b = b % a;
		swap(a, b);
	}
	return b;
}


int n;
vector<int> a;
vector<int> nxt;
set<int> bd;
vector<int> res;


int32_t main() {
	int t;
	cin >> t;
	while (t--) {
		cin >> n;
		a.resize(n);
		nxt.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			nxt[i] = (i + 1) % n;
		}
		for (int i = 0; i < n; ++i) {
			if (gcd(a[i], a[nxt[i]]) == 1) {
				bd.insert(i);
			}
		}
		res.clear();
		int i = -1;
		while (!bd.empty()) {
			auto it = bd.upper_bound(i);
			if (it == bd.end()) {
				it = bd.begin();
			}
			i = (*it);
			bd.erase(i);
			res.push_back(nxt[i]);
			if (bd.find(nxt[i]) != bd.end()) {
				bd.erase(nxt[i]);
			}
			if(nxt[i] == i)
			{
				break;
			}
			nxt[i] = nxt[nxt[i]];
			if (gcd(a[i], a[nxt[i]]) == 1) {
				bd.insert(i);
			}
		}
		cout << res.size() << " ";
		for (auto c : res) {
			cout << c + 1 << " ";
		}
		cout << "\n";
	}
	return 0;
}