#include <bits/stdc++.h>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = (ll)(1e9 + 7);
const ll INF = (ll)(1e18);
const ld EPS = (ld)(1e-9);

mt19937 rnd(time(0));

void fast_stream() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

ll gcd(ll a, ll b) {
    if (b > a) {
        swap(a, b);
    }
    while (a % b) {
        a %= b;
        swap(a, b);
    }
    return b;
}

signed main() {
    fast_stream();
    ll tests;
    cin >> tests;
    while (tests--) {
        ll n;
        cin >> n;
        vector<ll> a(n);
        for (auto &i : a) {
            cin >> i;
        }
        vector<ll> next_ind(n), prev_ind(n);
        for (ll i = 0; i < n; ++i) {
            next_ind[i] = (i + 1) % n;
        }
        for (ll i = 0; i < n; ++i) {
            prev_ind[i] = (i - 1 + n) % n;
        }
        ll now_ind = 0LL;
        vector<ll> is_life(n, 1LL);
        vector<ll> dtp;
        vector<ll> uvolen;
        for (ll i = 0; i < n; ++i) {
            if (!is_life[i]) continue;
            if (gcd(a[i], a[(i + 1) % n]) == 1) {
                dtp.push_back(i);
                is_life[(i + 1) % n] = 0LL;
                next_ind[i] = next_ind[next_ind[i]];
                uvolen.push_back((i + 1) % n);
            }
        }
        while (dtp.size()) {
            vector<ll> new_dtp;
            for (auto i : dtp) {
                if (!is_life[i]) {
                    continue;
                }
                if (next_ind[i] == i) {
                    if (a[i] == 1) {
                        uvolen.push_back(i);
                    }
                    new_dtp.clear();
                    break;
                }
                ll sled_ind = next_ind[i];
                if (gcd(a[i], a[sled_ind]) == 1) {
                    new_dtp.push_back(i);
                    is_life[sled_ind] = 0LL;
                    next_ind[i] = next_ind[next_ind[i]];
                    uvolen.push_back(sled_ind);
                }
            }
            dtp = new_dtp;
        }
        cout << uvolen.size() << ' ';
        for (auto i : uvolen) {
            cout << ++i << ' ';
        }
        cout << '\n';
    }
}