#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define x first
#define y second

#define vert int v, int tl, int tr
#define left (v << 1), tl, tm
#define right (v << 1) + 1, tm, tr

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

ll dp[300009];
ll h[300009];
ll b[300009];
int lefles[300009];

const ll inf = 1e17;

ll tree_dp[1100009];
ll tree_sum[1100009];
ll upd_sum[1100009];

inline void push(vert) {
    if (upd_sum[v] == -inf) return;

    if (tr - tl != 1) {
        upd_sum[v << 1] = upd_sum[v];
        upd_sum[(v << 1) + 1] = upd_sum[v];
    }

    tree_sum[v] = upd_sum[v];
    upd_sum[v] = -inf;
}

void build(vert) {
    tree_dp[v] = -inf;
    tree_sum[v] = -inf;
    upd_sum[v] = -inf;

    if (tr - tl == 1) {
        if (tl == 0) {
            tree_dp[v] = 0;
        }

        return;
    }

    int tm = (tl + tr) >> 1;
    build(left);
    build(right);
}

void add_dp(vert, int i, ll x) {
    if (tr - tl == 1) {
        tree_dp[v] = x;
        return;
    }

    int tm = (tl + tr) >> 1;
    if (i < tm) {
        add_dp(left, i, x);
    }

    else {
        add_dp(right, i, x);
    }

    tree_dp[v] = max(tree_dp[v << 1], tree_dp[(v << 1) + 1]);
}

void change_bmin(vert, int l, int r, ll x) {
    push(v, tl, tr);

    if (tl >= r || l >= tr) return;
    if (tl >= l && tr <= r) {
        upd_sum[v] = x;
        push(v, tl, tr);
        return;
    }

    int tm = (tl + tr) >> 1;
    change_bmin(left, l, r, x);
    change_bmin(right, l, r, x);

    tree_sum[v] = max(tree_sum[v << 1], tree_sum[(v << 1) + 1]);
}

ll get_max_dp(vert, int l, int r) {
    if (tl >= r || l >= tr) return -inf;
    if (tl >= l && tr <= r) return tree_dp[v];
    int tm = (tl + tr) >> 1;
    return max(get_max_dp(left, l, r), get_max_dp(right, l, r));
}

ll get_max_sum(vert, int l, int r) {
    push(v, tl, tr);
    if (tl >= r || l >= tr) return -inf;
    if (tl >= l && tr <= r) return tree_sum[v];
    int tm = (tl + tr) >> 1;
    return max(get_max_sum(left, l, r), get_max_sum(right, l, r));
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    //freopen("in.txt", "r", stdin);
    //freopen("wa.txt", "w", stdout);

    int n;
    cin >> n;

    for (int i = 1; i <= n; i++) {
        cin >> h[i];
        dp[i] = -inf;
    }

    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    vector<int> st;
    for (int i = n; i >= 1; i--) {
        while (st.size() && h[st.back()] > h[i]) {
            lefles[st.back()] = i;
            st.pop_back();
        }

        st.push_back(i);
    }

    dp[0] = 0;
    build(1, 0, n + 1);

    for (int i = 1; i <= n; i++) {
        //lefles[i] ... i - 1 ->  + b[i]
        auto max_dp = get_max_dp(1,  0, n + 1, lefles[i], i);
        change_bmin(1, 0, n + 1, lefles[i], i, max_dp + b[i]);
        dp[i] = get_max_sum(1, 0, n + 1, 0, i);
        add_dp(1, 0, n + 1, i, dp[i]);
    }

    cout << dp[n];

    return 0;
}

