#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <tuple>
#include <deque>
#include <random>
#include <iterator>
#include <cmath>
#include <algorithm>

using namespace std;

// #define int long long
#define rs resize
#define ft first
#define sd second
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const int MN = 3e5 + 5;
ll dp[MN], tr[4 * MN];

void build(int u, int l, int r)
{
    tr[u] = -INF;
    if (l + 1 == r)
    {
        return;
    }
    int m = (l + r) / 2;
    build(u * 2, l, m);
    build(u * 2 + 1, m, r);
    return;
}

ll get_max(int u, int sl, int sr, int ql, int qr)
{
    // if (ql == qr)
    // {
    //     return 0;
    // }
    if (sl == ql && sr == qr)
    {
        return tr[u];
    }
    int sm = (sl + sr) / 2;
    ll res = -INF;
    if (ql < sm)
    {
        res = max(res, get_max(u * 2, sl, sm, ql, min(qr, sm)));
    }
    if (qr > sm)
    {
        res = max(res, get_max(u * 2 + 1, sm, sr, max(ql, sm), qr));
    }
    return res;
}

void update(int u, int l, int r, int x)
{
    if (l + 1 == r)
    {
        tr[u] = dp[x];
        return;
    }
    int m = (l + r) / 2;
    if (x < m)
    {
        update(u * 2, l, m, x);
    }
    else 
    {
        update(u * 2 + 1, m, r, x);
    }
    tr[u] = max(tr[u * 2], tr[u * 2 + 1]);
    return;
}

signed main()
{
    // ios_base::sync_with_stdio(false);
    // cin.tie(0);
    // cout.tie(0);
    int n;
    cin >> n;
    vector<ll> h(n), b(n);
    for (int i = 0; i < n; i++)
    {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }
    build(1, 0, n);
    deque<int> pr;
    ll mn = b[0], mi = 0;
    dp[0] = b[0];
    update(1, 0, n, 0);
    pr.push_back(0);
    // cout << "here\n";
    for (int i = 1; i < n; i++)
    {
        if (h[mi] > h[i])
        {
            mi = i;
            mn = b[i];
        }
        while (!pr.empty() && h[pr.back()] > h[i])
        {
            pr.pop_back();
        }
        if (pr.empty())
        {
            dp[i] = max(b[i] + get_max(1, 0, n, 0, i), mn);
            update(1, 0, n, i);
        }
        else
        {
            int j = pr.back();
            dp[i] = max({mn, b[i] + get_max(1, 0, n, j, i), dp[j]});
            update(1, 0, n, i);
        }
        pr.push_back(i);
    }
    // for (int i = 0; i < n; i++)
    // {
    //     cout << dp[i] << " ";
    // }
    cout << dp[n - 1];
    // cout << "\n" << get_max(1, 0, n, 0, 1);
    return 0;
}