#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <algorithm>
#include <stack>
#include <map>
#include <string>
#include <ctime>
#include <queue>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

ll inf = 1e18 + 7;

vector<pair<ll, ll> > mas;
vector<ll> h;

void upd(ll id, ll l, ll r, ll x, ll k){
    if (r - l == 1){
        mas[id].first = x;
        mas[id].second = k;
        return;
    }
    ll m = (l + r) / 2;
    if (k < m){
        upd(id * 2, l, m, x, k);
    }else{
        upd(id * 2 + 1, m, r, x, k);
    }
    if (mas[id * 2].first > mas[id * 2 + 1].first){
        mas[id] = mas[id * 2];
    }else{
        mas[id] = mas[id * 2 + 1];
    }
}

pair<ll, ll> get_max(ll id, ll l, ll r, ll s_l, ll s_r){

    if (l >= s_r || r <= s_l){
        return {-inf, -1};
    }
    //cout << l << ' ' << r << ' ' << s_l <<  ' '  << s_r << endl;
    if (s_l <= l && r <= s_r){
        return mas[id];
    }
    ll m = (l + r) / 2;
    auto res1 = get_max(id * 2, l, m, s_l, s_r);
    auto res2 = get_max(id * 2 + 1, m, r, s_l, s_r);
    if (res1.first > res2.first){
        return res1;
    }else{
        return res2;
    }
}

int main()
{
    srand(time(NULL));
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*
    cout.setf(ios::fixed);
    cout.precision(10);
    */
    int t = 1;
    //cin >> t;
    for (int ctr = 0 ;ctr < t; ctr++){
        ll n;
        cin >> n;
        h.resize(n);
        mas.resize(4 * n, {-inf, -1});
        vector<ll> b(n);
        for (int i = 0; i < n; i++){
            cin >> h[i];
        }

        for (int i = 0; i < n; i++){
            cin >> b[i];
        }
        vector<ll> left(n);
        left[0] = -1;
        //st.insert(-h[0]);
        for (int i = 1; i < n; i++){
            ll j = i - 1;
            while (h[j] > h[i]){
                j = left[j];
                if (j == -1){
                    break;
                }
            }
            if (j == -1){
                left[i] = -1;
            }else{
                left[i] = j;
            }
        }
        vector<ll> right(n);
        right[n - 1] = -1;
        for (int i = n - 2; i >= 0; i--){
            int j = i + 1;
            while (h[j] > h[i]){
                j = right[j];
                if (j == -1){
                    break;
                }
            }
            if (j == -1){
                right[i] = -1;
            }else{
                right[i] = j;
            }
        }

        vector<vector<ll> > dp(n, vector<ll> (3));
        vector<ll> p(n);
        dp[0][0] = b[0];
        dp[0][1] = b[0];
        p[0] = -1;
        upd(1, 0, n, b[0], 0);

        for (int i = 1; i < n; i++){
            dp[i][0] = b[i] + max(dp[i - 1][0], dp[i - 1][1]);
            if (left[i] == -1){
                auto now = get_max(1, 0, n, 0, i);
                //cout << now.first << endl;
                if (now.first < 0){
                    p[i] = -1;
                    dp[i][1] = b[i];
                }else{
                    p[i] = now.second;
                    dp[i][1] = now.first + b[i];
                }
                upd(1, 0, n, max(dp[i][0], dp[i][1]), i);
                continue;
            }
            auto now = get_max(1, 0, n, left[i] + 1, i);
            //cout << now.first << "!!!"  << left[i] << ' ' << i << endl;
            if (now.first < 0){
                p[i] = now.second;
                dp[i][1] = max(max(dp[left[i]][0], dp[left[i]][1]), now.first + b[i]) ;

            }else{
                p[i] = now.second;
                dp[i][1] = max(max(dp[left[i]][0], dp[left[i]][1]), now.first + b[i]) ;
                //dp[i][1] = now.first + b[i];
            }
            upd(1, 0, n, max(dp[i][0], dp[i][1]), i);
        }

        cout << max(dp[n - 1][0], dp[n - 1][1]) << endl;
    }

    return 0;
}
