#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <bitset>
#include <random>
#include <queue>
#include <ctime>
#include <deque>
#include <set>
#include <map>

#define all(x) (x).begin(), (x).end()
#define an cerr <<"--->"; cerr.flush();

#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;

const ll inf = (ll)1e18 + 228;
const ll cst = 3e5 + 5;
const ll mod = 1e9 + 7;

void operator delete(void*);

ll n;

ll h[cst];
ll b[cst];

ll dp[cst];

vector<pair<ll, ll>> st;

ll segt[4 * cst];

void upd(ll v, ll tl, ll tr, ll p, ll x) {
	if (tl == tr - 1) {
		segt[v] = x;
		return;
	}
	ll tm((tl + tr) >> 1);
	if (p < tm) upd(2 * v, tl, tm, p, x);
	else upd(2 * v + 1, tm, tr, p, x);
	segt[v] = max(segt[2 * v], segt[2 * v + 1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
	if (l >= r) return -inf;
	if (l == tl && r == tr) return segt[v];
	ll tm((tl + tr) >> 1);
	ll g1 = get(2 * v, tl, tm, l, min(r, tm));
	ll g2 = get(2 * v + 1, tm, tr, max(l, tm), r);
	return max(g1, g2);
}

ll get_max(ll l, ll r) {
	return get(1, 0, cst - 5, l, r);
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n;
	for (ll i = 1; i <= n; i++) cin >> h[i];
	for (ll i = 1; i <= n; i++) cin >> b[i];
	for (ll i = 1; i <= n; i++) {
		while (!st.empty() && h[st.back().first] > h[i]) st.pop_back();
		ll bg = 0;
		if (!st.empty()) bg = st.back().first;
		dp[i] = get_max(bg, i) + b[i];
		if (!st.empty()) dp[i] = max(dp[i], st.back().second);
		ll mxx = get_max(bg, i) + b[i];
		if (!st.empty()) mxx = max(mxx, st.back().second);
		st.push_back({ i, mxx });
		upd(1, 0, cst - 5, i, dp[i]);
	}
	cout << dp[n];
	return 0;
}
