#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"

using namespace std;

#define ll long long
#define vi vector<ll>
#define vvi vector<vi>
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<ll, ll>
#define all(x) x.begin(), x.end()
#define mn(a, b) a = min(a, b)
#define mx(a, b) a = max(a, b)

const ll INF = 2e9;
const ll inf = 2e18;
const ll MAXN = 3e5 + 10;

istream& operator >>(istream &in, pii x) {
    in >> x.first >> x.second;
    return in;
}

template <class T>
istream& operator >>(istream &in, vector<T> &a) {
    for (T &i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator <<(ostream &out, vector<T> a) {
    for (T i : a) {
        out << i << " ";
    }
    out << "\n";
    return out;
}

ll t[4 * MAXN];

void upd(ll v, ll tl, ll tr, ll pos, ll x) {
    if (tl + 1 == tr) return void(t[v] = x);
    ll tm = (tl + tr) / 2;
    if (pos < tm) upd(2 * v, tl, tm, pos, x);
    else upd(2 * v + 1, tm, tr, pos, x);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

ll query(ll v, ll tl, ll tr, ll l, ll r) {
    if (tl >= r || l >= tr) return -inf;
    if (l <= tl && tr <= r) return t[v];
    ll tm = (tl + tr) / 2;
    return max(query(2 * v, tl, tm, l, r), query(2 * v + 1, tm, tr, l, r));
}

ll cnt[MAXN];
ll dp[MAXN];

void solve() {
    ll n; 
    cin >> n;
    vi h(n), b(n);
    cin >> h >> b;
    //for (int i = 0; i < n; ++i) h[i] = i + 1, b[i] = -i - 1;
    for (ll i = 0; i < 4 * MAXN; ++i) t[i] = -inf;
    for (ll i = 0; i < MAXN; ++i) dp[i] = -inf;
    dp[0] = 0;
    upd(1, 0, MAXN, 0, dp[0]);
    set<pii> best_ans;
    deque<ll> q;
    for (ll i = 0; i < n; ++i) {
        while (q.size() && h[q.back()] > h[i]) {
            best_ans.erase(mp(cnt[q.back()], q.back()));
            q.pop_back();
        }
        if (q.size()) cnt[i] = query(1, 0, MAXN, q.back() + 1, i + 1) + b[i];
        else cnt[i] = query(1, 0, MAXN, 0, i + 1) + b[i];
        best_ans.insert(mp(cnt[i], i));
        auto it = best_ans.end();
        --it;
        dp[i + 1] = it->first;
        upd(1, 0, MAXN, i + 1, dp[i + 1]);
        q.push_back(i);
    }
    cout << dp[n] << "\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    #endif

    // ll t; cin >> t;
    // while (t--)
    solve();

    return 0;
}