#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

vector <ll> st;
ll sz;

void set_num(ll i, ll l, ll r, ll pos, ll x) {
    if (l > pos || r <= pos) {
        return;
    }
    if (i >= sz) {
        st[i] = x;
        return;
    }
    set_num(i * 2, l, (r + l) / 2, pos, x);
    set_num(i * 2 + 1, (r + l) / 2, r, pos, x);
    st[i] = max(st[i * 2], st[i * 2 + 1]);
}

ll find_seg(ll i, ll l, ll r, ll L, ll R) {
    if (l >= R || r <= L) {
        return -1e18;
    }
    if (L <= l && r <= R) {
        return st[i];
    }
    return max(find_seg(i * 2, l, (l + r) / 2, L, R), find_seg(i * 2 + 1, (l + r) / 2, r, L, R));
}

void solve() {
    ll n;
    cin >> n;
    vector <ll> highs(n);
    for (ll &i: highs) {
        cin >> i;
    }
    vector <ll> costs(n);
    for (ll &i: costs) {
        cin >> i;
    }
    vector <ll> last(n);
    vector <ll> tmp;
    tmp.push_back(-1);
    for (ll i = 0; i < n; i++) {
        while (tmp.back() != -1 && highs[tmp.back()] > highs[i]) {
            tmp.pop_back();
        }
        last[i] = tmp.back();
        tmp.push_back(i);
    }
    n++;
    sz = 1;
    while (sz < n) {
        sz *= 2;
    }
    st.resize(sz * 2, 0);
    set_num(1, 0, sz, 0, 0);
    for (ll i = 0; i < n - 1; i++) {
        if (last[i] == -1) {
            //cout << find_seg(1, 0, n, 0, i) + costs[i] << '!' << '\n';
            set_num(1, 0, sz, i + 1, find_seg(1, 0, sz, 0, i + 1) + costs[i]);
        }
        else {
            //cout << max(find_seg(1, 0, n, 0, last[i]), find_seg(1, 0, n, last[i], i) + costs[i]) << '\n';
            set_num(1, 0, sz, i + 1, max(st[sz + last[i] + 1], find_seg(1, 0, sz, last[i] + 1, i + 1) + costs[i]));
        }
    }
    cout << st[sz + n - 1];
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);/**/
    solve();
    return 0;
}
