#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define int long long
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define MP make_pair
#define pb push_back
#define sz(x) (int)x.size()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 3e5 + 10;
const int INF = 1e18;
int n;
int a[N], b[N], dp[N];
int t[4 * N];

void upd(int v, int l, int r, int p, int x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (p < m) {
        upd(v * 2 + 1, l, m, p, x);
    } else {
        upd(v * 2 + 2, m, r, p, x);
    }
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return -INF;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}


signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef FlameDragon
    freopen("in.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
#endif
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<int> st;
    for (int i = 0; i < n; i++) {
        while (sz(st) && a[st.back()] > a[i]) {
            st.pop_back();
        }
        if (sz(st) == 0) {
            dp[i] = b[i] + max(get(0, 0, n, 0, i), 0LL);
        } else {
//            cerr << "F " << i << endl;
            int l = st.back();
            dp[i] = dp[l];
            int x = b[i];
            x += get(0, 0, n, l, i);
            dp[i] = max(dp[i], x);
        }
        upd(0, 0, n, i, dp[i]);
        st.push_back(i);
    }
    cout << dp[n - 1] << '\n';
}

