﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
using namespace std;

long long t[1200000];


long long get(int v, int l, int r, int l1, int r1) {
	if (l >= l1 && r <= r1)
		return t[v];
	if (l > r1 || l1 > r)
		return -1000000000000000;
	int m = (l + r) / 2;
	return max(get(2 * v, l, m, l1, r1), get(2 * v + 1, m + 1, r, l1, r1));
}

void upd(int v, int l, int r, int pos,long long x) {
	if (l == r && l == pos) {
		t[v] = x;
		return;
	}
	int m = (l + r) / 2;
	if (pos > m)
		upd(2 * v + 1, m + 1, r, pos, x);
	else
		upd(2 * v, l, m, pos, x);
	t[v] = max(t[2 * v], t[2 * v + 1]);
}

void solve() {
	int n;
	cin >> n;
	vector<long long int>h(n);
	vector<long long>b(n);
	for (int i = 0; i < n; i++)
		cin >> h[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	vector<int>l(n,-1);
	deque<int>f;
	f.push_back(n - 1);
	for (int i = n - 2; i >= 0; i--) {
		if (h[i] >= h[f.back()]) {
			f.push_back(i);
			continue;
		}
		while (f.size() && h[i] < h[f.back()]) {
			l[f.back()] = i;
			f.pop_back();
		}
		f.push_back(i);
	}
	
	vector<long long>ans(n);
	for (int i = 0; i < n; i++) {
		long long best = -1000000000000000;
		int l1 = max(l[i],0);
		if (i > 0)
			best = get(1, 0, n - 1, l1, i - 1);
		else
			best = 0;
		best += b[i];
		if (l[i] != -1)
			best = max(best, ans[l[i]]);
		if (l[i] == -1)
			best = max(best, b[i]);
		ans[i] = best;
		upd(1, 0, n - 1, i, ans[i]);
	}
	cout << ans[n - 1];
}


int main() {
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
	int t;
	//cin >> t;
	t = 1;
	while (t) {
		t--;
		solve();
	}
}