#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define F first
#define S second
#define pb push_back
#define lll long long
#define lld long double

using namespace std;

using namespace __gnu_pbds;

const int N = 3e5 + 134;
const int M = 1e9 + 7;
const int rx[4] = {0, 0, -1, 1};
const int ry[4] = { -1, 1, 0, 0};

template < typename T >

using ordered_set = tree < T, null_type, less < T >, rb_tree_tag, tree_order_statistics_node_update >;

int a[N];

int b[N];

int L[N], R[N];

vector < lll > d, lazy;

void push(int v) {
    d[v * 2] = max(d[v * 2], lazy[v]);
    d[v * 2 + 1] = max(d[v * 2 + 1], lazy[v]);
    lazy[v * 2] = max(lazy[v * 2], lazy[v]);
    lazy[v * 2 + 1] = max(lazy[v * 2 + 1], lazy[v]);
}

lll get(int v, int l, int r, int cl, int cr) {
    if (cl >= r || cr <= l) {
        return -1e18;
    }
    if (cl >= l && cr <= r) {
        return d[v];
    }
    push(v);
    int mid = (cl + cr) / 2;
    return max(get(v * 2, l, r, cl, mid), get(v * 2 + 1, l, r, mid, cr));
}

void upd(int v, int l, int r, int cl, int cr, lll x) {
    if (cl >= r || cr <= l) {
        return;
    }
    if (cl >= l && cr <= r) {
        d[v] = max(d[v], x);
        lazy[v] = max(lazy[v], x);
        return;
    }
    push(v);
    int mid = (cl + cr) / 2;
    upd(v * 2, l, r, cl, mid, x);
    upd(v * 2 + 1, l, r, mid, cr, x);
    d[v] = max(d[v * 2], d[v * 2 + 1]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector < int > last;
    for (int i = 0; i < n; ++i) {
        while (!last.empty() && a[last.back()] > a[i]) {
            last.pop_back();
        }
        if (last.empty()) {
            L[i] = 0;
        } else {
            L[i] = last.back() + 1;
        }
        last.pb(i);
    }
    last.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!last.empty() && a[last.back()] > a[i]) {
            last.pop_back();
        }
        if (last.empty()) {
            R[i] = n - 1;
        } else {
            R[i] = last.back() - 1;
        }
        last.pb(i);
    }
    int st = 0;
    while ((1 << st) <= n) {
        ++st;
    }
    d.resize(1 << (st + 1), -1e18);
    lazy.resize(1 << (st + 1), -1e18);
    lll cur;
    upd(1, 0, 1, 0, 1 << st, 0);
    for (int i = 0; i < n; ++i) {
        cur = get(1, L[i], i + 1, 0, 1 << st);
        cur += b[i];
        upd(1, i + 1, R[i] + 2, 0, 1 << st, cur);
    }
    cout << get(1, n, n + 1, 0, (1 << st));
    return 0;
}
