#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 4e5 + 10;
ll INF = 1e18;
struct kek
{
    int id;
    ll maxDP;
    ll maxAnsw;
};
int main() {
    #ifndef LOCAL
        std::ios::sync_with_stdio(false);
        std::cin.tie(0); std::cout.tie(0);
    #endif
    int n;
    std::cin >> n;
    std::vector<int> a(n + 1), b(n + 1);
    FOR(i, n) {
        std::cin >> a[i + 1];
    }
    FOR(i, n) {
        std::cin >> b[i + 1];
    }

    a[0] = -1;
    b[0] = 0;

    std::vector<ll> dp(n + 1, -INF);
    dp[0] = 0;
    std::vector<kek> check;
    check.pb({0, -INF, -INF});
    for (int i = 1; i <= n; ++i) {
        kek cur = {i, dp[i - 1], dp[i - 1] + b[i]};
        while (!check.empty() && a[check.back().id] > a[i]) {
            cur.maxDP = std::max(cur.maxDP, check.back().maxDP);
            check.pop_back();
        }
        cur.maxAnsw = cur.maxDP + b[i];
        if (!check.empty())
            cur.maxAnsw = std::max(cur.maxAnsw, check.back().maxAnsw);
        dp[i] = cur.maxAnsw;
        check.pb(cur);
        // debug(i << ' ' << dp[i])
    }
    std::cout << dp[n];
}