/*#pragma GCC optimize(0fast)
#pragma GCC optimize("unroll-loops")*/

#include <bits/stdc++.h> // Nurstan Duisengaliev

#define ll long long 
#define pb push_back
#define in insert
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end();
#define pii pair <int, int>
#define pll pair <ll, ll>
#define mp make_pair
#define F first
#define S second
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define int ll
using namespace std;

const int mod = (int)1e9 + 7;
const int N = (int)3e5 + 123;
const ll INF = (ll)1e16 + 1;
int n, h[N], a[N];
pii d[N * 4]; 
bool t[N * 4];
void Build (int v, int l, int r) {
	d[v] = mp (-INF, -INF);
	if (l == r) return;
	int mid = l + r >> 1;
	Build (v * 2, l, mid);
	Build (v * 2 + 1, mid + 1, r);  
}
void push (int v, int l, int r) {
	if (t[v] == 1) {
		t[v] = 0;
		if (l != r) t[v * 2] = t[v * 2 + 1] = 1;
		d[v] = mp (-INF, -INF);
	}
}
int Get (int v, int l, int r, int nl, int nr) {
	push (v, l, r);
	if (nl > nr || nl > r || l > nr) return -INF;
	if (nl <= l && r <= nr) return d[v].F;
	int mid = l + r >> 1;
	return max (Get (v * 2, l, mid, nl, nr), Get (v * 2 + 1, mid + 1, r, nl, nr));
}
int Get2 (int v, int l, int r, int nl, int nr) {
	push (v, l, r);
	if (nl > nr || nl > r || l > nr) return -INF;
	if (nl <= l && r <= nr) return d[v].S;
	int mid = l + r >> 1;
	return max (Get2 (v * 2, l, mid, nl, nr), Get2 (v * 2 + 1, mid + 1, r, nl, nr));
}
void Upd (int v, int l, int r, int pos, int x) {
	push (v, l, r);
	if (l == r) {
		d[v].F = max (d[v].F, x);
		return;
	}
	int mid = l + r >> 1;
	push (v * 2, l, mid);
	push (v * 2 + 1, mid + 1, r);
	if (pos <= mid) Upd (v * 2, l, mid, pos, x);
	else Upd (v * 2 + 1, mid + 1, r, pos, x);
	d[v].F = max (d[v * 2].F, d[v * 2 + 1].F);
}
void Upd3 (int v, int l, int r, int pos, int x) {
	push (v, l, r);
	if (l == r) {
		d[v].S = max (d[v].S, x);
		return;
	}
	int mid = l + r >> 1;
	push (v * 2, l, mid);
	push (v * 2 + 1, mid + 1, r);
	if (pos <= mid) Upd3 (v * 2, l, mid, pos, x);
	else Upd3 (v * 2 + 1, mid + 1, r, pos, x);
	d[v].S = max (d[v * 2].S, d[v * 2 + 1].S);
}
void Upd2 (int v, int l, int r, int nl, int nr) {
	push (v, l, r);
	if (nl > nr || l > nr || nl > r) return;
	if (nl <= l && r <= nr) {
		t[v] = 1;
		push (v, l, r);
		return;
	}
	int mid = l + r >> 1;
	Upd2 (v * 2, l, mid, nl, nr);
	Upd2 (v * 2 + 1, mid + 1, r, nl, nr);
	d[v].F = max (d[v * 2].F, d[v * 2 + 1].F);
	d[v].S = max (d[v * 2].S, d[v * 2 + 1].S);
}
solve () {
	cin >> n;
	Build (1, 1, n);
	for (int i = 1; i <= n; i ++) {
		cin >> h[i];
	}
	for (int i = 1; i <= n; i ++) {
		cin >> a[i];
	}
	int last = 0;
	for (int i = 1; i <= n; i ++) {
		int o = max (last, Get (1, 1, n, h[i] + 1, n));
		Upd (1, 1, n, h[i], o);
		Upd2 (1, 1, n, h[i] + 1, n);
		last = o + a[i];
		last = max (last, Get2 (1, 1, n, 1, h[i] - 1));
		Upd3 (1, 1, n, h[i], last);	
	}               
	cout << last;	
}

main () {
	ios_base::sync_with_stdio (0), cin.tie(0), cout.tie(0);
	int TT = 1;
//	cin >> TT;
	while (TT --) {
		solve ();
	} 
}