#include <bits/stdc++.h>
 
#define int long long
 
#define pii pair<int, int>
 
#define x1 x1228
#define y1 y1228
 
#define left left228
#define right right228

#define data data228
 
#define pb push_back
#define eb emplace_back
 
#define mp make_pair                                                                
                                                                                                                                        
#define ff first                                                                  
#define ss second   
 
#define all(x) x.begin(), x.end()
#define debug(x) cout << #x << ": " << x << endl; 
#define TIME (ld)clock()/CLOCKS_PER_SEC
 
using namespace std;
typedef long long ll; 
typedef long double ld; 
                                                                                                   
const int maxn = 3e5 + 7, mod = 1e9 + 7, MAXN = 2e6 + 7;
const double eps = 1e-9;                                        
const ll INF = 1e18, inf = 1e15;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());                       
int n; 
int h[maxn]; 
int b[maxn];
int L[maxn]; 
int R[maxn]; 

struct node {
    int x; 
    int push; 
}; 

struct Tree {
    node tree[4 * maxn]; 

    void push(int rt, int l, int r) {
        int push = tree[rt].push; 
        tree[rt].push = -inf; 
        tree[rt].x = max(tree[rt].x, push); 
        if (l != r) {
            tree[rt * 2 + 1].push = max(tree[rt * 2 + 1].push, push); 
            tree[rt * 2 + 2].push = max(tree[rt * 2 + 2].push, push); 
        }
    }

    void build() {
        for (int i = 0; i < 4 * maxn; ++i) {
            tree[i] = {-inf, -inf}; 
        }
    }

    void add(int l, int r, int l1, int r1, int rt, int x) {
        push(rt, l, r);
        if (l >= l1 && r <= r1) {
            tree[rt].push = x; 
            push(rt, l, r); 
            return; 
        } 
        if (max(l, l1) > min(r, r1)) return; 
        int t = (l + r) / 2; 
        add(l, t, l1, r1, rt * 2 + 1, x); 
        add(t + 1, r, l1, r1, rt * 2 + 2, x); 
        tree[rt].x = max(tree[rt * 2 + 1].x, tree[rt * 2 + 2].x); 
    }

    int get(int l, int r, int l1, int r1, int rt) {
        push(rt, l, r); 
        if (l >= l1 && r <= r1) {
            return tree[rt].x; 
        }
        if (max(l, l1) > min(r, r1)) return -inf;  
        int t = (l + r) / 2; 
        int L = get(l, t, l1, r1, rt * 2 + 1); 
        int R = get(t + 1, r, l1, r1, rt * 2 + 2); 
        tree[rt].x = max(tree[rt * 2 + 1].x, tree[rt * 2 + 2].x); 
        return max(L, R); 
    } 
}; 

int dp[maxn]; 

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> h[i]; 
    }    
    for (int i = 0; i < n; ++i) {
        cin >> b[i]; 
    }
    vector<pii> st = {{-inf, -1}}; 
    for (int i = 0; i < n; ++i) {
        while (st.back().ff > h[i]) {
            st.pop_back(); 
        }    
        L[i] = st.back().ss; 
        st.pb({h[i], i}); 
    }
    st.clear(); 
    st.pb({-inf, n}); 
    for (int i = n - 1; i >= 0; --i) {
        while (st.back().ff > h[i]) {
            st.pop_back(); 
        }        
        R[i] = st.back().ss; 
        st.pb({h[i], i}); 
    }
    for (int i = 0; i < n; ++i) {
        L[i]++; 
        R[i]--; 
    }

    Tree tet;
    tet.build();

    tet.add(0, n, 0, 0, 0, 0); 
    for (int i = 0; i < n; ++i) {
        int l = L[i];
        int r = R[i];
        int lst = tet.get(0, n, l, i, 0);
//        cout << lst << " " << l << " " << r << '\n'; 
        tet.add(0, n, i + 1, r + 1, 0, lst + b[i]);
    }
    cout << tet.get(0, n, n, n, 0) << '\n'; 
}                                
                 
signed main() {          
#ifdef LOCAL
    freopen("TASK.in", "r", stdin);
    freopen("TASK.out", "w", stdout);
#endif // LOCAL                                                                             
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(20); 
    cout << fixed; 
    int t = 1; 
    for (int i = 0; i < t; ++i) {              
        solve();
    }
    return 0;
}  