#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>


#define ll long long
#define ld long double
#define all(x)  (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second
#define _ nullptr

using namespace std;


const int N = 3e5;

ll t[N*4];

ll rmq(int v, int l, int r, int tl, int tr) {
    if (l >= tr || r <= tl) {
        return -1e18;
    }
    if (tl <= l && r <= tr) {
        return t[v];
    }
    int m=(l+r)/2;
    return max(rmq(2*v+1, l, m, tl, tr), rmq(2*v+2, m, r, tl, tr));
}

void change(int v, int l, int r, int pos, ll x) {
    if (l == r-1) {
        t[v] = x;
        return;
    }
    int m = (l+r)/2;
    if (pos >= m) {
        change(2*v+2, m, r, pos, x);
    } else {
        change(2*v+1, l, m, pos, x);
    }
    t[v] = max(t[2*v+1], t[2*v+2]);
}

ll get(int v, int l, int r, int pos) {
    if (l == r-1) {
        return t[v];
    }
    int m = (l+r)/2;
    if (pos >= m) {
        return get(2*v+2, m, r, pos);
    } else {
        return get(2*v+1, l, m, pos);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    fill(t, t+N, -1e18);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i<n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i<n; i++) {
        cin >> b[i];
    }
    vector<int> prev(n);
    stack<int> st;
    for (int i = 0; i<n; i++) {
        if (i == 0) {
            prev[i] = i;
            st.push(i);
        } else {
            while (!st.empty() && a[st.top()] > a[i]) {
                st.pop();
            }
            prev[i] = (st.empty() ? i : st.top());
            st.push(i);
        }
    }
    change(0, 0, n, 0, b[0]);
    for (int i = 1; i<n; i++ ){
        if (prev[i] == i) {
            change(0, 0, n, i,b[i]+max(0LL, rmq(0, 0, n, 0, i)));
        } else {
            change(0, 0, n, i, max(b[i] + rmq(0, 0, n, prev[i], i), get(0, 0, n, prev[i])));
        }
    }
    cout << get(0, 0, n, n-1);

    return 0;
}

