#include <bits/stdc++.h>
#include <bits/extc++.h>


//        //
//      //  //
//    //      //
//  //          //
//  ////      ////
//  //  //  //  //
//  //    //    //
//  //    //    //
//  //    //    //
//    //  //  //
//      //////
//        //
// I LOVE MINECRAFT!!!!!!!!!!!!

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template <typename A, typename B>
using pa = pair<A, B>;

template <typename T>
using v = vector<T>;

template <typename T>
using indexed_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename K, typename V>
using indexed_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
istream& operator>>(istream& in, v<T>& a) {
    for(T& x : a) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, v<T>& a) {
    for(T& x : a) {
        out << x << ' ';
    }
    return out;
}

struct segment_tree{
    static const ll neutral = -1e18;
    ll n;
    v<ll> st;
    v<ll> addition;
    segment_tree(ll n) : n(n), st(4 * n), addition(4 * n) {

    }
    ll combine(ll a, ll b) {
        return max(a, b);
    }

    void propagate(ll i) {
        st[i] += addition[i];
        if(((i << 1) + 1) < st.size()) {
            addition[((i << 1) + 1)] += addition[i];
            if(((i << 1) + 2) < st.size()) {
                addition[((i << 1) + 2)] += addition[i];
            }
        }
        addition[i] = 0;
    }

    ll get_range(ll inL, ll inR, ll i = 0, ll L = 0, ll R = -1) {
        if(R == -1) {
            R = n;
        }
        propagate(i);
        if(L >= inL && R <= inR) {
            return st[i];
        } else if(R <= inL || L >= inR) {
            return neutral;
        } else {
            ll M = (L + R) >> 1;
            return combine(get_range(inL, inR, (i << 1) + 1, L, M), get_range(inL, inR, (i << 1) + 2, M, R));
        }
    }

    ll add_range(ll inL, ll inR, ll inX, ll i = 0, ll L = 0, ll R = -1) {
        if(R == -1) {
            R = n;
        }
        propagate(i);
        if(L >= inL && R <= inR) {
            addition[i] += inX;
            propagate(i);
            return st[i];
        } else if(R <= inL || L >= inR) {
            return st[i];
        } else {
            ll M = (L + R) >> 1;
            return st[i] = combine(add_range(inL, inR, inX, (i << 1) + 1, L, M), add_range(inL, inR, inX, (i << 1) + 2, M, R));
        }
    }
};

int main() {
    //freopen("out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    /*ll n;
    cin >> n;
    segment_tree st(n);
    while(true) {
        ll t, L, R;
        cin >> t >> L >> R;
        if(t == 0) {
            cout << st.get_range(L, R) << endl;
        } else {
            ll x;
            cin >> x;
            st.add_range(L, R, x);
        }
    }*/
    ll n;
    cin >> n;
    v<ll> h(n);
    cin >> h;
    v<ll> b(n);
    cin >> b;
    v<ll> dpv(n + 1);
    segment_tree st(n + 1);
    v<ll> suf_m_p;
    for(ll i = n - 1; i >= 0; --i) {
        ll cp = i;
        ll cb = 0;
        while(!suf_m_p.empty()) {
            ll x = suf_m_p.back();
            st.add_range(cp + 1, x + 1, b[i] - cb);
            if(h[x] < h[i]) {
                break;
            } else {
                cp = x;
                cb = b[x];
                suf_m_p.pop_back();
            }
        }
        if(suf_m_p.empty()) {
            st.add_range(cp + 1, n + 1, b[i] - cb);
        }
        suf_m_p.push_back(i);
        /*cout << suf_m_p.size() << ' ';
        for(ll i = 0; i < suf_m_p.size(); ++i) {
            cout << suf_m_p[i] << ' ';
        }
        cout << '\n';*/
        ll mab = st.get_range(i + 1, n + 1);
        /*ll ch = 1e18;
        ll cb = -1e18;
        ll mab = -1e18;
        for(ll j = i + 1; j <= n; ++j) {
            if(h[j - 1] < ch) {
                ch = h[j - 1];
                cb = b[j - 1];
            }
            mab = max(mab, cb + dpv[j]);
        }*/
        dpv[i] = mab;
        st.add_range(i, i + 1, dpv[i]);
    }
    //cout << n << endl;
    /*for(ll i = 0; i < n; ++i) {
        cout << dpv[i] << ' ';
    }*/
    cout << dpv[0];
}
