#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <queue>
#include <string>
#define forr(i,a,b,c) for(int i=a;i<b;i+=c)
#define fort(i,a,b) forr(i,a,b,1)
#define forn(i,n) fort(i,1,n)
#define fori(i,n) fort(i,0,n)
#define forin(i,arr) fori(i,arr.size())
#define forrb(i,a,b,c) for(int i=b-1;i>=a;i-=c)
#define fortb(i,a,b) forrb(i,a,b,1)
#define fornb(i,n) fortb(i,1,n)
#define forib(i,n) fortb(i,0,n)
#define forinb(i,arr) forib(i,arr.size())
#define maxi 1000000007
#define lmaxi 1000000001000000007
#define mod %maxi
using namespace std;
typedef long long lol;
typedef vector<int> veci;
typedef vector<lol> vecl;
typedef pair<int, int> point;
typedef vector<point> vecp;
lol gcd(lol a, lol b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}
#define logn 20
void add(vector<vecl> &segtre, int p, lol v) {
	segtre[0][p] = v;
	forn(i, logn) {
		p >>= 1;
		segtre[i][p] = max(segtre[i - 1][2 * p], segtre[i - 1][2 * p + 1]);
	}
}
lol find(vector<vecl> &segtre, int l, int r) {
	lol val = -lmaxi;
	fori(i, logn) {
		if (l > r) {
			return val;
		}
		if (l & 1) {
			val = max(val, segtre[i][l]);
			l++;
		}
		if ((r & 1)==0) {
			val = max(val, segtre[i][r]);
			r--;
			if (r < 0) {
				return val;
			}
		}
		l /= 2;
		r /= 2;
	}
}
int main() {
	ios::sync_with_stdio(0);
	int n;
	cin >> n;
	vecl h(n), b(n);
	fori(i, n) {
		cin >> h[i];
	}
	fori(i, n) {
		cin >> b[i];
	}
	vecl stk;
	vector<vecl> val(logn, vecl(n + 2));
	vector<vecl> stkval(logn, vecl(n + 2));
	fori(i, n) {
		while (stk.size() && h[stk.back()] > h[i]) {
			stk.pop_back();
		}
		lol pos = 0;
		if (stk.size()) {
			pos = stk.back() + 1;
		}
		lol curval = find(val, pos, i)+b[i];
		add(stkval, stk.size(), curval);
		add(val,i+1, find(stkval,0,stk.size()));
		stk.push_back(i);
	}
	cout << val[0][n] << endl;
	return 0;
}