#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<fstream>
#include<algorithm>
#include<math.h>
#include<cmath>
#include<vector>
#include<set>
#include<queue>
#include<map>
#include<string>

//#define int long long
#define ll long long
#define ld long double
#define pii pair<int,int>
#define endl '\n'
#define range(i,n) for(int i=0;i<n;i++)
#define BE(v) v.begin(), v.end()
#define cint(a) int a; cin>>a;
#define pb push_back

using namespace std;

int maxeq(int& a, int b)
{
	a = max(a, b);
	return a;
}

int mineq(int& a, int b)
{
	a = min(a, b);
	return a;
}

pii operator+=(pii& a, pii b)
{
	a.first += b.first;
	a.second += b.second;
	return a;
}

pii operator+(pii a, pii b)
{
	return a += b;
}

pii operator-=(pii& a, pii b)
{
	a.first -= b.first;
	a.second -= b.second;
	return a;
}

pii operator-(pii a, pii b)
{
	return a -= b;
}

int gcd(int a, int b)
{
	while (b != 0)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

const int N = (1 << 21) + 500;
const int L = 20;
const int D = (1 << 19);
const ll bes = 1e16;

int l[N];
int r[N];
int h[N];
int b[N];
int s[L][N];
int maxk[N];
ll dp[N];
ll a[N];

int getmin(int l, int r)
{
	return min(s[maxk[r - l]][l], s[maxk[r - l]][r - (1 << maxk[r - l])]);
}

void push(int i)
{
	if (a[i] != -bes)
	{
		dp[2 * i] = max(dp[2 * i], a[i]);
		dp[2 * i + 1] = max(dp[2 * i + 1], a[i]);
		a[2 * i] = max(a[2 * i], a[i]);
		a[2 * i + 1] = max(a[2 * i + 1], a[i]);
		a[i] = -bes;
	}
}

void add(int l, int r, ll x, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (r <= L || R <= l)
		return;
	if (l <= L && R <= r)
	{
		a[i] = max(a[i], x);
		dp[i] = max(dp[i], a[i]);
	}
	else
	{
		add(l, r, x, 2 * i, L, (L + R) / 2);
		add(l, r, x, 2 * i + 1, (L + R) / 2, R);
		dp[i] = max(dp[2 * i], dp[2 * i + 1]);
	}
}

ll que(int l, int r, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (r <= L || R <= l)
		return -bes;
	if (l <= L && R <= r)
	{
		return dp[i];
	}
	else
	{
		return max(que(l, r, 2 * i, L, (L + R) / 2), que(l, r, 2 * i + 1, (L + R) / 2, R));
	}
}

ll el(int ind, int i = 1, int L = 0, int R = D)
{
	push(i);
	if (ind < L || ind >= R)
	{
		return-bes;
	}
	if (R - L == 1)
	{
		return dp[i];
	}
	return max(el(ind, 2 * i, L, (L + R) / 2), el(ind, 2 * i + 1, (L + R) / 2, R));
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cint(n);
	fill(dp, dp + N, -bes);
	fill(a, a + N, -bes);
	int powp = 1;
	int ind = 0;
	for (int i = 0; i <= n + 1; i++)
	{
		if (i > powp * 2)
		{
			powp *= 2;
			ind++;
		}
		maxk[i] = ind;
	}
	h[0] = 0;
	h[n + 1] = 0;
	for(int i=1;i<=n;i++)
		cin >> h[i];
	for(int i=1;i<=n;i++)
		cin >> b[i];
	vector<pii> v;
	for (int i = 0; i <= n + 1; i++)
		s[0][i] = h[i];
	for (int i = 1; i < L; i++)
		for (int j = 0; j <= n + 1; j++)
			s[i][j] = min(s[i - 1][j], s[i - 1][j + (1 << (i - 1))]);
	add(0, 1, 0);
	for (int i = 1; i <= n; i++)
	{
		int l, r;
		int L = 0, R = i;
		while (L + 1 != R)
		{
			int M = (L + R) / 2;
			if (getmin(M, i + 1) < h[i])
			{
				L = M;
			}
			else
			{
				R = M;
			}
		}
		l = L;
		L = i + 1, R = n + 2;
		while (L + 1 != R)
		{
			int M = (L + R) / 2;
			if (getmin(i, M) < h[i])
			{
				R = M;
			}
			else
			{
				L = M;
			}
		}
		r = L;
		add(i, r, que(l, i) + b[i]);
	}
	cout << el(n);
}