#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#define int long long 

using namespace std;
vector <int> tree;

void upd(int v, int l, int r, int lx, int c) {
	if (r - l == 1 && l == lx) {
		tree[v] = c;
	}
	else {
		if (lx < r && lx >= l) {
			int mid = (r + l) / 2;
			upd(v * 2 + 1, l, mid, lx, c);
			upd(v * 2 + 2, mid, r, lx, c);
			tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
		}
	}
}


int mx(int v, int l, int r, int lx, int rx) {
	if (l >= lx && r <= rx) {
		return tree[v];
	}
	if (l >= rx || r <= lx) {
		return -1e9;
	}
	int mid = (r + l) / 2;
	return max(mx(v * 2 + 1, l, mid, lx, rx), mx(v * 2 + 2, mid, r, lx, rx));
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> h;
	vector <int >b;
	vector <int> ht(n+1);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		ht[x] = i;
		h.push_back(x);
	}
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		b.push_back(x);
	}
	tree.resize(4 * (n+1), 0);
	vector <int> sl(n, 0);
	deque <vector <int> > a;
	vector <int> dp(n+1, 0);
	a.push_back({ 0,0 });
	for (int i = 0; i < n; ++i) {
		while (a.size() && a.back()[0] > h[i]) {
			a.pop_back();
		}
		sl[i] = a.back()[1];
		a.push_back({ h[i],i + 1 });
	}
	for (int i = 1; i <= n; ++i) {
		int u = sl[i-1];
		int y1 = mx(0, 0, n+1, u, i);
		if (u != 0) {
			dp[i] = max(dp[u], y1 + b[i - 1]);
		}
		else {
			dp[i] = y1 + b[i - 1];
		}
		upd(0, 0, n+1, i, dp[i]);
	}
	cout << dp[n];

}

/*
1
5
1 1 1 1 1
5 2 4 1 3 5
*/