#include <bits/stdc++.h>
#define x first
#define y second
#define int long long
#define ld long double

using namespace std;

mt19937_64 rnd(42);
ld eps = 1e-7;
ld pi = acos(-1);
struct node;
typedef node* pnode;
struct node{
    int dp;
    int maxdp;

    int add;
    int f;
    int maxa;

    int sz;
    pnode l;
    pnode r;
    int prior;
    node(){}
    node(int x){
        dp = x;
        maxdp = x;
        add = INT_MAX;
        maxa = x;
        f = 0;
        sz = 1;
        prior = rnd();
        l = 0;
        r = 0;
    }
};
pnode root;
struct dd{
    dd(){}
    int getsz(pnode t){
        if(!t)
            return 0;
        return t->sz;
    }
    int getmaxdp(pnode t){
        if(!t)
            return INT_MIN;
        return t->maxdp;
    }
    int getmaxa(pnode t){
        if(!t)
            return INT_MIN;
        if(t->add==INT_MAX)
            return t->maxa;
        else return t->maxdp+t->add;
    }
    void upd(pnode t){
        if(!t)
            return;
        t->sz = getsz(t->l)+getsz(t->r)+1;
        t->maxdp = max(max(getmaxdp(t->l), getmaxdp(t->r)), t->dp);
        if(t->add==INT_MAX){
            t->maxa = max(max(getmaxa(t->l), getmaxa(t->r)), t->dp+t->f);
        } else {
            if(t->l)
                t->l->add=t->add;
            if(t->r)
                t->r->add=t->add;
            t->f = t->add;
            t->add = INT_MAX;
            t->maxa = max(max(getmaxa(t->l), getmaxa(t->r)), t->dp+t->f);
        }
    }
    pnode merge(pnode t, pnode v){
        if(!t){
            upd(v);
            return v;
        }
        if(!v){
            upd(t);
            return t;
        }
        upd(t);
        upd(v);
        if(t->prior>v->prior){
            pnode p = merge(t->r, v);
            t->r = p;
            upd(t);
            return t;
        }
        pnode p = merge(t, v->l);
        v->l = p;
        upd(v);
        return v;
    }
    pair<pnode, pnode> split(pnode t, int x){
        if(!t)
            return {0, 0};
        upd(t);
        if(getsz(t->l)>x){
            auto p = split(t->l, x);
            t->l = p.y;
            upd(t);
            return {p.x, t};
        }
        auto p = split(t->r, x-getsz(t->l)-1);
        t->r = p.x;
        upd(t);
        return {t, p.y};
    }

    int getmax(pnode t, int l, int r){
        auto p = split(t, l-1);
        auto p1 = split(p.y, r-l-1);
        int ans = getmaxa(p1.x);
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
        return ans;
    }

    void addx(pnode t, int l, int r, int x){
        auto p = split(t, l-1);
        auto p1 = split(p.y, r-l-1);
        if(p1.x){
            p1.x->add=x;
        }
        p.y = merge(p1.x, p1.y);
        t = merge(p.x, p.y);
    }

    void printtree(pnode t){
        if(!t)
            return;
        printtree(t->l);
        cout << t->dp+t->f << " ";
        printtree(t->r);
    }
};
signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int qq = 1;
    //cin >> qq;
    for(int qqq = 0; qqq<qq; qqq++){
        int n;
        cin >> n;
        int h[n];
        int b[n];
        int lst[n];
        vector<pair<int, int>> lessi;
        for(int i = 0; i<n; i++){
            cin >> h[i];
            while(lessi.size()>0 && lessi.back().x>h[i]){
                lessi.pop_back();
            }
            if(lessi.empty())
                lst[i] = -1;
            else lst[i] = lessi.back().y;
            lessi.push_back({h[i], i});
        }
        for(int i = 0; i<n; i++)
            cin >> b[i];
        int dp[n];
        dd d = dd();
        root = new node(0);
        for(int i = 0; i<n; i++){
            d.addx(root, lst[i]+1, i+1, b[i]);
            dp[i] = d.getmax(root, 0, i+1);
            root = d.merge(root, new node(dp[i]));
        }
        cout << dp[n-1];
    }
    return 0;
}
