#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <set>
using namespace std;
#define int long long
#define ii pair <int, int> 
#define ll long long
#define vi vector <int>
#define debug(x) cerr << #x << ": " << x << endl;
#define mp make_pair
#define app push_back
#define x first
#define y second
void ckmin(int &a, int b) { a = min(a, b); }
void ckmax(int &a, int b) { a = max(a, b); }
int gcd(int a, int b) {
    while (b) {
        int t = a%b;
        a = b;
        b = t;
    }
    return a;
}

const int N = 3e5+7;
const int INF = 1e18;

int n;
int mx[N << 2];

int getmax(int v, int tl, int tr, int l, int r) {
    if (tr < l || r < tl)
        return -INF;
    if (l <= tl && tr <= r)
        return mx[v];
    int tm = (tl + tr) >> 1;
    return max(getmax(v * 2 + 1, tl, tm, l, r), getmax(v * 2 + 2, tm + 1, tr, l, r));
}

void setpoint(int v, int tl, int tr, int i, int x) {
    ckmax(mx[v], x);
    if (tl == tr) {
        return;
    }
    int tm = (tl + tr) >> 1;
    if (i <= tm)
        setpoint(v * 2 + 1, tl, tm, i, x);
    else
        setpoint(v * 2 + 2, tm + 1, tr, i, x);
}
int getmax(int l, int r) {
    return getmax(0, 0, n, l, r);
}
void setpoint(int i, int x) {
    setpoint(0, 0, n, i, x);
}

signed main() {
    #ifdef LOCAL
    #else
    ios_base::sync_with_stdio(0); cin.tie(0);
    #define endl '\n'
    #endif

    for (int i = 0; i < (N << 2); ++i)
        mx[i] = -INF;

    cin >> n;
    vector <int> h(n), c(n);
    for (int i = 0; i < n; ++i)
        cin >> h[i];
    for (int i = 0; i < n; ++i)
        cin >> c[i];

    vi dp(n + 1, -INF);
    dp[0] = 0;
    setpoint(0, 0);

    vi s, re;
    for (int i = 0; i < n; ++i) {
        while (s.size() && h[i] < h[s.back()]) {
            s.pop_back();
            re.pop_back();
        }

        int prv = -1;
        if (s.size())
            prv = s.back();
        int last = getmax(prv + 1, i) + c[i];
        if (re.size())
            ckmax(last, re.back());
        re.app(last);

        s.app(i);
        dp[i + 1] = re.back();
        setpoint(i + 1, dp[i + 1]);
    }
    cout << dp[n] << endl;
}