#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <math.h>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 500010;
const int MOD = 1000000007;
const ll INFLL = 1e15 + 10;

ll h[N], b[N];

ll dp[N];

struct otr {
	ll h, dp, b;
	
};

struct sr {
	bool operator()(const otr &a, const otr &b) const {
		return a.h < b.h;
	}
};

set < otr, sr > s;
multiset < ll > d;

signed main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	int n;

	cin >> n;

	for (int i = 1; i <= n; ++i) {
		cin >> h[i];
	}

	for (int i = 1; i <= n; ++i) {
		cin >> b[i];
	}

	dp[0] = 0;

	for (int i = 1; i <= n; ++i) {
		auto it = s.lower_bound(otr{ h[i], -INFLL, -INFLL });
		ll Max = dp[i - 1];
		while (it != s.end())
			Max = max(Max, it->dp), d.erase(d.find(it->dp + it->b)), s.erase(it++);
		s.insert({ h[i], Max, b[i] });
		d.insert({ Max + b[i] });
		auto jt = d.end();
		--jt;
		dp[i] = *jt;
	}

	cout << dp[n];

}