#include <bits/stdc++.h>


// #pragma GCC optimize("Ofast")
// #pragma GCC target("avx2,avx")

typedef long long ll;
typedef long double ld;

using namespace std;

#define int ll
#define pii pair<int, int>
#define f first
#define s second
#define vi vector<int>
#define vp vector<pii>
#define pb push_back

const int maxn = 4e5;
int t[4 * maxn];
int m[4 * maxn];
void push(int v) {
	if (m[v] != 0) {
		if (2 * v + 1 < 4 * maxn) {
			t[2 * v] += m[v];
			t[2 * v + 1] += m[v];
			m[2 * v] += m[v];
			m[2 * v + 1] += m[v];
		}
		m[v] = 0;
	}
}
void build(int v, int tl, int tr) {
	if (tl == tr) {
		t[v] = 0;
		m[v] = 0;
	} else {
		int tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = 0;
		m[v] = 0;
	}
}

void upd(int v, int tl, int tr, int l, int r, int x) {
	if (l > tr || r < tl || l > r)
		return;
	push(v);
	if (tl >= l && tr <= r) {
		t[v] += x;
		m[v] += x;
	} else {
		int tm = (tl + tr) / 2;
		upd(2 * v, tl, tm, l, r, x);
		upd(2 * v + 1, tm + 1, tr, l, r, x);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
}

int get(int v, int tl, int tr, int l, int r) {
	if (l > tr || r < tl || l > r)
		return -4e18;
	push(v);
	if (tl >= l && tr <= r) {
		return t[v];
	} else {
		// return t[v];
		int tm = (tl + tr) / 2;
		return max(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
	}
}

void solve() {
	int n;
	cin >> n;
	// cout << n << endl;
	int a[n];
	for (auto &i : a)
		cin >> i;
	int b[n];
	for (auto &i : b)
		cin >> i;	
	int dp[n + 1];
	build(1, 0, n);
	memset(dp, 0, sizeof(dp));
	vector<int> v;
	for (int i = 1; i <= n; ++i) {
		// cout << i << endl;
		while (v.size() && a[i - 1] < a[v.back()]) {
			if (v.size() == 1) {
				upd(1, 0, n, 0, v.back(), -b[v.back()]);
			} else {
				upd(1, 0, n, v[v.size() - 2] + 1, v.back(), -b[v.back()]);
			}
			v.pop_back();
		}
		// cout << i << endl;
		if (v.size() == 0) {
			// cout << 0 << ' ' << i - 1 << '\n';
			upd(1, 0, n, 0, i - 1, b[i - 1]);
		} else {
			// cout << i << ' ' << v.back() + 1 << ' ' << i - 1 << '\n';
			upd(1, 0, n, v.back() + 1, i - 1, b[i - 1]);
		}
		// cout << i << endl;
		v.pb(i - 1);
		// cout << get(1, 0, n, 0, i - 1) << '\n';
		dp[i] = get(1, 0, n, 0, i - 1);
		// cout << i << endl;
		upd(1, 0, n, i, i, dp[i]);
		// cout << i << endl;
	}
	// for (int i = 0; i < n; ++i) {
	// 	cout << dp[i] << ' ';
	// }
	// cout << '\n';
	cout << dp[n] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	// freopen("input.txt", "r", stdin);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}