#include<bits/stdc++.h>

using namespace std;

typedef long long int lli;

const int N = 3e5 + 10;
const lli INF64 = 1e18 + 100;
lli hh[N];
lli bb[N];
lli dp[N];

struct SegTree {
public:
    vector<lli> tree;
    int ver;
    SegTree(int oper, int n) {
        ver = oper;
        if(ver == 1)
            tree.assign(4*n + 10, n+1);
        else
            tree.assign(4*n + 10, 0);
    }
    lli query(int v, int l, int r, int L, int R) {
        if(l > r || l > R || r < L) {
            if(ver == 1)
                return INF64;
            else
                return -INF64;
        }
        if(L <= l && r <= R) return tree[v];
        int v1 = 2 * v + 1;
        int v2 = 2 * v + 2;
        int mid = (l + r) / 2;
        lli q1 = query(v1, l, mid, L, R);
        lli q2 = query(v2, mid + 1, r, L, R);
        if(ver == 1)
            return min(q1, q2);
        else
            return max(q1, q2);
    }
    void update(int v, int l, int r, int pos, lli newVal) {
        if(l > r || l > pos || r < pos) return;
        if(l == r && l == pos) {
            tree[v] = newVal;
            return;
        }
        int v1 = 2 * v + 1;
        int v2 = 2 * v + 2;
        int mid = (l + r) / 2;
        update(v1, l, mid, pos, newVal);
        update(v2, mid + 1, r, pos, newVal);
        if(ver == 1)
            tree[v] = min(tree[v1], tree[v2]);
        else
            tree[v] = max(tree[v1], tree[v2]);
    }
};

int nnn;

void generatee() {
    nnn = 200000;
    for(int i = 1; i <= nnn; i++) hh[i] = i;
    for(int i = 1; i <= nnn; i++) bb[i] = rand();
    random_shuffle(hh + 1, hh + nnn + 1);
}

multiset<lli> dd;
vector<lli> erasee[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
  //  generatee();
  //  n = nnn;
    cin >> n;
    for(int i = 1; i <= n; i++) cin >> hh[i];
    for(int i = 1; i <= n; i++) cin >> bb[i];
    SegTree dps(2, n);
    SegTree maxPref(2, n);
    SegTree minSuff(1, n);
    for(int i = 1; i <= n; i++)
        minSuff.update(0, 1, n, hh[i], i);
   // for(int i = 1; i <= n; i++)
  //      cout << minSuff.query(0, 1, n, i, i) << " ";
  //  cout << "\n";
    for(int i = 1; i <= n; i++) {
        minSuff.update(0, 1, n, hh[i], n+1);
        int ind = maxPref.query(0, 1, n, 1, hh[i]) + 1;
        int ind2 = minSuff.query(0, 1, n, 1, hh[i]) - 1;
        dps.update(0, 1, n, i, dp[i-1]);

        lli mm = dps.query(0, 1, n, ind, i);
     //   cout << "for " << i << " found from " << ind << " to " << ind2 << "\n";
     //   cout << "mm = " << mm << "\n";
        dp[i] = mm + bb[i];
        lli a2 = -INF64;
        if(!dd.empty())
            a2 = *dd.rbegin();

        if(a2 < dp[i]) {
            dd.insert(dp[i]);
            erasee[ind2].push_back(dp[i]);
        }
        dp[i] = max(dp[i], a2);
        for(lli j : erasee[i])
            dd.erase(*dd.find(j));

        maxPref.update(0, 1, n, hh[i], i);
    }
    /*for(int i = 1; i <= n; i++)
        cout << dp[i] << " ";
    cout << "\n";*/
    cout << dp[n] << "\n";
    return 0;
}
