#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
using namespace std;
const int N = 524288;
pair<int, int> tree[4 * N + 50];
int METKA[4 * N + 7];
int dp[N];

void push(int v) {
  if (v >= 4 * N + 7 || METKA[v] == 1e18) {
    return;
  }
  tree[v].second = METKA[v] + tree[v].first;
  if (2 * v + 2 < 4 * N + 7) {
    METKA[2 * v + 1] = METKA[v];
    METKA[2 * v + 2] = METKA[v];
  }
  METKA[v] = 1e18;
}

void cdp(int v, int l, int r, int i) {
  if (l >= r) return;
  push(v);
  push(2 * v + 1);
  push(2 * v + 2);
  if (l + 1 == r && l == i) {
    while (v > 0) {
      tree[v].first = max(tree[v].first, dp[i]);
      tree[v].second = max(tree[v].second, dp[i]);
      v = (v - 1) / 2;
    }
    tree[0].first = max(tree[0].first, dp[i]);
    tree[0].second = max(tree[0].second, dp[i]);
  } else {
    int m = (l + r) / 2;
    if (i < m) {
      cdp(2 * v + 1, l, m, i);
    } else {
      cdp(2 * v + 2, m, r, i);
    }
  }
}

void upd(int v, int l, int r, int lq, int rq, int x) {
  if (r <= lq || l >= rq) return;
  push(v);
  push(2 * v + 1);
  push(2 * v + 2);
  if (l >= lq && rq >= r) {
    METKA[v] = x;
    push(v);
    int u = (v - 1) / 2;
    while (u > 0) {
      tree[u].first = max(tree[2 * u + 1].first, tree[2 * u + 2].first);
      tree[u].second = max(tree[2 * u + 1].second, tree[2 * u + 2].second);
      u = (u - 1) / 2;
    }
    tree[u].first = max(tree[2 * u + 1].first, tree[2 * u + 2].first);
    tree[u].second = max(tree[2 * u + 1].second, tree[2 * u + 2].second);
  } else {
    int m = (l + r) / 2;
    upd(2 * v + 1, l, m, lq, rq, x);
    upd(2 * v + 2, m, r, lq, rq, x);
  }
}

void solve() {
  for (int i = 0; i < 4 * N + 5; i++) {
    METKA[i] = 1e18;
    tree[i] = {-1e18, -1e18};
  }
  int n;
  cin >> n;
  vector<int> H(n + 1), l(n + 1), B(n + 1);
  for (int i = 1; i <= n; i++) cin >> H[i];
  for (int i = 1; i <= n; i++) cin >> B[i];
  vector<pair<int, int>> st;
  for (int i = 1; i <= n; i++) {
    while (!st.empty() && st.back().first > H[i]) {
      st.pop_back();
    }
    if (st.empty()) {
      l[i] = 0;
    } else {
      l[i] = st.back().second;
    }
    st.pb({H[i], i});
  }
  dp[0] = 0;
  cdp(0, 0, N, 0);
  for (int i = 1; i <= n; i++) {
    upd(0, 0, N, l[i], i + 1, B[i]);
    push(0);
    dp[i] = tree[0].second;
    cdp(0, 0, N, i);
  }
  cout << dp[n];
  cout << '\n';
}

signed main() {
  int t = 1;
  while (t--) {
    solve();
  }
}