#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;
using li = long long;
using ld = long double;
using pii = pair<int, int>;

const li INF = 1e18 + 13;
const int M = 1e9 + 7;
const int N = 3e5 + 13;

int a[N], b[N], lf[N];
li dp[N];

li t[N * 4];

void build(int v, int l, int r) {
    t[v] = -INF;
    if(r - l == 1) {

        return;
    }

    int m = (l + r) / 2;

    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
}

void change(int v, int l, int r, int i, li x) {
    if(i < l || i >= r)
        return;

    if(r - l == 1) {
        t[v] = x;
        return;
    }

    int m = (l + r) / 2;
    change(v * 2 + 1, l, m, i, x);
    change(v * 2 + 2, m, r, i, x);

    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

li get(int v, int l, int r, int ql, int qr) {
    if(l >= qr || r <= ql)
        return -INF;

    if(ql <= l && r <= qr)
        return t[v];

    int m = (l + r) / 2;

    return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for(int i = 0; i < n; i++) {
        cin >> b[i];
    }

    stack<int> st;
    for(int i = 0; i < n; i++) {
        while(!st.empty() && a[st.top()] > a[i])
            st.pop();

        lf[i] = (st.empty() ? -1 : st.top());
        st.push(i);
    }

    build(0, 0, n);

    dp[0] = b[0];

    change(0, 0, n, 0, dp[0]);
    for(int i = 1; i < n; i++) {
        dp[i] = get(0, 0, n, (lf[i] == -1 ? 0 : lf[i]), i) + b[i];
//        cout << i << ' '<< dp[i] << ' ' << lf[i] << endl;
        if(lf[i] > -1)
            dp[i] = max(dp[i], dp[lf[i]]);
        else
            dp[i] = max(dp[i], b[i] * 1ll);
        change(0, 0, n, i, dp[i]);
    }

    cout << dp[n - 1] << endl;
}
