#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; }
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; }
void debug_out() { cerr << endl; }
template<typename T1, typename... T2> void debug_out(T1 A, T2... B) { cerr << ' ' << A; debug_out(B...); }
template<typename T> void mdebug_out(T* a, int n) { for (int i = 0; i < n; ++i) cerr << a[i] << ' '; cerr << endl; }
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a) { for (auto &x : a) stream << x << ' '; return stream; }
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2> &p) { return stream << p.first << ' ' << p.second; }

#define int ll

const ll INF64 = 1e18;
const int maxN = 300005;
const int logN = 19;
int n;
int H[maxN];
int B[maxN];
int L[maxN], R[maxN];
ll dp[maxN];

ll val[maxN];
vector<int> rem[maxN];

void rec(int *h, int *l)
{
    vector<int> stk = {0};
    for (int i = 1; i <= n; ++i)
    {
        while (h[stk.back()] >= h[i])
            stk.pop_back();
        l[i] = stk.back();
        stk.push_back(i);
    }
}

namespace sgt
{
    const int NN = 1 << logN;
    ll mn[2 * NN];

    void init()
    {
        fill(mn, mn + 2 * NN, -INF64);
    }

    void upd(int v)
    {
        mn[v] = max(mn[v << 1], mn[v << 1 | 1]);
    }

    void mdf(int v, int vl, int vr, int i, int val)
    {
        if (vl == vr)
        {
            mn[v] = val;
            return;
        }
        int vm = (vl + vr) >> 1;
        if (i <= vm)
            mdf(v << 1, vl, vm, i, val);
        else
            mdf(v << 1 | 1, vm + 1, vr, i, val);
        upd(v);
    }

    ll rmq(int v, int vl, int vr, int l, int r)
    {
        if (l > r || vr < l || r < vl) return -INF64;
        if (l <= vl && vr <= r) return mn[v];
        int vm = (vl + vr) >> 1;
        return max(rmq(v << 1, vl, vm, l, r), rmq(v << 1 | 1, vm + 1, vr, l, r));
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    cin >> n;
    for (int i = 1; i <= n; ++i) cin >> H[i];
    for (int i = 1; i <= n; ++i) cin >> B[i];
    H[0] = 0;
    rec(H, L);
    reverse(H + 1, H + n + 1);
    rec(H, R);
    reverse(H + 1, H + n + 1);
    reverse(R + 1, R + n + 1);
    for (int i = 1; i <= n; ++i) R[i] = n - R[i] + 1;
    
    fill(dp, dp + n + 1, -INF64);
    dp[0] = 0;
    sgt::init();
    sgt::mdf(1, 0, n, 0, 0);
    set<pll> S;
    for (int i = 1; i <= n; ++i)
    {
        // add i
        val[i] = sgt::rmq(1, 0, n, L[i], i - 1) + B[i];
        S.insert({-val[i], i});
        rem[R[i]].push_back(i);

        // rem others
        for (int j : rem[i])
            S.erase({-val[j], j});

        dp[i] = -S.begin()->fi;
        sgt::mdf(1, 0, n, i, dp[i]);
    }
    cout << dp[n] << '\n';

    return 0;
}