#include <bits/stdc++.h>

#ifndef KEK
    #pragma GCC optimize("Ofast")
#endif

using namespace std;

const int maxn = 3e5 + 10;
#define int long long
int n, m, k;
vector <int> t(4 * maxn);

void update(int v, int tl, int tr, int pos, int new_val) {
    if (tl == tr) {
        t[v] = new_val;
        return;
    }

    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        update(v * 2, tl, tm, pos, new_val);
    } else {
        update(v * 2 + 1, tm + 1, tr, pos, new_val);
    }
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || l > tr) {
        return -1e18;
    }

    if (l <= tl && tr <= r) {
        return t[v];
    }

    int tm = (tl + tr) / 2;
    int L = get(v * 2, tl, tm, l, r);
    int R = get(v * 2 + 1, tm + 1, tr, l, r);

    return max(R, L);
}

void solve() {
    cin >> n;
    vector <pair <int, int>> a(n);
    for (auto &i : a) {
        cin >> i.first;
    }

    for (auto &i : a) {
        cin >> i.second;
    }

    vector <int> pref_max(n + 10);
    vector <int> left(n + 10);

    deque <int> pos;
    for (int i = n - 1; i >= 0; --i) {
        while (pos.size() && a[pos.front()].first > a[i].first) {
            left[pos.front()] = i;
            pos.pop_front();
        }

        pos.push_front(i);
    }

    while (pos.size()) {
        left[pos.front()] = -1;
        pos.pop_front();
    }

    vector <int> dp(n + 1);
    dp[0] = a[0].second;
    update(1, 0, n - 1, 0, dp[0]);

    for (int i = 1; i < n; ++i) {
        int mx = (left[i] == -1 ? 0 : dp[i - 1]);
        if (left[i] + 1 != i) {
            mx = max(get(1, 0, n - 1, left[i] + 1, i - 1), mx);
        }

        dp[i] = max({dp[i - 1] + a[i].second, mx + a[i].second, (left[i] == -1 ? a[i].second : dp[left[i]])});
        update(1, 0, n - 1, i, dp[i]);
    }

    cout << dp[n - 1];
}

void files() {
#ifdef KEK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main() {
    files();
    fastio();
    int qq = 1;
    //cin >> qq;
    while (qq--) {
        solve();
    }
}