#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 605, M = N * N, inf = 1e9;
const ll INF = 1e18;

int n, m, q, wei[M];
vector<pii> g[N];
ll dist[N][N];
vector<pii> ques[N];
bool ans[M];

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= n; ++j) {
			dist[i][j] = INF;
		}
		dist[i][i] = 0;
	}
	for (int i = 1; i <= m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		dist[v][u] = min(dist[v][u], 1ll * w);
		dist[u][v] = min(dist[u][v], 1ll * w);
		wei[i] = w;
		g[v].eb(u, i);
		g[u].eb(v, i);
	}
	for (int k = 1; k <= n; ++k) {
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= n; ++j) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}
	cin >> q;
	while (q--) {
		int s, t, l;
		cin >> s >> t >> l;
		ques[t].eb(s, l);
	}
	for (int v = 1; v <= n; ++v) {
		for (int t = 1; t <= n; ++t) {
			ll mx = -1;
			for (int i = 0; i < sz(ques[t]); ++i) {
				int s = ques[t][i].fi, l = ques[t][i].se;
				ll need = 1ll * l - dist[v][s];
				if (dist[v][s] == INF || need < 0) continue;
				mx = max(mx, need);
			}
			for (auto e : g[v]) {
				int u = e.fi, i = e.se;
				if (dist[u][t] < INF) {
					ll curr = 1ll * wei[i] + dist[u][t];
					if (dist[u][t] < INF && curr <= mx) {
						ans[i] = 1;
					}
				}
			}
		}
	}
	int answ = 0;
	for (int i = 1; i <= m; ++i) {
		answ += ans[i];
	}
	cout << answ << "\n";
	return 0;
}