#include <bits/stdc++.h>
#define int ll
#define x first
#define y second
using namespace std;
using ll = long long;

const int N   = 606;
const int INF = 1e18;

int n;
int m;
int q;
int g[N][N];
vector<pair<int, int>> tri[N];
bool used[N];

void dijksta(int dist[N]) {
	fill_n(used, N, false);
	for (int it = 0; it < n; ++it) {
		int v = -1;
		for (int i = 0; i < n; ++i) {
			if (used[i]) {
				continue;
			}
			if (v == -1 || dist[v] > dist[i]) {
				v = i;
			}
		}
		assert(v != -1);
		used[v] = true;
		for (int u = 0; u < n; ++u) {
			if (dist[u] > dist[v] + g[v][u]) {
				dist[u] = dist[v] + g[v][u];
			}
		}
	}
}

bool ok[N][N];
int d[N], f[N];

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
	fill_n(g[0], N * N, INF);
	for (int v, u, w, i = 0; i < m; ++i) {
		cin >> v >> u >> w;
		--v, --u;
		g[v][u] = min(g[v][u], w);
		g[u][v] = min(g[u][v], w);
	}
	cin >> q;
	for (int v, u, l, i = 0; i < q; ++i) {
		cin >> v >> u >> l;
		--v, --u;
		tri[v].emplace_back(u, l);
	}
	for (int v = 0; v < n; ++v) {
		fill_n(d, N, INF);
		fill_n(f, N, INF);
		d[v] = 0;
		for (auto e : tri[v]) {
			f[e.x] = -e.y;
		}
		dijksta(d);
		dijksta(f);
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (g[i][j] >= INF) {
					continue;
				}
				if (min(d[i] + f[j], d[j] + f[i]) <= -g[i][j]) {
					ok[i][j] = ok[j][i] = true;
				}
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			ans += ok[i][j];
		}
	}
	cout << ans << "\n";
	return 0;
}