#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 610;
ll INF = 1e18;
ll g[N][N];
std::vector<ll> dist[N];
int n, m;
std::vector<ll> dijk(int v) {
    std::vector<ll> d(n, INF), used(n, 0);
    d[v] = 0;
    FOR(i, n) {
        int last = -1;
        FOR(j, n) {
            if (used[j]) continue;
            if (last == -1 || d[j] < d[last]) {
                last = j;
            }
        }
        used[last] = 1;
        FOR(q, n) {
            if (g[last][q] != -1) {
                d[q] = std::min(d[q], d[last] + g[last][q]);
            }
        }
    }
    return d;
}
struct kek
{
    int other;
    int c;
    int i;
};
std::vector<kek> query[N];
std::vector<int> edges[N];
ll kek[N];
bool good[N][N];
int main() {
    #ifndef LOCAL
        std::ios::sync_with_stdio(false);
        std::cin.tie(0); std::cout.tie(0);
    #endif
    std::cin >> n >> m;
    memset(g, -1, sizeof(g));
    FOR(i, m) {
        int u, v;
        ll w;
        std::cin >> u >> v >> w;
        --u; --v;
        g[u][v] = w;
        g[v][u] = w;
    }
    FOR(i, n) {
        dist[i] = dijk(i);
    }
    int q;
    std::cin >> q;
    FOR(i, q) {
        int u, v, l;
        std::cin >> u >> v >> l;
        --u; --v;
        query[u].pb({v, l, i});
    }
    // FOR(v, n) {
    //     FOR(u, n) {
    //         debug(v << ' ' << u << ' ' << dist[v][u])
    //     }
    // }
    ll answ = 0;
    FOR(v, n) {
        FOR(i, n) {
            edges[i].clear();
            kek[i] = -INF;
        }
        for (auto e : query[v]) {
            int t2 = e.other;
            int c2 = e.c;
            FOR(i, n) {
                kek[i] = std::max(kek[i], e.c - dist[t2][i]);
            }
        }
        FOR(i, n) {
            FOR(j, n) {
                if (good[i][j] || good[j][i]) continue;
                if (g[i][j] == -1) continue;
                if (kek[j] >= dist[v][i] + g[i][j]) {
                    answ++;
                    good[i][j] = 1;
                }
            }
        }
    }
    std::cout << answ;
}