#include <bits/stdc++.h>
#define PB push_back
#define sz(x) ((int)x.size())
#define i2 array<int,2>
#define l2 array<ll,2>
using namespace std;
typedef long long ll;
const int N = 610;
const int M = 100100;
const int oo = 2e9;
const ll OO = 1e18;
ll dist[N][N], mn[N][N], mx[N][N], mem[N][N];
bool ok[N][N];
int n, m, q;

void amax(ll &x, ll y){
    x = max(x, y);
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef _LOCAL
    freopen("in.txt","r",stdin);
#endif // _LOCAL

    cin >> n >> m;

    for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++) {
        dist[i][j] = OO;
        mn[i][j] = OO;
        mx[i][j] = -1;
        mem[i][j] = OO;

        if (i == j)
            mn[i][j] = 0;
    }

    for (int i = 0; i < m; i++){
        int x, y; ll w;

        cin >> x >> y >> w;
        x--; y--;

        dist[x][y] = dist[y][x] = w;
        mn[x][y] = mn[y][x] = w;
    }

    for (int k = 0; k < n; k++)
    for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++)
        mn[i][j] = min(mn[i][j], mn[i][k] + mn[j][k]);

    cin >> q;

    for (int i = 0; i < q; i++){
        int x, y; ll l; cin >> x >> y >> l;

        x--; y--;

        mem[x][y] = mem[y][x] = l;
    }

    {
        /// get mx[i][j]

        for (int ed = 0; ed < n; ed++)
        for (int st = 0; st < n; st++){
            if (mem[ed][st] == OO) continue;

            for (int i = 0; i < n; i++)
                amax(mx[i][st], mem[ed][st] - mn[ed][i]);
        }
    }

    /// add ok[i][j] && ok[j][i]

    {
        for (int st = 0; st < n; st++)
        for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            if (mx[j][st] - dist[i][j] - mn[st][i] >= 0)
                ok[i][j] = 1;
    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    for (int j = i + 1; j < n; j++)
        if (ok[i][j])
            ans++;

    cout << ans;

    return 0;
}
