#include<bits/stdc++.h>

#define fi first
#define se second
#define ll long long

using namespace std;

const int N = 6e2 + 7;

int n,m;
ll d[N][N];
vector<pair<ll, int>> v[N];

void solve()
{
    cin >> n >> m;
    vector<pair<int, pair<int, int>>> g;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            d[i][j] = 1e18;
        }
        d[i][i] = 0;
    }
    for(int i = 1; i <= m; i++){
        int x,y,z;
        cin >> x >> y >> z;
        v[x].push_back({z, y});
        v[y].push_back({z, x});
        assert(d[x][y] == 1e18);
        d[x][y] = d[y][x] = z;
        g.push_back({z,{x, y}});
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            for(int h = 1; h <= n; h++){
                d[j][h] = min(d[j][h], d[j][i] + d[i][h]);
            }
        }
    }
    int q;
    cin >> q;
    vector<int> used(m + 1, 0);
    vector<ll> u(q + 1) , v(q + 1) , l(q + 1);
    for(int i = 1; i <= q; i++){
        cin >> u[i] >> v[i] >> l[i];
    }
    vector<int> qu[n + 1];
    for(int i = 1; i <= q; i++){
        qu[u[i]].push_back(i);
    }
    vector<ll> best(n + 1, -1e18);
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            best[j] = -1e18;
            for(auto h : qu[i]){
                best[j] = max(best[j], l[h] - d[v[h]][j]);
            }
        }
        for(int j = 0; j < m; j++){
            if( d[i][g[j].se.fi] + g[j].fi <= best[g[j].se.se] ){
                used[j] = true;
            }
            if( d[i][g[j].se.se] + g[j].fi <= best[g[j].se.fi] ){
                used[j] = true;
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < m; i++)ans += used[i];
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int T = 1;
    //cin >> T;
    while(T--){
        solve();
    }
}
