#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 606;

const ll inf = 1e15;

ll d[N][N], L[N][N], ed[N][N], X[N][N], Y[N][N];
bool res[N][N];
int n, m, q;
struct edge {
  int v, u;
  ll w;
};
void solve() {
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    fill(d[i], d[i] + n, inf);
    d[i][i] = 0;
  }
  vector<edge> e(m);
  for (int i = 0; i < m; ++i) {
    cin >> e[i].v >> e[i].u >> e[i].w;
    e[i].v--, e[i].u--;
    d[e[i].v][e[i].u] = d[e[i].u][e[i].v] = min(d[e[i].v][e[i].u], e[i].w);
    ed[e[i].v][e[i].u] = ed[e[i].u][e[i].v] = e[i].w;
  }
  for (int k = 0; k < n; ++k)
    for (int i = 0; i < n; ++i)
      for (int j = 0; j < n; ++j)
        d[i][j] = min(d[i][j], d[i][k] + d[k][j]);

  cin >> q;
  for (int i = 0; i < n; ++i) {
    fill(L[i], L[i] + n, -inf);
  }
  for (int i = 0; i < q; ++i) {
    ll u, v, l;
    cin >> u >> v >> l;
    u--, v--;
    L[u][v] = L[v][u] = max(L[u][v], l);
  }
  for (int v = 0; v < n; ++v) {
    for (int a = 0; a < n; ++a) {
      for (int b = 0; b < n; ++b) {
        Y[a][b] = L[a][b] - d[v][a];
      }
    }
    for (int u = 0; u < n; ++u) {
      for (int b = 0; b < n; ++b) {
        X[u][b] = d[u][b] + ed[v][u];
      }
    }
    for (int b = 0; b < n; ++b) {
      ll mx = -inf;
      for (int a = 0; a < n; ++a)
        mx = max(mx, Y[a][b]);
      for (int u = 0; u < n; ++u)
        if (X[u][b] <= mx)
          res[v][u] = true;
    }
  }
  int ans = 0;
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < i; ++j)
      if ((res[i][j] || res[j][i]) && ed[i][j] != 0)
        ans++;
  cout << ans;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
}