//
// Created by watemus on 21.03.2021.
//

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

const int INFI = 1'000'000'228;
const ll INFL = 1'000'000'000'000'000'228;

mt19937 rnd(228);

#define int ll
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

void precalc() {

}

const int N = 610;

vec<pair<int, int>> ps[N];

int d[N][N];
vec<tuple<int, int, int>> edges;
vec<int> ans;
int dd[N];

void run() {
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      d[i][j] = INFL;
    }
    d[i][i] = 0;
  }
  for (int i = 0; i < m; i++) {
    int u, v, l;
    cin >> u >> v >> l;
    u--, v--;
    edges.emplace_back(u, v, l);
    ans.push_back(0);
    d[u][v] = d[v][u] = l;
  }
  for (int k = 0; k < n; k++) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
      }
    }
  }
  int q;
  cin >> q;
  for (int i = 0; i < q; i++) {
    int u, v, l;
    cin >> u >> v >> l;
    u--, v--;
    if (u > v) swap(u, v);
    ps[u].emplace_back(v, l);
    ps[v].emplace_back(u, l);
  }
  for (int u = 0; u < n; u++) {
    for (int v = 0; v < n; v++) {
      dd[v] = -INFL;
      for (auto [k, ddd] : ps[u]) {
        dd[v] = max(dd[v], ddd - d[v][k]);
      }
    }
    for (int i = 0; i < edges.size(); i++) {
      auto [u1, v1, w] = edges[i];
      if (d[u][u1] + w <= dd[v1] || d[u][v1] + w <= dd[u1]) {
        ans[i] = 1;
      }
    }
  }
  int ansik = 0;
  for (auto el : ans) ansik += el;
  cout << ansik << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  precalc();
  int t = 1;
//  cin >> t;
  while (t--) {
    run();
  }
  return 0;
}